/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Q){for(var e=[],E=0,I=Q.length;E<I;E++)e[E]=ge[Q[E]];return e};define(ge[52],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=E}),define(ge[53],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function I(R){const C=[];for(let w in R)E.call(R,w)&&C.push(R[w]);return C}e.values=I;function T(R,C){for(let w in R)if(E.call(R,w)&&C({key:w,value:R[w]},function(){delete R[w]})===!1)return}e.forEach=T;function P(R,C){const w=Object.create(null);for(const g of R){const s=C(g);let d=w[s];d||(d=w[s]=[]),d.push(g)}return w}e.groupBy=P;function D(R){const C=Object.create(null);return R&&R.forEach((w,g)=>{C[g]=w}),C}e.fromMap=D;function A(R,C){const w=[],g=[];for(let s of R)C.has(s)||w.push(s);for(let s of C)R.has(s)||g.push(s);return{removed:w,added:g}}e.diffSets=A;function y(R,C){const w=[],g=[];for(let[s,d]of R)C.has(s)||w.push(d);for(let[s,d]of C)R.has(s)||g.push(d);return{removed:w,added:g}}e.diffMaps=y;class i{constructor(){this.map=new Map}add(C,w){let g=this.map.get(C);g||(g=new Set,this.map.set(C,g)),g.add(w)}delete(C,w){const g=this.map.get(C);!g||(g.delete(w),g.size===0&&this.map.delete(C))}forEach(C,w){const g=this.map.get(C);!g||g.forEach(w)}}e.SetMap=i}),define(ge[68],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(i,R,C)=>{let w=null,g=null;if(typeof C.value=="function"?(w="value",g=C.value):typeof C.get=="function"&&(w="get",g=C.get),!g)throw new Error("not supported");C[w]=y(g,R)}}e.createDecorator=E;let I=0;function T(){const y=`$memoize${I++}`;let i;const R=function(w,g,s){let d=null,S=null;if(typeof s.value=="function"?(d="value",S=s.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(d="get",S=s.get),!S)throw new Error("not supported");const v=`${y}:${g}`;s[d]=function(..._){return i=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,_)}),this[v]}};return R.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(C=>{C.indexOf(y)===0&&delete i[C]})},R}e.createMemoizer=T;function P(y,i,R){return T()(y,i,R)}e.memoize=P;function D(y,i,R){return E((C,w)=>{const g=`$debounce$${w}`,s=`$debounce$result$${w}`;return function(...d){this[s]||(this[s]=R?R():void 0),clearTimeout(this[g]),i&&(this[s]=i(this[s],...d),d=[this[s]]),this[g]=setTimeout(()=>{C.apply(this,d),this[s]=R?R():void 0},y)}})}e.debounce=D;function A(y,i,R){return E((C,w)=>{const g=`$throttle$timer$${w}`,s=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,S=`$throttle$pending$${w}`;return function(...v){if(this[s]||(this[s]=R?R():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),i&&(this[s]=i(this[s],...v)),!this[S]){const _=this[d]+y;_<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0):(this[S]=!0,this[g]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0},_-Date.now()))}}})}e.throttle=A}),define(ge[17],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function I(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=I;function T(a){y(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=T;function P(a){y(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=P;function D(a){if(a instanceof Error){let{name:t,message:n}=a;const o=a.stacktrace||a.stack;return{$isError:!0,name:t,message:n,stack:o}}return a}e.transformErrorForSerialization=D;const A="Canceled";function y(a){return a instanceof Error&&a.name===A&&a.message===A}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(A);this.name=this.message}}e.CancellationError=i;function R(){const a=new Error(A);return a.name=a.message,a}e.canceled=R;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=w;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function s(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function d(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=d;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function p(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function u(a,t=Object.create(null)){const n=new Error(a);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(ge[18],ve([0,1,17]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(F,U=0){return F[F.length-(1+U)]}e.tail=I;function T(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=T;function P(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=P;function D(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const j=(N+O)/2|0,K=M(F[j],U);if(K<0)N=j+1;else if(K>0)O=j-1;else return j}return-(N+1)}e.binarySearch=D;function A(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=A;function y(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],j=[],K=[];for(let X of U){const me=M(X,N);me<0?O.push(X):me>0?j.push(X):K.push(X)}return F<O.length?y(F,O,M):F<O.length+K.length?K[0]:y(F-(O.length+K.length),j,M)}e.quickSelect=y;function i(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=i;function R(F,U,M){const N=[];function O(X,me,we){if(!(me===0&&we.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===X?(Ae.deleteCount+=me,Ae.toInsert.push(...we)):N.push({start:X,deleteCount:me,toInsert:we})}}let j=0,K=0;for(;;){if(j===F.length){O(j,0,U.slice(K));break}if(K===U.length){O(j,F.length-j,[]);break}const X=F[j],me=U[K],we=M(X,me);we===0?(j+=1,K+=1):we<0?(O(j,1,[]),j+=1):we>0&&(O(j,0,[me]),K+=1)}return N}e.sortedDiff=R;function C(F,U,M){const N=R(F,U,M),O=[],j=[];for(const K of N)O.push(...F.slice(K.start,K.start+K.deleteCount)),j.push(...K.toInsert);return{removed:O,added:j}}e.delta=C;function w(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return s(F,U,N,M,F.length),N}e.top=w;function g(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((j,K)=>{(async()=>{const X=F.length,me=F.slice(0,M).sort(U);for(let we=M,Ae=Math.min(M+N,X);we<X;we=Ae,Ae=Math.min(Ae+N,X)){if(we>M&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,E.canceled)();s(F,U,me,we,Ae)}return me})().then(j,K)})}e.topAsync=g;function s(F,U,M,N,O){for(const j=M.length;N<O;N++){const K=F[N];if(U(K,M[j-1])<0){M.pop();const X=A(M,me=>U(K,me)<0);M.splice(X,0,K)}}}function d(F){return F.filter(U=>!!U)}e.coalesce=d;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function v(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=v;function _(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=_;function p(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=p;function u(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function a(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=a;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function n(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=n;function o(F,U){return F.length>0?F[0]:U}e.firstOrDefault=o;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,j=Math.min(F.length,U.length);O<j&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function l(F){return[].concat(...F)}e.flatten=l;function h(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=h;function m(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=m;function b(F,U){return F.push(U),()=>c(F,U)}e.insert=b;function c(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=c;function f(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=f;function k(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),j=F[N];F[N]=F[O],F[O]=j}}e.shuffle=k;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function $(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=$;function ee(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=ee;function H(F){return Array.isArray(F)?F:[F]}e.asArray=H;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function B(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=B}),define(ge[69],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(I){const T=this;let P=!1,D;return function(){return P||(P=!0,D=I.apply(T,arguments)),D}}e.once=E}),define(ge[70],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(ge[71],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(I){function T(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}I.is=T;const P=Object.freeze([]);function D(){return P}I.empty=D;function*A(a){yield a}I.single=A;function y(a){return a||P}I.from=y;function i(a){return!a||a[Symbol.iterator]().next().done===!0}I.isEmpty=i;function R(a){return a[Symbol.iterator]().next().value}I.first=R;function C(a,t){for(const n of a)if(t(n))return!0;return!1}I.some=C;function w(a,t){for(const n of a)if(t(n))return n}I.find=w;function*g(a,t){for(const n of a)t(n)&&(yield n)}I.filter=g;function*s(a,t){for(const n of a)yield t(n)}I.map=s;function*d(...a){for(const t of a)for(const n of t)yield n}I.concat=d;function*S(a){for(const t of a)for(const n of t)yield n}I.concatNested=S;function v(a,t,n){let o=n;for(const r of a)o=t(o,r);return o}I.reduce=v;function*_(a,t,n=a.length){for(t<0&&(t+=a.length),n<0?n+=a.length:n>a.length&&(n=a.length);t<n;t++)yield a[t]}I.slice=_;function p(a,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,a];const o=a[Symbol.iterator]();for(let r=0;r<t;r++){const l=o.next();if(l.done)return[n,I.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}I.consume=p;function u(a,t,n=(o,r)=>o===r){const o=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=o.next(),h=r.next();if(l.done!==h.done)return!1;if(l.done)return!0;if(!n(l.value,h.value))return!1}}I.equals=u})(E=e.Iterable||(e.Iterable={}))}),define(ge[54],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function D(t,n=!1){let o=0,r=t.length,l="",h=0,m=16,b=0;function c(x){let B=0,F=0;for(;B<x;){const U=t.charCodeAt(o);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;o++,B++}return B<x&&(F=-1),F}function f(x){o=x,l="",h=0,m=16,b=0}function k(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return b=3,t.substring(x,o);let B=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;B=o}else b=3;return t.substring(x,B)}function L(){let x="",B=o;for(;;){if(o>=r){x+=t.substring(B,o),b=2;break}const F=t.charCodeAt(o);if(F===34){x+=t.substring(B,o),o++;break}if(F===92){if(x+=t.substring(B,o),o++,o>=r){b=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=c(4);M>=0?x+=String.fromCharCode(M):b=4;break;default:b=5}B=o;continue}if(F>=0&&F<=31)if(y(F)){x+=t.substring(B,o),b=2;break}else b=6;o++}return x}function $(){if(l="",b=0,h=o,o>=r)return h=r,m=17;let x=t.charCodeAt(o);if(A(x)){do o++,l+=String.fromCharCode(x),x=t.charCodeAt(o);while(A(x));return m=15}if(y(x))return o++,l+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,l+=`
`),m=14;switch(x){case 123:return o++,m=1;case 125:return o++,m=2;case 91:return o++,m=3;case 93:return o++,m=4;case 58:return o++,m=6;case 44:return o++,m=5;case 34:return o++,l=L(),m=10;case 47:const B=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!y(t.charCodeAt(o));)o++;return l=t.substring(B,o),m=12}if(t.charCodeAt(o+1)===42){o+=2;const F=r-1;let U=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,b=1),l=t.substring(B,o),m=13}return l+=String.fromCharCode(x),o++,m=16;case 45:if(l+=String.fromCharCode(x),o++,o===r||!i(t.charCodeAt(o)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=k(),m=11;default:for(;o<r&&ee(x);)o++,x=t.charCodeAt(o);if(h!==o){switch(l=t.substring(h,o),l){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return l+=String.fromCharCode(x),o++,m=16}}function ee(x){if(A(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=$();while(x>=12&&x<=15);return x}return{setPosition:f,getPosition:()=>o,scan:n?H:$,getToken:()=>m,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>b}}e.createScanner=D;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,n){const o=[],r=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function b(c,f,k,L){h.value=c,h.offset=f,h.length=k,h.type=L,h.colonOffset=void 0,l=h}try{p(t,{onObjectBegin:(c,f)=>{if(n<=c)throw r;l=void 0,m=n>c,o.push("")},onObjectProperty:(c,f,k)=>{if(n<f||(b(c,f,k,"property"),o[o.length-1]=c,n<=f+k))throw r},onObjectEnd:(c,f)=>{if(n<=c)throw r;l=void 0,o.pop()},onArrayBegin:(c,f)=>{if(n<=c)throw r;l=void 0,o.push(0)},onArrayEnd:(c,f)=>{if(n<=c)throw r;l=void 0,o.pop()},onLiteralValue:(c,f,k)=>{if(n<f||(b(c,f,k,a(c)),n<=f+k))throw r},onSeparator:(c,f,k)=>{if(n<=f)throw r;if(c===":"&&l&&l.type==="property")l.colonOffset=f,m=!1,l=void 0;else if(c===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(m=!0,o[o.length-1]=""),l=void 0}}})}catch(c){if(c!==r)throw c}return{path:o,previousNode:l,isAtPropertyKey:m,matches:c=>{let f=0;for(let k=0;f<c.length&&k<o.length;k++)if(c[f]===o[k]||c[f]==="*")f++;else if(c[f]!=="**")return!1;return f===c.length}}}e.getLocation=C;function w(t,n=[],o=P.DEFAULT){let r=null,l=[];const h=[];function m(c){Array.isArray(l)?l.push(c):r!==null&&(l[r]=c)}return p(t,{onObjectBegin:()=>{const c={};m(c),h.push(l),l=c,r=null},onObjectProperty:c=>{r=c},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const c=[];m(c),h.push(l),l=c,r=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:m,onError:(c,f,k)=>{n.push({error:c,offset:f,length:k})}},o),l[0]}e.parse=w;function g(t,n=[],o=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(c){r.type==="property"&&(r.length=c-r.offset,r=r.parent)}function h(c){return r.children.push(c),c}p(t,{onObjectBegin:c=>{r=h({type:"object",offset:c,length:-1,parent:r,children:[]})},onObjectProperty:(c,f,k)=>{r=h({type:"property",offset:f,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:c,offset:f,length:k,parent:r})},onObjectEnd:(c,f)=>{r.length=c+f-r.offset,r=r.parent,l(c+f)},onArrayBegin:(c,f)=>{r=h({type:"array",offset:c,length:-1,parent:r,children:[]})},onArrayEnd:(c,f)=>{r.length=c+f-r.offset,r=r.parent,l(c+f)},onLiteralValue:(c,f,k)=>{h({type:a(c),offset:f,length:k,parent:r,value:c}),l(f+k)},onSeparator:(c,f,k)=>{r.type==="property"&&(c===":"?r.colonOffset=f:c===","&&l(f))},onError:(c,f,k)=>{n.push({error:c,offset:f,length:k})}},o);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=g;function s(t,n){if(!!t){let o=t;for(let r of n)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let l=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===r){o=h.children[1],l=!0;break}if(!l)return}else{const l=r;if(o.type!=="array"||l<0||!Array.isArray(o.children)||l>=o.children.length)return;o=o.children[l]}return o}}e.findNodeAtLocation=s;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=d;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(n[o.children[0].value]=S(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=v;function _(t,n,o=!1){if(v(t,n,o)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=n;l++){const h=_(r[l],n,o);if(h)return h}return t}}e.findNodeAtOffset=_;function p(t,n,o=P.DEFAULT){const r=D(t,!1);function l(me){return me?()=>me(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(me){return me?we=>me(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=l(n.onObjectBegin),b=h(n.onObjectProperty),c=l(n.onObjectEnd),f=l(n.onArrayBegin),k=l(n.onArrayEnd),L=h(n.onLiteralValue),$=h(n.onSeparator),ee=l(n.onComment),H=h(n.onError),x=o&&o.disallowComments,B=o&&o.allowTrailingComma;function F(){for(;;){const me=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(me){case 12:case 13:x?U(10):ee();break;case 16:U(1);break;case 15:case 14:break;default:return me}}}function U(me,we=[],Ae=[]){if(H(me),we.length+Ae.length>0){let Ie=r.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){F();break}else if(Ae.indexOf(Ie)!==-1)break;Ie=F()}}}function M(me){const we=r.getTokenValue();return me?L(we):b(we),F(),!0}function N(){switch(r.getToken()){case 11:let me=0;try{me=JSON.parse(r.getTokenValue()),typeof me!="number"&&(U(2),me=0)}catch(we){U(2)}L(me);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?($(":"),F(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){m(),F();let me=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),$(","),F(),r.getToken()===2&&B)break}else me&&U(6,[],[]);O()||U(4,[],[2,5]),me=!0}return c(),r.getToken()!==2?U(7,[2],[]):F(),!0}function K(){f(),F();let me=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),$(","),F(),r.getToken()===4&&B)break}else me&&U(6,[],[]);X()||U(4,[],[4,5]),me=!0}return k(),r.getToken()!==4?U(8,[4],[]):F(),!0}function X(){switch(r.getToken()){case 3:return K();case 1:return j();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=p;function u(t,n){let o=D(t),r=[],l,h=0,m;do switch(m=o.getPosition(),l=o.scan(),l){case 12:case 13:case 17:h!==m&&r.push(t.substring(h,m)),n!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,n)),h=o.getPosition();break}while(l!==17);return r.join("")}e.stripComments=u;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ge[131],ve([0,1,54]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(y,i,R){let C,w,g,s,d;if(i){for(s=i.offset,d=s+i.length,g=s;g>0&&!A(y,g-1);)g--;let h=d;for(;h<y.length&&!A(y,h);)h++;w=y.substring(g,h),C=P(w,R)}else w=y,C=0,g=0,s=0,d=y.length;const S=D(R,y);let v=!1,_=0,p;R.insertSpaces?p=T(" ",R.tabSize||4):p="	";const u=(0,E.createScanner)(w,!1);let a=!1;function t(){return S+T(p,C+_)}function n(){let h=u.scan();for(v=!1;h===15||h===14;)v=v||h===14,h=u.scan();return a=h===16||u.getTokenError()!==0,h}const o=[];function r(h,m,b){!a&&m<d&&b>s&&y.substring(m,b)!==h&&o.push({offset:m,length:b-m,content:h})}let l=n();if(l!==17){const h=u.getTokenOffset()+g,m=T(p,C);r(m,g,h)}for(;l!==17;){let h=u.getTokenOffset()+u.getTokenLength()+g,m=n(),b="";for(;!v&&(m===12||m===13);){const f=u.getTokenOffset()+g;r(" ",h,f),h=u.getTokenOffset()+u.getTokenLength()+g,b=m===12?t():"",m=n()}if(m===2)l!==1&&(_--,b=t());else if(m===4)l!==3&&(_--,b=t());else{switch(l){case 3:case 1:_++,b=t();break;case 5:case 12:b=t();break;case 13:v?b=t():b=" ";break;case 6:b=" ";break;case 10:if(m===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?b=" ":m!==5&&m!==17&&(a=!0);break;case 16:a=!0;break}v&&(m===12||m===13)&&(b=t())}const c=u.getTokenOffset()+g;r(b,h,c),l=m}return o}e.format=I;function T(y,i){let R="";for(let C=0;C<i;C++)R+=y;return R}function P(y,i){let R=0,C=0;const w=i.tabSize||4;for(;R<y.length;){const g=y.charAt(R);if(g===" ")C++;else if(g==="	")C+=w;else break;R++}return Math.floor(C/w)}function D(y,i){for(let R=0;R<i.length;R++){const C=i.charAt(R);if(C==="\r")return R+1<i.length&&i.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function A(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=A}),define(ge[132],ve([0,1,54,131]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(i,R,C){return P(i,R,void 0,C)}e.removeProperty=T;function P(i,R,C,w,g){const s=R.slice(),d=[],S=(0,E.parseTree)(i,d);let v,_;for(;s.length>0&&(_=s.pop(),v=(0,E.findNodeAtLocation)(S,s),v===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(v)if(v.type==="object"&&typeof _=="string"&&Array.isArray(v.children)){const p=(0,E.findNodeAtLocation)(v,[_]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const u=v.children.indexOf(p.parent);let a,t=p.parent.offset+p.parent.length;if(u>0){const n=v.children[u-1];a=n.offset+n.length}else a=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return D(i,{offset:a,length:t-a,content:""},w)}else return D(i,{offset:p.offset,length:p.length,content:JSON.stringify(C)},w);else{if(C===void 0)return[];const u=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,a=g?g(v.children.map(n=>n.children[0].value)):v.children.length;let t;if(a>0){const n=v.children[a-1];t={offset:n.offset+n.length,length:0,content:","+u}}else v.children.length===0?t={offset:v.offset+1,length:0,content:u}:t={offset:v.offset+1,length:0,content:u+","};return D(i,t,w)}}else if(v.type==="array"&&typeof _=="number"&&Array.isArray(v.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let u;if(v.children.length===0||_===0)u={offset:v.offset+1,length:0,content:v.children.length===0?p:p+","};else{const a=_===-1||_>v.children.length?v.children.length:_,t=v.children[a-1];u={offset:t.offset+t.length,length:0,content:","+p}}return D(i,u,w)}else{const p=_,u=v.children[p];let a;if(v.children.length===1)a={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===p){const t=v.children[p-1],n=t.offset+t.length,o=v.offset+v.length;a={offset:n,length:o-2-n,content:""}}else a={offset:u.offset,length:v.children[p+1].offset-u.offset,content:""};return D(i,a,w)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${v.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(i,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},w)}}e.setProperty=P;function D(i,R,C){let w=A(i,R),g=R.offset,s=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,I.isEOL)(w,g-1);)g--;for(;s<w.length&&!(0,I.isEOL)(w,s);)s++}const d=(0,I.format)(w,{offset:g,length:s-g},C);for(let v=d.length-1;v>=0;v--){const _=d[v];w=A(w,_),g=Math.min(g,_.offset),s=Math.max(s,_.offset+_.length),s+=_.content.length-_.length}const S=i.length-(w.length-s)-g;return[{offset:g,length:S,content:w.substring(g,s)}]}e.withFormatting=D;function A(i,R){return i.substring(0,R.offset)+R.content+i.substring(R.offset+R.length)}e.applyEdit=A;function y(i,R){let C=R.slice(0).sort((g,s)=>{const d=g.offset-s.offset;return d===0?g.length-s.length:d}),w=i.length;for(let g=C.length-1;g>=0;g--){let s=C[g];if(s.offset+s.length<=w)i=A(i,s);else throw new Error("Overlapping edit");w=s.offset}return i}e.applyEdits=y}),define(ge[133],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new E(()=>T(this.getValue()))}}e.Lazy=E}),define(ge[6],ve([0,1,69,71]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function D(p){P=p}if(e.setDisposableTracker=D,T){const p="__is_disposable_tracked__";P=new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[p]||console.log(a)},3e3)}markTracked(u){if(u&&u!==d.None)try{u[p]=!0}catch(a){}}}}function A(p){!P||P.markTracked(p)}function y(p){return P&&P.trackDisposable(p),p}e.trackDisposable=y;class i extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=i;function R(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=R;function C(p){if(I.Iterable.is(p)){let u=[];for(const a of p)if(a){A(a);try{a.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new i(u);return Array.isArray(p)?[]:p}else if(p)return A(p),p.dispose(),p}e.dispose=C;function w(...p){return p.forEach(A),g(()=>C(p))}e.combinedDisposable=w;function g(p){const u=y({dispose:()=>{A(u),p()}});return u}e.toDisposable=g;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(A(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return A(u),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new s,y(this)}dispose(){A(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var a;this._isDisposed||u===this._value||((a=this._value)===null||a===void 0||a.dispose(),u&&A(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,A(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(u,...a){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,t));const{object:n}=t,o=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=v;class _{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=_}),define(ge[55],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(P){this.element=P,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class I{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,D){const A=new E(P);if(this._first===E.Undefined)this._first=A,this._last=A;else if(D){const i=this._last;this._last=A,A.prev=i,i.next=A}else{const i=this._first;this._first=A,A.next=i,i.prev=A}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(A))}}shift(){if(this._first!==E.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==E.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==E.Undefined&&P.next!==E.Undefined){const D=P.prev;D.next=P.next,P.next.prev=D}else P.prev===E.Undefined&&P.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):P.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):P.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==E.Undefined;)yield P.element,P=P.next}}e.LinkedList=I}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(q,oe){for(var he=0;he<oe.length;he++){var Z=oe[he];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(q,Z.key,Z)}}function e(q,oe,he){return oe&&Q(q.prototype,oe),he&&Q(q,he),q}function E(q,oe){if(!!q){if(typeof q=="string")return I(q,oe);var he=Object.prototype.toString.call(q).slice(8,-1);if(he==="Object"&&q.constructor&&(he=q.constructor.name),he==="Map"||he==="Set")return Array.from(q);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(q,oe)}}function I(q,oe){(oe==null||oe>q.length)&&(oe=q.length);for(var he=0,Z=new Array(oe);he<oe;he++)Z[he]=q[he];return Z}function T(q,oe){var he;if(typeof Symbol=="undefined"||q[Symbol.iterator]==null){if(Array.isArray(q)||(he=E(q))||oe&&q&&typeof q.length=="number"){he&&(q=he);var Z=0;return function(){return Z>=q.length?{done:!0}:{done:!1,value:q[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=q[Symbol.iterator](),he.next.bind(he)}function P(q){var oe={exports:{}};return q(oe,oe.exports),oe.exports}var D=P(function(q){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(Z){q.exports.defaults=Z}q.exports={defaults:oe(),getDefaults:oe,changeDefaults:he}}),A=/[&<>"']/,y=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(oe){return C[oe]};function g(q,oe){if(oe){if(A.test(q))return q.replace(y,w)}else if(i.test(q))return q.replace(R,w);return q}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(q){return q.replace(s,function(oe,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(q,oe){q=q.source||q,oe=oe||"";var he={replace:function(ne,le){return le=le.source||le,le=le.replace(S,"$1"),q=q.replace(ne,le),he},getRegex:function(){return new RegExp(q,oe)}};return he}var _=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(q,oe,he){if(q){var Z;try{Z=decodeURIComponent(d(he)).replace(_,"").toLowerCase()}catch(ne){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!p.test(he)&&(he=r(oe,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var a={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(q,oe){a[" "+q]||(t.test(q)?a[" "+q]=q+"/":a[" "+q]=b(q,"/",!0)),q=a[" "+q];var he=q.indexOf(":")===-1;return oe.substring(0,2)==="//"?he?oe:q.replace(n,"$1")+oe:oe.charAt(0)==="/"?he?oe:q.replace(o,"$1")+oe:q+oe}var l={exec:function(){}};function h(q){for(var oe=1,he,Z;oe<arguments.length;oe++){he=arguments[oe];for(Z in he)Object.prototype.hasOwnProperty.call(he,Z)&&(q[Z]=he[Z])}return q}function m(q,oe){var he=q.replace(/\|/g,function(le,pe,_e){for(var He=!1,We=pe;--We>=0&&_e[We]==="\\";)He=!He;return He?"|":" |"}),Z=he.split(/ \|/),ne=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ne<Z.length;ne++)Z[ne]=Z[ne].trim().replace(/\\\|/g,"|");return Z}function b(q,oe,he){var Z=q.length;if(Z===0)return"";for(var ne=0;ne<Z;){var le=q.charAt(Z-ne-1);if(le===oe&&!he)ne++;else if(le!==oe&&he)ne++;else break}return q.substr(0,Z-ne)}function c(q,oe){if(q.indexOf(oe[1])===-1)return-1;for(var he=q.length,Z=0,ne=0;ne<he;ne++)if(q[ne]==="\\")ne++;else if(q[ne]===oe[0])Z++;else if(q[ne]===oe[1]&&(Z--,Z<0))return ne;return-1}function f(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(q,oe){if(oe<1)return"";for(var he="";oe>1;)oe&1&&(he+=q),oe>>=1,q+=q;return he+q}var L={escape:g,unescape:d,edit:v,cleanUrl:u,resolveUrl:r,noopTest:l,merge:h,splitCells:m,rtrim:b,findClosingBracket:c,checkSanitizeDeprecation:f,repeatString:k},$=D.defaults,ee=L.rtrim,H=L.splitCells,x=L.escape,B=L.findClosingBracket;function F(q,oe,he){var Z=oe.href,ne=oe.title?x(oe.title):null,le=q[1].replace(/\\([\[\]])/g,"$1");return q[0].charAt(0)!=="!"?{type:"link",raw:he,href:Z,title:ne,text:le}:{type:"image",raw:he,href:Z,title:ne,text:x(le)}}function U(q,oe){var he=q.match(/^(\s+)(?:```)/);if(he===null)return oe;var Z=he[1];return oe.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var pe=le[0];return pe.length>=Z.length?ne.slice(Z.length):ne}).join(`
`)}var M=function(){function q(he){this.options=he||$}var oe=q.prototype;return oe.space=function(Z){var ne=this.rules.block.newline.exec(Z);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(Z){var ne=this.rules.block.code.exec(Z);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:ee(le,`
`)}}},oe.fences=function(Z){var ne=this.rules.block.fences.exec(Z);if(ne){var le=ne[0],pe=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:pe}}},oe.heading=function(Z){var ne=this.rules.block.heading.exec(Z);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var pe=ee(le,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(le=pe.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},oe.nptable=function(Z){var ne=this.rules.block.nptable.exec(Z);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var pe=le.align.length,_e;for(_e=0;_e<pe;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(pe=le.cells.length,_e=0;_e<pe;_e++)le.cells[_e]=H(le.cells[_e],le.header.length);return le}}},oe.hr=function(Z){var ne=this.rules.block.hr.exec(Z);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(Z){var ne=this.rules.block.blockquote.exec(Z);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},oe.list=function(Z){var ne=this.rules.block.list.exec(Z);if(ne){var le=ne[0],pe=ne[2],_e=pe.length>1,He={type:"list",raw:le,ordered:_e,start:_e?+pe.slice(0,-1):"",loose:!1,items:[]},We=ne[0].match(this.rules.block.item),qe=!1,Ye,Ze,ut,ot,nt,ue,Ce,ce,J=We.length;ut=this.rules.block.listItemStart.exec(We[0]);for(var Re=0;Re<J;Re++){if(Ye=We[Re],le=Ye,Re!==J-1){if(ot=this.rules.block.listItemStart.exec(We[Re+1]),this.options.pedantic?ot[1].length>ut[1].length:ot[1].length>ut[0].length||ot[1].length>3){We.splice(Re,2,We[Re]+`
`+We[Re+1]),Re--,J--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==pe[pe.length-1]:_e===(ot[2].length===1))&&(nt=We.slice(Re+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-nt.length),Re=J-1);ut=ot}Ze=Ye.length,Ye=Ye.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ye.indexOf(`
 `)&&(Ze-=Ye.length,Ye=this.options.pedantic?Ye.replace(/^ {1,4}/gm,""):Ye.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ue=qe||/\n\n(?!\s*$)/.test(Ye),Re!==J-1&&(qe=Ye.charAt(Ye.length-1)===`
`,ue||(ue=qe)),ue&&(He.loose=!0),this.options.gfm&&(Ce=/^\[[ xX]\] /.test(Ye),ce=void 0,Ce&&(ce=Ye[1]!==" ",Ye=Ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:Ce,checked:ce,loose:ue,text:Ye})}return He}},oe.html=function(Z){var ne=this.rules.block.html.exec(Z);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):x(ne[0]):ne[0]}},oe.def=function(Z){var ne=this.rules.block.def.exec(Z);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(Z){var ne=this.rules.block.table.exec(Z);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var pe=le.align.length,_e;for(_e=0;_e<pe;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(pe=le.cells.length,_e=0;_e<pe;_e++)le.cells[_e]=H(le.cells[_e].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(Z){var ne=this.rules.block.lheading.exec(Z);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(Z){var ne=this.rules.block.paragraph.exec(Z);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(Z){var ne=this.rules.block.text.exec(Z);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(Z){var ne=this.rules.inline.escape.exec(Z);if(ne)return{type:"escape",raw:ne[0],text:x(ne[1])}},oe.tag=function(Z,ne,le){var pe=this.rules.inline.tag.exec(Z);if(pe)return!ne&&/^<a /i.test(pe[0])?ne=!0:ne&&/^<\/a>/i.test(pe[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]}},oe.link=function(Z){var ne=this.rules.inline.link.exec(Z);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var pe=ee(le.slice(0,-1),"\\");if((le.length-pe.length)%2==0)return}else{var _e=B(ne[2],"()");if(_e>-1){var He=ne[0].indexOf("!")===0?5:4,We=He+ne[1].length+_e;ne[2]=ne[2].substring(0,_e),ne[0]=ne[0].substring(0,We).trim(),ne[3]=""}}var qe=ne[2],Ye="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Ze&&(qe=Ze[1],Ye=Ze[3])}else Ye=ne[3]?ne[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),F(ne,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Ye&&Ye.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(Z,ne){var le;if((le=this.rules.inline.reflink.exec(Z))||(le=this.rules.inline.nolink.exec(Z))){var pe=(le[2]||le[1]).replace(/\s+/g," ");if(pe=ne[pe.toLowerCase()],!pe||!pe.href){var _e=le[0].charAt(0);return{type:"text",raw:_e,text:_e}}return F(le,pe,le[0])}},oe.emStrong=function(Z,ne,le){le===void 0&&(le="");var pe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!pe&&!(pe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _e=pe[1]||pe[2]||"";if(!_e||_e&&(le===""||this.rules.inline.punctuation.exec(le))){var He=pe[0].length-1,We,qe,Ye=He,Ze=0,ut=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*Z.length+He);(pe=ut.exec(ne))!=null;)if(We=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!We){if(qe=We.length,pe[3]||pe[4]){Ye+=qe;continue}else if((pe[5]||pe[6])&&He%3&&!((He+qe)%3)){Ze+=qe;continue}if(Ye-=qe,!(Ye>0)){if(Ye+Ze-qe<=0&&!ne.slice(ut.lastIndex).match(ut)&&(qe=Math.min(qe,qe+Ye+Ze)),Math.min(He,qe)%2)return{type:"em",raw:Z.slice(0,He+pe.index+qe+1),text:Z.slice(1,He+pe.index+qe)};if(Math.min(He,qe)%2==0)return{type:"strong",raw:Z.slice(0,He+pe.index+qe+1),text:Z.slice(2,He+pe.index+qe-1)}}}}}},oe.codespan=function(Z){var ne=this.rules.inline.code.exec(Z);if(ne){var le=ne[2].replace(/\n/g," "),pe=/[^ ]/.test(le),_e=/^ /.test(le)&&/ $/.test(le);return pe&&_e&&(le=le.substring(1,le.length-1)),le=x(le,!0),{type:"codespan",raw:ne[0],text:le}}},oe.br=function(Z){var ne=this.rules.inline.br.exec(Z);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(Z){var ne=this.rules.inline.del.exec(Z);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(Z,ne){var le=this.rules.inline.autolink.exec(Z);if(le){var pe,_e;return le[2]==="@"?(pe=x(this.options.mangle?ne(le[1]):le[1]),_e="mailto:"+pe):(pe=x(le[1]),_e=pe),{type:"link",raw:le[0],text:pe,href:_e,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.url=function(Z,ne){var le;if(le=this.rules.inline.url.exec(Z)){var pe,_e;if(le[2]==="@")pe=x(this.options.mangle?ne(le[0]):le[0]),_e="mailto:"+pe;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);pe=x(le[0]),le[1]==="www."?_e="http://"+pe:_e=pe}return{type:"link",raw:le[0],text:pe,href:_e,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.inlineText=function(Z,ne,le){var pe=this.rules.inline.text.exec(Z);if(pe){var _e;return ne?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]:_e=x(this.options.smartypants?le(pe[0]):pe[0]),{type:"text",raw:pe[0],text:_e}}},q}(),N=L.noopTest,O=L.edit,j=L.merge,K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=O(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,K.item=O(K.item,"gm").replace(/bull/g,K.bullet).getRegex(),K.listItemStart=O(/^( *)(bull)/).replace("bull",K.bullet).getRegex(),K.list=O(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=O(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=O(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.blockquote=O(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=j({},K),K.gfm=j({},K.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.nptable=O(K.gfm.nptable).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.gfm.table=O(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.pedantic=j({},K.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=O(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=O(K._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=O(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=O(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=O(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=O(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=O(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=O(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=O(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=O(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=j({},X),X.pedantic=j({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=j({},X.normal,{escape:O(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=O(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=j({},X.gfm,{br:O(X.br).replace("{2,}","*").getRegex(),text:O(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:K,inline:X},we=D.defaults,Ae=me.block,Ie=me.inline,Me=L.repeatString;function V(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(q){var oe="",he,Z,ne=q.length;for(he=0;he<ne;he++)Z=q.charCodeAt(he),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var te=function(){function q(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Ae.normal,inline:Ie.normal};this.options.pedantic?(Z.block=Ae.pedantic,Z.inline=Ie.pedantic):this.options.gfm&&(Z.block=Ae.gfm,this.options.breaks?Z.inline=Ie.breaks:Z.inline=Ie.gfm),this.tokenizer.rules=Z}q.lex=function(Z,ne){var le=new q(ne);return le.lex(Z)},q.lexInline=function(Z,ne){var le=new q(ne);return le.inlineTokens(Z)};var oe=q.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var pe,_e,He,We;Z;){if(pe=this.tokenizer.space(Z)){Z=Z.substring(pe.raw.length),pe.type&&ne.push(pe);continue}if(pe=this.tokenizer.code(Z)){Z=Z.substring(pe.raw.length),We=ne[ne.length-1],We&&We.type==="paragraph"?(We.raw+=`
`+pe.raw,We.text+=`
`+pe.text):ne.push(pe);continue}if(pe=this.tokenizer.fences(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.heading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.nptable(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.hr(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.blockquote(Z)){Z=Z.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],le),ne.push(pe);continue}if(pe=this.tokenizer.list(Z)){for(Z=Z.substring(pe.raw.length),He=pe.items.length,_e=0;_e<He;_e++)pe.items[_e].tokens=this.blockTokens(pe.items[_e].text,[],!1);ne.push(pe);continue}if(pe=this.tokenizer.html(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(le&&(pe=this.tokenizer.def(Z))){Z=Z.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.lheading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(le&&(pe=this.tokenizer.paragraph(Z))){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.text(Z)){Z=Z.substring(pe.raw.length),We=ne[ne.length-1],We&&We.type==="text"?(We.raw+=`
`+pe.raw,We.text+=`
`+pe.text):ne.push(pe);continue}if(Z){var qe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},oe.inline=function(Z){var ne,le,pe,_e,He,We,qe=Z.length;for(ne=0;ne<qe;ne++)switch(We=Z[ne],We.type){case"paragraph":case"text":case"heading":{We.tokens=[],this.inlineTokens(We.text,We.tokens);break}case"table":{for(We.tokens={header:[],cells:[]},_e=We.header.length,le=0;le<_e;le++)We.tokens.header[le]=[],this.inlineTokens(We.header[le],We.tokens.header[le]);for(_e=We.cells.length,le=0;le<_e;le++)for(He=We.cells[le],We.tokens.cells[le]=[],pe=0;pe<He.length;pe++)We.tokens.cells[le][pe]=[],this.inlineTokens(He[pe],We.tokens.cells[le][pe]);break}case"blockquote":{this.inline(We.tokens);break}case"list":{for(_e=We.items.length,le=0;le<_e;le++)this.inline(We.items[le].tokens);break}}return Z},oe.inlineTokens=function(Z,ne,le,pe){ne===void 0&&(ne=[]),le===void 0&&(le=!1),pe===void 0&&(pe=!1);var _e,He,We=Z,qe,Ye,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)ut.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,qe.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Ye||(Ze=""),Ye=!1,_e=this.tokenizer.escape(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.tag(Z,le,pe)){Z=Z.substring(_e.raw.length),le=_e.inLink,pe=_e.inRawBlock;var ot=ne[ne.length-1];ot&&_e.type==="text"&&ot.type==="text"?(ot.raw+=_e.raw,ot.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.link(Z)){Z=Z.substring(_e.raw.length),_e.type==="link"&&(_e.tokens=this.inlineTokens(_e.text,[],!0,pe)),ne.push(_e);continue}if(_e=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(_e.raw.length);var nt=ne[ne.length-1];_e.type==="link"?(_e.tokens=this.inlineTokens(_e.text,[],!0,pe),ne.push(_e)):nt&&_e.type==="text"&&nt.type==="text"?(nt.raw+=_e.raw,nt.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.emStrong(Z,We,Ze)){Z=Z.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,pe),ne.push(_e);continue}if(_e=this.tokenizer.codespan(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.br(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.del(Z)){Z=Z.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,pe),ne.push(_e);continue}if(_e=this.tokenizer.autolink(Z,Y)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(!le&&(_e=this.tokenizer.url(Z,Y))){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.inlineText(Z,pe,V)){Z=Z.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(Ze=_e.raw.slice(-1)),Ye=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=_e.raw,He.text+=_e.text):ne.push(_e);continue}if(Z){var ue="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return ne},e(q,null,[{key:"rules",get:function(){return{block:Ae,inline:Ie}}}]),q}(),ae=D.defaults,fe=L.cleanUrl,De=L.escape,Oe=function(){function q(he){this.options=he||ae}var oe=q.prototype;return oe.code=function(Z,ne,le){var pe=(ne||"").match(/\S*/)[0];if(this.options.highlight){var _e=this.options.highlight(Z,pe);_e!=null&&_e!==Z&&(le=!0,Z=_e)}return Z=Z.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+De(pe,!0)+'">'+(le?Z:De(Z,!0))+`</code></pre>
`:"<pre><code>"+(le?Z:De(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ne,le,pe){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+pe.slug(le)+'">'+Z+"</h"+ne+`>
`:"<h"+ne+">"+Z+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ne,le){var pe=ne?"ol":"ul",_e=ne&&le!==1?' start="'+le+'"':"";return"<"+pe+_e+`>
`+Z+"</"+pe+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ne+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ne){var le=ne.header?"th":"td",pe=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return pe+Z+"</"+le+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ne,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var pe='<a href="'+De(Z)+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=">"+le+"</a>",pe},oe.image=function(Z,ne,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var pe='<img src="'+Z+'" alt="'+le+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=this.options.xhtml?"/>":">",pe},oe.text=function(Z){return Z},q}(),be=function(){function q(){}var oe=q.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ne,le){return""+le},oe.image=function(Z,ne,le){return""+le},oe.br=function(){return""},q}(),ke=function(){function q(){this.seen={}}var oe=q.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ne){var le=Z,pe=0;if(this.seen.hasOwnProperty(le)){pe=this.seen[Z];do pe++,le=Z+"-"+pe;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[Z]=pe,this.seen[le]=0),le},oe.slug=function(Z,ne){ne===void 0&&(ne={});var le=this.serialize(Z);return this.getNextSafeSlug(le,ne.dryrun)},q}(),Te=D.defaults,xe=L.unescape,Se=function(){function q(he){this.options=he||Te,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}q.parse=function(Z,ne){var le=new q(ne);return le.parse(Z)},q.parseInline=function(Z,ne){var le=new q(ne);return le.parseInline(Z)};var oe=q.prototype;return oe.parse=function(Z,ne){ne===void 0&&(ne=!0);var le="",pe,_e,He,We,qe,Ye,Ze,ut,ot,nt,ue,Ce,ce,J,Re,Le,Je,Ge,rt=Z.length;for(pe=0;pe<rt;pe++)switch(nt=Z[pe],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,xe(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ut="",Ze="",We=nt.header.length,_e=0;_e<We;_e++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[_e]),{header:!0,align:nt.align[_e]});for(ut+=this.renderer.tablerow(Ze),ot="",We=nt.cells.length,_e=0;_e<We;_e++){for(Ye=nt.tokens.cells[_e],Ze="",qe=Ye.length,He=0;He<qe;He++)Ze+=this.renderer.tablecell(this.parseInline(Ye[He]),{header:!1,align:nt.align[He]});ot+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),le+=this.renderer.blockquote(ot);continue}case"list":{for(ue=nt.ordered,Ce=nt.start,ce=nt.loose,We=nt.items.length,ot="",_e=0;_e<We;_e++)Re=nt.items[_e],Le=Re.checked,Je=Re.task,J="",Re.task&&(Ge=this.renderer.checkbox(Le),ce?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=Ge+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ge+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ge}):J+=Ge),J+=this.parse(Re.tokens,ce),ot+=this.renderer.listitem(J,Je,Le);le+=this.renderer.list(ot,ue,Ce);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;pe+1<rt&&Z[pe+1].type==="text";)nt=Z[++pe],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=ne?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return le},oe.parseInline=function(Z,ne){ne=ne||this.renderer;var le="",pe,_e,He=Z.length;for(pe=0;pe<He;pe++)switch(_e=Z[pe],_e.type){case"escape":{le+=ne.text(_e.text);break}case"html":{le+=ne.html(_e.text);break}case"link":{le+=ne.link(_e.href,_e.title,this.parseInline(_e.tokens,ne));break}case"image":{le+=ne.image(_e.href,_e.title,_e.text);break}case"strong":{le+=ne.strong(this.parseInline(_e.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(_e.tokens,ne));break}case"codespan":{le+=ne.codespan(_e.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(_e.tokens,ne));break}case"text":{le+=ne.text(_e.text);break}default:{var We='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}return le},q}(),Ke=L.merge,G=L.checkSanitizeDeprecation,re=L.escape,Ee=D.getDefaults,Ne=D.changeDefaults,Ve=D.defaults;function Be(q,oe,he){if(typeof q=="undefined"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof oe=="function"&&(he=oe,oe=null),oe=Ke({},Be.defaults,oe||{}),G(oe),he){var Z=oe.highlight,ne;try{ne=te.lex(q,oe)}catch(He){return he(He)}var le=function(We){var qe;if(!We)try{qe=Se.parse(ne,oe)}catch(Ye){We=Ye}return oe.highlight=Z,We?he(We):he(null,qe)};if(!Z||Z.length<3||(delete oe.highlight,!ne.length))return le();var pe=0;Be.walkTokens(ne,function(He){He.type==="code"&&(pe++,setTimeout(function(){Z(He.text,He.lang,function(We,qe){if(We)return le(We);qe!=null&&qe!==He.text&&(He.text=qe,He.escaped=!0),pe--,pe===0&&le()})},0))}),pe===0&&le();return}try{var _e=te.lex(q,oe);return oe.walkTokens&&Be.walkTokens(_e,oe.walkTokens),Se.parse(_e,oe)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(He.message+"",!0)+"</pre>";throw He}}Be.options=Be.setOptions=function(q){return Ke(Be.defaults,q),Ne(Be.defaults),Be},Be.getDefaults=Ee,Be.defaults=Ve,Be.use=function(q){var oe=Ke({},q);if(q.renderer&&function(){var Z=Be.defaults.renderer||new Oe,ne=function(_e){var He=Z[_e];Z[_e]=function(){for(var We=arguments.length,qe=new Array(We),Ye=0;Ye<We;Ye++)qe[Ye]=arguments[Ye];var Ze=q.renderer[_e].apply(Z,qe);return Ze===!1&&(Ze=He.apply(Z,qe)),Ze}};for(var le in q.renderer)ne(le);oe.renderer=Z}(),q.tokenizer&&function(){var Z=Be.defaults.tokenizer||new M,ne=function(_e){var He=Z[_e];Z[_e]=function(){for(var We=arguments.length,qe=new Array(We),Ye=0;Ye<We;Ye++)qe[Ye]=arguments[Ye];var Ze=q.tokenizer[_e].apply(Z,qe);return Ze===!1&&(Ze=He.apply(Z,qe)),Ze}};for(var le in q.tokenizer)ne(le);oe.tokenizer=Z}(),q.walkTokens){var he=Be.defaults.walkTokens;oe.walkTokens=function(Z){q.walkTokens(Z),he&&he(Z)}}Be.setOptions(oe)},Be.walkTokens=function(q,oe){for(var he=T(q),Z;!(Z=he()).done;){var ne=Z.value;switch(oe(ne),ne.type){case"table":{for(var le=T(ne.tokens.header),pe;!(pe=le()).done;){var _e=pe.value;Be.walkTokens(_e,oe)}for(var He=T(ne.tokens.cells),We;!(We=He()).done;)for(var qe=We.value,Ye=T(qe),Ze;!(Ze=Ye()).done;){var ut=Ze.value;Be.walkTokens(ut,oe)}break}case"list":{Be.walkTokens(ne.items,oe);break}default:ne.tokens&&Be.walkTokens(ne.tokens,oe)}}},Be.parseInline=function(q,oe){if(typeof q=="undefined"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");oe=Ke({},Be.defaults,oe||{}),G(oe);try{var he=te.lexInline(q,oe);return oe.walkTokens&&Be.walkTokens(he,oe.walkTokens),Se.parseInline(he,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Z.message+"",!0)+"</pre>";throw Z}},Be.Parser=Se,Be.parser=Se.parse,Be.Renderer=Oe,Be.TextRenderer=be,Be.Lexer=te,Be.lexer=te.lex,Be.Tokenizer=M,Be.Slugger=ke,Be.parse=Be;var et=Be;return et}),define(ge[72],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(D,A,y){return Math.min(Math.max(D,A),y)}e.clamp=E;function I(D,A){return(A+D%A)%A}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function Q(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function D(y){P.push(y,Date.now())}function A(){const y=[];for(let i=0;i<P.length;i+=2)y.push({name:P[i],startTime:P[i+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(T+D.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function E(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=E(I))})(),define(ge[9],ve([0,1]),function(Q,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,P=!1,D=!1,A=!1,y=!1,i=!1,R=!1,C,w=I,g,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const S=typeof((E=d==null?void 0:d.versions)===null||E===void 0?void 0:E.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=S&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)s=navigator.userAgent,T=s.indexOf("Windows")>=0,P=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,i=!0,C=navigator.language,w=C;else if(typeof d=="object"){T=d.platform==="win32",P=d.platform==="darwin",D=d.platform==="linux",A=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=I,w=I;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),h=l.availableLanguages["*"];C=l.locale,w=h||I,g=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let p=0;P?p=1:T?p=3:D&&(p=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=D,e.isLinuxSnap=A,e.isNative=y,e.isWeb=i,e.isIOS=R,e.platform=p,e.userAgent=s,e.language=w;var u;(function(r){function l(){return e.language}r.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function m(){return e.language==="en"}r.isDefault=m})(u=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeSetImmediateId)for(let c=0,f=h.length;c<f;c++){const k=h[c];if(k.id===b.data.vscodeSetImmediateId){h.splice(c,1),k.callback();return}}});let m=0;return b=>{const c=++m;h.push({id:c,callback:b}),e.globals.postMessage({vscodeSetImmediateId:c},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const l=Promise.resolve();return h=>l.then(h)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||R?2:T?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[36],ve([0,1,9]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof E.globals.vscode!="undefined"){const T=E.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(P){return(0,E.setImmediate)(P)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(T){return(0,E.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],ve([0,1,36]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,P=90,D=122,A=46,y=47,i=92,R=58,C=63;class w extends Error{constructor(u,a,t){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${o} ${n} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(p,u){if(typeof p!="string")throw new w(u,"string",p)}function s(p){return p===y||p===i}function d(p){return p===y}function S(p){return p>=I&&p<=P||p>=T&&p<=D}function v(p,u,a,t){let n="",o=0,r=-1,l=0,h=0;for(let m=0;m<=p.length;++m){if(m<p.length)h=p.charCodeAt(m);else{if(t(h))break;h=y}if(t(h)){if(!(r===m-1||l===1))if(l===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const b=n.lastIndexOf(a);b===-1?(n="",o=0):(n=n.slice(0,b),o=n.length-1-n.lastIndexOf(a)),r=m,l=0;continue}else if(n.length!==0){n="",o=0,r=m,l=0;continue}}u&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${p.slice(r+1,m)}`:n=p.slice(r+1,m),o=m-r-1;r=m,l=0}else h===A&&l!==-1?++l:l=-1}return n}function _(p,u){if(u===null||typeof u!="object")throw new w("pathObject","Object",u);const a=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return a?a===u.root?`${a}${t}`:`${a}${p}${t}`:t}e.win32={resolve(...p){let u="",a="",t=!1;for(let n=p.length-1;n>=-1;n--){let o;if(n>=0){if(o=p[n],g(o,"path"),o.length===0)continue}else u.length===0?o=E.cwd():(o=E.env[`=${u}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${u}\\`));const r=o.length;let l=0,h="",m=!1;const b=o.charCodeAt(0);if(r===1)s(b)&&(l=1,m=!0);else if(s(b))if(m=!0,s(o.charCodeAt(1))){let c=2,f=c;for(;c<r&&!s(o.charCodeAt(c));)c++;if(c<r&&c!==f){const k=o.slice(f,c);for(f=c;c<r&&s(o.charCodeAt(c));)c++;if(c<r&&c!==f){for(f=c;c<r&&!s(o.charCodeAt(c));)c++;(c===r||c!==f)&&(h=`\\\\${k}\\${o.slice(f,c)}`,l=c)}}}else l=1;else S(b)&&o.charCodeAt(1)===R&&(h=o.slice(0,2),l=2,r>2&&s(o.charCodeAt(2))&&(m=!0,l=3));if(h.length>0)if(u.length>0){if(h.toLowerCase()!==u.toLowerCase())continue}else u=h;if(t){if(u.length>0)break}else if(a=`${o.slice(l)}\\${a}`,t=m,m&&u.length>0)break}return a=v(a,!t,"\\",s),t?`${u}\\${a}`:`${u}${a}`||"."},normalize(p){g(p,"path");const u=p.length;if(u===0)return".";let a=0,t,n=!1;const o=p.charCodeAt(0);if(u===1)return d(o)?"\\":p;if(s(o))if(n=!0,s(p.charCodeAt(1))){let l=2,h=l;for(;l<u&&!s(p.charCodeAt(l));)l++;if(l<u&&l!==h){const m=p.slice(h,l);for(h=l;l<u&&s(p.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&!s(p.charCodeAt(l));)l++;if(l===u)return`\\\\${m}\\${p.slice(h)}\\`;l!==h&&(t=`\\\\${m}\\${p.slice(h,l)}`,a=l)}}}else a=1;else S(o)&&p.charCodeAt(1)===R&&(t=p.slice(0,2),a=2,u>2&&s(p.charCodeAt(2))&&(n=!0,a=3));let r=a<u?v(p.slice(a),!n,"\\",s):"";return r.length===0&&!n&&(r="."),r.length>0&&s(p.charCodeAt(u-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(p){g(p,"path");const u=p.length;if(u===0)return!1;const a=p.charCodeAt(0);return s(a)||u>2&&S(a)&&p.charCodeAt(1)===R&&s(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let u,a;for(let o=0;o<p.length;++o){const r=p[o];g(r,"path"),r.length>0&&(u===void 0?u=a=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof a=="string"&&s(a.charCodeAt(0))){++n;const o=a.length;o>1&&s(a.charCodeAt(1))&&(++n,o>2&&(s(a.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&s(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(p,u){if(g(p,"from"),g(u,"to"),p===u)return"";const a=e.win32.resolve(p),t=e.win32.resolve(u);if(a===t||(p=a.toLowerCase(),u=t.toLowerCase(),p===u))return"";let n=0;for(;n<p.length&&p.charCodeAt(n)===i;)n++;let o=p.length;for(;o-1>n&&p.charCodeAt(o-1)===i;)o--;const r=o-n;let l=0;for(;l<u.length&&u.charCodeAt(l)===i;)l++;let h=u.length;for(;h-1>l&&u.charCodeAt(h-1)===i;)h--;const m=h-l,b=r<m?r:m;let c=-1,f=0;for(;f<b;f++){const L=p.charCodeAt(n+f);if(L!==u.charCodeAt(l+f))break;L===i&&(c=f)}if(f!==b){if(c===-1)return t}else{if(m>b){if(u.charCodeAt(l+f)===i)return t.slice(l+f+1);if(f===2)return t.slice(l+f)}r>b&&(p.charCodeAt(n+f)===i?c=f:f===2&&(c=3)),c===-1&&(c=0)}let k="";for(f=n+c+1;f<=o;++f)(f===o||p.charCodeAt(f)===i)&&(k+=k.length===0?"..":"\\..");return l+=c,k.length>0?`${k}${t.slice(l,h)}`:(t.charCodeAt(l)===i&&++l,t.slice(l,h))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const u=e.win32.resolve(p);if(u.length<=2)return p;if(u.charCodeAt(0)===i){if(u.charCodeAt(1)===i){const a=u.charCodeAt(2);if(a!==C&&a!==A)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===R&&u.charCodeAt(2)===i)return`\\\\?\\${u}`;return p},dirname(p){g(p,"path");const u=p.length;if(u===0)return".";let a=-1,t=0;const n=p.charCodeAt(0);if(u===1)return s(n)?p:".";if(s(n)){if(a=t=1,s(p.charCodeAt(1))){let l=2,h=l;for(;l<u&&!s(p.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&s(p.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&!s(p.charCodeAt(l));)l++;if(l===u)return p;l!==h&&(a=t=l+1)}}}}else S(n)&&p.charCodeAt(1)===R&&(a=u>2&&s(p.charCodeAt(2))?3:2,t=a);let o=-1,r=!0;for(let l=u-1;l>=t;--l)if(s(p.charCodeAt(l))){if(!r){o=l;break}}else r=!1;if(o===-1){if(a===-1)return".";o=a}return p.slice(0,o)},basename(p,u){u!==void 0&&g(u,"ext"),g(p,"path");let a=0,t=-1,n=!0,o;if(p.length>=2&&S(p.charCodeAt(0))&&p.charCodeAt(1)===R&&(a=2),u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let r=u.length-1,l=-1;for(o=p.length-1;o>=a;--o){const h=p.charCodeAt(o);if(s(h)){if(!n){a=o+1;break}}else l===-1&&(n=!1,l=o+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return a===t?t=l:t===-1&&(t=p.length),p.slice(a,t)}for(o=p.length-1;o>=a;--o)if(s(p.charCodeAt(o))){if(!n){a=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let u=0,a=-1,t=0,n=-1,o=!0,r=0;p.length>=2&&p.charCodeAt(1)===R&&S(p.charCodeAt(0))&&(u=t=2);for(let l=p.length-1;l>=u;--l){const h=p.charCodeAt(l);if(s(h)){if(!o){t=l+1;break}continue}n===-1&&(o=!1,n=l+1),h===A?a===-1?a=l:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||n===-1||r===0||r===1&&a===n-1&&a===t+1?"":p.slice(a,n)},format:_.bind(null,"\\"),parse(p){g(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const a=p.length;let t=0,n=p.charCodeAt(0);if(a===1)return s(n)?(u.root=u.dir=p,u):(u.base=u.name=p,u);if(s(n)){if(t=1,s(p.charCodeAt(1))){let c=2,f=c;for(;c<a&&!s(p.charCodeAt(c));)c++;if(c<a&&c!==f){for(f=c;c<a&&s(p.charCodeAt(c));)c++;if(c<a&&c!==f){for(f=c;c<a&&!s(p.charCodeAt(c));)c++;c===a?t=c:c!==f&&(t=c+1)}}}}else if(S(n)&&p.charCodeAt(1)===R){if(a<=2)return u.root=u.dir=p,u;if(t=2,s(p.charCodeAt(2))){if(a===3)return u.root=u.dir=p,u;t=3}}t>0&&(u.root=p.slice(0,t));let o=-1,r=t,l=-1,h=!0,m=p.length-1,b=0;for(;m>=t;--m){if(n=p.charCodeAt(m),s(n)){if(!h){r=m+1;break}continue}l===-1&&(h=!1,l=m+1),n===A?o===-1?o=m:b!==1&&(b=1):o!==-1&&(b=-1)}return l!==-1&&(o===-1||b===0||b===1&&o===l-1&&o===r+1?u.base=u.name=p.slice(r,l):(u.name=p.slice(r,o),u.base=p.slice(r,l),u.ext=p.slice(o,l))),r>0&&r!==t?u.dir=p.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let u="",a=!1;for(let t=p.length-1;t>=-1&&!a;t--){const n=t>=0?p[t]:E.cwd();g(n,"path"),n.length!==0&&(u=`${n}/${u}`,a=n.charCodeAt(0)===y)}return u=v(u,!a,"/",d),a?`/${u}`:u.length>0?u:"."},normalize(p){if(g(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y,a=p.charCodeAt(p.length-1)===y;return p=v(p,!u,"/",d),p.length===0?u?"/":a?"./":".":(a&&(p+="/"),u?`/${p}`:p)},isAbsolute(p){return g(p,"path"),p.length>0&&p.charCodeAt(0)===y},join(...p){if(p.length===0)return".";let u;for(let a=0;a<p.length;++a){const t=p[a];g(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(p,u){if(g(p,"from"),g(u,"to"),p===u||(p=e.posix.resolve(p),u=e.posix.resolve(u),p===u))return"";const a=1,t=p.length,n=t-a,o=1,r=u.length-o,l=n<r?n:r;let h=-1,m=0;for(;m<l;m++){const c=p.charCodeAt(a+m);if(c!==u.charCodeAt(o+m))break;c===y&&(h=m)}if(m===l)if(r>l){if(u.charCodeAt(o+m)===y)return u.slice(o+m+1);if(m===0)return u.slice(o+m)}else n>l&&(p.charCodeAt(a+m)===y?h=m:m===0&&(h=0));let b="";for(m=a+h+1;m<=t;++m)(m===t||p.charCodeAt(m)===y)&&(b+=b.length===0?"..":"/..");return`${b}${u.slice(o+h)}`},toNamespacedPath(p){return p},dirname(p){if(g(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y;let a=-1,t=!0;for(let n=p.length-1;n>=1;--n)if(p.charCodeAt(n)===y){if(!t){a=n;break}}else t=!1;return a===-1?u?"/":".":u&&a===1?"//":p.slice(0,a)},basename(p,u){u!==void 0&&g(u,"ext"),g(p,"path");let a=0,t=-1,n=!0,o;if(u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let r=u.length-1,l=-1;for(o=p.length-1;o>=0;--o){const h=p.charCodeAt(o);if(h===y){if(!n){a=o+1;break}}else l===-1&&(n=!1,l=o+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return a===t?t=l:t===-1&&(t=p.length),p.slice(a,t)}for(o=p.length-1;o>=0;--o)if(p.charCodeAt(o)===y){if(!n){a=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let u=-1,a=0,t=-1,n=!0,o=0;for(let r=p.length-1;r>=0;--r){const l=p.charCodeAt(r);if(l===y){if(!n){a=r+1;break}continue}t===-1&&(n=!1,t=r+1),l===A?u===-1?u=r:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===a+1?"":p.slice(u,t)},format:_.bind(null,"/"),parse(p){g(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const a=p.charCodeAt(0)===y;let t;a?(u.root="/",t=1):t=0;let n=-1,o=0,r=-1,l=!0,h=p.length-1,m=0;for(;h>=t;--h){const b=p.charCodeAt(h);if(b===y){if(!l){o=h+1;break}continue}r===-1&&(l=!1,r=h+1),b===A?n===-1?n=h:m!==1&&(m=1):n!==-1&&(m=-1)}if(r!==-1){const b=o===0&&a?1:o;n===-1||m===0||m===1&&n===r-1&&n===o+1?u.base=u.name=p.slice(b,r):(u.name=p.slice(b,n),u.base=p.slice(b,r),u.ext=p.slice(n,r))}return o>0?u.dir=p.slice(0,o-1):a&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...D){const A=D.reduce((R,C)=>(R[C]=!0,R),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(R=>!A[R]).forEach(R=>{for(let C=0;C<y.length;C++)if(R.search(y[C])!==-1){delete P[R];break}})}e.sanitizeProcessEnvironment=T}),define(ge[46],ve([0,1,9]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=E.globals.performance&&typeof E.globals.performance.now=="function";class T{constructor(D){this._highResolution=I&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new T(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],ve([0,1,17,69,6,55,46]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var A;(function(v){v.None=()=>T.Disposable.None;function _(H){return(x,B=null,F)=>{let U=!1,M;return M=H(N=>{if(!U)return M?M.dispose():U=!0,x.call(B,N)},null,F),U&&M.dispose(),M}}v.once=_;function p(H,x){return r((B,F=null,U)=>H(M=>B.call(F,x(M)),null,U))}v.map=p;function u(H,x){return r((B,F=null,U)=>H(M=>{x(M),B.call(F,M)},null,U))}v.forEach=u;function a(H,x){return r((B,F=null,U)=>H(M=>x(M)&&B.call(F,M),null,U))}v.filter=a;function t(H){return H}v.signal=t;function n(...H){return(x,B=null,F)=>(0,T.combinedDisposable)(...H.map(U=>U(M=>x.call(B,M),null,F)))}v.any=n;function o(H,x,B){let F=B;return p(H,U=>(F=x(F,U),F))}v.reduce=o;function r(H){let x;const B=new w({onFirstListenerAdd(){x=H(B.fire,B)},onLastListenerRemove(){x.dispose()}});return B.event}v.snapshot=r;function l(H,x,B=100,F=!1,U){let M,N,O,j=0;const K=new w({leakWarningThreshold:U,onFirstListenerAdd(){M=H(X=>{j++,N=x(N,X),F&&!O&&(K.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const me=N;N=void 0,O=void 0,(!F||j>1)&&K.fire(me),j=0},B)})},onLastListenerRemove(){M.dispose()}});return K.event}v.debounce=l;function h(H){const x=new Date().getTime();return p(_(H),B=>new Date().getTime()-x)}v.stopwatch=h;function m(H){let x=!0,B;return a(H,F=>{const U=x||F!==B;return x=!1,B=F,U})}v.latch=m;function b(H,x=!1,B=[]){let F=B.slice(),U=H(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new w({onFirstListenerAdd(){U||(U=H(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}v.buffer=b;class c{constructor(x){this.event=x}map(x){return new c(p(this.event,x))}forEach(x){return new c(u(this.event,x))}filter(x){return new c(a(this.event,x))}reduce(x,B){return new c(o(this.event,x,B))}latch(){return new c(m(this.event))}debounce(x,B=100,F=!1,U){return new c(l(this.event,x,B,F,U))}on(x,B,F){return this.event(x,B,F)}once(x,B,F){return _(this.event)(x,B,F)}}function f(H){return new c(H)}v.chain=f;function k(H,x,B=F=>F){const F=(...O)=>N.fire(B(...O)),U=()=>H.on(x,F),M=()=>H.removeListener(x,F),N=new w({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromNodeEventEmitter=k;function L(H,x,B=F=>F){const F=(...O)=>N.fire(B(...O)),U=()=>H.addEventListener(x,F),M=()=>H.removeEventListener(x,F),N=new w({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromDOMEventEmitter=L;function $(H){const x=new w;let B=!1;return H.then(void 0,()=>null).then(()=>{B?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),B=!0,x.event}v.fromPromise=$;function ee(H){return new Promise(x=>_(H)(x))}v.toPromise=ee})(A=e.Event||(e.Event={}));class y{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${y._idPool++}`}start(_){this._stopWatch=new D.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function R(v){const _=i;return i=v,{dispose(){i=_}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(_,p=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let p=i;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||_<p)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(u)||0;if(this._stacks.set(u,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,n=0;for(const[o,r]of this._stacks)(!t||n<r)&&(t=o,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class w{constructor(_){var p;this._disposed=!1,this._options=_,this._leakageMon=i>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(_,p,u)=>{var a;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(p?[_,p]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,p);const o=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=w._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof T.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(_){var p,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,_]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(n){(0,E.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var _,p,u;(_=this._listeners)===null||_===void 0||_.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=w,w._noop=function(){};class g extends w{constructor(_){super(_);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=g;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const p={event:_,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const u=()=>{this.hasListeners&&this.unhook(p);const a=this.events.indexOf(p);this.events.splice(a,1)};return(0,T.toDisposable)((0,I.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(p=>this.emitter.fire(p))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class d{constructor(){this.buffers=[]}wrapEvent(_){return(p,u,a)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(u,t)):p.call(u,t)},void 0,a)}bufferEvents(_){const p=[];this.buffers.push(p);const u=_();return this.buffers.pop(),p.forEach(a=>a()),u}}e.EventBufferer=d;class S{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=T.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],ve([0,1,3]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(A,y){const i=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(i)}}});var T;(function(A){function y(i){return i===A.None||i===A.Cancelled||i instanceof P?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=D}),define(ge[47],ve([0,1,3]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function P(i,R){return new D(i,R)}e.registerCodicon=P;class D{constructor(R,C,w){this.id=R,this.definition=C,this.description=w,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function A(i,R){const C=["codicon","codicon-"+i];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=A;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function C(s){if(s instanceof D)return["codicon","codicon-"+s.id];const d=R.exec(s.id);if(!d)return C(D.error);let[,S,v]=d;const _=["codicon","codicon-"+S];return v&&_.push("codicon-modifier-"+v.substr(1)),_}i.asClassNameArray=C;function w(s){return C(s).join(" ")}i.asClassName=w;function g(s){return"."+C(s).join(".")}i.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ge[91],ve([0,1,17,6]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(S){const v=S;return v&&[v.on,v.pause,v.resume,v.destroy].every(_=>typeof _=="function")}e.isReadableStream=T;function P(S){const v=S;return v&&T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=P;function D(S,v){return new A(S,v)}e.newWriteableStream=D;class A{constructor(v,_){this.reducer=v,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var _;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((_=this.options)===null||_===void 0?void 0:_.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(_=>_(v))}emitError(v){this.listeners.error.length===0?(0,E.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(_=>_(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,_){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(v,_){if(!this.state.destroyed){let p;switch(v){case"data":p=this.listeners.data;break;case"end":p=this.listeners.end;break;case"error":p=this.listeners.error;break}if(p){const u=p.indexOf(_);u>=0&&p.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(p=>p())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,v){const _=[];let p;for(;(p=S.read())!==null;)_.push(p);return v(_)}e.consumeReadable=y;function i(S,v,_){const p=[];let u;for(;(u=S.read())!==null&&p.length<_;)p.push(u);return u===null&&p.length>0?v(p):{read:()=>{if(p.length>0)return p.shift();if(typeof u!="undefined"){const a=u;return u=void 0,a}return S.read()}}}e.peekReadable=i;function R(S,v){return new Promise((_,p)=>{const u=[];C(S,{onData:a=>{v&&u.push(a)},onError:a=>{v?p(a):_(void 0)},onEnd:()=>{_(v?v(u):void 0)}})})}e.consumeStream=R;function C(S,v){S.on("error",_=>v.onError(_)),S.on("end",()=>v.onEnd()),S.on("data",_=>v.onData(_))}e.listenStream=C;function w(S,v){return new Promise((_,p)=>{const u=new I.DisposableStore,a=[],t=r=>{if(a.push(r),a.length>v)return u.dispose(),S.pause(),_({stream:S,buffer:a,ended:!1})},n=r=>p(r),o=()=>_({stream:S,buffer:a,ended:!0});u.add((0,I.toDisposable)(()=>S.removeListener("error",n))),S.on("error",n),u.add((0,I.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),u.add((0,I.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=w;function g(S,v){const _=D(v);return _.end(S),_}e.toStream=g;function s(S){let v=!1;return{read:()=>v?null:(v=!0,S)}}e.toReadable=s;function d(S,v,_){const p=D(_);return C(S,{onData:u=>p.write(v.data(u)),onError:u=>p.error(v.error?v.error(u):u),onEnd:()=>p.end()}),p}e.transform=d}),define(ge[10],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=E;const I=/{(\d+)}/g;function T(q,...oe){return oe.length===0?q:q.replace(I,function(he,Z){const ne=parseInt(Z,10);return isNaN(ne)||ne<0||ne>=oe.length?he:oe[ne]})}e.format=T;function P(q){return q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function D(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function A(q,oe){let he=0;const Z=oe.charCodeAt(0);for(let ne=q.length-1;ne>=0;ne--)q.charCodeAt(ne)===Z&&he++;return he}e.count=A;function y(q,oe,he="\u2026"){return q.length<=oe?q:`${q.substr(0,oe)}${he}`}e.truncate=y;function i(q,oe=" "){const he=R(q,oe);return C(he,oe)}e.trim=i;function R(q,oe){if(!q||!oe)return q;const he=oe.length;if(he===0||q.length===0)return q;let Z=0;for(;q.indexOf(oe,Z)===Z;)Z=Z+he;return q.substring(Z)}e.ltrim=R;function C(q,oe){if(!q||!oe)return q;const he=oe.length,Z=q.length;if(he===0||Z===0)return q;let ne=Z,le=-1;for(;le=q.lastIndexOf(oe,ne-1),!(le===-1||le+he!==ne);){if(le===0)return"";ne=le}return q.substring(0,ne)}e.rtrim=C;function w(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function g(q){return q.replace(/\*/g,"")}e.stripWildcards=g;function s(q,oe,he={}){if(!q)throw new Error("Cannot create regex from empty string");oe||(q=D(q)),he.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Z="";return he.global&&(Z+="g"),he.matchCase||(Z+="i"),he.multiline&&(Z+="m"),he.unicode&&(Z+="u"),new RegExp(q,Z)}e.createRegExp=s;function d(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function S(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=v;function _(q){return q.split(/\r\n|\r|\n/)}e.splitLines=_;function p(q){for(let oe=0,he=q.length;oe<he;oe++){const Z=q.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=p;function u(q,oe=0,he=q.length){for(let Z=oe;Z<he;Z++){const ne=q.charCodeAt(Z);if(ne!==32&&ne!==9)return q.substring(oe,Z)}return q.substring(oe,he)}e.getLeadingWhitespace=u;function a(q,oe=q.length-1){for(let he=oe;he>=0;he--){const Z=q.charCodeAt(he);if(Z!==32&&Z!==9)return he}return-1}e.lastNonWhitespaceIndex=a;function t(q,oe){return q<oe?-1:q>oe?1:0}e.compare=t;function n(q,oe,he=0,Z=q.length,ne=0,le=oe.length){for(;he<Z&&ne<le;he++,ne++){let He=q.charCodeAt(he),We=oe.charCodeAt(ne);if(He<We)return-1;if(He>We)return 1}const pe=Z-he,_e=le-ne;return pe<_e?-1:pe>_e?1:0}e.compareSubstring=n;function o(q,oe){return r(q,oe,0,q.length,0,oe.length)}e.compareIgnoreCase=o;function r(q,oe,he=0,Z=q.length,ne=0,le=oe.length){for(;he<Z&&ne<le;he++,ne++){let He=q.charCodeAt(he),We=oe.charCodeAt(ne);if(He!==We){const qe=He-We;if(!(qe===32&&h(We))&&!(qe===-32&&h(He)))return l(He)&&l(We)?qe:n(q.toLowerCase(),oe.toLowerCase(),he,Z,ne,le)}}const pe=Z-he,_e=le-ne;return pe<_e?-1:pe>_e?1:0}e.compareSubstringIgnoreCase=r;function l(q){return q>=97&&q<=122}e.isLowerAsciiLetter=l;function h(q){return q>=65&&q<=90}e.isUpperAsciiLetter=h;function m(q){return l(q)||h(q)}function b(q,oe){return q.length===oe.length&&c(q,oe)}e.equalsIgnoreCase=b;function c(q,oe,he=q.length){for(let Z=0;Z<he;Z++){const ne=q.charCodeAt(Z),le=oe.charCodeAt(Z);if(ne!==le){if(m(ne)&&m(le)){const pe=Math.abs(ne-le);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function f(q,oe){const he=oe.length;return oe.length>q.length?!1:c(q,oe,he)}e.startsWithIgnoreCase=f;function k(q,oe){let he,Z=Math.min(q.length,oe.length);for(he=0;he<Z;he++)if(q.charCodeAt(he)!==oe.charCodeAt(he))return he;return Z}e.commonPrefixLength=k;function L(q,oe){let he,Z=Math.min(q.length,oe.length);const ne=q.length-1,le=oe.length-1;for(he=0;he<Z;he++)if(q.charCodeAt(ne-he)!==oe.charCodeAt(le-he))return he;return Z}e.commonSuffixLength=L;function $(q){return 55296<=q&&q<=56319}e.isHighSurrogate=$;function ee(q){return 56320<=q&&q<=57343}e.isLowSurrogate=ee;function H(q,oe){return(q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=H;function x(q,oe,he){const Z=q.charCodeAt(he);if($(Z)&&he+1<oe){const ne=q.charCodeAt(he+1);if(ee(ne))return H(Z,ne)}return Z}e.getNextCodePoint=x;function B(q,oe){const he=q.charCodeAt(oe-1);if(ee(he)&&oe>1){const Z=q.charCodeAt(oe-2);if($(Z))return H(Z,he)}return he}function F(q,oe){const he=Be.getInstance(),Z=oe,ne=q.length,le=x(q,ne,oe);oe+=le>=65536?2:1;let pe=he.getGraphemeBreakType(le);for(;oe<ne;){const _e=x(q,ne,oe),He=he.getGraphemeBreakType(_e);if(Ne(pe,He))break;oe+=_e>=65536?2:1,pe=He}return oe-Z}e.nextCharLength=F;function U(q,oe){const he=Be.getInstance(),Z=oe,ne=B(q,oe);oe-=ne>=65536?2:1;let le=he.getGraphemeBreakType(ne);for(;oe>0;){const pe=B(q,oe),_e=he.getGraphemeBreakType(pe);if(Ne(_e,le))break;oe-=pe>=65536?2:1,le=_e}return Z-oe}e.prevCharLength=U;function M(q,oe){const he=Be.getInstance(),Z=q.length,ne=oe,le=x(q,Z,oe),pe=he.getGraphemeBreakType(le);oe+=le>=65536?2:1;let _e=pe;for(;oe<Z;){const We=x(q,Z,oe),qe=he.getGraphemeBreakType(We);if(Ne(_e,qe))break;oe+=We>=65536?2:1,_e=qe}const He=oe;for(oe=ne,_e=pe;oe>0;){const We=B(q,oe),qe=he.getGraphemeBreakType(We);if(Ne(qe,_e))break;oe-=We>=65536?2:1,_e=qe}return[oe,He]}function N(q,oe){return oe>0&&ee(q.charCodeAt(oe))?M(q,oe-1):M(q,oe)}e.getCharContainingOffset=N;function O(q){const oe=q.length;let he=0,Z=0;for(;Z<oe;){const pe=x(q,oe,Z);Z+=pe>=65536?2:1,pe<128?he+=1:pe<2048?he+=2:pe<65536?he+=3:he+=4}const ne=new Uint8Array(he);Z=0;let le=0;for(;Z<oe;){const pe=x(q,oe,Z);Z+=pe>=65536?2:1,pe<128?ne[le++]=pe:pe<2048?(ne[le++]=192|(pe&1984)>>>6,ne[le++]=128|(pe&63)>>>0):pe<65536?(ne[le++]=224|(pe&61440)>>>12,ne[le++]=128|(pe&4032)>>>6,ne[le++]=128|(pe&63)>>>0):(ne[le++]=240|(pe&1835008)>>>18,ne[le++]=128|(pe&258048)>>>12,ne[le++]=128|(pe&4032)>>>6,ne[le++]=128|(pe&63)>>>0)}return ne}e.encodeUTF8=O;function j(q){const oe=q.byteLength,he=[];let Z=0;for(;Z<oe;){const ne=q[Z];let le;if(ne>=240&&Z+3<oe?le=(q[Z++]&7)<<18>>>0|(q[Z++]&63)<<12>>>0|(q[Z++]&63)<<6>>>0|(q[Z++]&63)<<0>>>0:ne>=224&&Z+2<oe?le=(q[Z++]&15)<<12>>>0|(q[Z++]&63)<<6>>>0|(q[Z++]&63)<<0>>>0:ne>=192&&Z+1<oe?le=(q[Z++]&31)<<6>>>0|(q[Z++]&63)<<0>>>0:le=q[Z++],le>=0&&le<=55295||le>=57344&&le<=65535)he.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const pe=le-65536,_e=55296+((pe&1047552)>>>10),He=56320+((pe&1023)>>>0);he.push(String.fromCharCode(_e)),he.push(String.fromCharCode(He))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=j;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(q){return K.test(q)}e.containsRTL=X;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(q){return me.test(q)}e.containsEmoji=we;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ie(q){return Ae.test(q)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=Me;function V(q){for(let oe=0,he=q.length;oe<he;oe++)if(Y(q.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=V;function Y(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=Y;function te(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=te;function ae(q,oe){if(q.length<oe)return q;const he=/\b/g;let Z=0;for(;he.test(q)&&!(q.length-he.lastIndex<oe);)Z=he.lastIndex,he.lastIndex+=1;return q.substring(Z).replace(/^\s/,"")}e.lcut=ae;const fe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(q){return q&&(q=q.replace(fe,""),q=q.replace(De,""),q=q.replace(Oe,"")),q}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(q){return ke(q)?q.substr(1):q}e.stripUTF8BOM=Te;function xe(q,oe){if(!q||!oe||q.length<oe.length)return!1;const he=oe.length,Z=q.toLowerCase();let ne=0,le=-1;for(;ne<he;){const pe=Z.indexOf(oe[ne],le+1);if(pe<0)return!1;le=pe,ne++}return!0}e.fuzzyContains=xe;function Se(q,oe=!1){return q?(oe&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Se;function Ke(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Ke;function G(q,oe=1){if(oe===0)return"";let he=-1;do he=q.indexOf(`
`,he+1),oe--;while(oe>0&&he>=0);return he===-1?q:(q[he-1]==="\r"&&he--,q.substr(0,he))}e.getNLines=G;function re(q){const oe=90-65+1;return q=q%(2*oe),q<oe?String.fromCharCode(97+q):String.fromCharCode(65+q-oe)}e.singleLetterHash=re;function Ee(q){return Be.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Ee;function Ne(q,oe){return q===0?oe!==5&&oe!==7:q===2&&oe===3?!1:q===4||q===2||q===3||oe===4||oe===2||oe===3?!0:!(q===8&&(oe===8||oe===9||oe===11||oe===12)||(q===11||q===9)&&(oe===9||oe===10)||(q===12||q===10)&&oe===10||oe===5||oe===13||oe===7||q===1||q===13&&oe===14||q===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=et()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const he=this._data,Z=he.length/3;let ne=1;for(;ne<=Z;)if(oe<he[3*ne])ne=2*ne;else if(oe>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}Be._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],ve([0,1,10,91]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let A,y;class i{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return T?new i(Buffer.allocUnsafe(l)):new i(new Uint8Array(l))}static wrap(l){return T&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new i(l)}static fromString(l,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&T?new i(Buffer.from(l)):P?(A||(A=new TextEncoder),new i(A.encode(l))):new i(E.encodeUTF8(l))}static concat(l,h){if(typeof h=="undefined"){h=0;for(let c=0,f=l.length;c<f;c++)h+=l[c].byteLength}const m=i.alloc(h);let b=0;for(let c=0,f=l.length;c<f;c++){const k=l[c];m.set(k,b),b+=k.byteLength}return m}toString(){return T?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(l,h){return new i(this.buffer.subarray(l,h))}set(l,h){l instanceof i?this.buffer.set(l.buffer,h):this.buffer.set(l,h)}readUInt32BE(l){return w(this.buffer,l)}writeUInt32BE(l,h){g(this.buffer,l,h)}readUInt32LE(l){return s(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,h){v(this.buffer,l,h)}}e.VSBuffer=i;function R(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=R;function C(r,l,h){r[h+0]=l&255,l=l>>>8,r[h+1]=l&255}e.writeUInt16LE=C;function w(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=w;function g(r,l,h){r[h+3]=l,l=l>>>8,r[h+2]=l,l=l>>>8,r[h+1]=l,l=l>>>8,r[h]=l}e.writeUInt32BE=g;function s(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=s;function d(r,l,h){r[h+0]=l&255,l=l>>>8,r[h+1]=l&255,l=l>>>8,r[h+2]=l&255,l=l>>>8,r[h+3]=l&255}e.writeUInt32LE=d;function S(r,l){return r[l]}e.readUInt8=S;function v(r,l,h){r[h]=l}e.writeUInt8=v;function _(r){return I.consumeReadable(r,l=>i.concat(l))}e.readableToBuffer=_;function p(r){return I.toReadable(r)}e.bufferToReadable=p;function u(r){return I.consumeStream(r,l=>i.concat(l))}e.streamToBuffer=u;async function a(r){return r.ended?i.concat(r.buffer):i.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=a;function t(r){return I.toStream(r,l=>i.concat(l))}e.bufferToStream=t;function n(r){return I.transform(r,{data:l=>typeof l=="string"?i.fromString(l):i.wrap(l)},l=>i.concat(l))}e.streamToBufferReadableStream=n;function o(r){return I.newWriteableStream(l=>i.concat(l),r)}e.newWriteableBufferStream=o}),define(ge[73],ve([0,1,10]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(v){return T(v,0)}e.hash=I;function T(v,_){switch(typeof v){case"object":return v===null?P(349,_):Array.isArray(v)?y(v,_):i(v,_);case"string":return A(v,_);case"boolean":return D(v,_);case"number":return P(v,_);case"undefined":return P(937,_);default:return P(617,_)}}e.doHash=T;function P(v,_){return(_<<5)-_+v|0}function D(v,_){return P(v?433:863,_)}function A(v,_){_=P(149417,_);for(let p=0,u=v.length;p<u;p++)_=P(v.charCodeAt(p),_);return _}e.stringHash=A;function y(v,_){return _=P(104579,_),v.reduce((p,u)=>T(u,p),_)}function i(v,_){return _=P(181387,_),Object.keys(v).sort().reduce((p,u)=>(p=A(u,p),T(v[u],p)),_)}class R{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=T(_,this._value),this._value}}e.Hasher=R;var C;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(v,_,p=32){const u=p-_,a=~((1<<u)-1);return(v<<_|(a&v)>>>u)>>>0}function g(v,_=0,p=v.byteLength,u=0){for(let a=0;a<p;a++)v[_+a]=u}function s(v,_,p="0"){for(;v.length<_;)v=p+v;return v}function d(v,_=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(p=>p.toString(16).padStart(2,"0")).join(""):s((v>>>0).toString(16),_/4)}e.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const p=_.length;if(p!==0){const u=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=_.charCodeAt(0),o=0);;){let r=n;if(E.isHighSurrogate(n))if(o+1<p){const l=_.charCodeAt(o+1);E.isLowSurrogate(l)?(o++,r=E.computeCodePoint(n,l)):r=65533}else{t=n;break}else E.isLowSurrogate(n)&&(r=65533);if(a=this._push(u,a,r),o++,o<p)n=_.charCodeAt(o);else break}this._buffLen=a,this._leftoverHighSurrogate=t}}_push(_,p,u){return u<128?_[p++]=u:u<2048?(_[p++]=192|(u&1984)>>>6,_[p++]=128|(u&63)>>>0):u<65536?(_[p++]=224|(u&61440)>>>12,_[p++]=128|(u&4032)>>>6,_[p++]=128|(u&63)>>>0):(_[p++]=240|(u&1835008)>>>18,_[p++]=128|(u&258048)>>>12,_[p++]=128|(u&4032)>>>6,_[p++]=128|(u&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,p=this._buffDV;for(let m=0;m<64;m+=4)_.setUint32(m,p.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)_.setUint32(m,w(_.getUint32(m-12,!1)^_.getUint32(m-32,!1)^_.getUint32(m-56,!1)^_.getUint32(m-64,!1),1),!1);let u=this._h0,a=this._h1,t=this._h2,n=this._h3,o=this._h4,r,l,h;for(let m=0;m<80;m++)m<20?(r=a&t|~a&n,l=1518500249):m<40?(r=a^t^n,l=1859775393):m<60?(r=a&t|a&n|t&n,l=2400959708):(r=a^t^n,l=3395469782),h=w(u,5)+r+o+l+_.getUint32(m*4,!1)&4294967295,o=n,n=t,t=w(a,30),a=u,u=h;this._h0=this._h0+u&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[56],ve([0,1,10]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const P="error",D="warning",A="warn",y="info";function i(R){return R?E.equalsIgnoreCase(P,R)?T.Error:E.equalsIgnoreCase(D,R)||E.equalsIgnoreCase(A,R)?T.Warning:E.equalsIgnoreCase(y,R)?T.Info:T.Ignore:T.Ignore}T.fromValue=i}(I||(I={})),e.default=I}),define(ge[14],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(h){return Array.isArray(h)}e.isArray=E;function I(h){return typeof h=="string"}e.isString=I;function T(h){return Array.isArray(h)&&h.every(m=>I(m))}e.isStringArray=T;function P(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=P;function D(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=D;function A(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=A;function y(h){return h===!0||h===!1}e.isBoolean=y;function i(h){return typeof h=="undefined"}e.isUndefined=i;function R(h){return!C(h)}e.isDefined=R;function C(h){return i(h)||h===null}e.isUndefinedOrNull=C;function w(h,m){if(!h)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=w;function g(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=g;function s(...h){const m=[];for(let b=0;b<h.length;b++){const c=h[b];if(C(c))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);m.push(c)}return m}e.assertAllDefined=s;const d=Object.prototype.hasOwnProperty;function S(h){if(!P(h))return!1;for(let m in h)if(d.call(h,m))return!1;return!0}e.isEmptyObject=S;function v(h){return typeof h=="function"}e.isFunction=v;function _(...h){return h.length>0&&h.every(v)}e.areFunctions=_;function p(h,m){const b=Math.min(h.length,m.length);for(let c=0;c<b;c++)u(h[c],m[c])}e.validateConstraints=p;function u(h,m){if(I(m)){if(typeof h!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(v(m)){try{if(h instanceof m)return}catch(b){}if(!C(h)&&h.constructor===m||m.length===1&&m.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function a(h){let m=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)m=m.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return m}e.getAllPropertyNames=a;function t(h){const m=[];for(const b of a(h))typeof h[b]=="function"&&m.push(b);return m}e.getAllMethodNames=t;function n(h,m){const b=f=>function(){const k=Array.prototype.slice.call(arguments,0);return m(f,k)};let c={};for(const f of h)c[f]=b(f);return c}e.createProxyObject=n;function o(h){return h===null?void 0:h}e.withNullAsUndefined=o;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function l(h){return class{constructor(){return new Proxy({},{get(m,b){if(m[b])return m[b];throw new Error(`Not Implemented: ${h}->${String(b)}`)}})}}}e.NotImplementedProxy=l}),define(ge[30],ve([0,1,9,10,8,14]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(n){return n===47||n===92}e.isPathSeparator=D;function A(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=A;function y(n,o=T.posix.sep){if(!n)return"";const r=n.length,l=n.charCodeAt(0);if(D(l)){if(D(n.charCodeAt(1))&&!D(n.charCodeAt(2))){let m=3;const b=m;for(;m<r&&!D(n.charCodeAt(m));m++);if(b!==m&&!D(n.charCodeAt(m+1))){for(m+=1;m<r;m++)if(D(n.charCodeAt(m)))return n.slice(0,m+1).replace(/[\\/]/g,o)}}return o}else if(S(l)&&n.charCodeAt(1)===58)return D(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(D(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=y;function i(n){if(!E.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let r=2;const l=r;for(;r<n.length&&(o=n.charCodeAt(r),o!==92);r++);return!(l===r||(o=n.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=i;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,o=E.isWindows){const r=o?R:C;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||o&&w.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function s(n,o,r){const l=n===o;return!r||l?l:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=s;function d(n,o,r,l=T.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let m=o.length;return o.charAt(o.length-1)===l&&m--,n.charAt(m)===l}return o.charAt(o.length-1)!==l&&(o+=l),n.indexOf(o)===0}e.isEqualOrParent=d;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function v(n,o){return E.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(o,n)),n=(0,T.normalize)(n),E.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=v;function _(n){const o=(0,T.normalize)(n);return E.isWindows?n.length>3?!1:p(o)&&(n.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=_;function p(n){return E.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function u(n){return p(n)?n[0]:void 0}e.getDriveLetter=u;function a(n,o,r){return o.length>n.length?-1:n===o?0:(r&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=a;function t(n){const o=n.split(":");let r,l,h;if(o.forEach(m=>{const b=Number(m);(0,P.isNumber)(b)?l===void 0?l=b:h===void 0&&(h=b):r=r?[r,m].join(":"):m}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],ve([0,1,14]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const d=Array.isArray(s)?[]:{};return Object.keys(s).forEach(S=>{s[S]&&typeof s[S]=="object"?d[S]=I(s[S]):d[S]=s[S]}),d}e.deepClone=I;function T(s){if(!s||typeof s!="object")return s;const d=[s];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const v in S)if(P.call(S,v)){const _=S[v];typeof _=="object"&&!Object.isFrozen(_)&&d.push(_)}}return s}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function D(s,d){return A(s,d,new Set)}e.cloneAndChange=D;function A(s,d,S){if((0,E.isUndefinedOrNull)(s))return s;const v=d(s);if(typeof v!="undefined")return v;if((0,E.isArray)(s)){const _=[];for(const p of s)_.push(A(p,d,S));return _}if((0,E.isObject)(s)){if(S.has(s))throw new Error("Cannot clone recursive data-structure");S.add(s);const _={};for(let p in s)P.call(s,p)&&(_[p]=A(s[p],d,S));return S.delete(s),_}return s}function y(s,d,S=!0){return(0,E.isObject)(s)?((0,E.isObject)(d)&&Object.keys(d).forEach(v=>{v in s?S&&((0,E.isObject)(s[v])&&(0,E.isObject)(d[v])?y(s[v],d[v],S):s[v]=d[v]):s[v]=d[v]}),s):d}e.mixin=y;function i(s,d){if(s===d)return!0;if(s==null||d===null||d===void 0||typeof s!=typeof d||typeof s!="object"||Array.isArray(s)!==Array.isArray(d))return!1;let S,v;if(Array.isArray(s)){if(s.length!==d.length)return!1;for(S=0;S<s.length;S++)if(!i(s[S],d[S]))return!1}else{const _=[];for(v in s)_.push(v);_.sort();const p=[];for(v in d)p.push(v);if(p.sort(),!i(_,p))return!1;for(S=0;S<_.length;S++)if(!i(s[_[S]],d[_[S]]))return!1}return!0}e.equals=i;function R(s){const d=new Set;return JSON.stringify(s,(S,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=R;function C(s,d,S){const v=d(s);return typeof v=="undefined"?S:v}e.getOrDefault=C;function w(s,d){const S=Object.create(null);return!s||!d||Object.keys(d).forEach(_=>{const p=s[_],u=d[_];i(p,u)||(S[_]=u)}),S}e.distinct=w;function g(s,d){const S=d.toLowerCase(),v=Object.keys(s).find(_=>_.toLowerCase()===S);return v?s[v]:s[d]}e.getCaseInsensitive=g}),define(ge[92],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function I(P){return P<0?0:P>255?255:P|0}e.toUint8=I;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(ge[2],ve([0,1,9,8]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,D=/^\/\//;function A(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,r){return!o&&!r?"file":o}function i(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const R="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,l,h,m,b,c=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,c),this.authority=l||R,this.path=i(this.scheme,h||R),this.query=m||R,this.fragment=b||R,A(this,c))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:h,path:m,query:b,fragment:c}=r;return l===void 0?l=this.scheme:l===null&&(l=R),h===void 0?h=this.authority:h===null&&(h=R),m===void 0?m=this.path:m===null&&(m=R),b===void 0?b=this.query:b===null&&(b=R),c===void 0?c=this.fragment:c===null&&(c=R),l===this.scheme&&h===this.authority&&m===this.path&&b===this.query&&c===this.fragment?this:new d(l,h,m,b,c)}static parse(r,l=!1){const h=w.exec(r);return h?new d(h[2]||R,n(h[4]||R),n(h[5]||R),n(h[7]||R),n(h[9]||R),l):new d(R,R,R,R,R)}static file(r){let l=R;if(E.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const h=r.indexOf(C,2);h===-1?(l=r.substring(2),r=C):(l=r.substring(2,h),r=r.substring(h)||C)}return new d("file",l,r,R,R)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return E.isWindows&&r.scheme==="file"?h=g.file(I.win32.join(p(r,!0),...l)).path:h=I.posix.join(r.path,...l),r.with({path:h})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const l=new d(r);return l._formatted=r.external,l._fsPath=r._sep===s?r.fsPath:null,l}}else return r}}e.URI=g;const s=E.isWindows?1:void 0;class d extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=s),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,r){let l,h=-1;for(let m=0;m<o.length;m++){const b=o.charCodeAt(m);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||r&&b===47)h!==-1&&(l+=encodeURIComponent(o.substring(h,m)),h=-1),l!==void 0&&(l+=o.charAt(m));else{l===void 0&&(l=o.substr(0,m));const c=S[b];c!==void 0?(h!==-1&&(l+=encodeURIComponent(o.substring(h,m)),h=-1),l+=c):h===-1&&(h=m)}}return h!==-1&&(l+=encodeURIComponent(o.substring(h))),l!==void 0?l:o}function _(o){let r;for(let l=0;l<o.length;l++){const h=o.charCodeAt(l);h===35||h===63?(r===void 0&&(r=o.substr(0,l)),r+=S[h]):r!==void 0&&(r+=o[l])}return r!==void 0?r:o}function p(o,r){let l;return o.authority&&o.path.length>1&&o.scheme==="file"?l=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?l=o.path.substr(1):l=o.path[1].toLowerCase()+o.path.substr(2):l=o.path,E.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=p;function u(o,r){const l=r?_:v;let h="",{scheme:m,authority:b,path:c,query:f,fragment:k}=o;if(m&&(h+=m,h+=":"),(b||m==="file")&&(h+=C,h+=C),b){let L=b.indexOf("@");if(L!==-1){const $=b.substr(0,L);b=b.substr(L+1),L=$.indexOf(":"),L===-1?h+=l($,!1):(h+=l($.substr(0,L),!1),h+=":",h+=l($.substr(L+1),!1)),h+="@"}b=b.toLowerCase(),L=b.indexOf(":"),L===-1?h+=l(b,!1):(h+=l(b.substr(0,L),!1),h+=b.substr(L))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const L=c.charCodeAt(1);L>=65&&L<=90&&(c=`/${String.fromCharCode(L+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const L=c.charCodeAt(0);L>=65&&L<=90&&(c=`${String.fromCharCode(L+32)}:${c.substr(2)}`)}h+=l(c,!0)}return f&&(h+="?",h+=l(f,!1)),k&&(h+="#",h+=r?k:v(k,!1)),h}function a(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,r=>a(r)):o}}),define(ge[24],ve([0,1,2,10]),function(Q,e,E,I){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(u,a,t){let n=u.get(a);return n===void 0&&(n=t,u.set(a,n)),n}e.getOrSet=D;function A(u){const a=[];return u.forEach((t,n)=>{a.push(`${n} => ${t}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.mapToString=A;function y(u){const a=[];return u.forEach(t=>{a.push(t)}),`Set(${u.size}) {${a.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const t=a.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=i;class R{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,I.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(a=!0,t=!0){this._splitOnBackslash=a,this._caseSensitive=t}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,I.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var w;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(w||(w={}));class g{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,I.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(a){this._iter=a}static forUris(a=()=>!1){return new d(new g(a))}static forPaths(){return new d(new C)}static forStrings(){return new d(new i)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}set(a,t){const n=this._iter.reset(a);let o;for(this._root||(this._root=new s,this._root.segment=n.value()),o=this._root;;){const l=n.cmp(o.segment);if(l>0)o.left||(o.left=new s,o.left.segment=n.value()),o=o.left;else if(l<0)o.right||(o.right=new s,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new s,o.mid.segment=n.value()),o=o.mid;else break}const r=o.value;return o.value=t,o.key=a,r}get(a){var t;return(t=this._getNode(a))===null||t===void 0?void 0:t.value}_getNode(a){const t=this._iter.reset(a);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(a){const t=this._getNode(a);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,t){const n=this._iter.reset(a),o=[];let r=this._root;for(;r;){const l=n.cmp(r.segment);if(l>0)o.push([1,r]),r=r.left;else if(l<0)o.push([-1,r]),r=r.right;else if(n.hasNext())n.next(),o.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;o.length>0&&r.isEmpty();){let[h,m]=o.pop();switch(h){case 1:m.left=void 0;break;case 0:m.mid=void 0;break;case-1:m.right=void 0;break}r=m}break}}}findSubstr(a){const t=this._iter.reset(a);let n=this._root,o;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(a){const t=this._iter.reset(a);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(a){for(const[t,n]of this)a(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=d;class S{constructor(a,t){this[T]="ResourceMap",a instanceof S?(this.map=new Map(a.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:S.defaultToKey)}set(a,t){return this.map.set(this.toKey(a),t),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t!="undefined"&&(a=a.bind(t));for(let[n,o]of this.map)a(o,E.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield E.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[E.URI.parse(a[0]),a[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[E.URI.parse(a[0]),a[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class _{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,t=0){const n=this._map.get(a);if(!!n)return t!==0&&this.touch(n,t),n.value}set(a,t,n=0){let o=this._map.get(a);if(o)o.value=t,n!==0&&this.touch(o,n);else{switch(o={key:a,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(a,o),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(!!t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,t){const n=this._state;let o=this._head;for(;o;){if(t?a.bind(t)(o.value,o.key,this):a(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const a=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:n.key,done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}values(){const a=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:n.value,done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}entries(){const a=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:[n.key,n.value],done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>a;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,n=a.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(a===this._head)return;const n=a.next,o=a.previous;a===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===2){if(a===this._tail)return;const n=a.next,o=a.previous;a===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,n)=>{a.push([n,t])}),a}fromJSON(a){this.clear();for(const[t,n]of a)this.set(t,n)}}e.LinkedMap=_;class p extends _{constructor(a,t=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=2){return super.get(a,t)}peek(a){return super.get(a,0)}set(a,t){return super.set(a,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(ge[93],ve([0,1,24,10]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(ke,Te){for(let xe=0,Se=be.length;xe<Se;xe++){const Ke=be[xe](ke,Te);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(be,ke,Te){if(!Te||Te.length<ke.length)return null;let xe;return be?xe=I.startsWithIgnoreCase(Te,ke):xe=Te.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(be,ke){const Te=ke.toLowerCase().indexOf(be.toLowerCase());return Te===-1?null:[{start:Te,end:Te+be.length}]}e.matchesContiguousSubString=D;function A(be,ke){return y(be.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=A;function y(be,ke,Te,xe){if(Te===be.length)return[];if(xe===ke.length)return null;if(be[Te]===ke[xe]){let Se=null;return(Se=y(be,ke,Te+1,xe+1))?v({start:xe,end:xe+1},Se):null}return y(be,ke,Te,xe+1)}function i(be){return 97<=be&&be<=122}function R(be){return 65<=be&&be<=90}e.isUpper=R;function C(be){return 48<=be&&be<=57}function w(be){return be===32||be===9||be===10||be===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>g.add(be.charCodeAt(0)));function s(be){return w(be)||g.has(be)}function d(be,ke){return be===ke||s(be)&&s(ke)}function S(be){return i(be)||R(be)||C(be)}function v(be,ke){return ke.length===0?ke=[be]:be.end===ke[0].start?ke[0].start=be.start:ke.unshift(be),ke}function _(be,ke){for(let Te=ke;Te<be.length;Te++){const xe=be.charCodeAt(Te);if(R(xe)||C(xe)||Te>0&&!S(be.charCodeAt(Te-1)))return Te}return be.length}function p(be,ke,Te,xe){if(Te===be.length)return[];if(xe===ke.length)return null;if(be[Te]!==ke[xe].toLowerCase())return null;{let Se=null,Ke=xe+1;for(Se=p(be,ke,Te+1,xe+1);!Se&&(Ke=_(ke,Ke))<ke.length;)Se=p(be,ke,Te+1,Ke),Ke++;return Se===null?null:v({start:xe,end:xe+1},Se)}}function u(be){let ke=0,Te=0,xe=0,Se=0,Ke=0;for(let Ve=0;Ve<be.length;Ve++)Ke=be.charCodeAt(Ve),R(Ke)&&ke++,i(Ke)&&Te++,S(Ke)&&xe++,C(Ke)&&Se++;const G=ke/be.length,re=Te/be.length,Ee=xe/be.length,Ne=Se/be.length;return{upperPercent:G,lowerPercent:re,alphaPercent:Ee,numericPercent:Ne}}function a(be){const{upperPercent:ke,lowerPercent:Te}=be;return Te===0&&ke>.6}function t(be){const{upperPercent:ke,lowerPercent:Te,alphaPercent:xe,numericPercent:Se}=be;return Te>.2&&ke<.8&&xe>.6&&Se<.2}function n(be){let ke=0,Te=0,xe=0,Se=0;for(let Ke=0;Ke<be.length;Ke++)xe=be.charCodeAt(Ke),R(xe)&&ke++,i(xe)&&Te++,w(xe)&&Se++;return(ke===0||Te===0)&&Se===0?be.length<=30:ke<=5}function o(be,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!n(be)||ke.length>60)return null;const Te=u(ke);if(!t(Te)){if(!a(Te))return null;ke=ke.toLowerCase()}let xe=null,Se=0;for(be=be.toLowerCase();Se<ke.length&&(xe=p(be,ke,0,Se))===null;)Se=_(ke,Se+1);return xe}e.matchesCamelCase=o;function r(be,ke,Te=!1){if(!ke||ke.length===0)return null;let xe=null,Se=0;for(be=be.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(xe=l(be,ke,0,Se,Te))===null;)Se=h(ke,Se+1);return xe}e.matchesWords=r;function l(be,ke,Te,xe,Se){if(Te===be.length)return[];if(xe===ke.length)return null;if(d(be.charCodeAt(Te),ke.charCodeAt(xe))){let Ke=null,G=xe+1;if(Ke=l(be,ke,Te+1,xe+1,Se),!Se)for(;!Ke&&(G=h(ke,G))<ke.length;)Ke=l(be,ke,Te+1,G,Se),G++;return Ke===null?null:v({start:xe,end:xe+1},Ke)}else return null}function h(be,ke){for(let Te=ke;Te<be.length;Te++)if(s(be.charCodeAt(Te))||Te>0&&s(be.charCodeAt(Te-1)))return Te;return be.length}const m=T(e.matchesPrefix,o,D),b=T(e.matchesPrefix,o,A),c=new E.LRUCache(1e4);function f(be,ke,Te=!1){if(typeof be!="string"||typeof ke!="string")return null;let xe=c.get(be);xe||(xe=new RegExp(I.convertSimple2RegExpPattern(be),"i"),c.set(be,xe));const Se=xe.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Te?b(be,ke):m(be,ke)}e.matchesFuzzy=f;function k(be,ke){const Te=V(be,be.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?$(Te):null}e.matchesFuzzy2=k;function L(be,ke,Te,xe,Se,Ke){const G=Math.min(13,be.length);for(;Te<G;Te++){const re=V(be,ke,Te,xe,Se,Ke,!1);if(re)return re}return[0,Ke]}e.anyScore=L;function $(be){if(typeof be=="undefined")return[];const ke=[],Te=be[1];for(let xe=be.length-1;xe>1;xe--){const Se=be[xe]+Te,Ke=ke[ke.length-1];Ke&&Ke.end===Se?Ke.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=$;const ee=128;function H(){const be=[],ke=[];for(let Te=0;Te<=ee;Te++)ke[Te]=0;for(let Te=0;Te<=ee;Te++)be.push(ke.slice(0));return be}function x(be){const ke=[];for(let Te=0;Te<=be;Te++)ke[Te]=0;return ke}const B=x(2*ee),F=x(2*ee),U=H(),M=H(),N=H(),O=!1;function j(be,ke,Te,xe,Se){function Ke(re,Ee,Ne=" "){for(;re.length<Ee;)re=Ne+re;return re}let G=` |   |${xe.split("").map(re=>Ke(re,3)).join("|")}
`;for(let re=0;re<=Te;re++)re===0?G+=" |":G+=`${ke[re-1]}|`,G+=be[re].slice(0,Se+1).map(Ee=>Ke(Ee.toString(),3)).join("|")+`
`;return G}function K(be,ke,Te,xe){be=be.substr(ke),Te=Te.substr(xe),console.log(j(M,be,be.length,Te,Te.length)),console.log(j(N,be,be.length,Te,Te.length)),console.log(j(U,be,be.length,Te,Te.length))}function X(be,ke){if(ke<0||ke>=be.length)return!1;const Te=be.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Te)}}function me(be,ke){if(ke<0||ke>=be.length)return!1;switch(be.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(be,ke,Te){return ke[be]!==Te[be]}function Ae(be,ke,Te,xe,Se,Ke,G=!1){for(;ke<Te&&Se<Ke;)be[ke]===xe[Se]&&(G&&(B[ke]=Se),ke+=1),Se+=1;return ke===Te}e.isPatternInWord=Ae;var Ie;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(be){be.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}be.isDefault=ke})(Me=e.FuzzyScore||(e.FuzzyScore={}));function V(be,ke,Te,xe,Se,Ke,G){const re=be.length>ee?ee:be.length,Ee=xe.length>ee?ee:xe.length;if(!(Te>=re||Ke>=Ee||re-Te>Ee-Ke)&&!!Ae(ke,Te,re,Se,Ke,Ee,!0)){Y(re,Ee,Te,Ke,ke,Se);let Ne=1,Ve=1,Be=Te,et=Ke;const q=[!1];for(Ne=1,Be=Te;Be<re;Ne++,Be++){const le=B[Be],pe=F[Be],_e=Be+1<re?F[Be+1]:Ee;for(Ve=le-Ke+1,et=le;et<_e;Ve++,et++){let He=Number.MIN_SAFE_INTEGER,We=!1;et<=pe&&(He=te(be,ke,Be,Te,xe,Se,et,Ee,Ke,U[Ne-1][Ve-1]===0,q));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(We=!0,qe=He+M[Ne-1][Ve-1]);const Ye=et>le,Ze=Ye?M[Ne][Ve-1]+(U[Ne][Ve-1]>0?-5:0):0,ut=et>le+1&&U[Ne][Ve-1]>0,ot=ut?M[Ne][Ve-2]+(U[Ne][Ve-2]>0?-5:0):0;if(ut&&(!Ye||ot>=Ze)&&(!We||ot>=qe))M[Ne][Ve]=ot,N[Ne][Ve]=3,U[Ne][Ve]=0;else if(Ye&&(!We||Ze>=qe))M[Ne][Ve]=Ze,N[Ne][Ve]=2,U[Ne][Ve]=0;else if(We)M[Ne][Ve]=qe,N[Ne][Ve]=1,U[Ne][Ve]=U[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(O&&K(be,Te,xe,Ke),!(!q[0]&&!G)){Ne--,Ve--;const oe=[M[Ne][Ve],Ke];let he=0,Z=0;for(;Ne>=1;){let le=Ve;do{const pe=N[Ne][le];if(pe===3)le=le-2;else if(pe===2)le=le-1;else break}while(le>=1);he>1&&ke[Te+Ne-1]===Se[Ke+Ve-1]&&!we(le+Ke-1,xe,Se)&&he+1>U[Ne][le]&&(le=Ve),le===Ve?he++:he=1,Z||(Z=le),Ne--,Ve=le-1,oe.push(Ve)}Ee===re&&(oe[0]+=2);const ne=Z-re;return oe[0]-=ne,oe}}}e.fuzzyScore=V;function Y(be,ke,Te,xe,Se,Ke){let G=be-1,re=ke-1;for(;G>=Te&&re>=xe;)Se[G]===Ke[re]&&(F[G]=re,G--),re--}function te(be,ke,Te,xe,Se,Ke,G,re,Ee,Ne,Ve){if(ke[Te]!==Ke[G])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return G===Te-xe?Be=be[Te]===Se[G]?7:5:we(G,Se,Ke)&&(G===0||!we(G-1,Se,Ke))?(Be=be[Te]===Se[G]?7:5,et=!0):X(Ke,G)&&(G===0||!X(Ke,G-1))?Be=5:(X(Ke,G-1)||me(Ke,G-1))&&(Be=5,et=!0),Be>1&&Te===xe&&(Ve[0]=!0),et||(et=we(G,Se,Ke)||X(Ke,G-1)||me(Ke,G-1)),Te===xe?G>Ee&&(Be-=et?3:5):Ne?Be+=et?2:0:Be+=et?0:1,G+1===re&&(Be-=et?3:5),Be}function ae(be,ke,Te,xe,Se,Ke,G){return De(be,ke,Te,xe,Se,Ke,!0,G)}e.fuzzyScoreGracefulAggressive=ae;function fe(be,ke,Te,xe,Se,Ke,G){return De(be,ke,Te,xe,Se,Ke,!1,G)}e.fuzzyScoreGraceful=fe;function De(be,ke,Te,xe,Se,Ke,G,re){let Ee=V(be,ke,Te,xe,Se,Ke,re);if(Ee&&!G)return Ee;if(be.length>=3){const Ne=Math.min(7,be.length-1);for(let Ve=Te+1;Ve<Ne;Ve++){const Be=Oe(be,Ve);if(Be){const et=V(Be,Be.toLowerCase(),Te,xe,Se,Ke,re);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function Oe(be,ke){if(!(ke+1>=be.length)){const Te=be[ke],xe=be[ke+1];if(Te!==xe)return be.slice(0,ke)+xe+Te+be.slice(ke+2)}}}),define(ge[135],ve([0,1,47,93,10]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${P.source}`,"g");function A(d){return d.replace(D,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=A;const y=new RegExp(`\\\\${P.source}`,"g");function i(d){return d.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=i;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(R,(S,v,_,p)=>_?S:v||p||"")}e.stripIcons=C;function w(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:g(d,S)}e.parseLabelWithIcons=w;function g(d,S){const v=[];let _="";function p(h){if(h){_+=h;for(const m of h)v.push(t)}}let u=-1,a="",t=0,n,o,r=S;const l=d.length;for(p(d.substr(0,S));r<l;)n=d[r],o=d[r+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=r,p(a),a=e.iconStartMarker,r++):n===")"&&u!==-1?(t+=r-u+1,u=-1,a=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?a+=n:(p(a),u=-1,a=""):p(n),r++;return p(a),{text:_,iconOffsets:v}}function s(d,S,v=!1){const{text:_,iconOffsets:p}=S;if(!p||p.length===0)return(0,I.matchesFuzzy)(d,_,v);const u=(0,T.ltrim)(_," "),a=_.length-u.length,t=(0,I.matchesFuzzy)(d,u,v);if(t)for(const n of t){const o=p[n.start+a]+a;n.start+=o,n.end+=o}return t}e.matchesFuzzyIconAware=s}),define(ge[94],ve([0,1,18,135,17]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",S=!1){var v,_;if(this.value=d,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(_=S.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(d,S=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(d):d).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,S){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function A(s){return y(s)?!s.value:Array.isArray(s)?s.every(A):!0}e.isEmptyMarkdownString=A;function y(s){return s instanceof D?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function i(s,d){return!s&&!d?!0:!s||!d?!1:Array.isArray(s)&&Array.isArray(d)?(0,E.equals)(s,d,R):y(s)&&y(d)?R(s,d):!1}e.markedStringsEquals=i;function R(s,d){return s===d?!0:!s||!d?!1:s.value===d.value&&s.isTrusted===d.isTrusted&&s.supportThemeIcons===d.supportThemeIcons}function C(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function w(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function g(s){const d=[],S=s.split("|").map(_=>_.trim());s=S[0];const v=S[1];if(v){const _=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),u=_?_[1]:"",a=p?p[1]:"",t=isFinite(parseInt(a)),n=isFinite(parseInt(u));t&&d.push(`width="${a}"`),n&&d.push(`height="${u}"`)}return{href:s,dimensions:d}}e.parseHrefAndDimensions=g}),define(ge[57],ve([0,1,22,10,2]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(i){return JSON.stringify(i,A)}e.stringify=P;function D(i){let R=JSON.parse(i);return R=y(R),R}e.parse=D;function A(i,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,I.regExpFlags)(R)}:R}function y(i,R=0){if(!i||R>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return T.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof E.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let C=0;C<i.length;++C)i[C]=y(i[C],R+1);else for(const C in i)Object.hasOwnProperty.call(i,C)&&(i[C]=y(i[C],R+1))}return i}e.revive=y}),define(ge[11],ve([0,1,2,9]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.vscodeWebviewResource="vscode-webview-resource",A.extension="extension",A.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,R){this._hosts[y]=i,this._ports[y]=R}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let R=this._hosts[i];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[i],w=this._connectionTokens[i];let g=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(g+=`&tkn=${encodeURIComponent(w)}`),E.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new P;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,R){const C=this.toUri(y,i);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(R||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,i){const R=this.toUri(y,i);return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,i){return E.URI.isUri(y)?y:E.URI.parse(i.toUrl(y))}}e.FileAccess=new D}),define(ge[74],ve([0,1,24]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new E.LRUCache(1e4);function T(i){return y(i,"NFC",I)}e.normalizeNFC=T;const P=new E.LRUCache(1e4);function D(i){return y(i,"NFD",P)}e.normalizeNFD=D;const A=/[^\u0000-\u0080]/;function y(i,R,C){if(!e.canNormalize||!i)return i;const w=C.get(i);if(w)return w;let g;return A.test(i)?g=i.normalize(R):g=i,C.set(i,g),g}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(R){return D(R).replace(i,"")}}else return function(i){return i}}()}),define(ge[25],ve([0,1,30,8,2,10,11,9]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=y;class i{constructor(s){this._ignorePathCasing=s}compare(s,d,S=!1){return s===d?0:(0,P.compare)(this.getComparisonKey(s,S),this.getComparisonKey(d,S))}isEqual(s,d,S=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,S)===this.getComparisonKey(d,S)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,S=!1){if(s.scheme===d.scheme){if(s.scheme===D.Schemas.file)return E.isEqualOrParent(y(s),y(d),this._ignorePathCasing(s))&&s.query===d.query&&(S||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return E.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(S||s.fragment===d.fragment)}return!1}joinPath(s,...d){return T.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return I.posix.basename(s.path)}extname(s){return I.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===D.Schemas.file?d=T.URI.file(I.dirname(y(s))).path:(d=I.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===D.Schemas.file?d=T.URI.file(I.normalize(y(s))).path:d=I.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(!(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))){if(s.scheme===D.Schemas.file){const _=I.relative(y(s),y(d));return A.isWindows?E.toSlashes(_):_}let S=s.path||"/",v=d.path||"/";if(this._ignorePathCasing(s)){let _=0;for(const p=Math.min(S.length,v.length);_<p&&!(S.charCodeAt(_)!==v.charCodeAt(_)&&S.charAt(_).toLowerCase()!==v.charAt(_).toLowerCase());_++);S=v.substr(0,_)+S.substr(_)}return I.posix.relative(S,v)}}resolvePath(s,d){if(s.scheme===D.Schemas.file){const S=T.URI.file(I.resolve(y(s),d));return s.with({authority:S.authority,path:S.path})}return d.indexOf("/")===-1&&(d=E.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),s.with({path:I.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,P.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=I.sep){if(s.scheme===D.Schemas.file){const S=y(s);return S.length>E.getRoot(S).length&&S[S.length-1]===d}else{const S=s.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=I.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=I.sep){let S=!1;if(s.scheme===D.Schemas.file){const v=y(s);S=v!==void 0&&v.length===E.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=s.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(g=>g.scheme===D.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new i(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(g,s){const d=[];for(let S=0;S<g.length;S++){const v=s(g[S]);g.some((_,p)=>p===S?!1:(0,e.isEqualOrParent)(v,s(_)))||d.push(g[S])}return d}e.distinctParents=R;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function s(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[u,a]=p.split(":");u&&a&&S.set(u,a)});const _=d.path.substring(0,d.path.indexOf(";"));return _&&S.set(g.META_DATA_MIME,_),S}g.parseMetaData=s})(C=e.DataUri||(e.DataUri={}));function w(g,s,d){if(s){let S=g.path;return S&&S[0]!==I.posix.sep&&(S=I.posix.sep+S),g.with({scheme:d,authority:s,path:S})}return g.with({scheme:d})}e.toLocalResource=w}),define(ge[19],ve([0,1,21,17,3,6,55,25]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function i(M){const N=new E.CancellationTokenSource,O=M(N.token),j=new Promise((K,X)=>{N.token.onCancellationRequested(()=>{X((0,I.canceled)())}),Promise.resolve(O).then(me=>{N.dispose(),K(me)},me=>{N.dispose(),X(me)})});return new class{cancel(){N.cancel()}then(K,X){return j.then(K,X)}catch(K){return this.then(void 0,K)}finally(K){return j.finally(K)}}}e.createCancelablePromise=i;function R(M,N,O){return Promise.race([M,new Promise(j=>N.onCancellationRequested(()=>j(O)))])}e.raceCancellation=R;async function C(M){let N=-1;const O=M.map((K,X)=>K.then(me=>(N=X,me))),j=await Promise.race(O);return M.forEach((K,X)=>{X!==N&&K.cancel()}),j}e.raceCancellablePromises=C;function w(M,N,O){let j;const K=setTimeout(()=>{j==null||j(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(K)),new Promise(X=>j=X)])}e.raceTimeout=w;function g(M){return new Promise((N,O)=>{const j=M();y(j)?j.then(N,O):N(j)})}e.asPromise=g;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(O,O).then(j)})}return new Promise((O,j)=>{this.queuedPromise.then(O,j)})}return this.activePromise=N(),new Promise((O,j)=>{this.activePromise.then(K=>{this.activePromise=null,O(K)},K=>{this.activePromise=null,j(K)})})}}e.Throttler=s;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(N,O){var j;const X=((j=this.promiseMap.get(N))!==null&&j!==void 0?j:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===X&&this.promiseMap.delete(N)});return this.promiseMap.set(N,X),X}}e.SequencerByKey=S;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,K)=>{this.doResolve=j,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class _{constructor(N){this.delayer=new v(N),this.throttler=new s}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class p{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class u extends p{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function a(M,N){return N?new Promise((O,j)=>{const K=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(K),j((0,I.canceled)())})}):i(O=>a(M,O))}e.timeout=a;function t(M,N=0){const O=setTimeout(M,N);return(0,P.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(M){return M.then(void 0,N=>{})}e.ignoreErrors=n;function o(M){const N=[];let O=0;const j=M.length;function K(){return O<j?M[O++]():null}function X(me){me!=null&&N.push(me);const we=K();return we?we.then(X):Promise.resolve(N)}return Promise.resolve(null).then(X)}e.sequence=o;function r(M,N=j=>!!j,O=null){let j=0;const K=M.length,X=()=>{if(j>=K)return Promise.resolve(O);const me=M[j++];return Promise.resolve(me()).then(Ae=>N(Ae)?Promise.resolve(Ae):X())};return X()}e.first=r;function l(M,N=j=>!!j,O=null){if(M.length===0)return Promise.resolve(O);let j=M.length;const K=()=>{var X,me;j=-1;for(const we of M)(me=(X=we).cancel)===null||me===void 0||me.call(X)};return new Promise((X,me)=>{for(const we of M)we.then(Ae=>{--j>=0&&N(Ae)?(K(),X(Ae)):j===0&&X(O)}).catch(Ae=>{--j>=0&&(K(),me(Ae))})})}e.firstParallel=l;class h{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,j)=>{this.outstandingPromises.push({factory:N,c:O,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class m extends h{constructor(){super(1)}}e.Queue=m;class b{constructor(){this.queues=new Map}queueFor(N,O=A.extUri){const j=O.getComparisonKey(N);let K=this.queues.get(j);return K||(K=new m,T.Event.once(K.onFinished)(()=>{K==null||K.dispose(),this.queues.delete(j)}),this.queues.set(j,K)),K}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=b;class c{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=c;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=f;class k{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class L extends k{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let j=!1;return{dispose(){j||(j=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(O))}}}}();class ${constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function ee(M,N,O){let j;for(let K=0;K<O;K++)try{return await M()}catch(X){j=X,await a(N)}throw j}e.retry=ee;class H{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,j){return this._pending={taskId:N,cancel:()=>j==null?void 0:j(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,j;const K=new Promise((X,me)=>{O=X,j=me});this._next={run:N,promise:K,promiseResolve:O,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=H;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=B;class F extends T.Emitter{async fireAsync(N,O,j){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const K of this._listeners)this._asyncDeliveryQueue.push([K,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[K,X]=this._asyncDeliveryQueue.shift(),me=[],we=Object.assign(Object.assign({},X),{waitUntil:Ae=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");j&&(Ae=j(Ae,typeof K=="function"?K:K[0])),me.push(Ae)}});try{typeof K=="function"?K.call(void 0,we):K[0].call(K[1],we)}catch(Ae){(0,I.onUnexpectedError)(Ae);continue}Object.freeze(me),await U.settled(me).catch(Ae=>(0,I.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(X){return typeof Promise.allSettled=="function"?O(X):j(X)}M.allSettled=N;async function O(X){return Promise.allSettled(X)}async function j(X){return Promise.all(X.map(me=>me.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function K(X){let me;const we=await Promise.all(X.map(Ae=>Ae.then(Ie=>Ie,Ie=>{me||(me=Ie)})));if(typeof me!="undefined")throw me;return we}M.settled=K})(U=e.Promises||(e.Promises={}))}),define(ge[95],ve([0,1,8,19]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),P=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,a,t=!1){const n=u||"",o=a||"",r=T.value.collator.compare(n,o);return T.value.collatorIsNumeric&&r===0&&n!==o?n<o?-1:1:r}e.compareFileNames=A;function y(u,a){const t=P.value.collator;return u=u||"",a=a||"",d(t,u,a)}e.compareFileNamesDefault=y;function i(u,a,t=!1){t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase());const[n,o]=g(u),[r,l]=g(a);return n!==r?n<r?-1:1:o===l?0:o<l?-1:1}e.noIntlCompareFileNames=i;function R(u,a){const[t,n]=g(u),[o,r]=g(a);let l=T.value.collator.compare(n,r);if(l===0){if(T.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(l=T.value.collator.compare(t,o),T.value.collatorIsNumeric&&l===0&&t!==o)return t<o?-1:1}return l}e.compareFileExtensions=R;function C(u,a){u=u||"",a=a||"";const t=s(u),n=s(a),o=P.value.collator,r=D.value.collator;let l;return l=d(r,t,n),l!==0?l:d(o,u,a)}e.compareFileExtensionsDefault=C;const w=/^(.*?)(\.([^.]*))?$/;function g(u,a=!1){const t=u?w.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return a&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function s(u){const a=u?w.exec(u):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function d(u,a,t){let n=u.compare(a,t);return n!==0?n:a.length!==t.length?a.length<t.length?-1:1:0}function S(u,a,t=!1){return t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase()),u===a?0:u<a?-1:1}function v(u,a,t=!1){const n=u.split(E.sep),o=a.split(E.sep),r=n.length-1,l=o.length-1;let h,m;for(let b=0;;b++){if(h=r===b,m=l===b,h&&m)return A(n[b],o[b],t);if(h)return-1;if(m)return 1;const c=S(n[b],o[b],t);if(c!==0)return c}}e.comparePaths=v;function _(u,a,t){const n=u.toLowerCase(),o=a.toLowerCase(),r=p(u,a,t);if(r)return r;const l=n.endsWith(t),h=o.endsWith(t);if(l!==h)return l?-1:1;const m=A(n,o);return m!==0?m:n.localeCompare(o)}e.compareAnything=_;function p(u,a,t){const n=u.toLowerCase(),o=a.toLowerCase(),r=n.startsWith(t),l=o.startsWith(t);if(r!==l)return r?-1:1;if(r&&l){if(n.length<o.length)return-1;if(n.length>o.length)return 1}return 0}e.compareByPrefix=p}),define(ge[96],ve([0,1,95,93,8,9,10]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const A=0,y=[A,[]];function i(x,B,F,U){if(!x||!B)return y;const M=x.length,N=B.length;if(M<N)return y;const O=x.toLowerCase();return!U&&!O.includes(F)?y:R(B,F,N,x,O,M)}e.scoreFuzzy=i;function R(x,B,F,U,M,N){const O=[],j=[];for(let we=0;we<F;we++){const Ae=we*N,Ie=Ae-N,Me=we>0,V=x[we],Y=B[we];for(let te=0;te<N;te++){const ae=te>0,fe=Ae+te,De=fe-1,Oe=Ie+te-1,be=ae?O[De]:0,ke=Me&&ae?O[Oe]:0,Te=Me&&ae?j[Oe]:0;let xe;!ke&&Me?xe=0:xe=C(V,Y,U,M,te,Te),xe&&ke+xe>=be?(j[fe]=Te+1,O[fe]=ke+xe):(j[fe]=A,O[fe]=be)}}const K=[];let X=F-1,me=N-1;for(;X>=0&&me>=0;){const we=X*N+me;j[we]===A||(K.push(me),X--),me--}return[O[F*N-1],K.reverse()]}function C(x,B,F,U,M,N){let O=0;if(!w(B,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const j=g(F.charCodeAt(M-1));j?O+=j:(0,I.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function w(x,B){return x===B?!0:x==="/"||x==="\\"?B==="/"||B==="\\":!1}function g(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const s=[void 0,[]];function d(x,B,F=0,U=0){const M=B;return M.values&&M.values.length>1?S(x,M.values,F,U):v(x,B,F,U)}e.scoreFuzzy2=d;function S(x,B,F,U){let M=0;const N=[];for(const O of B){const[j,K]=v(x,O,F,U);if(typeof j!="number")return s;M+=j,N.push(...K)}return[M,h(N)]}function v(x,B,F,U){const M=(0,I.fuzzyScore)(B.original,B.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,I.createMatches)(M)]:s}const _=Object.freeze({score:0}),p=1<<18,u=1<<17,a=1<<16;function t(x,B,F,U,M){if(!x||!B.normalized)return _;const N=U.getItemLabel(x);if(!N)return _;const O=U.getItemDescription(x);let j;O?j=`${N}${O}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${F}`:j=`${N}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${F}`;const K=M[j];if(K)return K;const X=n(N,O,U.getItemPath(x),B,F);return M[j]=X,X}e.scoreItemFuzzy=t;function n(x,B,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(P.isLinux?U.pathNormalized===F:(0,D.equalsIgnoreCase)(U.pathNormalized,F))?{score:p,labelMatch:[{start:0,end:x.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:U.values&&U.values.length>1?o(x,B,F,U.values,N,M):r(x,B,F,U,N,M)}function o(x,B,F,U,M,N){let O=0;const j=[],K=[];for(const X of U){const{score:me,labelMatch:we,descriptionMatch:Ae}=r(x,B,F,X,M,N);if(me===A)return _;O+=me,we&&j.push(...we),Ae&&K.push(...Ae)}return{score:O,labelMatch:h(j),descriptionMatch:h(K)}}function r(x,B,F,U,M,N){if(M||!B){const[O,j]=i(x,U.normalized,U.normalizedLowercase,N);if(O){const K=(0,I.matchesPrefix)(U.normalized,x);let X;return K?(X=u,X+=Math.round(U.normalized.length/x.length*100)):X=a,{score:X+O,labelMatch:K||l(j)}}}if(B){let O=B;F&&(O=`${B}${T.sep}`);const j=O.length,K=`${O}${x}`,[X,me]=i(K,U.normalized,U.normalizedLowercase,N);if(X){const we=l(me),Ae=[],Ie=[];return we.forEach(Me=>{Me.start<j&&Me.end>j?(Ae.push({start:0,end:Me.end-j}),Ie.push({start:Me.start,end:j})):Me.start>=j?Ae.push({start:Me.start-j,end:Me.end-j}):Ie.push(Me)}),{score:X,labelMatch:Ae,descriptionMatch:Ie}}}return _}function l(x){const B=[];if(!x)return B;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},B.push(F));return B}function h(x){const B=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of B)!U||!m(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function m(x,B){return!(x.end<B.start||B.end<x.start)}function b(x,B,F,U,M,N){const O=t(x,F,U,M,N),j=t(B,F,U,M,N),K=O.score,X=j.score;if((K===p||X===p)&&K!==X)return K===p?-1:1;if(K>a||X>a){if(K!==X)return K>X?-1:1;if(K<u&&X<u){const Y=f(O.labelMatch,j.labelMatch);if(Y!==0)return Y}const Me=M.getItemLabel(x)||"",V=M.getItemLabel(B)||"";if(Me.length!==V.length)return Me.length-V.length}if(K!==X)return K>X?-1:1;const me=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,we=Array.isArray(j.labelMatch)&&j.labelMatch.length>0;if(me&&!we)return-1;if(we&&!me)return 1;const Ae=c(x,O,M),Ie=c(B,j,M);return Ae&&Ie&&Ae!==Ie?Ie>Ae?-1:1:k(x,B,F,M)}e.compareItemsByFuzzyScore=b;function c(x,B,F){let U=-1,M=-1;if(B.descriptionMatch&&B.descriptionMatch.length?U=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(U=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(M=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(M=B.descriptionMatch[B.descriptionMatch.length-1].end);return M-U}function f(x,B){if(!x&&!B||(!x||!x.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=B[0].start,j=B[B.length-1].end-N;return M===j?0:j<M?1:-1}function k(x,B,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel(B)||"",O=U.getItemDescription(x),j=U.getItemDescription(B),K=M.length+(O?O.length:0),X=N.length+(j?j.length:0);if(K!==X)return K-X;const me=U.getItemPath(x),we=U.getItemPath(B);return me&&we&&me.length!==we.length?me.length-we.length:M!==N?(0,E.compareAnything)(M,N,F.normalized):O&&j&&O!==j?(0,E.compareAnything)(O,j,F.normalized):me&&we&&me!==we?(0,E.compareAnything)(me,we,F.normalized):0}const L=" ";function $(x){typeof x!="string"&&(x="");const B=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=ee(x),N=F.indexOf(T.sep)>=0;let O;const j=x.split(L);if(j.length>1)for(const K of j){const{pathNormalized:X,normalized:me,normalizedLowercase:we}=ee(K);me&&(O||(O=[]),O.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:X,normalized:me,normalizedLowercase:we}))}return{original:x,originalLowercase:B,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=$;function ee(x){let B;P.isWindows?B=x.replace(/\//g,T.sep):B=x.replace(/\\/g,T.sep);const F=(0,D.stripWildcards)(B).replace(/\s/g,"");return{pathNormalized:B,normalized:F,normalizedLowercase:F.toLowerCase()}}function H(x){return Array.isArray(x)?$(x.map(B=>B.original).join(L)):$(x.original)}e.pieceToQuery=H}),define(ge[33],ve([0,1,10,30,8,24,19]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const y="**",i="/",R="[/\\\\]",C="[^/\\\\]",w=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function s(O,j){if(!O)return[];const K=[];let X=!1,me=!1,we="";for(const Ae of O){switch(Ae){case j:if(!X&&!me){K.push(we),we="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":me=!0;break;case"]":me=!1;break}we+=Ae}return we&&K.push(we),K}e.splitGlobAware=s;function d(O){if(!O)return"";let j="";const K=s(O,i);if(K.every(X=>X===y))j=".*";else{let X=!1;K.forEach((me,we)=>{if(me===y){X||(j+=g(2),X=!0);return}let Ae=!1,Ie="",Me=!1,V="";for(const Y of me){if(Y!=="}"&&Ae){Ie+=Y;continue}if(Me&&(Y!=="]"||!V)){let te;Y==="-"?te=Y:(Y==="^"||Y==="!")&&!V?te="^":Y===i?te="":te=E.escapeRegExpCharacters(Y),V+=te;continue}switch(Y){case"{":Ae=!0;continue;case"[":Me=!0;continue;case"}":j+=`(?:${s(Ie,",").map(fe=>d(fe)).join("|")})`,Ae=!1,Ie="";break;case"]":j+="["+V+"]",Me=!1,V="";break;case"?":j+=C;continue;case"*":j+=g(1);continue;default:j+=E.escapeRegExpCharacters(Y)}}we<K.length-1&&(K[we+1]!==y||we+2<K.length)&&(j+=R),X=!1})}return j}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),n=function(){return!1},o=function(){return null};function r(O,j){if(!O)return o;let K;typeof O!="string"?K=O.pattern:K=O,K=K.trim();const X=`${K}_${!!j.trimForExclusions}`;let me=t.get(X);if(me)return l(me,O);let we;if(S.test(K)){const Ae=K.substr(4);me=function(Ie,Me){return typeof Ie=="string"&&Ie.endsWith(Ae)?K:null}}else(we=v.exec(h(K,j)))?me=m(we[1],K):(j.trimForExclusions?p:_).test(K)?me=b(K,j):(we=u.exec(h(K,j)))?me=c(we[1].substr(1),K,!0):(we=a.exec(h(K,j)))?me=c(we[1],K,!1):me=f(K);return t.set(X,me),l(me,O)}function l(O,j){return typeof j=="string"?O:function(K,X){return I.isEqualOrParent(K,j.base)?O(T.relative(j.base,K),X):null}}function h(O,j){return j.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function m(O,j){const K=`/${O}`,X=`\\${O}`,me=function(Ae,Ie){return typeof Ae!="string"?null:Ie?Ie===O?j:null:Ae===O||Ae.endsWith(K)||Ae.endsWith(X)?j:null},we=[O];return me.basenames=we,me.patterns=[j],me.allBasenames=we,me}function b(O,j){const K=N(O.slice(1,-1).split(",").map(Ie=>r(Ie,j)).filter(Ie=>Ie!==o),O),X=K.length;if(!X)return o;if(X===1)return K[0];const me=function(Ie,Me){for(let V=0,Y=K.length;V<Y;V++)if(K[V](Ie,Me))return O;return null},we=K.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=K.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function c(O,j,K){const X=T.sep===T.posix.sep,me=X?O:O.replace(w,T.sep),we=T.sep+me,Ae=T.posix.sep+O,Ie=K?function(Me,V){return typeof Me=="string"&&(Me===me||Me.endsWith(we)||!X&&(Me===O||Me.endsWith(Ae)))?j:null}:function(Me,V){return typeof Me=="string"&&(Me===me||!X&&Me===O)?j:null};return Ie.allPaths=[(K?"*/":"./")+O],Ie}function f(O){try{const j=new RegExp(`^${d(O)}$`);return function(K){return j.lastIndex=0,typeof K=="string"&&j.test(K)?O:null}}catch(j){return o}}function k(O,j,K){return!O||typeof j!="string"?!1:L(O)(j,void 0,K)}e.match=k;function L(O,j={}){if(!O)return n;if(typeof O=="string"||x(O)){const K=r(O,j);if(K===o)return n;const X=function(me,we){return!!K(me,we)};return K.allBasenames&&(X.allBasenames=K.allBasenames),K.allPaths&&(X.allPaths=K.allPaths),X}return U(O,j)}e.parse=L;function $(O){if(!!O){let j;return K=>(j||(j=(O()||Promise.resolve([])).then(X=>X?H(X):{})),j.then(X=>!!X[K]))}}e.hasSiblingPromiseFn=$;function ee(O){if(!!O){let j;return K=>{if(!j){const X=O();j=X?H(X):{}}return!!j[K]}}}e.hasSiblingFn=ee;function H(O){const j={};for(const K of O)j[K]=!0;return j}function x(O){const j=O;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=x;function B(O){return O.allBasenames||[]}e.getBasenameTerms=B;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,j){const K=N(Object.getOwnPropertyNames(O).map(Ie=>M(Ie,O[Ie],j)).filter(Ie=>Ie!==o)),X=K.length;if(!X)return o;if(!K.some(Ie=>!!Ie.requiresSiblings)){if(X===1)return K[0];const Ie=function(Y,te){for(let ae=0,fe=K.length;ae<fe;ae++){const De=K[ae](Y,te);if(De)return De}return null},Me=K.find(Y=>!!Y.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const V=K.reduce((Y,te)=>te.allPaths?Y.concat(te.allPaths):Y,[]);return V.length&&(Ie.allPaths=V),Ie}const me=function(Ie,Me,V){let Y;for(let te=0,ae=K.length;te<ae;te++){const fe=K[te];fe.requiresSiblings&&V&&(Me||(Me=T.basename(Ie)),Y||(Y=Me.substr(0,Me.length-T.extname(Ie).length)));const De=fe(Ie,Me,Y,V);if(De)return De}return null},we=K.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=K.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function M(O,j,K){if(j===!1)return o;const X=r(O,K);if(X===o)return o;if(typeof j=="boolean")return X;if(j){const me=j.when;if(typeof me=="string"){const we=(Ae,Ie,Me,V)=>{if(!V||!X(Ae,Ie))return null;const Y=me.replace("$(basename)",Me),te=V(Y);return(0,D.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return we.requiresSiblings=!0,we}}return X}function N(O,j){const K=O.filter(Ie=>!!Ie.basenames);if(K.length<2)return O;const X=K.reduce((Ie,Me)=>{const V=Me.basenames;return V?Ie.concat(V):Ie},[]);let me;if(j){me=[];for(let Ie=0,Me=X.length;Ie<Me;Ie++)me.push(j)}else me=K.reduce((Ie,Me)=>{const V=Me.patterns;return V?Ie.concat(V):Ie},[]);const we=function(Ie,Me){if(typeof Ie!="string")return null;if(!Me){let Y;for(Y=Ie.length;Y>0;Y--){const te=Ie.charCodeAt(Y-1);if(te===47||te===92)break}Me=Ie.substr(Y)}const V=X.indexOf(Me);return V!==-1?me[V]:null};we.basenames=X,we.patterns=me,we.allBasenames=X;const Ae=O.filter(Ie=>!Ie.basenames);return Ae.push(we),Ae}}),define(ge[75],ve([0,1,2,8,10,11,9,25,30]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(r,l,h){if(typeof r=="string"&&(r=E.URI.file(r)),h){const b=h.getWorkspaceFolder(r);if(b){const c=h.getWorkspace().folders.length>1;let f;if((0,A.isEqual)(b.uri,r)?f="":f=(0,A.relativePath)(b.uri,r),c){const k=b.name?b.name:(0,A.basename)(b.uri);f=f?k+" \u2022 "+f:k}return f}}if(r.scheme!==P.Schemas.file&&r.scheme!==P.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,I.normalize)(C(r.fsPath));let m=(0,I.normalize)(r.fsPath);return!D.isWindows&&(l==null?void 0:l.userHome)&&(m=g(m,l.userHome.fsPath)),m}e.getPathLabel=i;function R(r){if(!!r){typeof r=="string"&&(r=E.URI.file(r));const l=(0,A.basename)(r)||(r.scheme===P.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(l)?C(l):l}}e.getBaseLabel=R;function C(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let w=Object.create(null);function g(r,l){if(D.isWindows||!r||!l)return r;let h=w.original===l?w.normalized:void 0;return h||(h=`${(0,T.rtrim)(l,I.posix.sep)}${I.posix.sep}`,w={original:l,normalized:h}),(D.isLinux?r.startsWith(h):(0,T.startsWithIgnoreCase)(r,h))&&(r=`~/${r.substr(h.length)}`),r}e.tildify=g;function s(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=s;const d="\u2026",S="\\\\",v="~";function _(r,l=I.sep){const h=new Array(r.length);let m=!1;for(let b=0;b<r.length;b++){let c=r[b];if(c===""){h[b]=`.${l}`;continue}if(!c){h[b]=c;continue}m=!0;let f="";c.indexOf(S)===0?(f=c.substr(0,c.indexOf(S)+S.length),c=c.substr(c.indexOf(S)+S.length)):c.indexOf(l)===0?(f=c.substr(0,c.indexOf(l)+l.length),c=c.substr(c.indexOf(l)+l.length)):c.indexOf(v)===0&&(f=c.substr(0,c.indexOf(v)+v.length),c=c.substr(c.indexOf(v)+v.length));const k=c.split(l);for(let L=1;m&&L<=k.length;L++)for(let $=k.length-L;m&&$>=0;$--){m=!1;let ee=k.slice($,$+L).join(l);for(let H=0;!m&&H<r.length;H++)if(H!==b&&r[H]&&r[H].indexOf(ee)>-1){const x=$+L===k.length,B=$>0&&r[H].indexOf(l)>-1?l+ee:ee,F=r[H].endsWith(B);m=!x||F}if(!m){let H="";(k[0].endsWith(":")||f!=="")&&($===1&&($=0,L++,ee=k[0]+l+ee),$>0&&(H=k[0]+l),H=f+H),$>0&&(H=H+d+l),H=H+ee,$+L<k.length&&(H=H+l+d),h[b]=H}}m&&(h[b]=c)}return h}e.shorten=_;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function u(r,l=Object.create(null)){const h=[];let m=!1,b="";for(const c of r)if(c==="$"||m&&c==="{")b&&h.push({value:b,type:p.TEXT}),b="",m=!0;else if(c==="}"&&m){const f=l[b];if(typeof f=="string")f.length&&h.push({value:f,type:p.VARIABLE});else if(f){const k=h[h.length-1];(!k||k.type!==p.SEPARATOR)&&h.push({value:f.label,type:p.SEPARATOR})}b="",m=!1}else b+=c;return b&&!m&&h.push({value:b,type:p.TEXT}),h.filter((c,f)=>{if(c.type===p.SEPARATOR){const k=h[f-1],L=h[f+1];return[k,L].every($=>$&&($.type===p.VARIABLE||$.type===p.TEXT)&&$.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=u;function a(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(r){const l=r.indexOf("/")!==-1?I.posix:I.win32,h=l.basename(r),m=l.dirname(r);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(ge[97],ve([0,1,2]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(R){return R.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const w=this._uriTransformer.transformIncoming(C);return w===C?C:I(E.URI.from(w))}transformOutgoing(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:I(E.URI.from(w))}transformOutgoingURI(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:E.URI.from(w)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,C,w){if(!R||w>200)return null;if(typeof R=="object"){if(R instanceof E.URI)return C.transformOutgoing(R);for(let g in R)if(Object.hasOwnProperty.call(R,g)){const s=P(R[g],C,w+1);s!==null&&(R[g]=s)}}return null}function D(R,C){const w=P(R,C,0);return w===null?R:w}e.transformOutgoingURIs=D;function A(R,C,w,g){if(!R||g>200)return null;if(typeof R=="object"){if(R.$mid===1)return w?E.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const d=A(R[s],C,w,g+1);d!==null&&(R[s]=d)}}return null}function y(R,C){const w=A(R,C,!1,0);return w===null?R:w}e.transformIncomingURIs=y;function i(R,C){const w=A(R,C,!0,0);return w===null?R:w}e.transformAndReviveIncomingURIs=i}),define(ge[28],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return E.test(y)}e.isUUID=I;const T=new Uint8Array(16),P=[];for(let y=0;y<256;y++)P.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function A(){D(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,i="";return i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i+="-",i+=P[T[y++]],i+=P[T[y++]],i+="-",i+=P[T[y++]],i+=P[T[y++]],i+="-",i+=P[T[y++]],i+=P[T[y++]],i+="-",i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i+=P[T[y++]],i}e.generateUuid=A}),define(ge[136],ve([0,1,98]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(P="utf8"){this.stringDecoder=new E.StringDecoder(P),this.remaining=null}write(P){const D=[],A=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(A.length<1)return D;let y=0,i,R=y;for(;R<A.length;)if(i=A.charCodeAt(R),i===13||i===10){if(D.push(A.substring(y,R)),R++,R<A.length){const C=i;i=A.charCodeAt(R),(C===13&&i===10||C===10&&i===13)&&R++}y=R}else R++;return this.remaining=y<A.length?A.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],ve([0,1,37,48,8,19,9,30,28,74,25,2]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var w;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function g(B,F=w.UNLINK){if((0,A.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return F===w.UNLINK?d(B):s(B)}e.rimraf=g;async function s(B){try{const F=(0,T.join)((0,I.tmpdir)(),(0,y.generateUuid)());try{await E.promises.rename(B,F)}catch(U){return d(B)}d(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function d(B){return E.promises.rmdir(B,{recursive:!0,maxRetries:3})}function S(B){if((0,A.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync(B,{recursive:!0})}e.rimrafSync=S;async function v(B,F){return u(await(F?_(B):E.promises.readdir(B)))}e.readdir=v;async function _(B){try{return await E.promises.readdir(B,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await v(B);for(const M of U){let N=!1,O=!1,j=!1;try{const K=await E.promises.lstat((0,T.join)(B,M));N=K.isFile(),O=K.isDirectory(),j=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>j})}return F}function p(B){return u(E.readdirSync(B))}e.readdirSync=p;function u(B){return B.map(F=>typeof F=="string"?D.isMacintosh?(0,i.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,i.normalizeNFC)(F.name):F.name,F))}async function a(B){const F=await v(B),U=[];for(const M of F)await n.existsDirectory((0,T.join)(B,M))&&U.push(M);return U}e.readDirsInDir=a;function t(B,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,E.access(B,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var n;(function(B){async function F(N){let O;try{if(O=await E.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(j){}try{return{stat:await E.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&j.code==="EACCES")try{return{stat:await E.promises.stat(await E.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw K}throw j}}B.stat=F;async function U(N){try{const{stat:O,symbolicLink:j}=await B.stat(N);return O.isFile()&&(j==null?void 0:j.dangling)!==!0}catch(O){}return!1}B.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:j}=await B.stat(N);return O.isDirectory()&&(j==null?void 0:j.dangling)!==!0}catch(O){}return!1}B.existsDirectory=M})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function r(B,F,U){return o.queueFor(C.URI.file(B),R.extUriBiasedIgnorePathCase).queue(()=>{const M=b(U);return new Promise((N,O)=>h(B,F,M,j=>j?O(j):N()))})}e.writeFile=r;let l=!0;function h(B,F,U,M){if(!l)return E.writeFile(B,F,{mode:U.mode,flag:U.flag},M);E.open(B,U.flag,U.mode,(N,O)=>{if(N)return M(N);E.writeFile(O,F,j=>{if(j)return E.close(O,()=>M(j));E.fdatasync(O,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),l=!1),E.close(O,X=>M(X))))})})}function m(B,F,U){const M=b(U);if(!l)return E.writeFileSync(B,F,{mode:M.mode,flag:M.flag});const N=E.openSync(B,M.flag,M.mode);try{E.writeFileSync(N,F);try{E.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{E.closeSync(N)}}e.writeFileSync=m;function b(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function c(B,F){if(B!==F){async function U(M){try{const N=await E.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await E.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await E.promises.rename(B,F),await U(F)}catch(M){if(B.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||B.endsWith("."))await f(B,F,{preserveSymlinks:!1}),await g(B,w.MOVE),await U(F);else throw M}}}e.move=c;async function f(B,F,U){return L(B,F,{root:{source:B,target:F},options:U,handledSourcePaths:new Set})}e.copy=f;const k=511;async function L(B,F,U){if(!U.handledSourcePaths.has(B)){U.handledSourcePaths.add(B);const{stat:M,symbolicLink:N}=await n.stat(B);if(N){if(U.options.preserveSymlinks)try{return await H(B,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?$(B,F,M.mode&k,U):ee(B,F,M.mode&k)}}async function $(B,F,U,M){await E.promises.mkdir(F,{recursive:!0,mode:U});const N=await v(B);for(const O of N)await L((0,T.join)(B,O),(0,T.join)(F,O),M)}async function ee(B,F,U){await E.promises.copyFile(B,F),await E.promises.chmod(F,U)}async function H(B,F,U){let M=await E.promises.readlink(B);(0,A.isEqualOrParent)(M,U.root.source,!D.isLinux)&&(M=(0,T.join)(U.root.target,M.substr(U.root.source.length+1))),await E.promises.symlink(M,F)}async function x(B){try{return await E.promises.access(B),!0}catch(F){return!1}}e.exists=x}),define(ge[99],ve([0,1,37,283,10,8,26]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(C){const w=(0,P.dirname)(C);if(C===w)return C;const g=((0,P.basename)(C)||C).toLowerCase();try{const d=(0,D.readdirSync)(w).filter(S=>S.toLowerCase()===g);if(d.length===1){const S=A(w);if(S)return(0,P.join)(S,d[0])}else if(d.length>1){const S=d.indexOf(g);if(S>=0){const v=A(w);if(v)return(0,P.join)(v,d[S])}}}catch(s){}return null}e.realcaseSync=A;async function y(C){try{return await(0,I.promisify)(E.realpath)(C)}catch(w){const g=R(C);return await E.promises.access(g,E.constants.R_OK),g}}e.realpath=y;function i(C){try{return E.realpathSync(C)}catch(w){const g=R(C);return E.accessSync(g,E.constants.R_OK),g}}e.realpathSync=i;function R(C){return(0,T.rtrim)((0,P.normalize)(C),P.sep)}});var vt=this&&this.__await||function(Q){return this instanceof vt?(this.v=Q,this):new vt(Q)},An=this&&this.__asyncGenerator||function(Q,e,E){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=E.apply(Q,e||[]),T,P=[];return T={},D("next"),D("throw"),D("return"),T[Symbol.asyncIterator]=function(){return this},T;function D(w){I[w]&&(T[w]=function(g){return new Promise(function(s,d){P.push([w,g,s,d])>1||A(w,g)})})}function A(w,g){try{y(I[w](g))}catch(s){C(P[0][3],s)}}function y(w){w.value instanceof vt?Promise.resolve(w.value.v).then(i,R):C(P[0][2],w)}function i(w){A("next",w)}function R(w){A("throw",w)}function C(w,g){w(g),P.shift(),P.length&&A(P[0][0],P[0][1])}},rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],E;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),E={},I("next"),I("throw"),I("return"),E[Symbol.asyncIterator]=function(){return this},E);function I(P){E[P]=Q[P]&&function(D){return new Promise(function(A,y){D=Q[P](D),T(A,y,D.done,D.value)})}}function T(P,D,A,y){Promise.resolve(y).then(function(i){P({value:i,done:A})},D)}};define(ge[100],ve([0,1,26,48,8]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(y||(y={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class C{constructor(a,t,n){this.exePath=a,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:u=!1}={}){return u?i===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:a=!1}={}){const t=w({useAlternateBitness:u});if(!t)return null;const n=T.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let o=-1,r=null;for(const m of await E.readdir(n)){let b=-1;if(a){const f=m.indexOf("-");if(f<0)continue;const k=m.substring(0,f);if(!P.test(k)||m.substring(f+1)!=="preview")continue;b=parseInt(k,10)}else{if(!P.test(m))continue;b=parseInt(m,10)}if(!(b<=o)){const c=T.join(n,m,"pwsh.exe");!await E.SymlinkSupport.existsFile(c)||(r=c,o=b)}}if(!r)return null;const l=t.includes("x86")?" (x86)":"",h=a?" Preview":"";return new C(r,`PowerShell${h}${l}`,!0)}async function s({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const a=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=u?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await E.readdir(a))if(t.test(o)){const r=T.join(a,o,"pwsh.exe");return new C(r,n)}return null}function d(){const u=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function S(){const u=T.join(process.env.windir,i===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}function v(){return An(this,arguments,function*(){let a=yield vt(g());a&&(yield yield vt(a)),a=yield vt(g({useAlternateBitness:!0})),a&&(yield yield vt(a)),a=yield vt(s()),a&&(yield yield vt(a)),a=d(),a&&(yield yield vt(a)),a=yield vt(g({findPreview:!0})),a&&(yield yield vt(a)),a=yield vt(s({findPreview:!0})),a&&(yield yield vt(a)),a=yield vt(g({useAlternateBitness:!0,findPreview:!0})),a&&(yield yield vt(a)),a=S(),a&&(yield yield vt(a))})}function _(){return An(this,arguments,function*(){var a,t;try{for(var n=rn(v()),o;o=yield vt(n.next()),!o.done;){const r=o.value;(yield vt(r.exists()))&&(yield yield vt(r))}}catch(r){a={error:r}}finally{try{o&&!o.done&&(t=n.return)&&(yield vt(t.call(n)))}finally{if(a)throw a.error}}})}e.enumeratePowerShellInstallations=_;async function p(){var u,a;try{for(var t=rn(_()),n;n=await t.next(),!n.done;)return n.value}catch(o){u={error:o}}finally{try{n&&!n.done&&(a=t.return)&&await a.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=p}),define(ge[101],ve([0,1,3,6,19,21,17,22,18,14,57,10]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function g(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(s=e.ResponseType||(e.ResponseType={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class _{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var p;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(p||(p={}));function u(M){const N=A.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function a(M){return M.read(4).readUInt32BE(0)}function t(M){const N=A.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const n={Undefined:t(p.Undefined),String:t(p.String),Buffer:t(p.Buffer),VSBuffer:t(p.VSBuffer),Array:t(p.Array),Object:t(p.Object)},o=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(n.Undefined);else if(typeof N=="string"){const O=A.VSBuffer.fromString(N);M.write(n.String),M.write(u(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(N)){const O=A.VSBuffer.wrap(N);M.write(n.Buffer),M.write(u(O.byteLength)),M.write(O)}else if(N instanceof A.VSBuffer)M.write(n.VSBuffer),M.write(u(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(n.Array),M.write(u(N.length));for(const O of N)r(M,O)}else{const O=A.VSBuffer.fromString(JSON.stringify(N));M.write(n.Object),M.write(u(O.byteLength)),M.write(O)}}function l(M){switch(M.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return M.read(a(M)).toString();case p.Buffer:return M.read(a(M)).buffer;case p.VSBuffer:return M.read(a(M));case p.Array:{const O=a(M),j=[];for(let K=0;K<O;K++)j.push(l(M));return j}case p.Object:return JSON.parse(M.read(a(M)).toString())}}class h{constructor(N,O,j=null,K=1e3){this.protocol=N,this.ctx=O,this.logger=j,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,d(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,d(N.type),N.data);return}}}send(N,O=void 0){const j=new _;return r(j,N),r(j,O),this.sendBuffer(j.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),j=l(O),K=l(O),X=j[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}: ${j[2]}.${j[3]}`,K),this.onPromise({type:X,id:j[1],channelName:j[2],name:j[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}: ${j[2]}.${j[3]}`,K),this.onEventListen({type:X,id:j[1],channelName:j[2],name:j[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:j[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const j=new P.CancellationTokenSource;let K;try{K=O.call(this.ctx,N.name,N.arg,j.token)}catch(we){K=Promise.reject(we)}const X=N.id;K.then(we=>{this.sendResponse({id:X,data:we,type:201}),this.activeRequests.delete(N.id)},we=>{we instanceof Error?this.sendResponse({id:X,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:X,data:we,type:203}),this.activeRequests.delete(N.id)});const me=(0,I.toDisposable)(()=>j.cancel());this.activeRequests.set(N.id,me)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const j=N.id,X=O.listen(this.ctx,N.name,N.arg)(me=>this.sendResponse({id:j,data:me,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const j=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:j})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const j of O)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var m;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=O}getChannel(N){const O=this;return{call(j,K,X){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(N,j,K,X)},listen(j,K){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(N,j,K)}}}requestPromise(N,O,j,K=P.CancellationToken.None){const X=this.lastRequestId++,we={id:X,type:100,channelName:N,name:O,arg:j};if(K.isCancellationRequested)return Promise.reject(D.canceled());let Ae;return new Promise((Me,V)=>{if(K.isCancellationRequested)return V(D.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(X),Me(Oe.data);break;case 202:this.handlers.delete(X);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,V(be);break;case 203:this.handlers.delete(X),V(Oe.data);break}};this.handlers.set(X,De),this.sendRequest(we)};let te=null;this.state===S.Idle?Y():(te=(0,T.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,Y()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:X,type:101}),V(D.canceled())},fe=K.onCancellationRequested(ae);Ae=(0,I.combinedDisposable)((0,I.toDisposable)(ae),fe),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,j){const K=this.lastRequestId++,me={id:K,type:102,channelName:N,name:O,arg:j};let we=null;const Ae=new E.Emitter({onFirstListenerAdd:()=>{we=(0,T.createCancelablePromise)(Me=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Ae),this.sendRequest(me)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Ae),this.sendRequest({id:K,type:103}))}}),Ie=Me=>Ae.fire(Me.data);return this.handlers.set(K,Ie),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${g(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,g(N.type));return}}}send(N,O=void 0){const j=new _;return r(j,N),r(j,O),this.sendBuffer(j.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),j=l(O),K=l(O),X=j[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,d(X)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],0,d(X),K),this.onResponse({type:j[0],id:j[1],data:K})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():E.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=b;class c{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:j})=>{E.Event.once(O.onMessage)(X=>{const me=new v(X),we=l(me),Ae=new h(O,we),Ie=new b(O);this.channels.forEach((V,Y)=>Ae.registerChannel(Y,V));const Me={channelServer:Ae,channelClient:Ie,ctx:we};this._connections.add(Me),this._onDidAddConnection.fire(Me),j(()=>{Ae.dispose(),Ie.dispose(),this._connections.delete(Me),this._onDidRemoveConnection.fire(Me)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const j=this;return{call(K,X,me){let we;if((0,i.isFunction)(O)){let Ie=(0,y.getRandomElement)(j.connections.filter(O));we=Ie?Promise.resolve(Ie):E.Event.toPromise(E.Event.filter(j.onDidAddConnection,O))}else we=O.routeCall(j,K,X);const Ae=we.then(Ie=>Ie.channelClient.getChannel(N));return k(Ae).call(K,X,me)},listen(K,X){if((0,i.isFunction)(O))return j.getMulticastEvent(N,O,K,X);const me=O.routeEvent(j,K,X).then(we=>we.channelClient.getChannel(N));return k(me).listen(K,X)}}}getMulticastEvent(N,O,j,K){const X=this;let me=new I.DisposableStore;const we=new E.Emitter({onFirstListenerAdd:()=>{me=new I.DisposableStore;const Ae=new E.EventMultiplexer,Ie=new Map,Me=Y=>{const ae=Y.channelClient.getChannel(N).listen(j,K),fe=Ae.add(ae);Ie.set(Y,fe)},V=Y=>{const te=Ie.get(Y);!te||(te.dispose(),Ie.delete(Y))};X.connections.filter(O).forEach(Me),E.Event.filter(X.onDidAddConnection,O)(Me,void 0,me),X.onDidRemoveConnection(V,void 0,me),Ae.event(we.fire,we,me),me.add(Ae)},onLastListenerRemove:()=>{me.dispose()}});return we.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(j=>{j.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=c;class f{constructor(N,O,j=null){const K=new _;r(K,O),N.send(K.buffer),this.channelClient=new b(N,j),this.channelServer=new h(N,O,j)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=f;function k(M){return{call(N,O,j){return M.then(K=>K.call(N,O,j))},listen(N,O){const j=new E.Relay;return M.then(K=>j.input=K.listen(N,O)),j.event}}}e.getDelayedChannel=k;function L(M){let N=!1;return{call(O,j,K){return N?M.call(O,j,K):(0,T.timeout)(0).then(()=>N=!0).then(()=>M.call(O,j,K))},listen(O,j){if(N)return M.listen(O,j);const K=new E.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>K.input=M.listen(O,j)),K.event}}}e.getNextTickChannel=L;class ${constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await E.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=$;var ee;(function(M){function N(K,X){const me=K,we=X&&X.disableMarshalling,Ae=new Map;for(const Ie in me)j(Ie)&&Ae.set(Ie,E.Event.buffer(me[Ie],!0));return new class{listen(Ie,Me){const V=Ae.get(Me);if(V)return V;throw new Error(`Event not found: ${Me}`)}call(Ie,Me,V){const Y=me[Me];if(typeof Y=="function"){if(!we&&Array.isArray(V))for(let te=0;te<V.length;te++)V[te]=(0,R.revive)(V[te]);return Y.apply(me,V)}throw new Error(`Method not found: ${Me}`)}}}M.fromService=N;function O(K,X){const me=X&&X.disableMarshalling;return new Proxy({},{get(we,Ae){var Ie;if(typeof Ae=="string")return((Ie=X==null?void 0:X.properties)===null||Ie===void 0?void 0:Ie.has(Ae))?X.properties.get(Ae):j(Ae)?K.listen(Ae):async function(...Me){let V;X&&!(0,i.isUndefinedOrNull)(X.context)?V=[X.context,...Me]:V=Me;const Y=await K.call(Ae,V);return me?Y:(0,R.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function j(K){return K[0]==="o"&&K[1]==="n"&&C.isUpperAsciiLetter(K.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function B(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,j,K,X,me){me=B(me);const we=H[K],Ae=we[j%we.length];let Ie=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(X)?(Ie=Ie.concat(me),Ie.push(")")):Ie.push(me),console.log.apply(console,Ie)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,j,K,X){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,j,K,X)}logIncoming(N,O,j,K,X){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,j,K,X)}}e.IPCLogger=U}),define(ge[102],ve([0,1,3,101,6,22,9,36]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=P.VSBuffer.alloc(0)),y}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const b=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),b}if(this._chunks[0].byteLength>o){const b=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),b}let l=P.VSBuffer.alloc(o),h=0,m=0;for(;o>0;){const b=this._chunks[m];if(b.byteLength>o){const c=b.slice(0,o);l.set(c,h),h+=o,r&&(this._chunks[m]=b.slice(o),this._totalLength-=o),o-=o}else l.set(b,h),h+=b.byteLength,r?(this._chunks.shift(),this._totalLength-=b.byteLength):m++,o-=b.byteLength}return l}}e.ChunkStream=R;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var w;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,r,l,h){this.type=o,this.id=r,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends T.Disposable{constructor(o){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const l=this._state.messageType,h=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(l,h,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const l=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,l}_bufferTake(){const o=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends T.Disposable{constructor(o){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=S;class v extends I.IPCClient{constructor(o,r,l=null){super(o,r,l);this.protocol=o}static fromSocket(o,r){return new v(new S(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class p{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,l=this._first;for(;l;)o[r++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new p(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<a._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=a._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),r=(1+a._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<a._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=r&&l++;return 1-l/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=a.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new g(4,0,0,i());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,l=o.length;r<l;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let l=0,h=r.length;l<h;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new g(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const r=new g(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[103],ve([0,1,92]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(A){let y=(0,E.toUint8)(A);this._defaultValue=y,this._asciiMap=I._createAsciiMap(y),this._map=new Map}static _createAsciiMap(A){let y=new Uint8Array(256);for(let i=0;i<256;i++)y[i]=A;return y}set(A,y){let i=(0,E.toUint8)(y);A>=0&&A<256?this._asciiMap[A]=i:this._map.set(A,i)}get(A){return A>=0&&A<256?this._asciiMap[A]:this._map.get(A)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new I(0)}add(A){this._actual.set(A,1)}has(A){return this._actual.get(A)===1}}e.CharacterSet=P}),define(ge[137],ve([0,1,103]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends E.CharacterClassifier{constructor(A){super(0);for(let y=0,i=A.length;y<i;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(D){let A={};return y=>(A.hasOwnProperty(y)||(A[y]=D(y)),A[y])}e.getMapForWordSeparators=P(D=>new T(D))}),define(ge[49],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new E(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return E.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return E.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return E.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let D=T.lineNumber|0,A=P.lineNumber|0;if(D===A){let y=T.column|0,i=P.column|0;return y-i}return D-A}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new E(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=E}),define(ge[43],ve([0,1,49]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(P,D,A,y){P>A||P===A&&D>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=P,this.endColumn=D):(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return I.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return I.containsPosition(this,P)}static containsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<P.startColumn||D.lineNumber===P.endLineNumber&&D.column>P.endColumn)}containsRange(P){return I.containsRange(this,P)}static containsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>P.endColumn)}strictContainsRange(P){return I.strictContainsRange(this,P)}static strictContainsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<=P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>=P.endColumn)}plusRange(P){return I.plusRange(this,P)}static plusRange(P,D){let A,y,i,R;return D.startLineNumber<P.startLineNumber?(A=D.startLineNumber,y=D.startColumn):D.startLineNumber===P.startLineNumber?(A=D.startLineNumber,y=Math.min(D.startColumn,P.startColumn)):(A=P.startLineNumber,y=P.startColumn),D.endLineNumber>P.endLineNumber?(i=D.endLineNumber,R=D.endColumn):D.endLineNumber===P.endLineNumber?(i=D.endLineNumber,R=Math.max(D.endColumn,P.endColumn)):(i=P.endLineNumber,R=P.endColumn),new I(A,y,i,R)}intersectRanges(P){return I.intersectRanges(this,P)}static intersectRanges(P,D){let A=P.startLineNumber,y=P.startColumn,i=P.endLineNumber,R=P.endColumn,C=D.startLineNumber,w=D.startColumn,g=D.endLineNumber,s=D.endColumn;return A<C?(A=C,y=w):A===C&&(y=Math.max(y,w)),i>g?(i=g,R=s):i===g&&(R=Math.min(R,s)),A>i||A===i&&y>R?null:new I(A,y,i,R)}equalsRange(P){return I.equalsRange(this,P)}static equalsRange(P,D){return!!P&&!!D&&P.startLineNumber===D.startLineNumber&&P.startColumn===D.startColumn&&P.endLineNumber===D.endLineNumber&&P.endColumn===D.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(P){return new E.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(P){return new E.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,D){return new I(this.startLineNumber,this.startColumn,P,D)}setStartPosition(P,D){return new I(P,D,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(P){return new I(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,D=P){return new I(P.lineNumber,P.column,D.lineNumber,D.column)}static lift(P){return P?new I(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<P.startColumn)}static areIntersecting(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<=D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,D){if(P&&D){const i=P.startLineNumber|0,R=D.startLineNumber|0;if(i===R){const C=P.startColumn|0,w=D.startColumn|0;if(C===w){const g=P.endLineNumber|0,s=D.endLineNumber|0;if(g===s){const d=P.endColumn|0,S=D.endColumn|0;return d-S}return g-s}return C-w}return i-R}return(P?1:0)-(D?1:0)}static compareRangesUsingEnds(P,D){return P.endLineNumber===D.endLineNumber?P.endColumn===D.endColumn?P.startLineNumber===D.startLineNumber?P.startColumn-D.startColumn:P.startLineNumber-D.startLineNumber:P.endColumn-D.endColumn:P.endLineNumber-D.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=I}),define(ge[138],ve([0,1,49,43]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends I.Range{constructor(A,y,i,R){super(A,y,i,R);this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=i,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return P.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,A,y):new P(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(A,y){return this.getDirection()===0?new P(A,y,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new P(A.lineNumber,A.column,y.lineNumber,y.column)}static liftSelection(A){return new P(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let i=0,R=A.length;i<R;i++)if(!this.selectionsEqual(A[i],y[i]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,i,R,C){return C===0?new P(A,y,i,R):new P(i,R,A,y)}}e.Selection=P}),define(ge[104],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class y{constructor(s,d){this.range=s,this.matches=d}}e.FindMatch=y;var i;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(s,d,S,v,_,p){this.identifier=s,this.range=d,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=_,this._isTracked=p}}e.ValidAnnotatedEditOperation=C;class w{constructor(s,d,S){this.reverseEdits=s,this.changes=d,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=w}),define(ge[139],ve([0,1,10,137,49,43,104]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,u,a,t){this.searchString=p,this.isRegex=u,this.matchCase=a,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=i(this.searchString):p=this.searchString.indexOf(`
`)>=0;let u=null;try{u=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let a=!this.isRegex&&!p;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new R(u,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=y;function i(_){if(!_||_.length===0)return!1;for(let p=0,u=_.length;p<u;p++)if(_.charCodeAt(p)===92){if(p++,p>=u)break;const t=_.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class R{constructor(p,u,a){this.regex=p,this.wordSeparators=u,this.simpleSearch=a}}e.SearchData=R;function C(_,p,u){if(!u)return new D.FindMatch(_,null);let a=[];for(let t=0,n=p.length;t<n;t++)a[t]=p[t];return new D.FindMatch(_,a)}e.createFindMatch=C;class w{constructor(p){let u=[],a=0;for(let t=0,n=p.length;t<n;t++)p.charCodeAt(t)===10&&(u[a++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(p){const u=this._lineFeedsOffsets;let a=0,t=u.length-1;if(t===-1||p<=u[0])return 0;for(;a<t;){const n=a+((t-a)/2>>0);u[n]>=p?t=n-1:u[n+1]>=p?(a=n,t=n):a=n+1}return a+1}}class g{static findMatches(p,u,a,t,n){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(p,a,new v(o.wordSeparators,o.regex),t,n):this._doFindMatchesLineByLine(p,a,o,t,n):[]}static _getMultilineMatchRange(p,u,a,t,n,o){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(n),r=u+n+l):r=u+n;let h;if(t){let f=t.findLineFeedCountBeforeOffset(n+o.length)-l;h=r+o.length+f}else h=r+o.length;const m=p.getPositionAt(r),b=p.getPositionAt(h);return new P.Range(m.lineNumber,m.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(p,u,a,t,n){const o=p.getOffsetAt(u.getStartPosition()),r=p.getValueInRange(u,1),l=p.getEOL()===`\r
`?new w(r):null,h=[];let m=0,b;for(a.reset(0);b=a.next(r);)if(h[m++]=C(this._getMultilineMatchRange(p,o,r,l,b.index,b[0]),b,t),m>=n)return h;return h}static _doFindMatchesLineByLine(p,u,a,t,n){const o=[];let r=0;if(u.startLineNumber===u.endLineNumber){const h=p.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(a,h,u.startLineNumber,u.startColumn-1,r,o,t,n),o}const l=p.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(a,l,u.startLineNumber,u.startColumn-1,r,o,t,n);for(let h=u.startLineNumber+1;h<u.endLineNumber&&r<n;h++)r=this._findMatchesInLine(a,p.getLineContent(h),h,0,r,o,t,n);if(r<n){const h=p.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(a,h,u.endLineNumber,0,r,o,t,n)}return o}static _findMatchesInLine(p,u,a,t,n,o,r,l){const h=p.wordSeparators;if(!r&&p.simpleSearch){const c=p.simpleSearch,f=c.length,k=u.length;let L=-f;for(;(L=u.indexOf(c,L+f))!==-1;)if((!h||S(h,u,k,L,f))&&(o[n++]=new D.FindMatch(new P.Range(a,L+1+t,a,L+1+f+t),null),n>=l))return n;return n}const m=new v(p.wordSeparators,p.regex);let b;m.reset(0);do if(b=m.next(u),b&&(o[n++]=C(new P.Range(a,b.index+1+t,a,b.index+1+b[0].length+t),b,r),n>=l))return n;while(b);return n}static findNextMatch(p,u,a,t){const n=u.parseSearchRequest();if(!n)return null;const o=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(p,a,o,t):this._doFindNextMatchLineByLine(p,a,o,t)}static _doFindNextMatchMultiline(p,u,a,t){const n=new T.Position(u.lineNumber,1),o=p.getOffsetAt(n),r=p.getLineCount(),l=p.getValueInRange(new P.Range(n.lineNumber,n.column,r,p.getLineMaxColumn(r)),1),h=p.getEOL()===`\r
`?new w(l):null;a.reset(u.column-1);let m=a.next(l);return m?C(this._getMultilineMatchRange(p,o,l,h,m.index,m[0]),m,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(p,new T.Position(1,1),a,t):null}static _doFindNextMatchLineByLine(p,u,a,t){const n=p.getLineCount(),o=u.lineNumber,r=p.getLineContent(o),l=this._findFirstMatchInLine(a,r,o,u.column,t);if(l)return l;for(let h=1;h<=n;h++){const m=(o+h-1)%n,b=p.getLineContent(m+1),c=this._findFirstMatchInLine(a,b,m+1,1,t);if(c)return c}return null}static _findFirstMatchInLine(p,u,a,t,n){p.reset(t-1);const o=p.next(u);return o?C(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,n):null}static findPreviousMatch(p,u,a,t){const n=u.parseSearchRequest();if(!n)return null;const o=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(p,a,o,t):this._doFindPreviousMatchLineByLine(p,a,o,t)}static _doFindPreviousMatchMultiline(p,u,a,t){const n=this._doFindMatchesMultiline(p,new P.Range(1,1,u.lineNumber,u.column),a,t,10*A);if(n.length>0)return n[n.length-1];const o=p.getLineCount();return u.lineNumber!==o||u.column!==p.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(p,new T.Position(o,p.getLineMaxColumn(o)),a,t):null}static _doFindPreviousMatchLineByLine(p,u,a,t){const n=p.getLineCount(),o=u.lineNumber,r=p.getLineContent(o).substring(0,u.column-1),l=this._findLastMatchInLine(a,r,o,t);if(l)return l;for(let h=1;h<=n;h++){const m=(n+o-h-1)%n,b=p.getLineContent(m+1),c=this._findLastMatchInLine(a,b,m+1,t);if(c)return c}return null}static _findLastMatchInLine(p,u,a,t){let n=null,o;for(p.reset(0);o=p.next(u);)n=C(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,t);return n}}e.TextModelSearch=g;function s(_,p,u,a,t){if(a===0)return!0;const n=p.charCodeAt(a-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=p.charCodeAt(a);if(_.get(o)!==0)return!0}return!1}function d(_,p,u,a,t){if(a+t===u)return!0;const n=p.charCodeAt(a+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=p.charCodeAt(a+t-1);if(_.get(o)!==0)return!0}return!1}function S(_,p,u,a,t){return s(_,p,u,a,t)&&d(_,p,u,a,t)}e.isValidMatch=S;class v{constructor(p,u){this._wordSeparators=p,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const u=p.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(a=this._searchRegex.exec(p),!a))return null;const t=a.index,n=a[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){E.getNextCodePoint(p,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||S(this._wordSeparators,p,u,t,n))return a}while(a);return null}}e.Searcher=v}),define(ge[105],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(A=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)A.indexOf(i)>=0||(y+="\\"+i);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function I(A){let y=e.DEFAULT_WORD_REGEXP;if(A&&A instanceof RegExp)if(A.global)y=A;else{let i="g";A.ignoreCase&&(i+="i"),A.multiline&&(i+="m"),A.unicode&&(i+="u"),y=new RegExp(A.source,i)}return y.lastIndex=0,y}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(A,y,i,R,C=T){if(i.length>C.maxLen){let S=A-C.maxLen/2;return S<0?S=0:R+=S,i=i.substring(S,A+C.maxLen/2),P(A,y,i,R,C)}const w=Date.now(),g=A-1-R;let s=-1,d=null;for(let S=1;!(Date.now()-w>=C.timeBudget);S++){const v=g-C.windowSize*S;y.lastIndex=Math.max(0,v);const _=D(y,i,g,s);if(!_&&d||(d=_,v<=0))break;s=v}if(d){let S={word:d[0],startColumn:R+1+d.index,endColumn:R+1+d.index+d[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=P;function D(A,y,i,R){let C;for(;C=A.exec(y);){const w=C.index||0;if(w<=i&&A.lastIndex>=i)return C;if(R>0&&w>R)return null}return null}}),define(ge[140],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let y=0,i=A.notIn.length;y<i;y++)switch(A.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)P(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),P(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),P(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),P(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&P(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function P(D,A,y){D.has(A)?D.get(A).push(y):D.set(A,[y])}}),define(ge[76],ve([0,1,33,8]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,D,A,y){if(Array.isArray(P)){let i=0;for(const R of P){const C=T(R,D,A,y);if(C===10)return C;C>i&&(i=C)}return i}else{if(typeof P=="string")return y?P==="*"?5:P===A?10:0:0;if(P){const{language:i,pattern:R,scheme:C,hasAccessToAllModels:w}=P;if(!y&&!w)return 0;let g=0;if(C)if(C===D.scheme)g=10;else if(C==="*")g=5;else return 0;if(i)if(i===A)g=10;else if(i==="*")g=Math.max(g,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s=Object.assign(Object.assign({},R),{base:(0,I.normalize)(R.base)}),s===D.fsPath||(0,E.match)(s,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=T}),define(ge[141],ve([0,1,103]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(s,d,S){const v=new Uint8Array(s*d);for(let _=0,p=s*d;_<p;_++)v[_]=S;this._data=v,this.rows=s,this.cols=d}get(s,d){return this._data[s*this.cols+d]}set(s,d,S){this._data[s*this.cols+d]=S}}e.Uint8Matrix=T;class P{constructor(s){let d=0,S=0;for(let _=0,p=s.length;_<p;_++){let[u,a,t]=s[_];a>d&&(d=a),u>S&&(S=u),t>S&&(S=t)}d++,S++;let v=new T(S,d,0);for(let _=0,p=s.length;_<p;_++){let[u,a,t]=s[_];v.set(u,a,t)}this._states=v,this._maxCharCode=d}nextState(s,d){return d<0||d>=this._maxCharCode?0:this._states.get(s,d)}}e.StateMachine=P;let D=null;function A(){return D===null&&(D=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let i=null;function R(){if(i===null){i=new E.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<g.length;d++)i.set(g.charCodeAt(d),1);const s=".,;";for(let d=0;d<s.length;d++)i.set(s.charCodeAt(d),2)}return i}class C{static _createLink(s,d,S,v,_){let p=_-1;do{const u=d.charCodeAt(p);if(s.get(u)!==2)break;p--}while(p>v);if(v>0){const u=d.charCodeAt(v-1),a=d.charCodeAt(p);(u===40&&a===41||u===91&&a===93||u===123&&a===125)&&p--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:p+2},url:d.substring(v,p+1)}}static computeLinks(s,d=A()){const S=R();let v=[];for(let _=1,p=s.getLineCount();_<=p;_++){const u=s.getLineContent(_),a=u.length;let t=0,n=0,o=0,r=1,l=!1,h=!1,m=!1,b=!1;for(;t<a;){let c=!1;const f=u.charCodeAt(t);if(r===13){let k;switch(f){case 40:l=!0,k=0;break;case 41:k=l?0:1;break;case 91:m=!0,h=!0,k=0;break;case 93:m=!1,k=h?0:1;break;case 123:b=!0,k=0;break;case 125:k=b?0:1;break;case 39:k=o===34||o===96?0:1;break;case 34:k=o===39||o===96?0:1;break;case 96:k=o===39||o===34?0:1;break;case 42:k=o===42?1:0;break;case 124:k=o===124?1:0;break;case 32:k=m?0:1;break;default:k=S.get(f)}k===1&&(v.push(C._createLink(S,u,_,n,t)),c=!0)}else if(r===12){let k;f===91?(h=!0,k=0):k=S.get(f),k===1?c=!0:r=13}else r=d.nextState(r,f),r===0&&(c=!0);c&&(r=1,l=!1,h=!1,b=!1,n=t+1,o=f),t++}r===13&&v.push(C._createLink(S,u,_,n,a))}return v}}e.LinkComputer=C;function w(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:C.computeLinks(g)}e.computeLinks=w}),define(ge[142],ve([0,1,3,6]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,A){return this._map.set(D,A),this.fire([D]),(0,I.toDisposable)(()=>{this._map.get(D)===A&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,A){let y=null,i=!1;return this._promises.set(D,A.then(R=>{this._promises.delete(D),!(i||!R)&&(y=this.register(D,R))})),(0,I.toDisposable)(()=>{i=!0,y&&y.dispose()})}getPromise(D){const A=this.get(D);if(A)return Promise.resolve(A);const y=this._promises.get(D);return y?y.then(i=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[106],ve([0,1,22,9]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function P(C){for(let w=0,g=C.length;w<g;w+=4){const s=C[w+0],d=C[w+1],S=C[w+2],v=C[w+3];C[w+0]=v,C[w+1]=S,C[w+2]=d,C[w+3]=s}}function D(C){const w=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||P(w),E.VSBuffer.wrap(w)}function A(C){const w=C.buffer;if(I.isLittleEndian()||P(w),w.byteOffset%4==0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const g=new Uint8Array(w.byteLength);return g.set(w),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(C){const w=new Uint32Array(i(C));let g=0;if(w[g++]=C.id,C.type==="full")w[g++]=1,w[g++]=C.data.length,w.set(C.data,g),g+=C.data.length;else{w[g++]=2,w[g++]=C.deltas.length;for(const s of C.deltas)w[g++]=s.start,w[g++]=s.deleteCount,s.data?(w[g++]=s.data.length,w.set(s.data,g),g+=s.data.length):w[g++]=0}return D(w)}e.encodeSemanticTokensDto=y;function i(C){let w=0;if(w+=1+1,C.type==="full")w+=1+C.data.length;else{w+=1,w+=(1+1+1)*C.deltas.length;for(const g of C.deltas)g.data&&(w+=g.data.length)}return w}function R(C){const w=A(C);let g=0;const s=w[g++];if(w[g++]===1){const _=w[g++],p=w.subarray(g,g+_);return g+=_,{id:s,type:"full",data:p}}const S=w[g++];let v=[];for(let _=0;_<S;_++){const p=w[g++],u=w[g++],a=w[g++];let t;a>0&&(t=w.subarray(g,g+a),g+=a),v[_]={start:p,deleteCount:u,data:t}}return{id:s,type:"delta",deltas:v}}e.decodeSemanticTokensDto=R}),define(ge[107],ve([0,1,92]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(D,A){this.index=D,this.remainder=A}}e.PrefixSumIndexOfResult=I;class T{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,A){D=(0,E.toUint32)(D);const y=this.values,i=this.prefixSum,R=A.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+R),this.values.set(A,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,A){return D=(0,E.toUint32)(D),A=(0,E.toUint32)(A),this.values[D]===A?!1:(this.values[D]=A,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,A){D=(0,E.toUint32)(D),A=(0,E.toUint32)(A);const y=this.values,i=this.prefixSum;if(D>=y.length)return!1;let R=y.length-D;return A>=R&&(A=R),A===0?!1:(this.values=new Uint32Array(y.length-A),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+A),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,E.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),D>=this.values.length&&(D=this.values.length-1);for(let y=A;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let A=0,y=this.values.length-1,i=0,R=0,C=0;for(;A<=y;)if(i=A+(y-A)/2|0,R=this.prefixSum[i],C=R-this.values[i],D<C)y=i-1;else if(D>=R)A=i+1;else break;return new I(i,D-C)}}e.PrefixSumComputer=T}),define(ge[143],ve([0,1,10,49,107]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(A,y,i,R){this._uri=A,this._lines=y,this._eol=i,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(A){A.eol&&A.eol!==this._eol&&(this._eol=A.eol,this._lineStarts=null);const y=A.changes;for(const i of y)this._acceptDeleteRange(i.range),this._acceptInsertText(new I.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=A.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const A=this._eol.length,y=this._lines.length,i=new Uint32Array(y);for(let R=0;R<y;R++)i[R]=this._lines[R].length+A;this._lineStarts=new T.PrefixSumComputer(i)}}_setLineText(A,y){this._lines[A]=y,this._lineStarts&&this._lineStarts.changeValue(A,this._lines[A].length+this._eol.length)}_acceptDeleteRange(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.startLineNumber-1].substring(A.endColumn-1));return}this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.endLineNumber-1].substring(A.endColumn-1)),this._lines.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}_acceptInsertText(A,y){if(y.length!==0){let i=(0,E.splitLines)(y);if(i.length===1){this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+i[0]+this._lines[A.lineNumber-1].substring(A.column-1));return}i[i.length-1]+=this._lines[A.lineNumber-1].substring(A.column-1),this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+i[0]);let R=new Uint32Array(i.length-1);for(let C=1;C<i.length;C++)this._lines.splice(A.lineNumber+C-1,0,i[C]),R[C-1]=i[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(A.lineNumber,R)}}}e.MirrorTextModel=P}),define(ge[144],ve([15,16]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ge[145],ve([0,1,144]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,P=T*24,D=P*7,A=P*30,y=P*365;function i(C,w){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,E.localize)(0,null,i(new Date().getTime()+g*1e3,!1));if(g<30)return(0,E.localize)(1,null);let s;return g<I?(s=g,w?s===1?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):s===1?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s)):g<T?(s=Math.floor(g/I),w?s===1?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):s===1?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):g<P?(s=Math.floor(g/T),w?s===1?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):s===1?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s)):g<D?(s=Math.floor(g/P),w?s===1?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):s===1?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):g<A?(s=Math.floor(g/D),w?s===1?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):s===1?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s)):g<y?(s=Math.floor(g/A),w?s===1?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):s===1?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):(s=Math.floor(g/y),w?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s))}e.fromNow=i;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ge[146],ve([15,16]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ge[58],ve([0,1,146,14,18]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(i,R){return R&&(i.stack||i.stacktrace)?E.localize(0,null,A(i),D(i.stack)||D(i.stacktrace)):A(i)}function D(i){return Array.isArray(i)?i.join(`
`):i}function A(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?E.localize(1,null,i.message):i.message||E.localize(2,null)}function y(i=null,R=!1){if(!i)return E.localize(3,null);if(Array.isArray(i)){const C=T.coalesce(i),w=y(C[0],R);return C.length>1?E.localize(4,null,w,C.length):w}if(I.isString(i))return i;if(i.detail){const C=i.detail;if(C.error)return P(C.error,R);if(C.exception)return P(C.exception,R)}return i.stack?P(i,R):i.message?i.message:E.localize(5,null)}e.toErrorMessage=y}),define(ge[147],ve([15,16]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ge[77],ve([0,1,8,37,26,38,147,36,14,23,30,9,136,11]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function s(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(a,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=P.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(r=>{o.once("error",l=>{r({success:!1,error:l})}),o.once("exit",(l,h)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?s(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(o=>{P.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,l,h)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function S(a=A.env){return a.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,n,o,r){if(n!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=r;else{const l=t;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(A.env).forEach(h=>{l[h]=A.env[h]}),Object.keys(this.options.env).forEach(h=>{l[h]=this.options.env[h]}),this.options.env=l}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(E.sep);return n!==-1&&(t=t.substring(n+1)),v.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(A.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(n=>{let o,r;const l=new Promise((h,m)=>{o=h,r=m});if(n){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=P.exec(h,this.options,(m,b,c)=>{this.childProcess=null;const f=m;f&&f.killed?r({killed:this.terminateRequested,stdout:b.toString(),stderr:c.toString()}):this.handleExec(o,t,m,b,c)})}else{let h=null;const m=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,o,t,r);const c={terminated:this.terminateRequested};y.isNumber(b)&&(c.cmdCode=b),o(c)};if(this.shell&&C.isWindows){const b=i.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let c=!1,f=!1;const k=[];let L=this.ensureQuotes(this.cmd);k.push(L.value),c=L.quoted,this.args&&this.args.forEach(ee=>{L=this.ensureQuotes(ee),k.push(L.value),f=f&&L.quoted});const $=["/s","/c"];c?f?$.push('"'+k.join(" ")+'"'):k.length>1?$.push('"'+k[0]+'" '+k.slice(1).join(" ")):$.push('"'+k[0]+'"'):$.push(k.join(" ")),h=P.spawn(S(),$,b)}else this.cmd&&(h=P.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(y.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",b=>{this.childProcess=null,r({terminated:this.terminateRequested,error:b})}),h.pid&&(this.childProcess.on("close",m),this.handleSpawn(h,o,t,r,!0)))}return l})}handleClose(t,n,o,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=P.spawn(S(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class _ extends v{constructor(t,n,o,r){super(t,n,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,r,l){[r,l].forEach((h,m)=>{const b=new w.LineDecoder;b.write(h).forEach(k=>{n({line:k,source:m===0?0:1})});const f=b.end();f&&n({line:f,source:m===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,r,l){const h=new w.LineDecoder,m=new w.LineDecoder;t.stdout.on("data",b=>{h.write(b).forEach(f=>o({line:f,source:0}))}),t.stderr.on("data",b=>{m.write(b).forEach(f=>o({line:f,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=m}handleClose(t,n,o,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&o({line:l,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&o({line:h,source:1})}}e.LineProcess=_;function p(a){let t=[],n=!1;const o=function(r){if(n){t.push(r);return}(!a.send(r,h=>{if(h&&console.error(h),n=!1,t.length>0){const m=t.slice(0);t=[],m.forEach(b=>o(b))}})||C.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=p;var u;(function(a){async function t(n,o,r){if(E.isAbsolute(n))return n;if(o===void 0&&(o=A.cwd()),E.dirname(n)!=="."||(r===void 0&&y.isString(A.env.PATH)&&(r=A.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(o,n);async function h(m){return await T.exists(m)?!(await I.promises.stat(m)).isDirectory():!1}for(let m of r){let b;if(E.isAbsolute(m)?b=E.join(m,n):b=E.join(o,m,n),await h(b))return b;let c=b+".com";if(await h(c)||(c=b+".exe",await h(c)))return c}return E.join(o,n)}a.findExecutable=t})(u=e.win32||(e.win32={}))}),define(ge[148],ve([0,1,48,9,100,77]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,s){return g===3?I.isWindows?C():P.getWindowsShell(s):i(g,s)}e.getSystemShell=D;function A(g,s){return g===3?I.isWindows?w(s):P.getWindowsShell(s):i(g,s)}e.getSystemShellSync=A;let y=null;function i(g,s){if(I.isLinux&&g===1||I.isMacintosh&&g===2)return"/bin/bash";if(!y){let d;if(I.isWindows)d="/bin/bash";else{if(d=s.SHELL,!d)try{d=E.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let R=null;async function C(){return R||(R=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),R}function w(g){if(R)return R;const s=I.isWindows&&parseFloat(E.release())>=10,d=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return s?S:P.getWindowsShell(g)}}),define(ge[149],ve([15,16]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],ve([0,1,149,9,105]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=D;class A{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,Ee){this._values[re]=Ee}}e.ValidatedEditorOptions=A;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class i{constructor(re,Ee,Ne,Ve){this.id=re,this.name=Ee,this.defaultValue=Ne,this.schema=Ve}compute(re,Ee,Ne){return Ne}}class R{constructor(re,Ee=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(re){return this.defaultValue}}class C{constructor(re,Ee,Ne,Ve){this.id=re,this.name=Ee,this.defaultValue=Ne,this.schema=Ve}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Ee,Ne){return Ne}}function w(G,re){return typeof G=="undefined"?re:G==="false"?!1:Boolean(G)}e.boolean=w;class g extends C{constructor(re,Ee,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(re,Ee,Ne,Ve)}validate(re){return w(re,this.defaultValue)}}class s extends C{constructor(re,Ee,Ne,Ve,Be,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Ne,et.minimum=Ve,et.maximum=Be),super(re,Ee,Ne,et),this.minimum=Ve,this.maximum=Be}static clampedInt(re,Ee,Ne,Ve){if(typeof re=="undefined")return Ee;let Be=parseInt(re,10);return isNaN(Be)?Ee:(Be=Math.max(Ne,Be),Be=Math.min(Ve,Be),Be|0)}validate(re){return s.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(re,Ee,Ne,Ve,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Ne),super(re,Ee,Ne,Be),this.validationFn=Ve}static clamp(re,Ee,Ne){return re<Ee?Ee:re>Ne?Ne:re}static float(re,Ee){if(typeof re=="number")return re;if(typeof re=="undefined")return Ee;const Ne=parseFloat(re);return isNaN(Ne)?Ee:Ne}validate(re){return this.validationFn(d.float(re,this.defaultValue))}}class S extends C{static string(re,Ee){return typeof re!="string"?Ee:re}constructor(re,Ee,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(re,Ee,Ne,Ve)}validate(re){return S.string(re,this.defaultValue)}}function v(G,re,Ee){return typeof G!="string"||Ee.indexOf(G)===-1?re:G}e.stringSet=v;class _ extends C{constructor(re,Ee,Ne,Ve,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=Ve,Be.default=Ne),super(re,Ee,Ne,Be),this._allowedValues=Ve}validate(re){return v(re,this.defaultValue,this._allowedValues)}}class p extends i{constructor(re,Ee,Ne,Ve,Be,et,q=void 0){typeof q!="undefined"&&(q.type="string",q.enum=Be,q.default=Ve),super(re,Ee,Ne,q),this._allowedValues=Be,this._convert=et}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function u(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ee,Ne){return Ne===0?re.accessibilitySupport:Ne}}class t extends i{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:E.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{insertSpace:w(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(G){switch(G){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function h(G){switch(G){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class m extends R{constructor(){super(123,[62,31])}compute(re,Ee,Ne){const Ve=["monaco-editor"];return Ee.get(31)&&Ve.push(Ee.get(31)),re.extraEditorClassName&&Ve.push(re.extraEditorClassName),Ee.get(62)==="default"?Ve.push("mouse-default"):Ee.get(62)==="copy"&&Ve.push("mouse-copy"),Ee.get(97)&&Ve.push("showUnused"),Ee.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class b extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(re,Ee,Ne){return Ne&&re.emptySelectionClipboard}}class c extends i{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:E.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:E.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{cursorMoveOnType:w(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:w(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":v(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(Ee.loop,this.defaultValue.loop)}}}class f extends i{constructor(){super(41,"fontLigatures",f.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?f.OFF:re==="true"?f.ON:re:Boolean(re)?f.ON:f.OFF}}e.EditorFontLigatures=f,f.OFF='"liga" off, "calt" off',f.ON='"liga" on, "calt" on';class k extends R{constructor(){super(40)}compute(re,Ee,Ne){return re.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(re){let Ee=d.float(re,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ee,6,100)}compute(re,Ee,Ne){return re.fontInfo.fontSize}}class $ extends i{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(s.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class ee extends i{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(re){var Ee,Ne,Ve,Be,et;if(!re||typeof re!="object")return this.defaultValue;const q=re;return{multiple:v(q.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=q.multipleDefinitions)!==null&&Ee!==void 0?Ee:v(q.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=q.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:v(q.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=q.multipleDeclarations)!==null&&Ve!==void 0?Ve:v(q.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=q.multipleImplementations)!==null&&Be!==void 0?Be:v(q.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=q.multipleReferences)!==null&&et!==void 0?et:v(q.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(q.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(q.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(q.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(q.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(q.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends i{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:E.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:w(Ee.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:w(Ee.sticky,this.defaultValue.sticky)}}}var x;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class B extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,Ee,Ne){return B.computeLayout(Ee,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Ee=re.height/re.lineHeight,Ne=re.scrollBeyondLastLine?Ee-1:0,Ve=(re.viewLineCount+Ne)/(re.pixelRatio*re.height),Be=Math.floor(re.viewLineCount/Ve);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:Be}}static _computeMinimapLayout(re,Ee){const Ne=re.outerWidth,Ve=re.outerHeight,Be=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const et=Ee.stableMinimapLayoutInput,q=et&&re.outerHeight===et.outerHeight&&re.lineHeight===et.lineHeight&&re.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&re.pixelRatio===et.pixelRatio&&re.scrollBeyondLastLine===et.scrollBeyondLastLine&&re.minimap.enabled===et.minimap.enabled&&re.minimap.side===et.minimap.side&&re.minimap.size===et.minimap.size&&re.minimap.showSlider===et.minimap.showSlider&&re.minimap.renderCharacters===et.minimap.renderCharacters&&re.minimap.maxColumn===et.minimap.maxColumn&&re.minimap.scale===et.minimap.scale&&re.verticalScrollbarWidth===et.verticalScrollbarWidth&&re.isViewportWrapping===et.isViewportWrapping,oe=re.lineHeight,he=re.typicalHalfwidthCharacterWidth,Z=re.scrollBeyondLastLine,ne=re.minimap.renderCharacters;let le=Be>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const pe=re.minimap.maxColumn,_e=re.minimap.size,He=re.minimap.side,We=re.verticalScrollbarWidth,qe=re.viewLineCount,Ye=re.remainingWidth,Ze=re.isViewportWrapping,ut=ne?2:3;let ot=Math.floor(Be*Ve);const nt=ot/Be;let ue=!1,Ce=!1,ce=ut*le,J=le/Be,Re=1;if(_e==="fill"||_e==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:Et}=B.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:Z,height:Ve,lineHeight:oe,pixelRatio:Be});if(qe/Et>1)ue=!0,Ce=!0,le=1,ce=1,J=le/Be;else{let wt=!1,St=le+1;if(_e==="fit"){const pt=Math.ceil((qe+st)*ce);Ze&&q&&Ye<=Ee.stableFitRemainingWidth?(wt=!0,St=Ee.stableFitMaxMinimapScale):(wt=pt>ot,Ze&&wt?(Ee.stableMinimapLayoutInput=re,Ee.stableFitRemainingWidth=Ye):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(_e==="fill"||wt){ue=!0;const pt=le;ce=Math.min(oe*Be,Math.max(1,Math.floor(1/gt))),le=Math.min(St,Math.max(1,Math.floor(ce/ut))),le>pt&&(Re=Math.min(2,le/pt)),J=le/Be/Re,ot=Math.ceil(Math.max(ct,qe+st)*ce),Ze&&wt&&(Ee.stableFitMaxMinimapScale=le)}}}const Le=Math.floor(pe*J),Je=Math.min(Le,Math.max(0,Math.floor((Ye-We-2)*J/(he+J)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Be*Je);const rt=Ge/Be;Ge=Math.floor(Ge*Re);const at=ne?1:2,Qe=He==="left"?0:Ne-Je-We;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Je,minimapHeightIsEditorHeight:ue,minimapIsSampling:Ce,minimapScale:le,minimapLineHeight:ce,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(re,Ee){const Ne=Ee.outerWidth|0,Ve=Ee.outerHeight|0,Be=Ee.lineHeight|0,et=Ee.lineNumbersDigitCount|0,q=Ee.typicalHalfwidthCharacterWidth,oe=Ee.maxDigitWidth,he=Ee.pixelRatio,Z=Ee.viewLineCount,ne=re.get(118),le=ne==="inherit"?re.get(117):ne,pe=le==="inherit"?re.get(113):le,_e=re.get(116),He=re.get(2),We=Ee.isDominatedByLongLines,qe=re.get(46),Ye=re.get(56).renderType!==0,Ze=re.get(57),ut=re.get(91),ot=re.get(61),nt=re.get(89),ue=nt.verticalScrollbarSize,Ce=nt.verticalHasArrows,ce=nt.arrowSize,J=nt.horizontalScrollbarSize,Re=re.get(54),Le=re.get(35);let Je;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const ft=parseFloat(Re.substr(0,Re.length-2));Je=s.clampedInt(ft*q,0,0,1e3)}else Je=s.clampedInt(Re,0,0,1e3);Le&&(Je+=16);let Ge=0;if(Ye){const ft=Math.max(et,Ze);Ge=Math.round(ft*oe)}let rt=0;qe&&(rt=Be);let at=0,Qe=at+rt,ct=Qe+Ge,st=ct+Je;const gt=Ne-rt-Ge-Je;let Et=!1,Dt=!1,wt=-1;He!==2&&(le==="inherit"&&We?(Et=!0,Dt=!0):pe==="on"||pe==="bounded"?Dt=!0:pe==="wordWrapColumn"&&(wt=_e));const St=B._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:Be,typicalHalfwidthCharacterWidth:q,pixelRatio:he,scrollBeyondLastLine:ut,minimap:ot,verticalScrollbarWidth:ue,viewLineCount:Z,remainingWidth:gt,isViewportWrapping:Dt},Ee.memory||new y);St.renderMinimap!==0&&St.minimapLeft===0&&(at+=St.minimapWidth,Qe+=St.minimapWidth,ct+=St.minimapWidth,st+=St.minimapWidth);const pt=gt-St.minimapWidth,Lt=Math.max(1,Math.floor((pt-ue-2)/q)),Ft=Ce?ce:0;return Dt&&(wt=Math.max(1,Lt),pe==="bounded"&&(wt=Math.min(wt,_e))),{width:Ne,height:Ve,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ct,decorationsWidth:Je,contentLeft:st,contentWidth:pt,minimap:St,viewportColumn:Lt,isWordWrapMinified:Et,isViewportWrapping:Dt,wrappingColumn:wt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:J,overviewRuler:{top:Ft,width:ue,height:Ve-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=B;class F extends i{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:E.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:w(re.enabled,this.defaultValue.enabled)}}}class U extends i{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:E.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:w(Ee.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class M extends s{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(re,Ee,Ne){return re.fontInfo.lineHeight}}class N extends i{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:re.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:E.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:w(Ee.enabled,this.defaultValue.enabled),size:v(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Ee.side,this.defaultValue.side,["right","left"]),showSlider:v(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ee.scale,1,1,3),maxColumn:s.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(G){return G==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends i{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{top:s.clampedInt(Ee.top,0,0,1e3),bottom:s.clampedInt(Ee.bottom,0,0,1e3)}}}class K extends i{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:E.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:w(Ee.enabled,this.defaultValue.enabled),cycle:w(Ee.cycle,this.defaultValue.cycle)}}}class X extends R{constructor(){super(124)}compute(re,Ee,Ne){return re.pixelRatio}}class me extends i{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:E.localize(58,null)},comments:{type:"boolean",default:re.comments,description:E.localize(59,null)},other:{type:"boolean",default:re.other,description:E.localize(60,null)}}}],default:re,description:E.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const Ee=re,Ne={other:w(Ee.other,this.defaultValue.other),comments:w(Ee.comments,this.defaultValue.comments),strings:w(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends i{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(re){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Ee=4,Ne=re):re==="interval"?Ee=3:re==="relative"?Ee=2:re==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ie(G){const re=G.get(84);return re==="editable"?G.get(77):re!=="on"}e.filterValidationDecorations=Ie;class Me extends i{constructor(){const re=[],Ee={type:"number",description:E.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:re,description:E.localize(69,null)})}validate(re){if(Array.isArray(re)){let Ee=[];for(let Ne of re)if(typeof Ne=="number")Ee.push({column:s.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;Ee.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return Ee.sort((Ne,Ve)=>Ne.column-Ve.column),Ee}return this.defaultValue}}function V(G,re){if(typeof G!="string")return re;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends i{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re,Ne=s.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ee.vertical,this.defaultValue.vertical),horizontal:V(Ee.horizontal,this.defaultValue.horizontal),useShadows:w(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:s.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(Ee.verticalSliderSize,Ve,0,1e3),scrollByPage:w(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends i{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:re.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{insertMode:v(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:w(Ee.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:w(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(Ee.showMethods,this.defaultValue.showMethods),showFunctions:w(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:w(Ee.showConstructors,this.defaultValue.showConstructors),showFields:w(Ee.showFields,this.defaultValue.showFields),showVariables:w(Ee.showVariables,this.defaultValue.showVariables),showClasses:w(Ee.showClasses,this.defaultValue.showClasses),showStructs:w(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:w(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:w(Ee.showModules,this.defaultValue.showModules),showProperties:w(Ee.showProperties,this.defaultValue.showProperties),showEvents:w(Ee.showEvents,this.defaultValue.showEvents),showOperators:w(Ee.showOperators,this.defaultValue.showOperators),showUnits:w(Ee.showUnits,this.defaultValue.showUnits),showValues:w(Ee.showValues,this.defaultValue.showValues),showConstants:w(Ee.showConstants,this.defaultValue.showConstants),showEnums:w(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:w(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(Ee.showKeywords,this.defaultValue.showKeywords),showWords:w(Ee.showWords,this.defaultValue.showWords),showColors:w(Ee.showColors,this.defaultValue.showColors),showFiles:w(Ee.showFiles,this.defaultValue.showFiles),showReferences:w(Ee.showReferences,this.defaultValue.showReferences),showFolders:w(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:w(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:w(Ee.showUsers,this.defaultValue.showUsers),showIssues:w(Ee.showIssues,this.defaultValue.showIssues)}}}class ae extends i{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends R{constructor(){super(125,[77])}compute(re,Ee,Ne){return Ee.get(77)?!0:re.tabFocusMode}}var De;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends R{constructor(){super(127,[126])}compute(re,Ee,Ne){const Ve=Ee.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Te:I.isLinux?xe:ke,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useTabStops=111]="useTabStops",G[G.wordSeparators=112]="wordSeparators",G[G.wordWrap=113]="wordWrap",G[G.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=116]="wordWrapColumn",G[G.wordWrapOverride1=117]="wordWrapOverride1",G[G.wordWrapOverride2=118]="wordWrapOverride2",G[G.wrappingIndent=119]="wrappingIndent",G[G.wrappingStrategy=120]="wrappingStrategy",G[G.showDeprecated=121]="showDeprecated",G[G.inlineHints=122]="inlineHints",G[G.editorClassName=123]="editorClassName",G[G.pixelRatio=124]="pixelRatio",G[G.tabFocusMode=125]="tabFocusMode",G[G.layoutInfo=126]="layoutInfo",G[G.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:Se(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:Se(new a),accessibilityPageSize:Se(new s(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null),deprecationMessage:E.localize(115,null)})),ariaLabel:Se(new S(4,"ariaLabel",E.localize(116,null))),autoClosingBrackets:Se(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(117,null),E.localize(118,null),""],description:E.localize(119,null)})),autoClosingDelete:Se(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(120,null),""],description:E.localize(121,null)})),autoClosingOvertype:Se(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(122,null),""],description:E.localize(123,null)})),autoClosingQuotes:Se(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(124,null),E.localize(125,null),""],description:E.localize(126,null)})),autoIndent:Se(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null),E.localize(131,null)],description:E.localize(132,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(133,null),E.localize(134,null),E.localize(135,null),""],description:E.localize(136,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:E.localize(137,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:E.localize(138,null)})),codeLensFontFamily:Se(new S(13,"codeLensFontFamily","",{description:E.localize(139,null)})),codeLensFontSize:Se(new s(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(140,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:E.localize(141,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:E.localize(142,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(143,null)})),cursorBlinking:Se(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:E.localize(144,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(145,null)})),cursorStyle:Se(new p(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:E.localize(146,null)})),cursorSurroundingLines:Se(new s(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(147,null)})),cursorSurroundingLinesStyle:Se(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(148,null),E.localize(149,null)],description:E.localize(150,null)})),cursorWidth:Se(new s(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(151,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:E.localize(152,null)})),emptySelectionClipboard:Se(new b),extraEditorClassName:Se(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new d(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:E.localize(153,null)})),find:Se(new c),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:E.localize(154,null)})),foldingStrategy:Se(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(155,null),E.localize(156,null)],description:E.localize(157,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:E.localize(158,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(159,null)})),fontFamily:Se(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(160,null)})),fontInfo:Se(new k),fontLigatures2:Se(new f),fontSize:Se(new L),fontWeight:Se(new $),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:E.localize(161,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:E.localize(162,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:E.localize(163,null)})),gotoLocation:Se(new ee),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:E.localize(164,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:E.localize(165,null)})),hover:Se(new H),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>d.clamp(G,-5,20),{description:E.localize(166,null)})),lightbulb:Se(new F),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new s(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:E.localize(167,null)})),links:Se(new g(59,"links",!0,{description:E.localize(168,null)})),matchBrackets:Se(new _(60,"matchBrackets","always",["always","near","never"],{description:E.localize(169,null)})),minimap:Se(new N),mouseStyle:Se(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new d(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:E.localize(170,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(171,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:E.localize(172,null)})),multiCursorModifier:Se(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[E.localize(173,null),E.localize(174,null)],markdownDescription:E.localize(175,null)})),multiCursorPaste:Se(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(176,null),E.localize(177,null)],markdownDescription:E.localize(178,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:E.localize(179,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:E.localize(180,null)})),overviewRulerLanes:Se(new s(70,"overviewRulerLanes",3,0,3)),padding:Se(new j),parameterHints:Se(new K),peekWidgetDefaultFocus:Se(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(181,null),E.localize(182,null)],description:E.localize(183,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:E.localize(184,null)})),quickSuggestions:Se(new me),quickSuggestionsDelay:Se(new s(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(185,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:E.localize(186,null),markdownDeprecationMessage:E.localize(187,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:E.localize(188,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:E.localize(189,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:E.localize(190,null)})),renderLineHighlight:Se(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(191,null)],description:E.localize(192,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(193,null)})),renderValidationDecorations:Se(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(194,null),E.localize(195,null),E.localize(196,null),""],description:E.localize(197,null)})),revealHorizontalRightPadding:Se(new s(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:E.localize(198,null)})),rulers:Se(new Me),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new s(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(199,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:E.localize(200,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:E.localize(201,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:E.localize(202,null),included:I.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:E.localize(203,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(204,null),E.localize(205,null)],description:E.localize(206,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:E.localize(207,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:E.localize(208,null)})),inlineHints:Se(new U),snippetSuggestions:Se(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(209,null),E.localize(210,null),E.localize(211,null),E.localize(212,null)],description:E.localize(213,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:E.localize(214,null)})),stopRenderingLineAfter:Se(new s(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new te),suggestFontSize:Se(new s(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestLineHeight:Se(new s(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(216,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:E.localize(217,null)})),suggestSelection:Se(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(218,null),E.localize(219,null),E.localize(220,null)],description:E.localize(221,null)})),tabCompletion:Se(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(222,null),E.localize(223,null),E.localize(224,null)],description:E.localize(225,null)})),tabIndex:Se(new s(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(226,null),E.localize(227,null),E.localize(228,null)],description:E.localize(229,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:E.localize(230,null)})),wordSeparators:Se(new S(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:E.localize(231,null)})),wordWrap:Se(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(232,null),E.localize(233,null),E.localize(234,null),E.localize(235,null)],description:E.localize(236,null)})),wordWrapBreakAfterCharacters:Se(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new s(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(237,null)})),wordWrapOverride1:Se(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[E.localize(238,null),E.localize(239,null),E.localize(240,null),E.localize(241,null)],description:E.localize(242,null)})),wrappingStrategy:Se(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(243,null),E.localize(244,null)],description:E.localize(245,null)})),editorClassName:Se(new m),pixelRatio:Se(new X),tabFocusMode:Se(new fe),layoutInfo:Se(new B),wrappingInfo:Se(new be)}}),define(ge[151],ve([15,16]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],ve([15,16]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],ve([15,16]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],ve([15,16]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ge[155],ve([15,16]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ge[156],ve([15,16]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[157],ve([15,16]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[159],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[160],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[161],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[162],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[163],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[164],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[165],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[166],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[167],ve([15,16]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[168],ve([15,16]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(ge[169],ve([15,16]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[170],ve([15,16]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[171],ve([15,16]),function(Q,e){return Q.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[172],ve([15,16]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],ve([15,16]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],ve([15,16]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var I;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],ve([0,1,153]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function P(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=C.match(I);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=P;function D(C){if(!C)return null;let w=C.majorBase,g=C.majorMustEqual,s=C.minorBase,d=C.minorMustEqual,S=C.patchBase,v=C.patchMustEqual;return C.hasCaret&&(w===0||(d=!1),v=!1),{majorBase:w,majorMustEqual:g,minorBase:s,minorMustEqual:d,patchBase:S,patchMustEqual:v,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=D;function A(C,w){let g;typeof C=="string"?g=D(P(C)):g=C;let s;if(typeof w=="string"?s=D(P(w)):s=w,!g||!s)return!1;let d=g.majorBase,S=g.minorBase,v=g.patchBase,_=s.majorBase,p=s.minorBase,u=s.patchBase,a=s.majorMustEqual,t=s.minorMustEqual,n=s.patchMustEqual;return s.isMinimum?d>_?!0:d<_?!1:S>p?!0:S<p?!1:v>=u:(d===1&&_===0&&(!a||!t||!n)&&(_=1,p=0,u=0,a=!0,t=!1,n=!1),d<_?!1:d>_?!a:S<p?!1:S>p?!t:v<u?!1:v>u?!n:!0)}e.isValidVersion=A;function y(C,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:R(C,w.engines.vscode,g)}e.isValidExtensionVersion=y;function i(C,w){return C==="*"||R(w,C)}e.isEngineValid=i;function R(C,w,g=[]){let s=D(P(w));if(!s)return g.push(E.localize(0,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return g.push(E.localize(1,null,w)),!1}else if(!s.majorMustEqual)return g.push(E.localize(2,null,w)),!1;return A(C,s)?!0:(g.push(E.localize(3,null,C,w)),!1)}e.isVersionValid=R}),define(ge[108],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(P,D=[],A=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E;const I=(T,...P)=>new E(T,P);e.createSyncDescriptor=I}),define(ge[78],ve([0,1,108]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(D,A,y){A instanceof E.SyncDescriptor||(A=new E.SyncDescriptor(A,[],y)),I.push([D,A])}e.registerSingleton=T;function P(){return I}e.getSingletonServiceDescriptors=P}),define(ge[177],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=E;class I{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let D of this._nodes.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const A=this.lookupOrInsertNode(P),y=this.lookupOrInsertNode(D);A.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(P),A)}removeNode(P){const D=this._hashFn(P);this._nodes.delete(D);for(let A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(P){const D=this._hashFn(P);let A=this._nodes.get(D);return A||(A=new E(P),this._nodes.set(D,A)),A}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[D,A]of this._nodes)P.push(`${D}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=I}),define(ge[4],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(A,y,i,R){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:A,index:i,optional:R}):(y[E.DI_DEPENDENCIES]=[{id:A,index:i,optional:R}],y[E.DI_TARGET]=y)}function T(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const y=function(i,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,i,C,!1)};return y.toString=()=>A,E.serviceIds.set(A,y),y}e.createDecorator=T;function P(A){return A}e.refineServiceDecorator=P;function D(A){return function(y,i,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(A,y,R,!0)}}e.optional=D}),define(ge[178],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[179],ve([0,1,3,73,6,24,72,76,178]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(i):!!w.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(g,s){let d={selector:g,provider:s,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(d){let S=this._entries.indexOf(d);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const s=[];for(let d of this._entries)d._score>0&&s.push(d.provider);return s}ordered(g){const s=[];return this._orderedForEach(g,d=>s.push(d.provider)),s}orderedGroups(g){const s=[];let d,S;return this._orderedForEach(g,v=>{d&&S===v._score?d.push(v.provider):(S=v._score,d=[v.provider],s.push(d))}),s}_orderedForEach(g,s){if(!!g){this._updateScores(g);for(const d of this._entries)d._score>0&&s(d)}}_updateScores(g){let s={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let d of this._entries)if(d._score=(0,A.score)(d.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),i(d.selector)&&d._score>0){for(let S of this._entries)S._score=0;d._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(g,s){return g._score<s._score?1:g._score>s._score?-1:g._time<s._time?1:g._time>s._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(g,s,d=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=s,this.max=d,this._cache=new P.LRUCache(50,.7)}_key(g){return g.id+(0,I.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const s=this._key(g),d=this._cache.get(s);return this._clamp(d==null?void 0:d.value)}update(g,s){const d=this._key(g);let S=this._cache.get(d);return S||(S=new D.MovingAverage,this._cache.set(d,S)),S.update(s),this.get(g)}}e.LanguageFeatureRequestDelays=C}),define(ge[79],ve([0,1,2,43,179,142,47]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var A;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));class y{constructor(f,k){this.language=f,this.id=k}}e.LanguageIdentifier=y;var i;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var R;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=2048]="ITALIC_MASK",c[c.BOLD_MASK=4096]="BOLD_MASK",c[c.UNDERLINE_MASK=8192]="UNDERLINE_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(f){return(f&255)>>>0}static getTokenType(f){return(f&1792)>>>8}static getFontStyle(f){return(f&14336)>>>11}static getForeground(f){return(f&8372224)>>>14}static getBackground(f){return(f&4286578688)>>>23}static getClassNameFromMetadata(f){let k=this.getForeground(f),L="mtk"+k,$=this.getFontStyle(f);return $&1&&(L+=" mtki"),$&2&&(L+=" mtkb"),$&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(f,k){const L=this.getForeground(f),$=this.getFontStyle(f);let ee=`color: ${k[L]};`;return $&1&&(ee+="font-style: italic;"),$&2&&(ee+="font-weight: bold;"),$&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=g;var s;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let c=Object.create(null);return c[0]="symbol-method",c[1]="symbol-function",c[2]="symbol-constructor",c[3]="symbol-field",c[4]="symbol-variable",c[5]="symbol-class",c[6]="symbol-struct",c[7]="symbol-interface",c[8]="symbol-module",c[9]="symbol-property",c[10]="symbol-event",c[11]="symbol-operator",c[12]="symbol-unit",c[13]="symbol-value",c[14]="symbol-constant",c[15]="symbol-enum",c[16]="symbol-enum-member",c[17]="symbol-keyword",c[27]="symbol-snippet",c[18]="symbol-text",c[19]="symbol-color",c[20]="symbol-file",c[21]="symbol-reference",c[22]="symbol-customcolor",c[23]="symbol-folder",c[24]="symbol-type-parameter",c[25]="account",c[26]="issues",function(f){const k=c[f];let L=k&&D.iconRegistry.get(k);return L||(console.info("No codicon found for CompletionItemKind "+f),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let c=Object.create(null);return c.method=0,c.function=1,c.constructor=2,c.field=3,c.variable=4,c.class=5,c.struct=6,c.interface=7,c.module=8,c.property=9,c.event=10,c.operator=11,c.unit=12,c.value=13,c.constant=14,c.enum=15,c["enum-member"]=16,c.enumMember=16,c.keyword=17,c.snippet=27,c.text=18,c.color=19,c.file=20,c.reference=21,c.customcolor=22,c.folder=23,c["type-parameter"]=24,c.typeParameter=24,c.account=25,c.issue=26,function(f,k){let L=c[f];return typeof L=="undefined"&&!k&&(L=9),L}}();var d;(function(c){c[c.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(c){return c&&E.URI.isUri(c.uri)&&I.Range.isIRange(c.range)&&(I.Range.isIRange(c.originSelectionRange)||I.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=a;var t;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(c){c[c.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var o;(function(c){const f=new Map;f.set("file",0),f.set("module",1),f.set("namespace",2),f.set("package",3),f.set("class",4),f.set("method",5),f.set("property",6),f.set("field",7),f.set("constructor",8),f.set("enum",9),f.set("interface",10),f.set("function",11),f.set("variable",12),f.set("constant",13),f.set("string",14),f.set("number",15),f.set("boolean",16),f.set("array",17),f.set("object",18),f.set("key",19),f.set("null",20),f.set("enum-member",21),f.set("struct",22),f.set("event",23),f.set("operator",24),f.set("type-parameter",25);const k=new Map;k.set(0,"file"),k.set(1,"module"),k.set(2,"namespace"),k.set(3,"package"),k.set(4,"class"),k.set(5,"method"),k.set(6,"property"),k.set(7,"field"),k.set(8,"constructor"),k.set(9,"enum"),k.set(10,"interface"),k.set(11,"function"),k.set(12,"variable"),k.set(13,"constant"),k.set(14,"string"),k.set(15,"number"),k.set(16,"boolean"),k.set(17,"array"),k.set(18,"object"),k.set(19,"key"),k.set(20,"null"),k.set(21,"enum-member"),k.set(22,"struct"),k.set(23,"event"),k.set(24,"operator"),k.set(25,"type-parameter");function L(H){return f.get(H)}c.fromString=L;function $(H){return k.get(H)}c.toString=$;function ee(H,x){const B=k.get(H);let F=B&&D.iconRegistry.get("symbol-"+B);return F||(console.info("No codicon found for SymbolKind "+H),F=D.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}c.toCssClassName=ee})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(f){this.value=f}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var m;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(m=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var b;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],ve([0,1,6,14,4,3,55,71]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,i){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:y,handler:i})}if(y.description){const s=[];for(let S of y.description.args)s.push(S.constraint);const d=y.handler;y.handler=function(S,...v){return(0,I.validateConstraints)(v,s),d(S,...v)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new D.LinkedList,this._commands.set(R,C));let w=C.unshift(y),g=(0,E.toDisposable)(()=>{w();const s=this._commands.get(R);(s==null?void 0:s.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),g}registerCommandAlias(y,i){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(i,...C))}getCommand(y){const i=this._commands.get(y);if(!(!i||i.isEmpty()))return A.Iterable.first(i)}getCommands(){const y=new Map;for(const i of this._commands.keys()){const R=this.getCommand(i);R&&y.set(i,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],ve([0,1,10,4,9]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",T.isMacintosh),D.set("isLinux",T.isLinux),D.set("isWindows",T.isWindows),D.set("isWeb",T.isWeb),D.set("isMacNative",T.isMacintosh&&!T.isWeb),D.set("isEdge",P.indexOf("Edg/")>=0),D.set("isFirefox",P.indexOf("Firefox")>=0),D.set("isChrome",P.indexOf("Chrome")>=0),D.set("isSafari",P.indexOf("Safari")>=0),D.set("isIPad",P.indexOf("iPad")>=0);const A=Object.prototype.hasOwnProperty;var y;(function(c){c[c.False=0]="False",c[c.True=1]="True",c[c.Defined=2]="Defined",c[c.Not=3]="Not",c[c.Equals=4]="Equals",c[c.NotEquals=5]="NotEquals",c[c.And=6]="And",c[c.Regex=7]="Regex",c[c.NotRegex=8]="NotRegex",c[c.Or=9]="Or",c[c.In=10]="In",c[c.NotIn=11]="NotIn",c[c.Greater=12]="Greater",c[c.GreaterEquals=13]="GreaterEquals",c[c.Smaller=14]="Smaller",c[c.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return C.INSTANCE}static true(){return w.INSTANCE}static has(f){return g.create(f)}static equals(f,k){return s.create(f,k)}static notEquals(f,k){return v.create(f,k)}static regex(f,k){return n.create(f,k)}static in(f,k){return d.create(f,k)}static not(f){return _.create(f)}static and(...f){return r.create(f)}static or(...f){return l.create(f)}static greater(f,k){return p.create(f,k)}static less(f,k){return a.create(f,k)}static deserialize(f,k=!1){if(!!f)return this._deserializeOrExpression(f,k)}static _deserializeOrExpression(f,k){let L=f.split("||");return l.create(L.map($=>this._deserializeAndExpression($,k)))}static _deserializeAndExpression(f,k){let L=f.split("&&");return r.create(L.map($=>this._deserializeOne($,k)))}static _deserializeOne(f,k){if(f=f.trim(),f.indexOf("!=")>=0){let L=f.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],k))}if(f.indexOf("==")>=0){let L=f.split("==");return s.create(L[0].trim(),this._deserializeValue(L[1],k))}if(f.indexOf("=~")>=0){let L=f.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],k))}if(f.indexOf(" in ")>=0){let L=f.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const L=f.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const L=f.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const L=f.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const L=f.split("<");return a.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(f)?_.create(f.substr(1).trim()):g.create(f)}static _deserializeValue(f,k){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let L=/^'([^']*)'$/.exec(f);return L?L[1].trim():f}static _deserializeRegexValue(f,k){if((0,E.isFalsyOrWhitespace)(f)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=f.indexOf("/"),$=f.lastIndexOf("/");if(L===$||L<0){if(k)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let ee=f.slice(L+1,$),H=f[$+1]==="i"?"i":"";try{return new RegExp(ee,H)}catch(x){if(k)throw new Error(`bad regexp-value '${f}', parse error: ${x}`);return console.warn(`bad regexp-value '${f}', parse error: ${x}`),null}}}e.ContextKeyExpr=i;function R(c,f){return c.cmp(f)}class C{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class w{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class g{constructor(f){this.key=f,this.type=2}static create(f){const k=D.get(f);return typeof k=="boolean"?k?w.INSTANCE:C.INSTANCE:new g(f)}cmp(f){return f.type!==this.type?this.type-f.type:m(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=g;class s{constructor(f,k){this.key=f,this.value=k,this.type=4}static create(f,k){if(typeof k=="boolean")return k?g.create(f):_.create(f);const L=D.get(f);return typeof L=="boolean"?k===(L?"true":"false")?w.INSTANCE:C.INSTANCE:new s(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class d{constructor(f,k){this.key=f,this.valueKey=k,this.type=10}static create(f,k){return new d(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const k=f.getValue(this.valueKey),L=f.getValue(this.key);return Array.isArray(k)?k.indexOf(L)>=0:typeof L=="string"&&typeof k=="object"&&k!==null?A.call(k,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=d;class S{constructor(f){this._actual=f,this.type=11}static create(f){return new S(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new S(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(f,k){this.key=f,this.value=k,this.type=5}static create(f,k){if(typeof k=="boolean")return k?_.create(f):g.create(f);const L=D.get(f);return typeof L=="boolean"?k===(L?"true":"false")?C.INSTANCE:w.INSTANCE:new v(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class _{constructor(f){this.key=f,this.type=3}static create(f){const k=D.get(f);return typeof k=="boolean"?k?C.INSTANCE:w.INSTANCE:new _(f)}cmp(f){return f.type!==this.type?this.type-f.type:m(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=_;class p{constructor(f,k){this.key=f,this.value=k,this.type=12}static create(f,k){return new p(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class u{constructor(f,k){this.key=f,this.value=k,this.type=13}static create(f,k){return new u(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(f,k){this.key=f,this.value=k,this.type=14}static create(f,k){return new a(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(f,k){this.key=f,this.value=k,this.type=15}static create(f,k){return new t(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:b(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(f,k){this.key=f,this.regexp=k,this.type=7}static create(f,k){return new n(f,k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const k=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return k<L?-1:k>L?1:0}equals(f){if(f.type===this.type){const k=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return this.key===f.key&&k===L}return!1}evaluate(f){let k=f.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=n;class o{constructor(f){this._actual=f,this.type=8}static create(f){return new o(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new o(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(f){this.expr=f,this.type=6}static create(f){return r._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const $=R(this.expr[k],f.expr[k]);if($!==0)return $}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].evaluate(f))return!1;return!0}static _normalizeArr(f){const k=[];let L=!1;for(const $ of f)if(!!$){if($.type===1){L=!0;continue}if($.type===0)return C.INSTANCE;if($.type===6){k.push(...$.expr);continue}k.push($)}if(k.length===0&&L)return w.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(R);k.length>1;){const $=k[k.length-1];if($.type!==9)break;k.pop();const ee=k.pop(),H=l.create($.expr.map(x=>r.create([x,ee])));H&&(k.push(H),k.sort(R))}return k.length===1?k[0]:new r(k)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new r(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let k of this.expr)f.push(k.negate());return l.create(f)}}e.ContextKeyAndExpr=r;class l{constructor(f){this.expr=f,this.type=9}static create(f){const k=l._normalizeArr(f);if(k.length!==0)return k.length===1?k[0]:new l(k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const $=R(this.expr[k],f.expr[k]);if($!==0)return $}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,L=this.expr.length;k<L;k++)if(this.expr[k].evaluate(f))return!0;return!1}static _normalizeArr(f){let k=[],L=!1;if(f){for(let $=0,ee=f.length;$<ee;$++){const H=f[$];if(!!H){if(H.type===0){L=!0;continue}if(H.type===1)return[w.INSTANCE];if(H.type===9){k=k.concat(H.expr);continue}k.push(H)}}if(k.length===0&&L)return[C.INSTANCE];k.sort(R)}return k}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new l(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let L of this.expr)f.push(L.negate());const k=L=>L.type===9?L.expr:[L];for(;f.length>1;){const L=f.shift(),$=f.shift(),ee=[];for(const H of k(L))for(const x of k($))ee.push(i.and(H,x));f.unshift(i.or(...ee))}return f[0]}}e.ContextKeyOrExpr=l;class h extends g{constructor(f,k,L){super(f);this.key=f,this._defaultValue=k,typeof L=="object"?h._info.push(Object.assign(Object.assign({},L),{key:f})):L!==!0&&h._info.push({key:f,description:L,type:k!=null?typeof k:void 0})}static all(){return h._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(f){return i.equals(this.key,f)}notEqualsTo(f){return i.notEquals(this.key,f)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(c,f){return c<f?-1:c>f?1:0}function b(c,f,k,L){return c<k?-1:c>k?1:f<L?-1:f>L?1:0}}),define(ge[181],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],ve([0,1,152,4,11]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=P;var D;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var A;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(w,g){super(w);this.code=g}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],ve([0,1,10,4]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequestType=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(R){return R&&typeof R=="object"&&typeof R.id=="string"&&(!R.uuid||typeof R.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class D{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,w){if(typeof C=="undefined"||C===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof C=="string"||typeof w=="string"){let g=typeof C=="string"?C:C.value,s=typeof w=="string"?w:w.value;return E.equalsIgnoreCase(g,s)}return C._lower===w._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=D;function A(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function i(R){var C;return((C=R.workspaceTrust)===null||C===void 0?void 0:C.request)!==void 0?R.workspaceTrust.request:R.main?"onStart":"never"}e.getExtensionWorkspaceTrustRequestType=i,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],ve([0,1,10,29]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(g,s){return g.uuid&&s.uuid?g.uuid===s.uuid:g.id===s.id?!0:(0,E.compareIgnoreCase)(g.id,s.id)===0}e.areSameExtensions=T;class P{constructor(s,d){this.version=d,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=P;function D(g,s){return`${g}.${s}`}e.getExtensionId=D;function A(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function y(g,s){return A(D(g,s))}e.getGalleryExtensionId=y;function i(g,s){const d=[],S=v=>{for(const _ of d)if(_.some(p=>T(s(p),s(v))))return _;return null};for(const v of g){const _=S(v);_?_.push(v):d.push([v])}return d}e.groupByExtension=i;function R(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function w(g){const s=new Set;for(const d of g)d.malicious&&s.add(d.id.id);return s}e.getMaliciousExtensionsSet=w}),define(ge[44],ve([0,1,154,8,2,4,10,14,24]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function i(H){return H.create===!0}e.isFileOpenForWriteOptions=i;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=w;function g(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=g;function s(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function d(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=d;var S;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(x,B){super(x);this.code=B}}e.FileSystemProviderError=v;function _(H,x){const B=new v(H.toString(),x);return u(B,x),B}e.createFileSystemProviderError=_;function p(H){return H||_((0,E.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=p;function u(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=u;function a(H){if(!H)return S.Unknown;if(H instanceof v)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=a;function t(H){if(H instanceof m)return H.fileOperationResult;switch(a(H)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(x,B,F){this.resource=x,this.operation=B,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var r;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,B){this.ignorePathCasing=B,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...B){return this.doContains(x,{includeChildren:!1},...B)}affects(x,...B){return this.doContains(x,{includeChildren:!0},...B)}doContains(x,B,...F){var U,M,N,O,j,K;if(!x)return!1;const X=F.length>0;return!!((!X||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||B.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!X||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||B.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!X||F.includes(2))&&(((j=this.deleted)===null||j===void 0?void 0:j.findSubstr(x))||B.includeChildren&&((K=this.deleted)===null||K===void 0?void 0:K.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const B=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)B.push(U);return B}filter(x){return new l(this.changes.filter(B=>x(B)),this.ignorePathCasing)}}e.FileChangesEvent=l;function h(H,x,B){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),B?(0,D.startsWithIgnoreCase)(H,x):H.indexOf(x)===0)}e.isParent=h;class m extends Error{constructor(x,B,F){super(x);this.fileOperationResult=B,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,A.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=m;var b;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var c;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(c=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function f(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=f;async function k(H,x){if(!x.canHandleResource(T.URI.from({scheme:H.scheme})))return new Promise(B=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(F.dispose(),B())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,A.isNumber)(x)||(x=0),x<L.KB?(0,E.localize)(1,null,x.toFixed(0)):x<L.MB?(0,E.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,E.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,E.localize)(4,null,(x/L.GB).toFixed(2)):(0,E.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var $;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function ee(H){return{maxFileSize:H===0?300*L.MB:16*L.GB,maxHeapSize:H===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ee}),define(ge[81],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...T){this._entries=new Map;for(let[P,D]of T)this.set(P,D)}set(T,P){const D=this._entries.get(T);return this._entries.set(T,P),D}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=E}),define(ge[184],ve([0,1,17,177,108,4,81,19]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class R{constructor(s=new D.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=S,this._services.set(P.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...d){let S=w.traceInvocation(s),v=!1;try{return s({get:(p,u)=>{if(v)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(p,S);if(!a&&u!==P.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return a}},...d)}finally{v=!0,S.stop()}}createInstance(s,...d){let S,v;return s instanceof T.SyncDescriptor?(S=w.traceCreation(s.ctor),v=this._createInstance(s.ctor,s.staticArguments.concat(d),S)):(S=w.traceCreation(s),v=this._createInstance(s,d,S)),S.stop(),v}_createInstance(s,d=[],S){let v=P._util.getServiceDependencies(s).sort((u,a)=>u.index-a.index),_=[];for(const u of v){let a=this._getOrCreateServiceInstance(u.id,S);if(!a&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);_.push(a)}let p=v.length>0?v[0].index:d.length;if(d.length!==p){console.warn(`[createInstance] First service dependency of ${s.name} at position ${p+1} conflicts with ${d.length} static arguments`);let u=p-d.length;u>0?d=d.concat(new Array(u)):d=d.slice(0,p)}return new s(...[...d,..._])}_setServiceInstance(s,d){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let S=this._getServiceInstanceOrDescriptor(s);return S instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,S,d.branch(s,!0)):(d.branch(s,!1),S)}_safeCreateAndCacheServiceInstance(s,d,S){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,S)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,S){const v=new I.Graph(u=>u.id.toString());let _=0;const p=[{id:s,desc:d,_trace:S}];for(;p.length;){const u=p.pop();if(v.lookupOrInsertNode(u),_++>1e3)throw new i(v);for(let a of P._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${s} depends on ${a.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:a.id,desc:t,_trace:u._trace.branch(a.id,!0)};v.insertEdge(u,n),p.push(n)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new i(v);break}for(const{data:a}of u){if(this._getServiceInstanceOrDescriptor(a.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,n)}v.removeNode(a)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,S=[],v,_){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(d,S,v,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,S,v,_);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],S,v){if(S){const _=new A.IdleValue(()=>this._createInstance(s,d,v));return new Proxy(Object.create(null),{get(p,u){if(u in p)return p[u];let a=_.value,t=a[u];return typeof t!="function"||(t=t.bind(a),p[u]=t),t},set(p,u,a){return _.value[u]=a,!0}})}else return this._createInstance(s,d,v)}}e.InstantiationService=R;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class w{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new w(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(s){return y?new w(0,s.name):w._None}branch(s,d){let S=new w(2,s.toString());return this._dep.push([s,d,S]),S}stop(){let s=Date.now()-this._start;w._totals+=s;let d=!1;function S(_,p){let u=[],a=new Array(_+1).join("	");for(const[t,n,o]of p._dep)if(n&&o){d=!0,u.push(`${a}CREATES -> ${t}`);let r=S(_+1,o);r&&u.push(r)}else u.push(`${a}uses -> ${t}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(v.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(ge[12],ve([0,1,4,6,9,3,58]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function A(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class R extends i{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(y.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(y.Error,this.format(o))}else this.log(y.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let r=t[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}n+=(o>0?" ":"")+r}return n}}e.AbstractMessageLogger=R;class C extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...n):console.log(`[main ${A()}]`,t,...n))}debug(t,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...n):console.log(`[main ${A()}]`,t,...n))}info(t,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...n):console.log(`[main ${A()}]`,t,...n))}warn(t,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,t,...n):console.warn(`[main ${A()}]`,t,...n))}error(t,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,t,...n):console.error(`[main ${A()}]`,t,...n))}critical(t,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,t,...n):console.error(`[main ${A()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class w extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=w;class g extends i{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class s extends i{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=s;class d extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class S extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?y.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class v{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=v;function _(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const t=p(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function p(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=p;function u(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(ge[109],ve([0,1,12,44]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(y,i,R,C){try{const w=await new Promise((g,s)=>{Q(["spdlog"],g,s)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(y,i,R,C)}catch(w){console.error(w)}return null}function P(y,i,R,C){return Q.__$__nodeRequire("spdlog").createRotatingLogger(y,i,R,C)}e.createRotatingLogger=P;function D(y,i,R){switch(i){case E.LogLevel.Trace:y.trace(R);break;case E.LogLevel.Debug:y.debug(R);break;case E.LogLevel.Info:y.info(R);break;case E.LogLevel.Warning:y.warn(R);break;case E.LogLevel.Error:y.error(R);break;case E.LogLevel.Critical:y.critical(R);break;default:throw new Error("Invalid log level")}}class A extends E.AbstractMessageLogger{constructor(i,R,C,w){super();this.name=i,this.filepath=R,this.rotating=C,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const i=this.rotating?6:1,R=30/i*I.ByteSize.MB;return T(this.name,this.filepath,R,i).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:w,message:g}of this.buffer)D(this._logger,w,g);this.buffer=[]}})}log(i,R){this._logger?D(this._logger,i,R):this.getLevel()<=i&&this.buffer.push({level:i,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=A}),define(ge[110],ve([0,1,4,155,56]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function i(s,d){return d-s}y.compare=i;const R=Object.create(null);R[y.Error]=(0,I.localize)(0,null),R[y.Warning]=(0,I.localize)(1,null),R[y.Info]=(0,I.localize)(2,null);function C(s){return R[s]||""}y.toString=C;function w(s){switch(s){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=w;function g(s){switch(s){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=g}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const i="";function R(w){return C(w,!0)}y.makeKey=R;function C(w,g){let s=[i];return w.source?s.push(w.source.replace("\xA6","\\\xA6")):s.push(i),w.code?typeof w.code=="string"?s.push(w.code.replace("\xA6","\\\xA6")):s.push(w.code.value.replace("\xA6","\\\xA6")):s.push(i),w.severity!==void 0&&w.severity!==null?s.push(D.toString(w.severity)):s.push(i),w.message&&g?s.push(w.message.replace("\xA6","\\\xA6")):s.push(i),w.startLineNumber!==void 0&&w.startLineNumber!==null?s.push(w.startLineNumber.toString()):s.push(i),w.startColumn!==void 0&&w.startColumn!==null?s.push(w.startColumn.toString()):s.push(i),w.endLineNumber!==void 0&&w.endLineNumber!==null?s.push(w.endLineNumber.toString()):s.push(i),w.endColumn!==void 0&&w.endColumn!==null?s.push(w.endColumn.toString()):s.push(i),s.push(i),s.join("\xA6")}y.makeKeyOptionalMessage=C})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ge[185],ve([0,1,56,4,3]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(ge[186],ve([0,1,11,9,36,25]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof I.globals.vscode!="undefined"){const A=I.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const A=(0,P.dirname)(E.FileAccess.asFileUri("",Q));D=Q.__$__nodeRequire((0,P.joinPath)(A,"product.json").fsPath);const y=Q.__$__nodeRequire((0,P.joinPath)(A,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=D});var je=this&&this.__decorate||function(Q,e,E,I){var T=arguments.length,P=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,E):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Q,e,E,I);else for(var A=Q.length-1;A>=0;A--)(D=Q[A])&&(P=(T<3?D(P):T>3?D(e,E,P):D(e,E))||P);return T>3&&P&&Object.defineProperty(e,E,P),P},Ue=this&&this.__param||function(Q,e){return function(E,I){e(E,I,Q)}};define(ge[111],ve([0,1,4,21,6,19]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(C,w){super();this.deferred=new P.DeferredPromise,w.withProgress(C,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class i extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const w=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:g.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=i,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(ge[40],ve([0,1,14,52]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(D,A){I.ok(E.isString(D)),I.ok(E.isObject(A)),I.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new T}),define(ge[112],ve([0,1,40,3]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[T(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new P;E.Registry.add(e.Extensions.JSONContribution,D)}),define(ge[82],ve([0,1,151,3,40,14,112]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(D.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,_=!0){this.registerConfigurations([v],_)}registerConfigurations(v,_=!0){const p=[];v.forEach(u=>{p.push(...this.validateAndRegisterProperties(u,_)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(v){const _=[],p=u=>{if(u.properties)for(const a in u.properties)_.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,u.properties[a]);u.allOf&&u.allOf.forEach(a=>p(a))};for(const u of v){p(u);const a=this.configurationContributors.indexOf(u);a!==-1&&this.configurationContributors.splice(a,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(v){const _=[],p=[];for(const u of v)for(const a in u)if(_.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),u[a]);const t={type:"object",default:this.defaultValues[a],description:E.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};p.push(C(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=u[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(v){const _=[];for(const p of v)for(const u in p)if(_.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const _ of v)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,_=!0,p=3){p=P.isUndefinedOrNull(v.scope)?p:v.scope;let u=[],a=v.properties;if(a)for(let n in a){if(_&&s(n)){delete a[n];continue}const o=a[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:o.scope=P.isUndefinedOrNull(o.scope)?p:o.scope,a[n].hasOwnProperty("included")&&!a[n].included){this.excludedConfigurationProperties[n]=a[n],delete a[n];continue}else this.configurationProperties[n]=a[n];!a[n].deprecationMessage&&a[n].markdownDeprecationMessage&&(a[n].deprecationMessage=a[n].markdownDeprecationMessage),u.push(n)}let t=v.allOf;if(t)for(let n of t)u.push(...this.validateAndRegisterProperties(n,_,p));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const _=p=>{let u=p.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let a=p.allOf;a&&a.forEach(_)};_(v)}updateSchema(v,_){switch(e.allSettings.properties[v]=_,_.scope){case 1:e.applicationSettings.properties[v]=_;break;case 2:e.machineSettings.properties[v]=_;break;case 6:e.machineOverridableSettings.properties[v]=_;break;case 3:e.windowSettings.properties[v]=_;break;case 4:e.resourceSettings.properties[v]=_;break;case 5:e.resourceSettings.properties[v]=_,this.resourceLanguageSettingsSchema.properties[v]=_;break}}removeFromSchema(v,_){switch(delete e.allSettings.properties[v],_.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const _=`[${v}]`,p={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,p),e.allSettings.properties[_]=p,e.applicationSettings.properties[_]=p,e.machineSettings.properties[_]=p,e.machineOverridableSettings.properties[_]=p,e.windowSettings.properties[_]=p,e.resourceSettings.properties[_]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,_){let p=this.defaultValues[v];P.isUndefined(p)&&(p=_.default),P.isUndefined(p)&&(p=w(_.type)),_.default=p}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=C;function w(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const g=new i;T.Registry.add(e.Extensions.Configuration,g);function s(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?E.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?E.localize(6,null,S):null:E.localize(4,null)}e.validateProperty=s;function d(){const S=[],v=g.getConfigurationProperties();for(const _ of Object.keys(v))S.push([_,v[_].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(ge[83],ve([0,1,23,14,2,40,4,82]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=y;var i;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(n,o){const r=o?n?o.keys.filter(k=>n.keys.indexOf(k)===-1):[...o.keys]:[],l=n?o?n.keys.filter(k=>o.keys.indexOf(k)===-1):[...n.keys]:[],h=[];if(o&&n){for(const k of n.keys)if(o.keys.indexOf(k)!==-1){const L=v(n.contents,k),$=v(o.contents,k);E.equals(L,$)||h.push(k)}}const m=[],b=k=>{const L={};for(const $ of k)for(const ee of $.identifiers)L[a(ee)]=$;return L},c=o?b(o.overrides):{},f=n?b(n.overrides):{};if(Object.keys(c).length)for(const k of r){const L=c[k];L&&m.push([(0,A.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(f).length)for(const k of l){const L=f[k];L&&m.push([(0,A.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(c).length&&Object.keys(f).length)for(const k of h){const L=f[k],$=c[k];if(L&&$){const ee=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(k),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:l,updated:h,overrides:m}}e.compare=C;function w(n,o){const r=[];for(const l of Object.keys(n))if(A.OVERRIDE_PROPERTY_PATTERN.test(l)){const h={};for(const m in n[l])h[m]=n[l][m];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(h),contents:g(h,o)})}return r}e.toOverrides=w;function g(n,o){const r=Object.create(null);for(let l in n)s(r,l,n[l],o);return r}e.toValuesTree=g;function s(n,o,r,l){const h=o.split("."),m=h.pop();let b=n;for(let c=0;c<h.length;c++){let f=h[c],k=b[f];switch(typeof k){case"undefined":k=b[f]=Object.create(null);break;case"object":break;default:l(`Ignoring ${o} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(k)}`);return}b=k}if(typeof b=="object"&&b!==null)try{b[m]=r}catch(c){l(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(b)}`)}else l(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function d(n,o){const r=o.split(".");S(n,r)}e.removeFromValueTree=d;function S(n,o){const r=o.shift();if(o.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const l=n[r];typeof l=="object"&&!Array.isArray(l)&&(S(l,o),Object.keys(l).length===0&&delete n[r])}}function v(n,o,r){function l(b,c){let f=b;for(const k of c){if(typeof f!="object"||f===null)return;f=f[k]}return f}const h=o.split("."),m=l(n,h);return typeof m=="undefined"?r:m}e.getConfigurationValue=v;function _(n,o,r){Object.keys(o).forEach(l=>{l!=="__proto__"&&(l in n?I.isObject(n[l])&&I.isObject(o[l])?_(n[l],o[l],r):r&&(n[l]=o[l]):n[l]=o[l])})}e.merge=_;function p(){const n=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=p;function u(){const n=Object.create(null),o=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in o){let l=o[r].default;s(n,r,l,h=>console.error(`Conflict in default settings: ${h}`))}return n}e.getDefaultValues=u;function a(n){return`[${n}]`}e.keyFromOverrideIdentifier=a;function t(n,o,r){const l=n.inspect(o),h=n.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:l.defaultValue}e.getMigratedSettingValue=t}),define(ge[187],ve([0,1,54,24,18,14,23,2,82,83,40,6,3]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],h=n[r];h&&(typeof l=="object"&&typeof h=="object"?(l=D.deepClone(l),this.mergeContents(l,h)):l=h),o[r]=l}return new g(o,this.keys,this.overrides)}merge(...t){const n=D.deepClone(this.contents),o=D.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(n,l.contents);for(const h of l.overrides){const[m]=o.filter(b=>T.equals(b.identifiers,h.identifiers));m?this.mergeContents(m.contents,h.contents):o.push(D.deepClone(h))}for(const h of l.keys)r.indexOf(h)===-1&&r.push(h)}return new g(n,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&P.isObject(t[o])&&P.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=D.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,i.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class s extends g{constructor(){const t=(0,i.getDefaultValues)(),n=(0,i.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,n,o)}}e.DefaultConfigurationModel=s;class d{constructor(t,n){this._name=t,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n)}}parseRaw(t){this._raw=t;const n=this.doParseRaw(t);this._configurationModel=new g(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let n={},o=null,r=[],l=[],h=[];function m(c){Array.isArray(r)?r.push(c):o&&(r[o]=c)}let b={onObjectBegin:()=>{let c={};m(c),l.push(r),r=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let c=[];m(c),l.push(r),r=c,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:m,onError:(c,f,k)=>{h.push({error:c,offset:f,length:k})}};if(t)try{E.visit(t,b),n=r[0]||{}}catch(c){console.error(`Error while parsing settings file ${this._name}: ${c}`),this._parseErrors=[c]}return n}doParseRaw(t){if(this._scopes){const l=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,l,!0,this._scopes)}const n=(0,i.toValuesTree)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),o=Object.keys(t),r=(0,i.toOverrides)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:n,keys:o,overrides:r}}filterByScope(t,n,o,r){const l={};for(let h in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(h)&&o)l[h]=this.filterByScope(t[h],n,!1,r);else{const m=this.getScope(h,n);(m===void 0||r.indexOf(m)!==-1)&&(l[h]=t[h])}return l}getScope(t,n){const o=n[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=d;class S extends C.Disposable{constructor(t,n,o,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new g}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class v{constructor(t,n,o=new g,r=new g,l=new I.ResourceMap,h=new g,m=new I.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new g,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const r=this.getConsolidateConfigurationModel(n,o),l=this.getFolderConfigurationModelForResource(n.resource,o),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),c=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,$=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(t):h.getValue(t),ee=r.getValue(t),H=T.distinct(T.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:c,userRemoteValue:f,workspaceValue:k,workspaceFolderValue:L,memoryValue:$,value:ee,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:c!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:n.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:h.getValue(t),override:n.overrideIdentifier?h.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,y.overrideIdentifierFromKey)(r),h=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=t.getKeysForOverrideIdentifier(l),b=[...m.filter(c=>h.indexOf(c)===-1),...h.filter(c=>m.indexOf(c)===-1),...h.filter(c=>!D.equals(this._defaultConfiguration.override(l).getValue(c),t.override(l).getValue(c)))];return[l,b]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,t),h=[...n,...o,...r];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,t);let h=[...n,...o,...r];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,t);let h=[...n,...o,...r];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:r,updated:l,removed:h,overrides:m}=(0,i.compare)(o,n);let b=[...r,...l,...h];return(b.length||!o)&&this.updateFolderConfiguration(t,n),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:l,overrides:h}=(0,i.compare)(n,void 0);return{keys:[...o,...r,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const l=this._memoryConfigurationByResource.get(t);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=o.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:r,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((h,m)=>(h.set(A.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new I.ResourceMap);return new v(n,o,new g,r,l,new g,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function _(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,n=new Map;for(const r of a)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,h])=>{const m=(0,I.getOrSet)(n,l,new Set);h.forEach(b=>m.add(b))});const o=[];return n.forEach((r,l)=>o.push([l,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=_;class p{constructor(t,n,o,r){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(m=>l.add(m)),t.overrides.forEach(([,m])=>m.forEach(b=>l.add(b))),this.affectedKeys=[...l.values()];const h=new g;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,l=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!D.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,i.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=p;class u extends p{constructor(t,n,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(ge[113],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,A=I.Unknown,y){super(D);this._message=D,this._code=A,this._detail=y,this.isHandled=A===I.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===I.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===I.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(ge[114],ve([0,1,11]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(P){return P.scheme===E.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=I;function T(P){if(!!P){const D=P.indexOf("+");return D<0?P:P.substr(0,D)}}e.getRemoteName=T}),define(ge[188],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{vsda(){return new Promise((T,P)=>Q(["vsda"],T,P))}async sign(T){try{const P=await this.vsda(),D=new P.signer;if(D)return D.sign(T)}catch(P){}return T}}e.SignService=E}),define(ge[189],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,D=5){let A;return A=P(y=>{const i=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(T);if(R){R.data.push(i);return}const C=setTimeout(()=>this.flushBuffer(T),D);R={data:[i],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),A.dispose()}},this._terminalBufferMap.set(T,R)}),A}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=E}),define(ge[190],ve([0,1,48,8,36,26,14,23,9]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function i(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let w=0;return C&&C.length===4&&(w=parseInt(C[3])),w}e.getWindowsBuildNumber=i;async function R(C,w,g,s=T.env,d=P.exists){if(I.isAbsolute(C))return await d(C)?C:void 0;if(w===void 0&&(w=T.cwd()),I.dirname(C)!=="."){const p=I.join(w,C);return await d(p)?p:void 0}const v=(0,A.getCaseInsensitive)(s,"PATH");if(g===void 0&&(0,D.isString)(v)&&(g=v.split(I.delimiter)),g===void 0||g.length===0){const p=I.join(w,C);return await d(p)?p:void 0}for(let p of g){let u;if(I.isAbsolute(p)?u=I.join(p,C):u=I.join(w,p,C),await d(u))return u;if(y.isWindows){let a=u+".com";if(await d(a)||(a=u+".exe",await d(a)))return a}}const _=I.join(w,C);return await d(_)?_:void 0}e.findExecutable=R}),define(ge[191],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(ge[192],ve([0,1,4,6,40,3,191,47]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(S){function v(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function i(S){return{id:S}}e.themeColorFromId=i;var R;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const _=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const n=_.exec(t);if(!!n){let[,o]=n;return{id:o}}}S.fromString=p;function u(t,n){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),n&&(o=`${o}~${n}`),{id:o}}S.modify=u;function a(t,n){var o,r;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=n.color)===null||r===void 0?void 0:r.id)}S.isEqual=a,S.asClassNameArray=A.CSSIcon.asClassNameArray,S.asClassName=A.CSSIcon.asClassName,S.asCSSSelector=A.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function C(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(v);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new w;T.Registry.add(e.Extensions.ThemingContribution,g);function s(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=s;class d extends I.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,_){let p=this.theme.getColor(v);return p&&_&&(p=_(p,this.theme)),p?p.toString():null}}e.Themable=d}),define(ge[193],ve([0,1,40,192,3,156,112,19,47]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,_,p,u){const a=this.iconsById[v];if(a){if(p&&!a.description){a.description=p,this.iconSchema.properties[v].markdownDescription=`${p} $(${v})`;const o=this.iconReferenceSchema.enum.indexOf(v);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=p),this._onDidChange.fire()}return a}let t={id:v,description:p,defaults:_,deprecationMessage:u};this.iconsById[v]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),p&&(n.markdownDescription=`${p}: $(${v})`),this.iconSchema.properties[v]=n,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const _=this.iconReferenceSchema.enum.indexOf(v);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,_){const p=this.iconFontsById[v];if(p)return p;let u={id:v,definition:_};return this.iconFontsById[v]=u,this._onDidChange.fire(),u}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(a,t)=>a.id.localeCompare(t.id),_=a=>{for(;I.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of u.filter(t=>!!t.description).sort(v))p.push(`|<i class="${_(a)}"></i>|${a.id}|${I.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const a of u.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(v))p.push(`|<i class="${_(a)}"></i>|${a.id}|`);return p.join(`
`)}}const R=new i;E.Registry.add(e.Extensions.IconContribution,R);function C(S,v,_,p){return R.registerIcon(S,v,_,p)}e.registerIcon=C;function w(){return R}e.getIconRegistry=w;function g(){for(const S of y.iconRegistry.all)R.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>R.registerIcon(S.id,S.definition,S.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let s=E.Registry.as(D.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,R.getIconSchema());const d=new A.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=I.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ge[59],ve([0,1,2,25,4,24]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var D;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function A(w){const g=w;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=A;function y(w){const g=w;return!!(g&&typeof g=="object"&&E.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(g,s,d,S){this._id=g,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class R{constructor(g,s){this.raw=s,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,I.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(w){return new R({uri:w,index:0,name:(0,I.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=C}),define(ge[115],ve([0,1,4,157,59,2,9,8,25,132,54,11,75,30,114]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(B){return(typeof B=="string"?(0,A.extname)(B):(0,y.extname)(B))===d}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function v(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function _(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=_;function p(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=p;function u(B){const F=B;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=u;function a(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(B){const F=B;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function n(B){const F=B;if(F==null?void 0:F.uri)return{id:F.id,uri:P.URI.revive(F.uri)};const U=B;if(U==null?void 0:U.configPath)return{id:U.id,configPath:P.URI.revive(U.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=n;function o(B,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent(B,F.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r(B){return l(B)||h(B)}e.isStoredWorkspaceFolder=r;function l(B){const F=B;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=l;function h(B){const F=B;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=h;function m(B,F,U,M,N=!D.isWindows,O){if(B.scheme!==M.scheme)return{name:U,uri:B.toString(!0)};let j=F?void 0:O.relativePath(M,B);if(j!==void 0)j.length===0?j=".":D.isWindows&&B.scheme===C.Schemas.file&&!N&&(j=j.replace(/\//g,"\\"));else if(B.scheme===C.Schemas.file)j=B.fsPath,D.isWindows&&(j=(0,w.normalizeDriveLetter)(j),N&&(j=(0,g.toSlashes)(j)));else{if(!O.isEqualAuthority(B.authority,M.authority))return{name:U,uri:B.toString(!0)};j=B.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=m;function b(B,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let j of B){let K=null;if(l(j))j.path&&(K=U.resolvePath(O,j.path));else if(h(j))try{K=P.URI.parse(j.uri),K.path[0]!=="/"&&(K=K.with({path:"/"+K.path}))}catch(X){console.warn(X)}if(K){let X=U.getComparisonKey(K);if(!N.has(X)){N.add(X);const me=j.name||U.basenameOrAuthority(K);M.push(new T.WorkspaceFolder({uri:K,name:me,index:M.length},j))}}}return M}e.toWorkspaceFolders=b;function c(B,F,U,M,N){let O=f(F,B);const j=N.dirname(F),K=N.dirname(M),X=[],me=k(O.folders);for(const Me of O.folders){const V=l(Me)?N.resolvePath(j,Me.path):P.URI.parse(Me.uri);let Y;U?Y=!1:Y=!l(Me)||(0,A.isAbsolute)(Me.path),X.push(m(V,Y,Me.name,K,me,N))}const we={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Ae=i.setProperty(B,["folders"],X,we);let Ie=i.applyEdits(B,Ae);return O.remoteAuthority===(0,s.getRemoteAuthority)(M)&&(Ie=i.applyEdits(Ie,i.removeProperty(Ie,["remoteAuthority"],we))),Ie}e.rewriteWorkspaceFileForNewLocation=c;function f(B,F){let U=R.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${B} looks like an invalid workspace file.`);return U}function k(B){return D.isWindows?B.some(F=>l(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function L(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function $(B){return typeof B.folderUri=="string"}function ee(B){return typeof B.fileUri=="string"}function H(B,F){const U={workspaces:[],files:[]};if(B){const M=function(O,j){for(let K=0;K<O.length;K++)try{j(O[K],K)}catch(X){F.warn(`Error restoring recent entry ${JSON.stringify(O[K])}: ${X.toString()}. Skip entry.`)}},N=B;if(Array.isArray(N.entries))M(N.entries,O=>{const j=O.label,K=O.remoteAuthority;L(O)?U.workspaces.push({label:j,remoteAuthority:K,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):$(O)?U.workspaces.push({label:j,remoteAuthority:K,folderUri:P.URI.parse(O.folderUri)}):ee(O)&&U.files.push({label:j,remoteAuthority:K,fileUri:P.URI.parse(O.fileUri)})});else{const O=B;Array.isArray(O.workspaces3)&&M(O.workspaces3,(j,K)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[K]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:j.id,configPath:P.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:X,folderUri:P.URI.parse(j)})}),Array.isArray(O.files2)&&M(O.files2,(j,K)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[K]||void 0;typeof j=="string"&&U.files.push({label:X,fileUri:P.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=H;function x(B){const F={entries:[]};for(const U of B.workspaces)_(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of B.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(ge[116],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(ge[194],ve([0,1,2,3]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(A=>({name:A.name,group:A.group,resource:E.URI.revive(A.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[60],ve([0,1,11,4]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,A){A===null?this._providerInfo.delete(D):this._providerInfo.set(D,A)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(ge[195],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(P,D,A){this._id=P,this._shared=D,this._storage=A,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(P,D){let A=this._value[P];return typeof A=="undefined"&&(A=D),A}update(P,D){return this._value[P]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class I extends E{constructor(P,D){super(P.identifier.value,!0,D);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=I}),define(ge[13],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class I{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[196],ve([0,1,29,3]),function(Q,e,E,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(A,y){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(A.identifier),tt(this,T,y,"f"),$e(this,T,"f").onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(A){return $e(this,T,"f").get(this._id,A)}store(A,y){return $e(this,T,"f").store(this._id,A,y)}delete(A){return $e(this,T,"f").delete(this._id,A)}}e.ExtensionSecrets=P,T=new WeakMap}),define(ge[117],ve([0,1,4,3]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(ge[50],ve([0,1,4,3,13]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(A){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}A.fromApiTunnel=y;function i(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}A.fromServiceTunnel=i})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,i){return{dispose:()=>{}}}async $providePortAttributes(y,i,R,C,w){return[]}async $forwardPort(y,i){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Ue(0,T.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[7],ve([0,1,18,17,94,24,14,2,28,44,113]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";var C,w,g,s,d,S,v,_,p,u,a,t,n,o,r,l,h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(z){function W(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(W,z),Object.setPrototypeOf(W.prototype,z.prototype),W}let c=d=class{constructor(W){C.set(this,void 0),tt(this,C,W,"f")}static from(...W){let se=W;return new d(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}dispose(){typeof $e(this,C,"f")=="function"&&($e(this,C,"f").call(this),tt(this,C,void 0,"f"))}};C=new WeakMap,c=d=je([b],c),e.Disposable=c;let f=S=class{constructor(W,se){if(W<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let ye=1;ye<W.length;ye++){const ze=W[ye];ze.isBefore(se)&&(se=ze)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let ye=1;ye<W.length;ye++){const ze=W[ye];ze.isAfter(se)&&(se=ze)}return se}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:se,character:ye}=W;return typeof se=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof W=="undefined"?ye=0:typeof W=="number"?ye=W:(ye=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),ye===0&&se===0?this:new S(this.line+ye,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof W=="undefined"?ye=this.line:typeof W=="number"?ye=W:(ye=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),ye===this.line&&se===this.character?this:new S(ye,se)}toJSON(){return{line:this.line,character:this.character}}};f=S=je([b],f),e.Position=f;let k=v=class{constructor(W,se,ye,ze){let Xe,it;if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new f(W,se),it=new f(ye,ze)):W instanceof f&&se instanceof f&&(Xe=W,it=se),!Xe||!it)throw new Error("Invalid arguments");Xe.isBefore(it)?(this._start=Xe,this._end=it):(this._start=it,this._end=Xe)}static isRange(W){return W instanceof v?!0:W?f.isPosition(W.start)&&f.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof v?this.contains(W._start)&&this.contains(W._end):W instanceof f?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=f.Max(W.start,this._start),ye=f.Min(W.end,this._end);if(!se.isAfter(ye))return new v(se,ye)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=f.Min(W.start,this._start),ye=f.Max(W.end,this.end);return new v(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return W?f.isPosition(W)?ye=W:(ye=W.start||this.start,se=W.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new v(ye,se)}toJSON(){return[this.start,this.end]}};k=v=je([b],k),e.Range=k;let L=_=class extends k{constructor(W,se,ye,ze){let Xe,it;if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new f(W,se),it=new f(ye,ze)):W instanceof f&&se instanceof f&&(Xe=W,it=se),!Xe||!it)throw new Error("Invalid arguments");super(Xe,it);this._anchor=Xe,this._active=it}static isSelection(W){return W instanceof _?!0:W?k.isRange(W)&&f.isPosition(W.anchor)&&f.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=_=je([b],L),e.Selection=L;class ${constructor(W,se,ye){if(typeof W!="string"||W.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,I.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=$;class ee extends Error{constructor(W,se=R.RemoteAuthorityResolverErrorCode.Unknown,ye){super(W);this._message=W,this._code=se,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(W,se){return new ee(W,R.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new ee(W,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var H;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var x;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=p=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof p?!0:W?k.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new p(W,se)}static insert(W,se){return p.replace(new k(W,W),se)}static delete(W){return p.replace(W,"")}static setEndOfLine(W){const se=new p(new k(new f(0,0),new f(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!k.isRange(W))throw(0,I.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,I.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,I.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=p=je([b],B),e.TextEdit=B;var F;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,ye,ze){this._edits.push({_type:1,from:W,to:se,options:ye,metadata:ze})}createFile(W,se,ye){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:ye})}deleteFile(W,se,ye){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(W,se,ye){this._edits.push({_type:3,metadata:ye,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,ye,ze,Xe){(se!==ye||ze.length>0)&&this._edits.push({_type:5,uri:W,index:se,count:ye-se,cells:ze,metadata:Xe})}replaceNotebookCellOutput(W,se,ye,ze){this._editNotebookCellOutput(W,se,!1,ye,ze)}appendNotebookCellOutput(W,se,ye,ze){this._editNotebookCellOutput(W,se,!0,ye,ze)}replaceNotebookCellOutputItems(W,se,ye,ze,Xe){this._editNotebookCellOutputItems(W,se,ye,!1,ze,Xe)}appendNotebookCellOutputItems(W,se,ye,ze,Xe){this._editNotebookCellOutputItems(W,se,ye,!0,ze,Xe)}_editNotebookCellOutputItems(W,se,ye,ze,Xe,it){this._edits.push({_type:6,metadata:it,uri:W,index:se,outputId:ye,append:ze,newOutputItems:Xe})}_editNotebookCellOutput(W,se,ye,ze,Xe){this._edits.push({_type:4,metadata:Xe,uri:W,index:se,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(W,se,ye,ze){this._edits.push({_type:3,metadata:ze,uri:W,edit:{editType:11,index:se,metadata:ye}})}replace(W,se,ye,ze){this._edits.push({_type:2,uri:W,edit:new B(se,ye),metadata:ze})}insert(W,se,ye,ze){this.replace(W,new k(se,se),ye,ze)}delete(W,se,ye){this.replace(W,se,"",ye)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const ye of se)ye&&this._edits.push({_type:2,uri:W,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===W.toString()&&(this._edits[ye]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===W.toString()&&se.push(ye.edit);return se}entries(){const W=new P.ResourceMap;for(let se of this._edits)if(se._type===2){let ye=W.get(se.uri);ye||(ye=[se.uri,[]],W.set(se.uri,ye)),ye[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([b],U),e.WorkspaceEdit=U;let M=u=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=u._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const ye=new u;ye._tabstop=this._tabstop,W(ye),this._tabstop=ye._tabstop,W=ye.value}else W=u._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const ye=W.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const ye=new u;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=u=je([b],M),e.SnippetString=M;var N;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let j=a=class{constructor(W,se){if(this.uri=W,se)if(se instanceof k)this.range=se;else if(se instanceof f)this.range=new k(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof a?!0:W?k.isRange(W.range)&&A.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};j=a=je([b],j),e.Location=j;let K=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&k.isRange(W.location.range)&&A.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};K=je([b],K),e.DiagnosticRelatedInformation=K;let X=class{constructor(W,se,ye=O.Error){if(!k.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=ye}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,E.equals)(W.tags,se.tags)&&(0,E.equals)(W.relatedInformation,se.relatedInformation,K.isEqual)}};X=je([b],X),e.Diagnostic=X;let me=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,T.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=se}};me=je([b],me),e.Hover=me;var we;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(W,se=we.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ae=je([b],Ae),e.DocumentHighlight=Ae;var Ie;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var Me;(function(z){z[z.Deprecated=1]="Deprecated"})(Me=e.SymbolTag||(e.SymbolTag={}));let V=t=class{constructor(W,se,ye,ze,Xe){this.name=W,this.kind=se,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),ze instanceof j?this.location=ze:ye instanceof k&&(this.location=new j(ze,ye)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};V=t=je([b],V),e.SymbolInformation=V;let Y=n=class{constructor(W,se,ye,ze,Xe){this.name=W,this.detail=se,this.kind=ye,this.range=ze,this.selectionRange=Xe,this.children=[],n.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(n.validate)}};Y=n=je([b],Y),e.DocumentSymbol=Y;var te;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,se){this.title=W,this.kind=se}};ae=je([b],ae),e.CodeAction=ae;let fe=o=class{constructor(W){this.value=W}append(W){return new o(this.value?this.value+o.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+o.sep)}};fe.sep=".",fe=o=je([b],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let De=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([b],De),e.SelectionRange=De;class Oe{constructor(W,se,ye,ze,Xe,it){this.kind=W,this.name=se,this.detail=ye,this.uri=ze,this.range=Xe,this.selectionRange=it}}e.CallHierarchyItem=Oe;class be{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=be;class ke{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=ke;let Te=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};Te=je([b],Te),e.CodeLens=Te;let xe=r=class{constructor(W,se=!1){w.set(this,void 0),tt(this,w,new T.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return $e(this,w,"f").value}set value(W){$e(this,w,"f").value=W}get isTrusted(){return $e(this,w,"f").isTrusted}set isTrusted(W){$e(this,w,"f").isTrusted=W}get supportThemeIcons(){return $e(this,w,"f").supportThemeIcons}appendText(W){return $e(this,w,"f").appendText(W),this}appendMarkdown(W){return $e(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,se){return $e(this,w,"f").appendCodeblock(se!=null?se:"",W),this}};w=new WeakMap,xe=r=je([b],xe),e.MarkdownString=xe;let Se=class{constructor(W,se){this.label=W,this.documentation=se}};Se=je([b],Se),e.ParameterInformation=Se;let Ke=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};Ke=je([b],Ke),e.SignatureInformation=Ke;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=je([b],G),e.SignatureHelp=G;var re;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ee=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(W,se,ye){this.text=W,this.range=se,this.kind=ye}};Ne=je([b],Ne),e.InlineHint=Ne;var Ve;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(z){z[z.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let q=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};q=je([b],q),e.CompletionItem=q;let oe=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};oe=je([b],oe),e.CompletionList=oe;var he;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var Z;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Z=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _e;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var He;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(He=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function W(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=W}(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let We=class{constructor(W,se){if(se&&!A.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!k.isRange(W)||W.isEmpty)throw(0,I.illegalArgument)("range");this.range=W,this.target=se}};We=je([b],We),e.DocumentLink=We;let qe=class{constructor(W,se,ye,ze){this.red=W,this.green=se,this.blue=ye,this.alpha=ze}};qe=je([b],qe),e.Color=qe;let Ye=class{constructor(W,se){if(se&&!(se instanceof qe))throw(0,I.illegalArgument)("color");if(!k.isRange(W)||W.isEmpty)throw(0,I.illegalArgument)("range");this.range=W,this.color=se}};Ye=je([b],Ye),e.ColorInformation=Ye;let Ze=class{constructor(W){if(!W||typeof W!="string")throw(0,I.illegalArgument)("label");this.label=W}};Ze=je([b],Ze),e.ColorPresentation=Ze;var ut;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var ot;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=l=class{constructor(W,se){if(typeof W!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ce.Clean=new l("clean","Clean"),Ce.Build=new l("build","Build"),Ce.Rebuild=new l("rebuild","Rebuild"),Ce.Test=new l("test","Test"),Ce=l=je([b],Ce),e.TaskGroup=Ce;function ce(z){let W="";for(let se=0;se<z.length;se++)W+=z[se].replace(/,/g,",,")+",";return W}let J=class{constructor(W,se,ye){if(typeof W!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,I.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return ce(W)}};J=je([b],J),e.ProcessExecution=J;let Re=class{constructor(W,se,ye){if(this._args=[],Array.isArray(se)){if(!W)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,I.illegalArgument)("command");this._command=W,this._args=se,this._options=ye}else{if(typeof W!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,I.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return ce(W)}};Re=je([b],Re),e.ShellExecution=Re;var Le;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Le=e.ShellQuoting||(e.ShellQuoting={}));var Je;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Je=e.TaskScope||(e.TaskScope={}));class Ge{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=h=class{constructor(W,se,ye,ze,Xe,it){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=ze,dt=Xe,this.__deprecated=!0):se===Je.Global||se===Je.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=it):(this.target=se,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof J?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(h.EmptyType===se||h.ProcessType===se||h.ShellType===se||h.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=h=je([b],rt),e.Task=rt;var at;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(W,se=ct.None){this.collapsibleState=se,A.URI.isUri(W)?this.resourceUri=W:this.label=W}};Qe=je([b],Qe),e.TreeItem=Qe;var ct;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(W,se){this.id=W,this.color=se}};st=je([b],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(W){this.id=W}};gt=je([b],gt),e.ThemeColor=gt;var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(W,se){if(typeof W!="string"&&(!W||!A.URI.isUri(W)&&!A.URI.isUri(W.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=A.URI.file(W),this.base=W):A.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};Dt=je([b],Dt),e.RelativePattern=Dt;let wt=class{constructor(W,se,ye,ze){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};wt=je([b],wt),e.Breakpoint=wt;let St=class extends wt{constructor(W,se,ye,ze,Xe){super(se,ye,ze,Xe);if(W===null)throw(0,I.illegalArgument)("location");this.location=W}};St=je([b],St),e.SourceBreakpoint=St;let pt=class extends wt{constructor(W,se,ye,ze,Xe){super(se,ye,ze,Xe);this.functionName=W}};pt=je([b],pt),e.FunctionBreakpoint=pt;let Lt=class extends wt{constructor(W,se,ye,ze,Xe,it,dt){super(ze,Xe,it,dt);if(!se)throw(0,I.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=ye}};Lt=je([b],Lt),e.DataBreakpoint=Lt;let Ft=class{constructor(W,se,ye){this.command=W,this.args=se||[],this.options=ye}};Ft=je([b],Ft),e.DebugAdapterExecutable=Ft;let ft=class{constructor(W,se){this.port=W,this.host=se}};ft=je([b],ft),e.DebugAdapterServer=ft;let yt=class{constructor(W){this.path=W}};yt=je([b],yt),e.DebugAdapterNamedPipeServer=yt;let Vt=class{constructor(W){this.implementation=W}};Vt=je([b],Vt),e.DebugAdapterInlineImplementation=Vt;let Qt=class{constructor(W,se){this.range=W,this.expression=se}};Qt=je([b],Qt),e.EvaluatableExpression=Qt;let Mt=class{constructor(W,se){this.range=W,this.text=se}};Mt=je([b],Mt),e.InlineValueText=Mt;let ht=class{constructor(W,se,ye=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=ye}};ht=je([b],ht),e.InlineValueVariableLookup=ht;let Xt=class{constructor(W,se){this.range=W,this.expression=se}};Xt=je([b],Xt),e.InlineValueEvaluatableExpression=Xt;let kt=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};kt=je([b],kt),e.InlineValueContext=kt;var Nt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let jt=m=class extends Error{constructor(W,se=i.FileSystemProviderErrorCode.Unknown,ye){var ze;super(A.URI.isUri(W)?W.toString(!0):W);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(W){return new m(W,i.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(W){return new m(W,i.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(W){return new m(W,i.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(W){return new m(W,i.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(W){return new m(W,i.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(W){return new m(W,i.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};jt=m=je([b],jt),e.FileSystemError=jt;let Jt=class{constructor(W,se,ye){this.start=W,this.end=se,this.kind=ye}};Jt=je([b],Jt),e.FoldingRange=Jt;var sn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class Ot{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=Ot;function pn(z){return typeof z=="undefined"||(0,D.isStringArray)(z)}class Ut{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,ye=W.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,ye=W.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,ye,ze,Xe){if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(W,se,ye,ze,Xe);if(k.isRange(W)&&typeof se=="string"&&pn(ye))return this._push(W,se,ye);throw(0,I.illegalArgument)()}_push(W,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const ze=W.start.line,Xe=W.start.character,it=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(se);let _t=0;if(ye)for(const Ct of ye){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);_t|=1<<It>>>0}this._pushEncoded(ze,Xe,it,dt,_t)}_pushEncoded(W,se,ye,ze,Xe){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<_t;Pt++){let Tt=this._data[5*Pt],tn=this._data[5*Pt+1];Tt===0?(Tt=Ct,tn+=It):Tt+=Ct,this._data[5*Pt]=Tt,this._data[5*Pt+1]=tn,Ct=Tt,It=tn}}let it=W,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Xe,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const ye=W.length/5|0;for(let dt=0;dt<ye;dt++)se[dt]=dt;se.sort((dt,_t)=>{const Ct=W[5*dt],It=W[5*_t];if(Ct===It){const Pt=W[5*dt+1],Tt=W[5*_t+1];return Pt-Tt}return Ct-It});const ze=new Uint32Array(W.length);let Xe=0,it=0;for(let dt=0;dt<ye;dt++){const _t=5*se[dt],Ct=W[_t+0],It=W[_t+1],Pt=W[_t+2],Tt=W[_t+3],tn=W[_t+4],Tn=Ct-Xe,On=Tn===0?It-it:It,nn=5*dt;ze[nn+0]=Tn,ze[nn+1]=On,ze[nn+2]=Pt,ze[nn+3]=Tt,ze[nn+4]=tn,Xe=Ct,it=It}return ze}build(W){return this._dataIsSortedAndDeltaEncoded?new xt(new Uint32Array(this._data),W):new xt(Ut._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ut;class xt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=xt;class vn{constructor(W,se,ye){this.start=W,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=vn;class wn{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=wn;var At;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(At=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let qt=class{constructor(){}};qt.Back={iconPath:new st("arrow-left")},qt=je([b],qt),e.QuickInputButtons=qt;var _n;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(W,se,ye){this.badge=W,this.tooltip=se,this.color=ye}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Bt=class{constructor(W){this.kind=W}};Bt=je([b],Bt),e.ColorTheme=Bt;var an;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(W,se){if(W<0)throw(0,I.illegalArgument)("start must be positive");if(se<W)throw(0,I.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,ye=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(ye=W.end),se===this._start&&ye===this._end?this:new Kt(se,ye)}}e.NotebookCellRange=Kt;class Wt{constructor(W,se,ye,ze,Xe,it,dt){this.editable=W,this.breakpointMargin=se,this.hasExecutionOrder=ye,this.statusMessage=ze,this.inputCollapsed=Xe,this.outputCollapsed=it,this.custom=dt}with(W){let{editable:se,breakpointMargin:ye,hasExecutionOrder:ze,statusMessage:Xe,inputCollapsed:it,outputCollapsed:dt,custom:_t}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.statusMessage:Xe===null&&(Xe=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),_t===void 0?_t=this.custom:_t===null&&(_t=void 0),se===this.editable&&ye===this.breakpointMargin&&ze===this.hasExecutionOrder&&Xe===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&_t===this.custom?this:new Wt(se,ye,ze,Xe,it,dt,_t)}}e.NotebookCellMetadata=Wt;class Fe{constructor(W=!0,se=!0,ye=!0,ze={},Xe=!0){this.editable=W,this.cellEditable=se,this.cellHasExecutionOrder=ye,this.custom=ze,this.trusted=Xe}with(W){let{editable:se,cellEditable:ye,cellHasExecutionOrder:ze,custom:Xe,trusted:it}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.custom:Xe===null&&(Xe=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),se===this.editable&&ye===this.cellEditable&&ze===this.cellHasExecutionOrder&&Xe===this.custom&&it===this.trusted?this:new Fe(se,ye,ze,Xe,it)}}e.NotebookDocumentMetadata=Fe;class Yt{constructor(W,se,ye,ze,Xe,it){this.kind=W,this.source=se,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Xe,this.latestExecutionSummary=it}}e.NotebookCellData=Yt;class Zt{constructor(W,se){this.cells=W,this.metadata=se!=null?se:new Fe}}e.NotebookData=Zt;class mt{constructor(W,se,ye){this.mime=W,this.value=se,this.metadata=ye}static isNotebookCellOutputItem(W){return W instanceof mt}}e.NotebookCellOutputItem=mt;class Sn{constructor(W,se,ye){this.outputs=W,typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=se!=null?se:ye)}}e.NotebookCellOutput=Sn;var yn;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(yn=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var cn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(cn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let en=class{constructor(W,se){this.label=W,this.timestamp=se}};en=je([b],en),e.TimelineItem=en;var Cn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=In;var Pn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Pn=e.TestResultState||(e.TestResultState={}));var dn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(dn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Gt=(z,W,se)=>{let ye=se;return{enumerable:!0,configurable:!1,get(){return ye},set(ze){var Xe;(Xe=z[e.TestItemHookProperty])===null||Xe===void 0||Xe.setProp(W,ze),ye=ze}}};class hn{constructor(W){g.set(this,new Map),s.set(this,void 0),tt(this,s,W,"f")}get size(){return $e(this,g,"f").size}add(W){const se=$e(this,g,"f"),ye=$e(this,s,"f").call(this),ze=se.get(W.id);ze!==W&&(ze&&(ye==null||ye.delete(W.id)),se.set(W.id,W),ye==null||ye.created(W))}get(W){return $e(this,g,"f").get(W)}clear(){for(const W of $e(this,g,"f").keys())this.delete(W)}delete(W){var se;const ye=typeof W=="string"?W:W.id;$e(this,g,"f").has(ye)&&($e(this,g,"f").delete(ye),(se=$e(this,s,"f").call(this))===null||se===void 0||se.delete(ye))}toJSON(){return[...$e(this,g,"f").values()]}[(g=new WeakMap,s=new WeakMap,Symbol.iterator)](){return $e(this,g,"f").values()}}e.TestChildrenCollection=hn;class ie{constructor(W,se,ye,ze){this.label=se,this.expandable=ze,Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},children:{value:new hn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:Gt(this,"range",void 0),description:Gt(this,"description",void 0),runnable:Gt(this,"runnable",!0),debuggable:Gt(this,"debuggable",!0)})}invalidate(){var W;(W=this[e.TestItemHookProperty])===null||W===void 0||W.invalidate(this.id)}discoverChildren(W,se){W.report({busy:!1})}}e.TestItem=ie;class de{constructor(W){this.message=W,this.severity=dn.Error}static diff(W,se,ye){const ze=new de(W);return ze.expectedOutput=se,ze.actualOutput=ye,ze}}e.TestMessage=de;var Pe;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Pe=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var lt;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(lt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],ve([0,1,52,11,10,143,105,7,18]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function R(s,d){d?i.set(s,d):i.delete(s)}e.setWordDefinitionFor=R;function C(s){return i.get(s)}e.getWordDefinitionFor=C;class w extends P.MirrorTextModel{constructor(d,S,v,_,p,u,a,t){super(S,v,_,p);this._proxy=d,this._languageId=u,this._isDirty=a,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===I.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(S){return S?d._getTextInRange(S):d.getText()},get eol(){return d._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(S){return d._lineAt(S)},offsetAt(S){return d._offsetAt(S)},positionAt(S){return d._positionAt(S)},validateRange(S){return d._validateRange(S)},validatePosition(S){return d._validatePosition(S)},getWordRangeAtPosition(S,v){return d._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,E.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,E.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const S=this._validateRange(d);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,_=S.start.line,p=S.end.line,u=[];u.push(this._lines[_].substring(S.start.character));for(let a=_+1;a<p;a++)u.push(this._lines[a]);return u.push(this._lines[p].substring(0,S.end.character)),u.join(v)}_lineAt(d){let S;if(d instanceof A.Position?S=d.line:typeof d=="number"&&(S=d),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(d),v=this._lines[S.index].length;return new A.Position(S.index,Math.min(S.remainder,v))}_validateRange(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const S=this._validatePosition(d.start),v=this._validatePosition(d.end);return S===d.start&&v===d.end?d:new A.Range(S.line,S.character,v.line,v.character)}_validatePosition(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:S,character:v}=d,_=!1;if(S<0)S=0,v=0,_=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,_=!0;else{const p=this._lines[S].length;v<0?(v=0,_=!0):v>p&&(v=p,_=!0)}return _?new A.Position(S,v):d}_getWordRangeAtPosition(d,S){const v=this._validatePosition(d);if(!S)S=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const _=(0,D.getWordAtText)(v.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[v.line],0);if(_)return new A.Range(v.line,_.startColumn-1,v.line,_.endColumn-1)}}e.ExtHostDocumentData=w;class g{constructor(d,S,v){this._line=d,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[197],ve([0,1,7,3,107,6,76,24,2,28]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(w,g,s,d){this._notebook=s,this._selector=d,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,i.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(v=>{const _=this._cellUris.get(v.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(w.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const w=[],g=[];for(const s of this._notebook.getCells())s.kind===E.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),w.push(s.document.getText().length+1),g.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(w)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(w){var g,s;if(!w){let p="";for(const u of this._cells)p+=u.document.getText()+`
`;return p=p.slice(0,-1),p}if(w.isEmpty)return"";const d=this.locationAt(w.start),S=this.locationAt(w.end),v=this._cells[(g=this._cellUris.get(d.uri))!==null&&g!==void 0?g:-1],_=this._cells[(s=this._cellUris.get(S.uri))!==null&&s!==void 0?s:-1];if(!v||!_)return"";if(v===_)return v.document.getText(new E.Range(d.range.start,S.range.end));{const p=v.document.getText(new E.Range(d.range.start,new E.Position(v.document.lineCount,0))),u=_.document.getText(new E.Range(new E.Position(0,0),S.range.end));return p+`
`+u}}offsetAt(w){const g=this._cellLines.getIndexOf(w.line),s=this._cellLengths.getAccumulatedValue(g.index-1),d=this._cells[g.index].document.offsetAt(w.with(g.remainder));return s+d}positionAt(w){if(typeof w=="number"){const s=this._cellLengths.getIndexOf(w),d=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const g=this._cellUris.get(w.uri);if(g!==void 0){const s=this._cellLines.getAccumulatedValue(g-1);return new E.Position(s+w.range.start.line,w.range.start.character)}return new E.Position(0,0)}locationAt(w){E.Range.isRange(w)||(w=new E.Range(w,w));const g=this._cellLines.getIndexOf(w.start.line);let s=g;w.isEmpty||(s=this._cellLines.getIndexOf(w.end.line));const d=new E.Position(g.remainder,w.start.character),S=new E.Position(s.remainder,w.end.character),v=new E.Range(d,S),_=this._cells[g.index];return new E.Location(_.document.uri,_.document.validateRange(v))}contains(w){return this._cellUris.has(w)}validateRange(w){const g=this.validatePosition(w.start),s=this.validatePosition(w.end);return w.with(g,s)}validatePosition(w){const g=this._cellLines.getIndexOf(w.line),s=new E.Position(g.remainder,w.character),d=this._cells[g.index].document.validatePosition(s),S=this._cellLines.getAccumulatedValue(g.index-1);return new E.Position(S+d.line,d.character)}}e.ExtHostNotebookConcatDocument=R}),define(ge[198],ve([0,1,7,13,3]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(A){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y=A==="light"?E.ColorThemeKind.Light:A==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([Ue(0,I.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(ge[61],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class I{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(ge[199],ve([0,1,22]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let i=this.buffers.indexOf(y);return i<0&&(i=this.buffers.length,this.buffers.push(y)),i}}function T(A,y){if(y){const i=new I,R=(g,s)=>{if(s instanceof ArrayBuffer){const d=i.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=P(s);if(d){const S=i.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},C=JSON.stringify(A,R),w=i.buffers.map(g=>{const s=new Uint8Array(g);return E.VSBuffer.wrap(s)});return{message:C,buffers:w}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function P(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(A,y){const i=y.map(w=>{const g=new ArrayBuffer(w.byteLength);return new Uint8Array(g).set(w.buffer),g}),R=y.length?(w,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const s=g,{index:d}=s,S=i[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(S,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return g}:void 0;return{message:JSON.parse(A,R),arrayBuffers:i}}e.deserializeWebviewMessage=D}),define(ge[84],ve([0,1,2]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(P,D,A){const y=P.webviewResourceRoot.replace("{{resource}}",A.scheme+T(A)).replace("{{uuid}}",D);return E.URI.parse(y)}e.asWebviewUri=I;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(ge[200],ve([0,1,3,6,84,28]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,i,R){this._proxy=y,this._editors=i,this._initData=R,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const C=i.getVisibleTextEditors();for(const w of this._insets.values())C.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,i,R,C,w){let g;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){g=u;break}if(!g)throw new Error("not a visible editor");const s=this,d=this._handlePool++,S=new E.Emitter,v=new E.Emitter,_=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,T.asWebviewUri)(s._initData,this._uuid,u)}get cspSource(){return s._initData.webviewCspSource}set options(u){this._options=u,s._proxy.$setOptions(d,u)}get options(){return this._options}set html(u){this._html=u,s._proxy.$setHtml(d,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return s._proxy.$postMessage(d,u)}},p=new class{constructor(){this.editor=y,this.line=i,this.height=R,this.webview=_,this.onDidDispose=v.event}dispose(){s._insets.has(d)&&(s._insets.delete(d),s._proxy.$disposeEditorInset(d),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(d,g.id,g.value.document.uri,i+1,R,C||{},w.identifier,w.extensionLocation),this._insets.set(d,{editor:y,inset:p,onDidReceiveMessage:S}),p}$onDidDispose(y){const i=this._insets.get(y);i&&i.inset.dispose()}$onDidReceiveMessage(y,i){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=D}),define(ge[201],ve([0,1,3,80,168,4,6,24,40,18,53,23,47,193]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",w.Codicon.window,(0,T.localize)(0,null));var s;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=v;class _ extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,i.flatten)([...this.viewContainers.values()])}registerViewContainer(h,m,b){var c;const f=this.get(h.id);if(f)return f;const k=h;return k.openCommandActionDescriptor=(b==null?void 0:b.donotRegisterOpenCommand)?void 0:(c=k.openCommandActionDescriptor)!==null&&c!==void 0?c:{id:k.id},(0,A.getOrSet)(this.viewContainers,m,[]).push(k),(b==null?void 0:b.isDefault)&&this.defaultViewContainers.push(k),this._onDidRegister.fire({viewContainer:k,viewContainerLocation:m}),k}deregisterViewContainer(h){for(const m of this.viewContainers.keys()){const b=this.viewContainers.get(m),c=b==null?void 0:b.indexOf(h);if(c!==-1){b==null||b.splice(c,1),b.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:m});return}}}get(h){return this.all.filter(m=>m.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(b=>(b==null?void 0:b.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===h)}}y.Registry.add(s.ViewContainersRegistry,new _);var p;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function u(l,h){var m,b,c,f;const k=(m=l.group)!==null&&m!==void 0?m:p.More,L=(b=h.group)!==null&&b!==void 0?b:p.More;return k!==L?k.localeCompare(L):((c=l.order)!==null&&c!==void 0?c:5)-((f=h.order)!==null&&f!==void 0?f:5)}class a extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(h,m){this.registerViews2([{views:h,viewContainer:m}])}registerViews2(h){h.forEach(({views:m,viewContainer:b})=>this.addViews(m,b)),this._onViewsRegistered.fire(h)}deregisterViews(h,m){const b=this.removeViews(h,m);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:m})}moveViews(h,m){for(const b of this._views.keys())if(b!==m){const c=this.removeViews(h,b);c.length&&(this.addViews(c,m),this._onDidChangeContainer.fire({views:c,from:b,to:m}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const m of this._viewContainers){const b=(this._views.get(m)||[]).filter(c=>c.id===h)[0];if(b)return b}return null}getViewContainer(h){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(c=>c.id===h)[0])return m;return null}registerViewWelcomeContent(h,m){return this._viewWelcomeContents.add(h,m),this._onDidChangeViewWelcomeContent.fire(h),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(h,m),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,m){const b=new Map;for(const[c,f]of m)this._viewWelcomeContents.add(h,f),b.set(c,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(h,f),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),b}getViewWelcomeContent(h){const m=[];return this._viewWelcomeContents.forEach(h,b=>m.push(b)),m.sort(u)}addViews(h,m){let b=this._views.get(m);b||(b=[],this._views.set(m,b),this._viewContainers.push(m));for(const c of h){if(this.getView(c.id)!==null)throw new Error((0,T.localize)(1,null,c.id));b.push(c)}}removeViews(h,m){const b=this._views.get(m);if(!b)return[];const c=[],f=[];for(const k of b)h.includes(k)?c.push(k):f.push(k);return c.length&&(f.length?this._views.set(m,f):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),c}}y.Registry.add(s.ViewsRegistry,new a),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var n;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(h,m){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,h),this._hasResolve=!!m,this.resolve=async b=>{var c,f;if(m&&!this.resolved){const k=await m(b);k&&(this.tooltip=(c=this.tooltip)!==null&&c!==void 0?c:k.tooltip,this.command=(f=this.command)!==null&&f!==void 0?f:k.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[202],ve([0,1,2,180,115,12,181,201]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(d){return(S,...v)=>d(S.get(I.ICommandService),...v)}class i{static execute(S,v){const _={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:i.ID,handler:y(i.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,S){return d.get(T.IWorkspacesService).removeRecentlyOpened([S])});class R{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?E.URI.parse(v):E.URI.file(v):v=E.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(S,v){const _=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,S){const v=d.get(T.IWorkspacesService);let _;const p=S.uri,u=S.label,a=S.remoteAuthority;return S.type==="workspace"?_={workspace:await v.getWorkspaceIdentifier(p),label:u,remoteAuthority:a}:S.type==="folder"?_={folderUri:p,label:u,remoteAuthority:a}:_={fileUri:p,label:u,remoteAuthority:a},v.addRecentlyOpened([_])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,S){const v=d.get(P.ILogService),_=d.get(D.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&v.setLevel(S)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(P.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,S){const v=d.get(A.IViewDescriptorService),_=v.getViewContainerById(S.destinationId);if(!!_){for(const p of S.viewIds){const u=v.getViewDescriptorById(p);(u==null?void 0:u.canMoveView)&&v.moveViewsToContainer([u],_,A.ViewVisibilityState.Default)}await d.get(A.IViewsService).openViewContainer(_.id,!0)}});class w{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=w,w.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:w.ID,handler:y(w.execute),description:{description:"Move Views",args:[]}});class g{static execute(S,v){return S.executeCommand("_workbench.open",v)}}g.ID="vscode.open",I.CommandsRegistry.registerCommand(g.ID,y(g.execute));class s{static execute(S,v,_,p,u){return S.executeCommand("_workbench.diff",[v,_,p])}}s.ID="vscode.diff",I.CommandsRegistry.registerCommand(s.ID,y(s.execute))}),define(ge[119],ve([0,1,3,19,169]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,i,R){const C={command:A};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const g=this.pendingRequests.get(C.seq);if(g){this.pendingRequests.delete(C.seq);const s={type:"response",seq:0,request_seq:C.seq,success:!1,command:A,message:(0,T.localize)(0,null,R,A)};g(s)}},R)}return i&&this.pendingRequests.set(C.seq,i),C.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const y=A,i=this.pendingRequests.get(y.request_seq);i&&(this.pendingRequests.delete(y.request_seq),i(y));break}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,i)=>A.set(i,y)),await(0,I.timeout)(500),A.forEach((y,i)=>{y({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(ge[203],ve([0,1,10,2,8,23,11]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(n,o,r){return n.replace(A,function(l,h){return o&&h.length>0&&h[0]!=="_"?l:r&&r.hasOwnProperty(h)?r[h]:l})}e.formatPII=y;function i(n){const o={};for(const r of Object.keys(n))r.startsWith("!")||(o[r]=n[r]);return o}e.filterExceptionsFromTelemetry=i;function R(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=R;function C(n){let o=n.configuration.type;if(!!o)return o==="vslsShare"&&(o=n.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(o,"extensionhost")||(0,E.equalsIgnoreCase)(o,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function w(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=w;function g(n,o,r){let l,h=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=m.exec(n);){let c=b.index+1,f=c+b[0].length;if(c<=o&&f>=r){l=b[0],h=c;break}}if(l){let c=/\w+/g,f=null;for(;(f=c.exec(l))&&!(f.index+1+h+f[0].length>=r););f&&(l=l.substring(0,c.lastIndex))}return l?{start:h,end:h+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(s))}e.isUri=d;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const o=I.URI.revive(n.path);if(o)return o.scheme===D.Schemas.file?o.fsPath:o.toString()}return n.path}function _(n,o){const r=o?S:v,l=(0,P.deepClone)(n);return u(l,(h,m)=>{h&&m&&(m.path=r(m))}),l}e.convertToDAPaths=_;function p(n,o){const r=o?S:v,l=(0,P.deepClone)(n);return u(l,(h,m)=>{!h&&m&&(m.path=r(m))}),l}e.convertToVSCPaths=p;function u(n,o){switch(n.type){case"event":const r=n;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=n;switch(l.command){case"setBreakpoints":o(!0,l.arguments.source);break;case"breakpointLocations":o(!0,l.arguments.source);break;case"source":o(!0,l.arguments.source);break;case"gotoTargets":o(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(m=>o(!1,m));break;default:break}break;case"response":const h=n;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(m=>o(!1,m.source));break;case"loadedSources":h.body.sources.forEach(m=>o(!1,m));break;case"scopes":h.body.scopes.forEach(m=>o(!1,m.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(m=>o(!1,m.source));break;case"setBreakpoints":h.body.breakpoints.forEach(m=>o(!1,m.source));break;default:break}break}}function a(n){return n.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=a;function t(n,o){return typeof n!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:n-o}}),define(ge[204],ve([0,1,26,38,170,120,8,10,23,9,182,119]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class w extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",u=>this.handleData(u))}sendMessage(_){if(this.outputStream){const p=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${w.TWO_CRLF}${p}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+p))}continue}}else{const p=this.rawData.indexOf(w.TWO_CRLF);if(p!==-1){const a=this.rawData.toString("utf8",0,p).split(w.HEADER_LINESEPARATOR);for(const t of a){const n=t.split(w.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(p+w.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=w,w.TWO_CRLF=`\r
\r
`,w.HEADER_LINESEPARATOR=/\r?\n/,w.HEADER_FIELDSEPARATOR=/: */;class g extends w{startSession(){return new Promise((_,p)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",a=>{u?this._onError.fire(a):p(a)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class s extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=s;class d extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return P.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=d;class S extends w{constructor(_,p,u){super();this.adapterExecutable=_,this.debugType=p,this.outputService=u}async startSession(){const _=this.adapterExecutable.command,p=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(_)if(D.isAbsolute(_)){if(!await(0,E.exists)(_))throw new Error(T.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let a=process.env;if(u.env&&Object.keys(u.env).length>0&&(a=y.mixin(y.deepClone(process.env),u.env)),_==="node")if(Array.isArray(p)&&p.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:a,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(o.cwd=u.cwd);const r=I.fork(p[0],p.slice(1),o);if(!r.pid)throw new Error(T.localize(2,null,p[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const n={env:a};u.cwd&&(n.cwd=u.cwd),this.serverProcess=I.spawn(_,p,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,o)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(R.ExtensionsChannelId);r&&r.append(n(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(a){this._onError.fire(a)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),i.isWindows?new Promise((_,p)=>{const u=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(a,t,n){if(a)return p(a)});u.on("exit",_),u.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,p){if(!!_){const u=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?u.runtime=D.join(p,_.runtime):u.runtime=_.runtime),_.runtimeArgs&&(u.runtimeArgs=_.runtimeArgs),_.program&&(D.isAbsolute(_.program)?u.program=_.program:u.program=D.join(p,_.program)),_.args&&(u.args=_.args);const a=_;return a.win&&(u.win=S.extract(a.win,p)),a.winx86&&(u.winx86=S.extract(a.winx86,p)),a.windows&&(u.windows=S.extract(a.windows,p)),a.osx&&(u.osx=S.extract(a.osx,p)),a.linux&&(u.linux=S.extract(a.linux,p)),u}}static platformAdapterExecutable(_,p){let u=Object.create(null);p=p.toLowerCase();for(const l of _)if(l.contributes){const h=l.contributes.debuggers;h&&h.length>0&&h.filter(m=>typeof m.type=="string"&&A.equalsIgnoreCase(m.type,p)).forEach(m=>{const b=S.extract(m,l.extensionLocation.fsPath);u=y.mixin(u,b,l.isBuiltin)})}let a;i.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=u.winx86||u.win||u.windows:i.isWindows?a=u.win||u.windows:i.isMacintosh?a=u.osx:i.isLinux&&(a=u.linux),a=a||u;let t=a.program||u.program;const n=a.args||u.args;let o=a.runtime||u.runtime;const r=a.runtimeArgs||u.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=S}),define(ge[205],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[206],ve([0,1,38,8,77,171,26,9,83,4,205,11]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=P.localize(0,null);let g=class $t{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,T.getWindowsShell(),p)}}runInTerminal(p,u,a,t,n){const o=n.windowsExec||$t.getDefaultTerminalWindows();return new Promise((r,l)=>{const h=`"${u} - ${w}"`,m=`""${a.join('" "')}" & pause"`,b=["/c","start",h,"/wait",o,"/c",m],c=Object.assign({},process.env,t);Object.keys(c).filter(L=>c[L]===null).forEach(L=>delete c[L]);const f={cwd:u,env:c,windowsVerbatimArguments:!0};E.spawn($t.CMD,b,f).on("error",L=>{l(S(L))}),r(void 0)})}spawnTerminal(p,u,a,t){const o=u.terminal.external.windowsExec||$t.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=I.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return o.indexOf(" ")>=0&&l.push('""'),l.push(o),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((h,m)=>{const b=t?{cwd:t}:void 0,c=p.spawn(a,l,b);c.on("error",m),c.on("exit",()=>h())})}static getDefaultTerminalWindows(){if(!$t._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");$t._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return $t._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=je([Ue(0,(0,i.optional)(y.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let s=class Rn{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,p)}}runInTerminal(p,u,a,t,n){const o=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===R.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const h=o===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Q).fsPath,"-t",p||w,"-w",u];for(let k of a)b.push("-a"),b.push(k);if(t)for(let k in t){const L=t[k];L===null?(b.push("-u"),b.push(k)):(b.push("-e"),b.push(`${k}=${L}`))}let c="";const f=E.spawn(Rn.OSASCRIPT,b);f.on("error",k=>{l(S(k))}),f.stderr.on("data",k=>{c+=k.toString()}),f.on("exit",k=>{if(k===0)r(void 0);else if(c){const L=c.split(`
`,1);l(new Error(L[0]))}else l(new Error(P.localize(1,null,h,k)))})}else l(new Error(P.localize(2,null,o)))})}spawnTerminal(p,u,a){const n=u.terminal.external.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const l=["-a",n];a&&l.push(a);const h=p.spawn("/usr/bin/open",l);h.on("error",r),h.on("exit",()=>o())})}};s.OSASCRIPT="/usr/bin/osascript",s=je([Ue(0,(0,i.optional)(y.IConfigurationService))],s),e.MacExternalTerminalService=s;let d=class Ht{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,p)}}runInTerminal(p,u,a,t,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let h=[];o.then(m=>{m.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const b=`${v(a)}; echo; read -p "${Ht.WAIT_MESSAGE}" -n1;`;h.push(`''${b}''`);const c=Object.assign({},process.env,t);Object.keys(c).filter($=>c[$]===null).forEach($=>delete c[$]);const f={cwd:u,env:c};let k="";const L=E.spawn(m,h,f);L.on("error",$=>{l(S($))}),L.stderr.on("data",$=>{k+=$.toString()}),L.on("exit",$=>{if($===0)r(void 0);else if(k){const ee=k.split(`
`,1);l(new Error(ee[0]))}else l(new Error(P.localize(4,null,m,$)))})})})}spawnTerminal(p,u,a){const t=u.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{n.then(l=>{const h=a?{cwd:a}:void 0,m=p.spawn(l,[],h);m.on("error",r),m.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return Ht._DEFAULT_TERMINAL_LINUX_READY||(Ht._DEFAULT_TERMINAL_LINUX_READY=new Promise(async p=>{A.isLinux?await D.exists("/etc/debian_version")?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm"):p("xterm")})),Ht._DEFAULT_TERMINAL_LINUX_READY}};d.WAIT_MESSAGE=P.localize(3,null),d=je([Ue(0,(0,i.optional)(y.IConfigurationService))],d),e.LinuxExternalTerminalService=d;function S(_){return"errno"in _&&_.errno==="ENOENT"&&"path"in _&&typeof _.path=="string"?new Error(P.localize(5,null,_.path)):_}function v(_){let p="";for(let u of _)u.indexOf(" ")>=0?p+='"'+u+'"':p+=u,p+=" ";return p}}),define(ge[207],ve([0,1,38,9,206,30]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function A(w,g){if(!D)if(I.isWindows)D=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)D=new T.MacExternalTerminalService(void 0);else if(I.isLinux)D=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const s=g.getConfiguration("terminal");return D.runInTerminal(w.title,w.cwd,w.args,w.env||{},s.external||{})}e.runInExternalTerminal=A;function y(w,g){return new Promise((s,d)=>{let S="";const v=E.spawn(w,g);v.pid&&v.stdout.on("data",_=>{S+=_.toString()}),v.on("error",_=>{d(_)}),v.on("close",_=>{s(S)})})}function i(w){return w?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(d=>parseInt(d)===w),g=>!0):y("/usr/bin/pgrep",["-lP",String(w)]).then(g=>{const s=g.trim();return!(s.length===0||s.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=i;var R;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(R||(R={}));function C(w,g,s,d){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:I.isWindows?S=0:S=2;let v,_=" ";switch(S){case 1:if(v=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),s){const u=(0,P.getDriveLetter)(s);u&&(_+=`${u}:; `),_+=`cd ${v(s)}; `}if(d)for(let u in d){const a=d[u];a===null?_+=`Remove-Item env:${u}; `:_+=`\${env:${u}}='${a}'; `}if(g.length>0){const u=v(g.shift());_+=u[0]==="'"?`& ${u} `:`${u} `;for(let a of g)_+=`${v(a)} `}break;case 0:if(v=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),s){const u=(0,P.getDriveLetter)(s);u&&(_+=`${u}: && `),_+=`cd ${v(s)} && `}if(d){_+='cmd /C "';for(let u in d){let a=d[u];a===null?_+=`set "${u}=" && `:(a=a.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${u}=${a}" && `)}}for(let u of g)_+=`${v(u)} `;d&&(_+='"');break;case 2:v=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const p=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(s&&(_+=`cd ${v(s)} ; `),d){_+="/usr/bin/env";for(let u in d){const a=d[u];a===null?_+=` -u ${p(u)}`:_+=` ${p(`${u}=${a}`)}`}_+=" "}for(let u of g)_+=`${v(u)} `;break}return _}e.prepareCommand=C}),define(ge[85],ve([0,1,33,11,8,9,80]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(k){k[k.Markdown=1]="Markdown",k[k.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(k){k[k.Running=1]="Running",k[k.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var i;(function(k){k[k.Idle=1]="Idle",k[k.Pending=2]="Pending",k[k.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var R;(function(k){k[k.ModelChange=1]="ModelChange",k[k.Move=2]="Move",k[k.CellClearOutput=3]="CellClearOutput",k[k.CellsClearOutput=4]="CellsClearOutput",k[k.ChangeLanguage=5]="ChangeLanguage",k[k.Initialize=6]="Initialize",k[k.ChangeCellMetadata=7]="ChangeCellMetadata",k[k.Output=8]="Output",k[k.OutputItem=9]="OutputItem",k[k.ChangeCellContent=10]="ChangeCellContent",k[k.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",k[k.Unknown=12]="Unknown"})(R=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(k){k[k.Handle=0]="Handle",k[k.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(k){k[k.Replace=1]="Replace",k[k.Output=2]="Output",k[k.Metadata=3]="Metadata",k[k.CellLanguage=4]="CellLanguage",k[k.DocumentMetadata=5]="DocumentMetadata",k[k.OutputsSplice=6]="OutputsSplice",k[k.Move=7]="Move",k[k.Unknown=8]="Unknown",k[k.CellContent=9]="CellContent",k[k.OutputItems=10]="OutputItems",k[k.PartialMetadata=11]="PartialMetadata"})(w=e.CellEditType||(e.CellEditType={}));function g(k){const L=s.parse(k);return L?L.notebook.toString():k.toString()}e.getCellUndoRedoComparisonKey=g;var s;(function(k){k.scheme=I.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function $(B,F){return B.with({scheme:k.scheme,fragment:`ch${F.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}k.generate=$;function ee(B){if(B.scheme===k.scheme){const F=L.exec(B.fragment);if(!!F)return{handle:Number(F[1]),notebook:B.with({scheme:B.fragment.substr(F[0].length)||I.Schemas.file,fragment:null})}}}k.parse=ee;function H(B,F){return B.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}k.generateCellMetadataUri=H;function x(B){if(B.scheme===I.Schemas.vscodeNotebookCellMetadata){const F=L.exec(B.fragment);if(!!F)return{handle:Number(F[1]),notebook:B.with({scheme:B.fragment.substr(F[0].length)||I.Schemas.file,fragment:null})}}}k.parseCellMetadataUri=x})(s=e.CellUri||(e.CellUri={}));const d=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.alwaysSecure)!==null&&$!==void 0?$:!1}e.mimeTypeIsAlwaysSecure=S;function v(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.supportedByCore)!==null&&$!==void 0?$:!1}e.mimeTypeSupportedByCore=v;function _(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.mergeable)!==null&&$!==void 0?$:!1}e.mimeTypeIsMergeable=_;function p(k,L){return P.isWindows&&(k=k.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),E.match(k,L)}function u(k,L,$){let ee=0;for(let H=0;H<L.length;H++){if(p(L[H],k))return ee;ee++}for(let H=0;H<$.length;H++){if(p($[H],k))return ee;ee++}return ee}function a(k,L,$){return k.sort((ee,H)=>u(ee,L,$)-u(H,L,$))}e.sortMimeTypes=a;function t(k,L,$,ee=(H,x)=>H===x){const H=[];function x(U,M,N){if(!(M===0&&N.length===0)){const O=H[H.length-1];O&&O.start+O.deleteCount===U?(O.deleteCount+=M,O.toInsert.push(...N)):H.push({start:U,deleteCount:M,toInsert:N})}}let B=0,F=0;for(;;){if(B===k.length){x(B,0,L.slice(F));break}if(F===L.length){x(B,k.length-B,[]);break}const U=k[B],M=L[F];if(ee(U,M)){B+=1,F+=1;continue}$(M)?(x(B,1,[]),B+=1):(x(B,0,[M]),F+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new D.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var n;(function(k){k.default="default",k.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(k){const L=k;return!!((typeof L.include=="string"||E.isRelativePattern(L.include))&&(typeof L.exclude=="string"||E.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=o;function r(k,L,$){if(Array.isArray(k.viewType)&&k.viewType.indexOf(L)>=0||k.viewType===L)return!0;if(k.filenamePattern){let ee=o(k.filenamePattern)?k.filenamePattern.include:k.filenamePattern,H=o(k.filenamePattern)?k.filenamePattern.exclude:void 0;if(E.match(ee,(0,T.basename)($.fsPath).toLowerCase()))return!(H&&E.match(H,(0,T.basename)($.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r;class l{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let $=0;$<this.textModel.cells.length;$++)L[$]=this.textModel.cells[$].getHashValue();return L}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(k){k[k.LEFT=0]="LEFT",k[k.RIGHT=1]="RIGHT"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function m(k){k.sort(($,ee)=>$-ee);const L=k.shift();return L===void 0?[]:k.reduce(function($,ee){return ee<=$[0][1]?$[0][1]=ee+1:$.unshift([ee,ee+1]),$},[[L,L+1]]).reverse().map($=>({start:$[0],end:$[1]}))}e.cellIndexesToRanges=m;function b(k){return k.reduce(($,ee)=>{for(let H=ee.start;H<ee.end;H++)$.push(H);return $},[])}e.cellRangesToIndexes=b;function c(k){const L=k.sort((ee,H)=>ee.start-H.start),$=L[0];return $?L.reduce((ee,H)=>{const x=ee[ee.length-1];return x.end>=H.start?x.end=Math.max(x.end,H.end):ee.push(H),ee},[$]):[]}e.reduceRanges=c;function f(k,L){return L.start>=k.start&&L.end<=k.end}e.cellRangeContains=f}),define(ge[208],ve([0,1,173,4,80]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[209],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=E;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(ge[210],ve([0,1,8,9,134]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(a,t){if(!!t)if(I.isWindows)for(const n in t){let o=n;for(const l in a)if(n.toLowerCase()===l.toLowerCase()){o=l;break}const r=t[n];r!==void 0&&D(a,o,r)}else Object.keys(t).forEach(n=>{const o=t[n];o!==void 0&&D(a,n,o)})}e.mergeEnvironments=P;function D(a,t,n){typeof n=="string"?a[t]=n:delete a[t]}function A(a,t,n,o){a.TERM_PROGRAM="vscode",t&&(a.TERM_PROGRAM_VERSION=t),R(a,o)&&(a.LANG=C(n)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=A;function y(a,t){if(!!t)for(const n of Object.keys(t)){const o=t[n];o&&(a[n]=o)}}function i(a,t){return Object.keys(t).forEach(n=>{const o=t[n];if(typeof o=="string")try{t[n]=a(o)}catch(r){t[n]=o}}),t}function R(a,t){if(t==="on")return!0;if(t==="auto"){const n=a.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function C(a){const t=a?a.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function w(a,t,n,o,r,l){if(a.cwd){const m=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,b=g(m,n);return s(b||m)}let h;return!a.ignoreConfigurationCwd&&r&&(n&&(r=g(r,n,l)),r&&(E.isAbsolute(r)?h=r:o&&(h=E.join(o.fsPath,r)))),h||(h=o?o.fsPath:t||""),s(h)}e.getCwd=w;function g(a,t,n){if(t)try{return t(a)}catch(o){n==null||n.error("Could not resolve terminal cwd",o);return}return a}function s(a){return I.platform===3&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function d(a){let t=a;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=d;function S(a,t){if(!!t)return n=>t.resolve(a,n)}e.createVariableResolver=S;function v(a,t,n,o,r,l,h,m,b=I.platform){let c=null;m&&(c=p(a,t,"automationShell",b)),c||(c=p(a,t,"shell",b));let f=c||n;if(b===3&&!o&&r){const k=E.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();f&&f.toLowerCase().indexOf(k)===0&&(f=E.join(r,"System32",f.substr(k.length+1)))}if(f&&b===3&&(f=f.replace(/\//g,"\\")),l)try{f=l(f)}catch(k){h.error("Could not resolve shell",k)}return f}e.getDefaultShell=v;function _(a,t,n,o,r,l=I.platform){if(n&&p(a,t,"automationShell",l))return[];const h=l===3?"windows":l===1?"osx":"linux",m=a(`terminal.integrated.shellArgs.${h}`);let b=(t?m.value:m.userValue)||m.defaultValue;if(!b)return[];if(typeof b=="string"&&l===3)return o?o(b):b;if(o){const c=[];for(const f of b)try{c.push(o(f))}catch(k){r.error(`Could not resolve terminal.integrated.shellArgs.${h}`,k),c.push(f)}b=c}return b}e.getDefaultShellArgs=_;function p(a,t,n,o=I.platform){const l=a(`terminal.integrated.${n}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?l.value:l.userValue)||l.defaultValue}function u(a,t,n,o,r,l,h){let m={};if(a.strictEnv)y(m,a.env);else{y(m,h);const b=Object.assign({},o?t.value:t.userValue);n&&(b&&i(n,b),a.env&&i(n,a.env)),(0,T.sanitizeProcessEnvironment)(m,"VSCODE_IPC_HOOK_CLI"),P(m,b),P(m,a.env),A(m,r,I.locale,l)}return m}e.createTerminalEnvironment=u});var rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],E;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),E={},I("next"),I("throw"),I("return"),E[Symbol.asyncIterator]=function(){return this},E);function I(P){E[P]=Q[P]&&function(D){return new Promise(function(A,y){D=Q[P](D),T(A,y,D.done,D.value)})}}function T(P,D,A,y){Promise.resolve(y).then(function(i){P({value:i,done:A})},D)}};define(ge[211],ve([0,1,37,9,8,100,190,38,26]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function R(p,u,a,t,n,o,r){return u=u||{existsFile:y.SymlinkSupport.existsFile,readFile:E.promises.readFile},I.isWindows?C(p,u,a,t==null?void 0:t.useWslProfiles,t==null?void 0:t.profiles.windows,n,o):S(u,a,p,I.isMacintosh?t==null?void 0:t.profiles.osx:t==null?void 0:t.profiles.linux,r,n,o)}e.detectAvailableProfiles=R;async function C(p,u,a,t,n,o,r){const l=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${process.env.windir}\\${l?"Sysnative":"System32"}`;let m=!1;(0,D.getWindowsBuildNumber)()>=16299&&(m=!0),await g();const b=new Map;p||(b.set("PowerShell",{source:"PowerShell",isAutoDetected:!0}),b.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),b.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),b.set("Command Prompt",{path:[`${h}\\cmd.exe`],icon:"terminal-cmd",isAutoDetected:!0})),v(n,b);const c=await w(b.entries(),u,a,o,r);if(!p||p&&t)try{const f=await d(`${h}\\${m?"wsl.exe":"bash.exe"}`,t);f&&c.push(...f)}catch(f){a==null||a.info("WSL is not installed, so could not detect WSL profiles")}return c}async function w(p,u,a,t,n){const o=[];for(const[r,l]of p)if(l!==null){let h,m,b;if("source"in l){const k=i==null?void 0:i.get(l.source);if(!k)continue;h=k.paths,m=l.args||k.args,b=l.icon||k.icon}else h=Array.isArray(l.path)?l.path:[l.path],m=I.isWindows||Array.isArray(l.args)?l.args:void 0,b=l.icon;const c=h.slice();for(let k=0;k<c.length;k++)c[k]=await(t==null?void 0:t.resolveAsync(n,c[k]))||c[k];const f=await _(r,c,u,m,l.env,l.overrideName,l.isAutoDetected,a);f?(f.isAutoDetected=l.isAutoDetected,f.icon=b,o.push(f)):a==null||a.trace("profile not validated",r,h)}return o}async function g(){i||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),i.set("Cygwin",{profileName:"Cygwin",paths:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:await s(),icon:"terminal-powershell"}))}async function s(){var p,u;const a=[];try{for(var t=rn((0,P.enumeratePowerShellInstallations)()),n;n=await t.next(),!n.done;){const o=n.value;a.push(o.exePath)}}catch(o){p={error:o}}finally{try{n&&!n.done&&(u=t.return)&&await u.call(t)}finally{if(p)throw p.error}}return a}async function d(p,u){const a=[];if(u){const t=await new Promise((n,o)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le"},(r,l)=>{if(r)return o("Problem occurred when getting wsl distros");n(l)})});if(t){const n=new RegExp(/[\r?\n]/),o=t.split(n).filter(r=>r.trim().length>0&&r!=="");for(let r of o)if(r!==""&&!r.startsWith("docker-desktop")){const l={profileName:`${r} (WSL)`,path:p,args:["-d",`${r}`]};r.includes("Debian")?l.icon="terminal-debian":l.icon="terminal-linux",a.push(l)}return a}}return[]}async function S(p,u,a,t,n,o,r){const l=new Map;if(!a){const h=await p.readFile("/etc/shells","utf8"),m=n||h.split(`
`).filter(c=>c.trim().indexOf("#")!==0&&c.trim().length>0),b=new Map;for(const c of m){let f=(0,T.basename)(c),k=b.get(f)||0;k++,k>1&&(f=`${f} (${k})`),b.set(f,k),l.set(f,{path:c,isAutoDetected:!0})}}return v(t,l),await w(l.entries(),p,u,o,r)}function v(p,u){if(!!p)for(const[a,t]of Object.entries(p))t===null||!("path"in t)&&!("source"in t)?u.delete(a):u.set(a,t)}async function _(p,u,a,t,n,o,r,l){if(u.length===0)return Promise.resolve(void 0);const h=u.shift();if(h==="")return _(p,u,a,t,n,o,r);const m={profileName:p,path:h,args:t,env:n,overrideName:o,isAutoDetected:r};if((0,T.basename)(h)===h){const c=process.env.PATH?process.env.PATH.split(T.delimiter):void 0;return await(0,D.findExecutable)(h,void 0,c,void 0,a.existsFile)?m:_(p,u,a,t)}return await a.existsFile((0,T.normalize)(h))?m:_(p,u,a,t,n,o,r)}}),define(ge[121],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(y,i)=>{i.expand!==void 0&&(y.expand=i.expand),i.item!==void 0&&Object.assign(y.item,i.item)};e.applyTestItemUpdate=I;var T;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const P=(y,i)=>`${y}:${i.toString()}`;e.getTestSubscriptionKey=P;class D{add(i){}update(i){}remove(i,R){}complete(){}}e.IncrementalChangeCollector=D;class A{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(i){const R=this.createChangeCollector();for(const C of i)switch(C[0]){case 0:{const w=C[1];if(w.parent){if(this.items.has(w.parent)){const g=this.items.get(w.parent);g.children.add(w.item.extId);const s=this.createItem(w,g);this.items.set(w.item.extId,s),R.add(s)}}else{this.roots.add(w.item.extId);const g=this.createItem(w);this.items.set(w.item.extId,g),R.add(g)}w.expand===2&&this.updateBusyProviders(1);break}case 1:{const w=C[1],g=this.items.get(w.extId);if(!g)break;(0,e.applyTestItemUpdate)(g,w),R.update(g),w.expand!==void 0&&g.expand===2&&w.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const w=this.items.get(C[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w.item.extId);const g=[[C[1]]];for(;g.length;)for(const s of g.pop()){const d=this.items.get(s);d&&(g.push(d.children),this.items.delete(s),R.remove(d,d!==w),d.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(i){}updateBusyProviders(i){this.busyProviderCount+=i}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=A}),define(ge[212],ve([0,1,8,36,14,23,9,75,174]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(C,w,g,s){if(this._contributedVariables=new Map,this._context=C,this._labelService=w,g)if(D.isWindows){const d=Object.create(null);this._envVariables=d,Object.keys(g).forEach(S=>{d[S.toLowerCase()]=g[S]})}else this._envVariables=g}resolveWithEnvironment(C,w,g){return this.recursiveResolve(C,w?w.uri:void 0,g)}async resolveAsync(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolve(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolveAnyBase(C,w,g,s){const d=P.deepClone(w);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,d,g,s)}resolveAny(C,w,g){return this.resolveAnyBase(C,w,g)}async resolveAnyAsync(C,w,g){return this.resolveAnyBase(C,w,g)}resolveAnyMap(C,w,g){const s=new Map;return{newConfig:this.resolveAnyBase(C,w,g,s),resolvedVariables:s}}resolveWithInteractionReplace(C,w,g,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,w,g,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,w){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,w)}recursiveResolve(C,w,g,s,d){if(T.isString(g))return this.resolveString(C,w,g,s,d);if(T.isArray(g))return g.map(S=>this.recursiveResolve(C,w,S,s,d));if(T.isObject(g)){let S=Object.create(null);return Object.keys(g).forEach(v=>{const _=this.resolveString(C,w,v,s,d);S[_]=this.recursiveResolve(C,w,g[v],s,d)}),S}return g}resolveString(C,w,g,s,d){return g.replace(i.VARIABLE_REGEXP,(v,_)=>{if(_.includes(i.VARIABLE_LHS))return v;let p=this.evaluateSingleVariable(C,v,_,w,s);return d&&d.set(_,p),p})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,w,g,s,d){let S;const v=g.split(":");v.length>1&&(g=v[0],S=v[1]);const _=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,y.localize)(0,null,w))},p=()=>{const a=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,w,E.basename(a)))},u=()=>{if(S){const a=this._context.getFolderUri(S);if(a)return a;throw new Error((0,y.localize)(2,null,w,S))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,w)):new Error((0,y.localize)(4,null,w))};switch(g){case"env":if(S){if(C){const a=C[D.isWindows?S.toLowerCase():S];if(T.isString(a))return a}return""}throw new Error((0,y.localize)(5,null,w));case"config":if(S){const a=this._context.getConfigurationValue(s,S);if(T.isUndefinedOrNull(a))throw new Error((0,y.localize)(6,null,w,S));if(T.isObject(a))throw new Error((0,y.localize)(7,null,w,S));return a}throw new Error((0,y.localize)(8,null,w));case"command":return this.resolveFromMap(w,S,d,"command");case"input":return this.resolveFromMap(w,S,d,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return s||S?(0,A.normalizeDriveLetter)(this.fsPath(u())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(u()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error((0,y.localize)(9,null,w));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,w));case"file":return _();case"fileWorkspaceFolder":return p();case"relativeFile":return s||S?E.relative(this.fsPath(u()),_()):_();case"relativeFileDirname":const n=E.dirname(_());if(s||S){const h=E.relative(this.fsPath(u()),n);return h.length===0?".":h}return n;case"fileDirname":return E.dirname(_());case"fileExtname":return E.extname(_());case"fileBasename":return E.basename(_());case"fileBasenameNoExtension":const o=E.basename(_());return o.slice(0,o.length-E.extname(o).length);case"fileDirnameBasename":return E.basename(E.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||w;case"execInstallFolder":const l=this._context.getAppRoot();return l||w;case"pathSeparator":return E.sep;default:try{const h=S?`${g}:${S}`:g;return this.resolveFromMap(w,h,d,void 0)}catch(h){return w}}}}resolveFromMap(C,w,g,s){if(w&&g){const d=s===void 0?g[w]:g[s+":"+w];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[213],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var D;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var A;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(A=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.EDITOR_OPEN=2]="EDITOR_OPEN",w[w.EDITOR_CLOSE=3]="EDITOR_CLOSE",w[w.EDITOR_MOVE=4]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=6]="EDITOR_LABEL",w[w.EDITOR_PIN=7]="EDITOR_PIN",w[w.EDITOR_STICKY=8]="EDITOR_STICKY",w[w.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[214],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],ve([0,1,18,94,284,57,23,14,2,43,79,175,110,85,214,7]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(ue){function Ce(J){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Je,positionColumn:Ge}=J,rt=new d.Position(Re-1,Le-1),at=new d.Position(Je-1,Ge-1);return new d.Selection(rt,at)}ue.to=Ce;function ce(J){const{anchor:Re,active:Le}=J;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ue.from=ce})(S=e.Selection||(e.Selection={}));var v;(function(ue){function Ce(J){if(!!J){const{start:Re,end:Le}=J;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}ue.from=Ce;function ce(J){if(!!J){const{startLineNumber:Re,startColumn:Le,endLineNumber:Je,endColumn:Ge}=J;return new d.Range(Re-1,Le-1,Je-1,Ge-1)}}ue.to=ce})(v=e.Range||(e.Range={}));var _;(function(ue){function Ce(ce){switch(ce){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ue.to=Ce})(_=e.TokenType||(e.TokenType={}));var p;(function(ue){function Ce(J){return new d.Position(J.lineNumber-1,J.column-1)}ue.to=Ce;function ce(J){return{lineNumber:J.line+1,column:J.character+1}}ue.from=ce})(p=e.Position||(e.Position={}));var u;(function(ue){function Ce(J){switch(J){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ue.from=Ce;function ce(J){switch(J){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ue.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(ue){function Ce(J){let Re;return J.code&&((0,A.isString)(J.code)||(0,A.isNumber)(J.code)?Re=String(J.code):Re={value:String(J.code.value),target:J.code.target}),Object.assign(Object.assign({},v.from(J.range)),{message:J.message,source:J.source,code:Re,severity:n.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(t.from),tags:Array.isArray(J.tags)?(0,E.coalesce)(J.tags.map(u.from)):void 0})}ue.from=Ce;function ce(J){var Re;const Le=new d.Diagnostic(v.to(J),J.message,n.to(J.severity));return Le.source=J.source,Le.code=(0,A.isString)(J.code)?J.code:(Re=J.code)===null||Re===void 0?void 0:Re.value,Le.relatedInformation=J.relatedInformation&&J.relatedInformation.map(t.to),Le.tags=J.tags&&(0,E.coalesce)(J.tags.map(u.to)),Le}ue.to=ce})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Ce(J){return Object.assign(Object.assign({},v.from(J.location.range)),{message:J.message,resource:J.location.uri})}ue.from=Ce;function ce(J){return new d.DiagnosticRelatedInformation(new d.Location(J.resource,v.to(J)),J.message)}ue.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function Ce(J){switch(J){case d.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}ue.from=Ce;function ce(J){switch(J){case w.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ue.to=ce})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ue){function Ce(J){return typeof J=="number"&&J>=d.ViewColumn.One?J-1:J===d.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ue.from=Ce;function ce(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ce})(o=e.ViewColumn||(e.ViewColumn={}));function r(ue){return typeof ue.range!="undefined"}function l(ue){return ue.length===0?!0:!!r(ue[0])}e.isDecorationOptionsArr=l;var h;(function(ue){function Ce(Ge){return Ge.map(ue.from)}ue.fromMany=Ce;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let rt;if(ce(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=y.URI.parse(st,!0);gt=gt.with({query:Re(gt.query,at)}),at[st]=gt}catch(gt){}return""},ct=new T.Renderer;return ct.link=Qe,ct.image=st=>Qe(I.parseHrefAndDimensions(st).href),T(rt.value,{renderer:ct}),rt}ue.from=J;function Re(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,P.parse)(Ge)}catch(ct){}if(!at)return Ge;let Qe=!1;return at=(0,D.cloneAndChange)(at,ct=>{if(y.URI.isUri(ct)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ct,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Le(Ge){const rt=new d.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ue.to=Le;function Je(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Je})(h=e.MarkdownString||(e.MarkdownString={}));function m(ue){return l(ue)?ue.map(Ce=>({range:v.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?h.fromMany(Ce.hoverMessage):Ce.hoverMessage?h.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ue.map(Ce=>({range:v.from(Ce)}))}e.fromRangeOrRangeWithMessage=m;function b(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=b;var c;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?b(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ue.from=Ce})(c=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var f;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?c.from(ce.before):void 0,after:ce.after?c.from(ce.after):void 0}}ue.from=Ce})(f=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var k;(function(ue){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Ce})(k=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?k.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?f.from(ce.light):void 0,dark:ce.dark?f.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?c.from(ce.before):void 0,after:ce.after?c.from(ce.after):void 0}}ue.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(ue){function Ce(J){return{text:J.newText,eol:J.newEol&&re.from(J.newEol),range:v.from(J.range)}}ue.from=Ce;function ce(J){const Re=new d.TextEdit(v.to(J.range),J.text);return Re.newEol=typeof J.eol=="undefined"?void 0:re.to(J.eol),Re}ue.to=ce})($=e.TextEdit||(e.TextEdit={}));var ee;(function(ue){function Ce(J,Re,Le){var Je,Ge,rt;const at={edits:[]};if(J instanceof d.WorkspaceEdit)for(let Qe of J._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ct=Re==null?void 0:Re.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:$.from(Qe.edit),modelVersionId:ct==null?void 0:ct.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Je=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(He.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(pe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(_e.from))||[],append:Qe.append}});return at}ue.from=Ce;function ce(J){const Re=new d.WorkspaceEdit;for(const Le of J.edits)Le.edit?Re.replace(y.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Re.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return Re}ue.to=ce})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ue){const Ce=Object.create(null);Ce[d.SymbolKind.File]=0,Ce[d.SymbolKind.Module]=1,Ce[d.SymbolKind.Namespace]=2,Ce[d.SymbolKind.Package]=3,Ce[d.SymbolKind.Class]=4,Ce[d.SymbolKind.Method]=5,Ce[d.SymbolKind.Property]=6,Ce[d.SymbolKind.Field]=7,Ce[d.SymbolKind.Constructor]=8,Ce[d.SymbolKind.Enum]=9,Ce[d.SymbolKind.Interface]=10,Ce[d.SymbolKind.Function]=11,Ce[d.SymbolKind.Variable]=12,Ce[d.SymbolKind.Constant]=13,Ce[d.SymbolKind.String]=14,Ce[d.SymbolKind.Number]=15,Ce[d.SymbolKind.Boolean]=16,Ce[d.SymbolKind.Array]=17,Ce[d.SymbolKind.Object]=18,Ce[d.SymbolKind.Key]=19,Ce[d.SymbolKind.Null]=20,Ce[d.SymbolKind.EnumMember]=21,Ce[d.SymbolKind.Struct]=22,Ce[d.SymbolKind.Event]=23,Ce[d.SymbolKind.Operator]=24,Ce[d.SymbolKind.TypeParameter]=25;function ce(Re){return typeof Ce[Re]=="number"?Ce[Re]:6}ue.from=ce;function J(Re){for(const Le in Ce)if(Ce[Le]===Re)return Number(Le);return d.SymbolKind.Property}ue.to=J})(H=e.SymbolKind||(e.SymbolKind={}));var x;(function(ue){function Ce(J){switch(J){case d.SymbolTag.Deprecated:return 1}}ue.from=Ce;function ce(J){switch(J){case 1:return d.SymbolTag.Deprecated}}ue.to=ce})(x=e.SymbolTag||(e.SymbolTag={}));var B;(function(ue){function Ce(J){return{name:J.name,kind:H.from(J.kind),tags:J.tags&&J.tags.map(x.from),containerName:J.containerName,location:O.from(J.location)}}ue.from=Ce;function ce(J){const Re=new d.SymbolInformation(J.name,H.to(J.kind),J.containerName,O.to(J.location));return Re.tags=J.tags&&J.tags.map(x.to),Re}ue.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(ue){function Ce(J){var Re,Le;const Je={name:J.name||"!!MISSING: name!!",detail:J.detail,range:v.from(J.range),selectionRange:v.from(J.selectionRange),kind:H.from(J.kind),tags:(Le=(Re=J.tags)===null||Re===void 0?void 0:Re.map(x.from))!==null&&Le!==void 0?Le:[]};return J.children&&(Je.children=J.children.map(Ce)),Je}ue.from=Ce;function ce(J){const Re=new d.DocumentSymbol(J.name,J.detail,H.to(J.kind),v.to(J.range),v.to(J.selectionRange));return(0,E.isNonEmptyArray)(J.tags)&&(Re.tags=J.tags.map(x.to)),J.children&&(Re.children=J.children.map(ce)),Re}ue.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function Ce(ce){const J=new d.CallHierarchyItem(H.to(ce.kind),ce.name,ce.detail||"",y.URI.revive(ce.uri),v.to(ce.range),v.to(ce.selectionRange));return J._sessionId=ce._sessionId,J._itemId=ce._itemId,J}ue.to=Ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(ue){function Ce(ce){return new d.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(J=>v.to(J)))}ue.to=Ce})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ue){function Ce(ce){return new d.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(J=>v.to(J)))}ue.to=Ce})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function Ce(J){return{range:J.range&&v.from(J.range),uri:J.uri}}ue.from=Ce;function ce(J){return new d.Location(y.URI.revive(J.uri),v.to(J.range))}ue.to=ce})(O=e.location||(e.location={}));var j;(function(ue){function Ce(J){const Re=J,Le=J;return{originSelectionRange:Re.originSelectionRange?v.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:v.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?v.from(Re.targetSelectionRange):void 0}}ue.from=Ce;function ce(J){return{targetUri:y.URI.revive(J.uri),targetRange:v.to(J.range),targetSelectionRange:J.targetSelectionRange?v.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?v.to(J.originSelectionRange):void 0}}ue.to=ce})(j=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(ue){function Ce(J){return{range:v.from(J.range),contents:h.fromMany(J.contents)}}ue.from=Ce;function ce(J){return new d.Hover(J.contents.map(h.to),v.to(J.range))}ue.to=ce})(K=e.Hover||(e.Hover={}));var X;(function(ue){function Ce(J){return{range:v.from(J.range),expression:J.expression}}ue.from=Ce;function ce(J){return new d.EvaluatableExpression(v.to(J.range),J.expression)}ue.to=ce})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(ue){function Ce(J){if(J instanceof d.InlineValueText)return{type:"text",range:v.from(J.range),text:J.text};if(J instanceof d.InlineValueVariableLookup)return{type:"variable",range:v.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Ce;function ce(J){switch(J.type){case"text":return{range:v.to(J.range),text:J.text};case"variable":return{range:v.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:v.to(J.range),expression:J.expression}}}ue.to=ce})(me=e.InlineValue||(e.InlineValue={}));var we;(function(ue){function Ce(J){return{frameId:J.frameId,stoppedLocation:v.from(J.stoppedLocation)}}ue.from=Ce;function ce(J){return new d.InlineValueContext(J.frameId,v.to(J.stoppedLocation))}ue.to=ce})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ue){function Ce(J){return{range:v.from(J.range),kind:J.kind}}ue.from=Ce;function ce(J){return new d.DocumentHighlight(v.to(J.range),J.kind)}ue.to=ce})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(ue){function Ce(ce){switch(ce){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ue.to=Ce})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(ue){function Ce(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ue.to=Ce})(Me=e.CompletionContext||(e.CompletionContext={}));var V;(function(ue){function Ce(J){switch(J){case d.CompletionItemTag.Deprecated:return 1}}ue.from=Ce;function ce(J){switch(J){case 1:return d.CompletionItemTag.Deprecated}}ue.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ue){const Ce=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ce(Le){var Je;return(Je=Ce.get(Le))!==null&&Je!==void 0?Je:9}ue.from=ce;const J=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Le){var Je;return(Je=J.get(Le))!==null&&Je!==void 0?Je:d.CompletionItemKind.Property}ue.to=Re})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ue){function Ce(ce,J){var Re;const Le=new d.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Le.label2=ce.label),Le.insertText=ce.insertText,Le.kind=Y.to(ce.kind),Le.tags=(Re=ce.tags)===null||Re===void 0?void 0:Re.map(V.to),Le.detail=ce.detail,Le.documentation=I.isMarkdownString(ce.documentation)?h.to(ce.documentation):ce.documentation,Le.sortText=ce.sortText,Le.filterText=ce.filterText,Le.preselect=ce.preselect,Le.commitCharacters=ce.commitCharacters,i.Range.isIRange(ce.range)?Le.range=v.to(ce.range):typeof ce.range=="object"&&(Le.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Le.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Le.insertText=new d.SnippetString(ce.insertText):(Le.insertText=ce.insertText,Le.textEdit=Le.range instanceof d.Range?new d.TextEdit(Le.range,Le.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Le.additionalTextEdits=ce.additionalTextEdits.map(Je=>$.to(Je))),Le.command=J&&ce.command?J.fromInternal(ce.command):void 0,Le}ue.to=Ce})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function Ce(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0}}ue.from=Ce;function ce(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation}}ue.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ue){function Ce(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0,parameters:Array.isArray(J.parameters)?J.parameters.map(ae.from):[],activeParameter:J.activeParameter}}ue.from=Ce;function ce(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(ae.to):[],activeParameter:J.activeParameter}}ue.to=ce})(fe=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.from):[]}}ue.from=Ce;function ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.to):[]}}ue.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ue){function Ce(J){var Re;return{text:J.text,range:v.from(J.range),kind:be.from((Re=J.kind)!==null&&Re!==void 0?Re:d.InlineHintKind.Other),description:J.description&&h.fromStrict(J.description),whitespaceBefore:J.whitespaceBefore,whitespaceAfter:J.whitespaceAfter}}ue.from=Ce;function ce(J){const Re=new d.InlineHint(J.text,v.to(J.range),be.to(J.kind));return Re.whitespaceAfter=J.whitespaceAfter,Re.whitespaceBefore=J.whitespaceBefore,Re.description=I.isMarkdownString(J.description)?h.to(J.description):J.description,Re}ue.to=ce})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function Ce(J){return J}ue.from=Ce;function ce(J){return J}ue.to=ce})(be=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(ue){function Ce(J){return{range:v.from(J.range),url:J.target,tooltip:J.tooltip}}ue.from=Ce;function ce(J){let Re;if(J.url)try{Re=typeof J.url=="string"?y.URI.parse(J.url,!0):y.URI.revive(J.url)}catch(Le){}return new d.DocumentLink(v.to(J.range),Re)}ue.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Te;(function(ue){function Ce(J){const Re=new d.ColorPresentation(J.label);return J.textEdit&&(Re.textEdit=$.to(J.textEdit)),J.additionalTextEdits&&(Re.additionalTextEdits=J.additionalTextEdits.map(Le=>$.to(Le))),Re}ue.to=Ce;function ce(J){return{label:J.label,textEdit:J.textEdit?$.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Re=>$.from(Re)):void 0}}ue.from=ce})(Te=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(ue){function Ce(J){return new d.Color(J[0],J[1],J[2],J[3])}ue.to=Ce;function ce(J){return[J.red,J.green,J.blue,J.alpha]}ue.from=ce})(xe=e.Color||(e.Color={}));var Se;(function(ue){function Ce(J){return{range:v.from(J.range)}}ue.from=Ce;function ce(J){return new d.SelectionRange(v.to(J.range))}ue.to=ce})(Se=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function Ce(ce){switch(ce){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ue.to=Ce})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(ue){function Ce(J){switch(J){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Ce;function ce(J){switch(J){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ue.to=ce})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(ue){function Ce(J){if(J===d.EndOfLine.CRLF)return 1;if(J===d.EndOfLine.LF)return 0}ue.from=Ce;function ce(J){if(J===1)return d.EndOfLine.CRLF;if(J===0)return d.EndOfLine.LF}ue.to=ce})(re=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(ue){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Ce})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ue){function Ce(ce){const J={start:ce.start+1,end:ce.end+1};return ce.kind&&(J.kind=Ve.from(ce.kind)),J}ue.from=Ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(ue){function Ce(ce){if(ce)switch(ce){case d.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}ue.from=Ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(ue){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=Ce})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ue){function Ce(J){return J instanceof d.RelativePattern||typeof J=="string"?J:ce(J)?new d.RelativePattern(J.base,J.pattern):J}ue.from=Ce;function ce(J){const Re=J;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var q;(function(ue){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const J=ce;return{language:J.language,scheme:J.scheme,pattern:typeof J.pattern=="undefined"?void 0:et.from(J.pattern),exclusive:J.exclusive}}}else return}ue.from=Ce})(q=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(ue){function Ce(J){return{start:J.start,end:J.end}}ue.from=Ce;function ce(J){return new d.NotebookCellRange(J.start,J.end)}ue.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function Ce(ce){return new d.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}ue.to=Ce})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function Ce(J){return J}ue.from=Ce;function ce(J){return new d.NotebookDocumentMetadata(J.editable,J.cellEditable,J.cellHasExecutionOrder,J.custom,J.trusted)}ue.to=ce})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ue){function Ce(J){return{duration:J.lastRunDuration,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ue.to=Ce;function ce(J){return{lastRunSuccess:J.success,lastRunDuration:J.duration,executionOrder:J.executionOrder}}ue.from=ce})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Ce(J){switch(J){case d.NotebookCellKind.Markdown:return g.CellKind.Markdown;case d.NotebookCellKind.Code:default:return g.CellKind.Code}}ue.from=Ce;function ce(J){switch(J){case g.CellKind.Markdown:return d.NotebookCellKind.Markdown;case g.CellKind.Code:default:return d.NotebookCellKind.Code}}ue.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(ue){function Ce(J){var Re;return{cellKind:le.from(J.kind),language:J.language,source:J.source,metadata:Object.assign(Object.assign({},J.metadata),ne.from((Re=J.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:J.outputs?J.outputs.map(He.from):[]}}ue.from=Ce;function ce(J){return new d.NotebookCellData(le.to(J.cellKind),J.source,J.language,J.outputs?J.outputs.map(He.to):void 0,J.metadata?he.to(J.metadata):void 0)}ue.to=ce})(pe=e.NotebookCellData||(e.NotebookCellData={}));var _e;(function(ue){function Ce(J){return{mime:J.mime,value:J.value,metadata:J.metadata}}ue.from=Ce;function ce(J){return new d.NotebookCellOutputItem(J.mime,J.value,J.metadata)}ue.to=ce})(_e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var He;(function(ue){function Ce(J){return{outputId:J.id,outputs:J.outputs.map(_e.from),metadata:J.metadata}}ue.from=Ce;function ce(J){const Re=J.outputs.map(_e.to);return new d.NotebookCellOutput(Re,J.outputId,J.metadata)}ue.to=ce})(He=e.NotebookCellOutput||(e.NotebookCellOutput={}));var We;(function(ue){function Ce(Le){if(Le!=null){if(Le instanceof d.RelativePattern||typeof Le=="string")return Le;if(Re(Le))return new d.RelativePattern(Le.base,Le.pattern);if(J(Le))return{include:et.from(Le.include)||void 0,exclude:et.from(Le.exclude)||void 0}}}ue.from=Ce;function ce(Le){return typeof Le=="string"?Le:Re(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ue.to=ce;function J(Le){const Je=Le,Ge=et.from(Je.include);if(!(Ge&&Ge instanceof d.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Je.exclude);return!!(rt&&rt instanceof d.RelativePattern||typeof rt=="string")}function Re(Le){const Je=Le;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(We=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var qe;(function(ue){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?c.from(ce.top):void 0}}ue.from=Ce})(qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ye;(function(ue){function Ce(ce){var J;return{transientOutputs:ce?ce.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(J=ce==null?void 0:ce.transientMetadata)!==null&&J!==void 0?J:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ue.from=Ce})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ue){function Ce(J){return{message:h.fromStrict(J.message)||"",severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location?O.from(J.location):void 0}}ue.from=Ce;function ce(J){const Re=new d.TestMessage(typeof J.message=="string"?J.message:h.to(J.message));return Re.severity=J.severity,Re.actualOutput=J.actualOutput,Re.expectedOutput=J.expectedOutput,Re}ue.to=ce})(Ze=e.TestMessage||(e.TestMessage={}));var ut;(function(ue){function Ce(Le){var Je,Ge;return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:(Je=Le.debuggable)!==null&&Je!==void 0?Je:!1,description:Le.description,runnable:(Ge=Le.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Le.expandable}}ue.from=Ce;function ce(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:!1,description:Le.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=ce;function J(Le){return{id:Le.extId,label:Le.label,uri:y.URI.revive(Le.uri),range:v.to(Le.range),expandable:Le.expandable,debuggable:Le.debuggable,description:Le.description,runnable:Le.runnable}}ue.toPlain=J;function Re(Le){const Je=new d.TestItem(Le.extId,Le.label,y.URI.revive(Le.uri),Le.expandable);return Je.range=v.to(Le.range),Je.debuggable=Le.debuggable,Je.description=Le.description,Je.runnable=Le.runnable,Je}ue.to=Re})(ut=e.TestItem||(e.TestItem={}));var ot;(function(ue){function Ce(Re,Le){var Je,Ge,rt;const at={completedAt:Le.completedAt,id:Re,items:[]},Qe=[[null,Le.results]];for(;Qe.length;){const[ct,st]=Qe.pop();for(const gt of st){const Et={children:(Ge=(Je=gt.children)===null||Je===void 0?void 0:Je.map(Dt=>Dt.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.state,item:ut.fromResultSnapshot(gt),state:{state:gt.state,duration:gt.duration,messages:gt.messages.map(Ze.from)},retired:void 0,expand:3,parent:(rt=ct==null?void 0:ct.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ct};at.items.push(Et),gt.children&&Qe.push([Et,gt.children])}}return at}ue.from=Ce;const ce=(Re,Le)=>Object.assign(Object.assign({},ut.toPlain(Re.item)),{state:Re.state.state,duration:Re.state.duration,messages:Re.state.messages.map(Ze.to),children:Re.children.map(Je=>Le.get(Je)).filter(A.isDefined).map(Je=>ce(Je,Le))});function J(Re){const Le=[],Je=new Map;for(const Ge of Re.items)Je.set(Ge.item.extId,Ge),Ge.direct&&Le.push(Ge);return{completedAt:Re.completedAt,results:Le.map(Ge=>ce(Ge,Je))}}ue.to=J})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ue){function Ce(ce){switch(ce){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ue.to=Ce})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[215],ve([0,1,2,17,7,20,55]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(i,R,C,w={timeout:1500,errors:3}){this._logService=i,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=w,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(R,C,w)=>{const s={dispose:this._callbacks.push([R,C,i])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(i,R){const C=E.URI.revive(i);let w=!1;const g=setTimeout(()=>w=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(w)break;const S=this._documents.getDocument(C),v=await this._deliverEventAsyncAndBlameBadListeners(d,{document:S,reason:P.TextDocumentSaveReason.to(R)});s.push(v)}}finally{clearTimeout(g)}return s}_deliverEventAsyncAndBlameBadListeners([i,R,C],w){const g=this._badListeners.get(i);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,i,R,w).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(i);this._badListeners.set(i,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,R,C,w){const g=[],s=Date.now(),{document:d,reason:S}=w,{version:v}=d,_=Object.freeze({document:d,reason:S,waitUntil(p){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(p))}});try{R.apply(C,[_])}catch(p){return Promise.reject(p)}return Object.freeze(g),new Promise((p,u)=>{const a=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(a),p(t)}).catch(t=>{clearTimeout(a),u(t)})}).then(p=>{const u={edits:[]};for(const a of p)if(Array.isArray(a)&&a.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:o}of a)u.edits.push({_type:2,resource:d.uri,edit:{range:o&&P.Range.from(o),text:t,eol:n&&P.EndOfLine.from(n)}});if(u.edits.length!==0)return v===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ge[216],ve([0,1,3,19,33,2,20,7]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,w,g,s,d){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,g&&(this._config+=1),s&&(this._config+=2),d&&(this._config+=4);const S=(0,T.parse)(w),v=C(_=>{if(!g)for(let p of _.created){const u=P.URI.revive(p);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!s)for(let p of _.changed){const u=P.URI.revive(p);S(u.fsPath)&&this._onDidChange.fire(u)}if(!d)for(let p of _.deleted){const u=P.URI.revive(p);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class i{constructor(C,w,g){this._logService=w,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,w,g,s){return new y(this._onFileSystemEvent.event,C,w,g,s)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,w){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(g=>({oldUri:P.URI.revive(g.source),newUri:P.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(g=>P.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(g=>P.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,w){return(g,s,d)=>{const S=function(_){g.call(s,_)};return S.extension=C,w.event(S,void 0,d)}}async $onWillRunFileOperation(C,w,g,s){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))},g,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(d=>P.URI.revive(d.target))},g,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(d=>P.URI.revive(d.target))},g,s)}}async _fireWillEvent(C,w,g,s){const d=new Set,S=[];if(await C.fireAsync(w,s,async(_,p)=>{var u;const a=Date.now(),t=await Promise.resolve(_);t instanceof A.WorkspaceEdit&&(S.push(t),d.add((u=p.extension.displayName)!==null&&u!==void 0?u:p.extension.identifier.value)),Date.now()-a>g&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!s.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let _ of S){let{edits:p}=D.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(p)}return{edit:v,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=i}),define(ge[217],ve([0,1,3,6,11,23,2,20,7,85]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(s,d,S,v){this.start=s,this.deletedCount=d,this.deletedItems=S,this.items=v}static asApiEvents(s){return s.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(S=>S.cell)}))}}class C{constructor(s,d,S){var v;this._notebook=s,this._extHostDocument=d,this._cellData=S,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=D.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(s,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:s}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const s=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return s._notebook.getCellIndex(s)},notebook:s._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return s._outputs.slice(0)},get metadata(){return s._metadata},get latestExecutionSummary(){return s._previousResult}})}return this._cell}setOutputs(s){this._outputs=s.map(A.NotebookCellOutput.to)}setOutputItems(s,d,S){const v=S.map(A.NotebookCellOutputItem.to),_=this._outputs.find(p=>p.id===s);_&&(d||(_.outputs.length=0),_.outputs.push(...v))}setMetadata(s){this._internalMetadata=s,this._metadata=A.NotebookCellMetadata.to(s),this._previousResult=A.NotebookCellPreviousExecutionResult.to(s)}}e.ExtHostCell=C;class w extends I.Disposable{constructor(s,d,S,v,_,p,u){super();this._proxy=s,this._textDocumentsAndEditors=d,this._textDocuments=S,this._emitter=v,this._viewType=_,this._metadata=p,this.uri=u,this.handle=w._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,I.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const s=this;this._notebook=Object.freeze({get uri(){return s.uri},get version(){return s._versionId},get fileName(){return s.uri.fsPath},get viewType(){return s._viewType},get isDirty(){return s._isDirty},get isUntitled(){return s.uri.scheme===T.Schemas.untitled},get isClosed(){return s._disposed},get metadata(){return s._metadata},get cellCount(){return s._cells.length},cellAt(d){return d=s._validateIndex(d),s._cells[d].cell},getCells(d){return(d?s._getCells(d):s._cells).map(v=>v.cell)},save(){return s._save()}})}return this._notebook}updateBackup(s){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=s}disposeBackup(){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(s){s.metadata&&(this._metadata=this._metadata.with(s.metadata))}acceptModelChanged(s,d){this._versionId=s.versionId,this._isDirty=d;for(const S of s.rawEvents)S.kind===i.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===i.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===i.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===i.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===i.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===i.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===i.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}_validateIndex(s){return s<0?0:s>=this._cells.length?this._cells.length-1:s}_validateRange(s){return s.start<0&&(s=s.with({start:0})),s.end>this._cells.length&&(s=s.with({end:this._cells.length})),s}_getCells(s){s=this._validateRange(s);const d=[];for(let S=s.start;S<s.end;S++)d.push(this._cells[S]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(s,d){if(!this._disposed){const S=[],v=[],_=[];s.reverse().forEach(p=>{var u;const t=p[2].map(r=>{const l=new C(this,this._textDocumentsAndEditors,r);if(d||v.push(C.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(l.handle)){const h=new I.DisposableStore;h.add(l),this._cellDisposableMapping.set(l.handle,h)}return l});for(let r=p[0];r<p[0]+p[1];r++)(u=this._cellDisposableMapping.get(this._cells[r].handle))===null||u===void 0||u.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const n=new R(p[0],p[1],[],t),o=this._cells.splice(p[0],p[1],...t);for(let r of o)_.push(r.uri),n.deletedItems.push(r.cell);S.push(n)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),d||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(S)}))}}_moveCell(s,d){const S=this._cells.splice(s,1);this._cells.splice(d,0,...S);const v=[new R(s,1,S.map(_=>_.cell),[]),new R(d,0,[],S)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(v)}))}_setCellOutputs(s,d){const S=this._cells[s];S.setOutputs(d),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(s,d,S,v){const _=this._cells[s];_.setOutputItems(d,S,v),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_changeCellLanguage(s,d){const S=this._cells[s];S.cell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(S.uri,d)}_changeCellMetadata(s,d){var S;const v=this._cells[s],_=v.internalMetadata,p=v.cell.metadata;v.setMetadata(d);const u=v.cell.metadata;if((0,P.equals)(p,u)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell})),_.runState!==d.runState){const a=(S=d.runState)!==null&&S!==void 0?S:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:a}))}}getCellFromIndex(s){return this._cells[s]}getCell(s){return this._cells.find(d=>d.handle===s)}getCellIndex(s){return this._cells.indexOf(s)}}e.ExtHostNotebookDocument=w,w._handlePool=0}),define(ge[218],ve([0,1,3,7,20]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,i){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:i})}replaceCellOutput(y,i){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:i.map(R=>T.NotebookCellOutput.from(R))})}replaceCells(y,i,R){this._throwIfFinalized(),!(y===i&&R.length===0)&&this._collectedEdits.push({editType:1,index:y,count:i-y,cells:R.map(T.NotebookCellData.from)})}}class D{constructor(y,i,R,C,w,g){this.id=y,this._proxy=i,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=w,this._visibleRanges=C,this._viewColumn=g}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var i;const R=y._selections[0];return R&&((i=y.notebookData.getCellFromIndex(R.start))===null||i===void 0?void 0:i.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(i,R){y._proxy.$tryRevealRange(y.id,T.NotebookCellRange.from(i),R!=null?R:I.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(i){const R=new P(this.document.version);return i(R),y._applyEdit(R.finalize())},get kernel(){return y._kernel},setDecorations(i,R){return y.setDecorations(i,R)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const i=[];let R=-1;for(let C=0;C<y.cellEdits.length;C++){if(R<0){i.push(y.cellEdits[C]),R++;continue}const g=i[R],s=y.cellEdits[C];if(g.editType===1&&s.editType===1&&g.index===s.index){g.cells.push(...y.cellEdits[C].cells),g.count+=y.cellEdits[C].count;continue}i.push(y.cellEdits[C]),R++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,i)}setDecorations(y,i){if(!(i.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return i.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(i),y.key)}}e.ExtHostNotebookEditor=D}),define(ge[219],ve([0,1,20,111,162,21,68]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,w,g){const s=this._handles++,{title:d,location:S,cancellable:v}=w,_={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(s,{location:E.ProgressLocation.from(S),title:d,source:_,cancellable:v},C),this._withProgress(s,g,!!v)}_withProgress(C,w,g){let s;g&&(s=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,s));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),s&&s.dispose()};let S;try{S=w(new i(this._proxy,C),g&&s?s.token:P.CancellationToken.None)}catch(v){throw d(C),v}return S.then(v=>d(C),v=>d(C)),S}$acceptProgressCanceled(C){const w=this._mapHandleToCancellationSource.get(C);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=A;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class i extends I.Progress{constructor(C,w){super(g=>this.throttledReport(g));this._proxy=C,this._handle=w}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,D.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(ge[122],ve([0,1,52,17,70,20,7]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(w,g){const s=A._Keys.nextId();w.$registerTextEditorDecorationType(s,P.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:s,dispose(){w.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=A,A._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(w,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,g){this._throwIfFinalized();let s=null;if(w instanceof D.Position)s=new D.Range(w,w);else if(w instanceof D.Range)s=w;else throw new Error("Unrecognized location");this._pushEdit(s,g,!1)}insert(w,g){this._throwIfFinalized(),this._pushEdit(new D.Range(w,w),g,!0)}delete(w){this._throwIfFinalized();let g=null;if(w instanceof D.Range)g=w;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(w,g,s){const d=this._document.validateRange(w);this._collectedEdits.push({range:d,text:g,forceMoveMarkers:s})}setEndOfLine(w){if(this._throwIfFinalized(),w!==D.EndOfLine.LF&&w!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=w}}e.TextEditorEdit=y;class i{constructor(w,g,s,d){this._proxy=w,this._id=g,this._accept(s),this._logService=d;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(w){this._tabSize=w.tabSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const g=Math.floor(w);return g>0?g:null}if(typeof w=="string"){const g=parseInt(w,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(w){const g=this._validateTabSize(w);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}_setInsertSpaces(w){const g=this._validateInsertSpaces(w);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(w)})))}assign(w){const g={};let s=!1;if(typeof w.tabSize!="undefined"){const d=this._validateTabSize(w.tabSize);d==="auto"?(s=!0,g.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,g.tabSize=d)}if(typeof w.insertSpaces!="undefined"){const d=this._validateInsertSpaces(w.insertSpaces);d==="auto"?(s=!0,g.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,g.insertSpaces=d)}typeof w.cursorStyle!="undefined"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,s=!0,g.cursorStyle=w.cursorStyle),typeof w.lineNumbers!="undefined"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,s=!0,g.lineNumbers=P.TextEditorLineNumbersStyle.from(w.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(w){w.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=i;class R{constructor(w,g,s,d,S,v,_,p){this.id=w,this._proxy=g,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new i(this._proxy,this.id,v,s),this._visibleRanges=_,this._viewColumn=p;const u=this;this.value=Object.freeze({get document(){return d.getValue()},set document(a){throw(0,I.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(a){if(!(a instanceof D.Selection))throw(0,I.illegalArgument)("selection");u._selections=[a],u._trySetSelection()},get selections(){return u._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof D.Selection)))throw(0,I.illegalArgument)("selections");u._selections=a,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(a){throw(0,I.readonly)("visibleRanges")},get options(){return u._options.value},set options(a){u._disposed||u._options.assign(a)},get viewColumn(){return u._viewColumn},set viewColumn(a){throw(0,I.readonly)("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(d.getValue(),t);return a(n),u._applyEdit(n)},insertSnippet(a,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(r=>P.Range.from(r));else if(t instanceof D.Position){const{lineNumber:r,column:l}=P.Position.from(t);o=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof D.Range)o=[P.Range.from(t)];else{o=[];for(const r of t)if(r instanceof D.Range)o.push(P.Range.from(r));else{const{lineNumber:l,column:h}=P.Position.from(r);o.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return g.$tryInsertSnippet(w,a.value,o,n)},setDecorations(a,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(a.key)||(n?u._hasDecorationsForKey.delete(a.key):u._hasDecorationsForKey.add(a.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return g.$trySetDecorations(w,a.key,P.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const h=t[r];o[4*r]=h.start.line+1,o[4*r+1]=h.start.character+1,o[4*r+2]=h.end.line+1,o[4*r+3]=h.end.character+1}return g.$trySetDecorationsFast(w,a.key,o)}}))},revealRange(a,t){u._runOnProxy(()=>g.$tryRevealRange(w,P.Range.from(a),t||D.TextEditorRevealType.Default))},show(a){g.$tryShowEditor(w,P.ViewColumn.from(a))},hide(){g.$tryHideEditor(w)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,E.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,E.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,E.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,E.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const g=w.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const s=g.edits.map(S=>S.range);s.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=s.length-1;S<v;S++){const _=s[S].end;if(s[S+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=g.edits.map(S=>({range:P.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,d,{setEndOfLine:typeof g.setEndOfLine=="number"?P.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=R}),define(ge[220],ve([0,1,165,25,2,3,6,19,7,14,18,20,21]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,v){if((0,i.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class s{constructor(v,_,p){this._proxy=v,this.commands=_,this.logService=p,this.treeViews=new Map;function u(a){return a&&a.$treeViewId&&a.$treeItemHandle}_.registerArgumentProcessor({processArgument:a=>u(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(t=>u(t)?this.convertArgument(t):t):a})}registerTreeDataProvider(v,_,p){const u=this.createTreeView(v,{treeDataProvider:_},p);return{dispose:()=>u.dispose()}}createTreeView(v,_,p){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),a=this.createExtHostTreeView(v,_,p);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(t){a.message=t},get title(){return a.title},set title(t){a.title=t},get description(){return a.description},set description(t){a.description=t},reveal:(t,n)=>a.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(v),a.dispose()}}}$getChildren(v,_){const p=this.treeViews.get(v);return p?p.getChildren(_):Promise.reject(new Error((0,E.localize)(0,null,v)))}async $hasResolve(v){const _=this.treeViews.get(v);if(!_)throw new Error((0,E.localize)(1,null,v));return _.hasResolve}$resolve(v,_,p){const u=this.treeViews.get(v);if(!u)throw new Error((0,E.localize)(2,null,v));return u.resolveTreeItem(_,p)}$setExpanded(v,_,p){const u=this.treeViews.get(v);if(!u)throw new Error((0,E.localize)(3,null,v));u.setExpanded(_,p)}$setSelection(v,_){const p=this.treeViews.get(v);if(!p)throw new Error((0,E.localize)(4,null,v));p.setSelection(_)}$setVisible(v,_){const p=this.treeViews.get(v);if(!p)throw new Error((0,E.localize)(5,null,v));p.setVisible(_)}createExtHostTreeView(v,_,p){const u=new d(v,_,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(v,u),u}convertArgument(v){const _=this.treeViews.get(v.$treeViewId);return _?_.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=s;class d extends D.Disposable{constructor(v,_,p,u,a,t){super();if(this.viewId=v,this.proxy=p,this.commands=u,this.logService=a,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new w.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===v&&(this._title=l.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,o;this._register(P.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(h=>o=h),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=o;return n=null,this.refresh(l).then(()=>h())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,i.isUndefinedOrNull)(v))}getChildren(v){const _=v?this.getExtensionElement(v):void 0;if(v&&!_)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(v);return(p?Promise.resolve(p):this.fetchChildrenNodes(_)).then(u=>u.map(a=>a.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,_){_=_||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,i.isUndefinedOrNull)(_.focus)?!1:_.focus,a=(0,i.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(o=>o.item)},{select:p,focus:u,expand:a})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:u,expand:a})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,_){const p=this.getExtensionElement(v);p&&(_?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(v){(0,R.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,_){var p;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(v);if(u){const a=this.nodes.get(u);if(a){const t=(p=await this.dataProvider.resolveTreeItem(a.extensionItem,u,_))!==null&&p!==void 0?p:a.extensionItem;return a.item.tooltip=this.getTooltip(t.tooltip),a.item.command=this.getCommand(a.disposableStore,t.command),a.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(_=>_?this.resolveUnknownParentChain(_).then(p=>this.resolveTreeNode(_,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}resolveParent(v){const _=this.nodes.get(v);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,_){const p=this.nodes.get(v);return p?Promise.resolve(p):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>this.createHandle(v,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const a=this.getExtensionElement(u);if(a){const t=this.nodes.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(v){if(v){let _;if(typeof v=="string"){const p=this.getExtensionElement(v);_=p?this.nodes.get(p):void 0}else _=v;return _&&_.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const _=new w.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=v?this.nodes.get(v):void 0,u=await this.dataProvider.getChildren(v);if(_.token.isCancellationRequested)return[];const a=await Promise.all((0,R.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,p):null}));return _.token.isCancellationRequested?[]:(0,R.coalesce)(a)}finally{_.dispose()}}refresh(v){if(v.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new w.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(v);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const _=new Set,p=v.map(a=>this.nodes.get(a));for(const a of p)if(a&&!_.has(a.item.handle)){let t=a;for(;t&&t.parent&&p.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(a.item.handle)}const u=[];return _.forEach(a=>{const t=this.elements.get(a);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&u.push(a)}}),u}refreshHandles(v){const _={};return Promise.all(v.map(p=>this.refreshNode(p).then(u=>{u&&(_[p]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(v){const _=this.getExtensionElement(v);if(_){const p=this.nodes.get(_);if(p)return this.clearChildren(_),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const a=this.createTreeNode(_,u,p.parent);return this.updateNodeCache(_,a,p,p.parent),p.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,_,p){const u=this.createTreeNode(v,_,p);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,E.localize)(6,null,_.id));return this.addNodeToCache(v,u),this.addNodeToParentCache(u,p),u}getTooltip(v){return y.MarkdownString.isMarkdownString(v)?C.MarkdownString.from(v):v}getCommand(v,_){return _?this.commands.toInternal(_,v):void 0}createTreeNode(v,_,p){const u=new D.DisposableStore,a=this.createHandle(v,_,p),t=this.getLightIconPath(_);return{item:{handle:a,parentHandle:p?p.item.handle:void 0,label:g(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,i.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(v){return v.iconPath instanceof y.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:_,label:p,resourceUri:u},a,t){if(_)return`${d.ID_HANDLE_PREFIX}/${_}`;const n=g(p,this.extension),o=a?a.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:u?(0,I.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,h=this.getChildrenNodes(a)||[];let m,b=0;do{if(m=`${o}/${b}:${r}`,t||!this.elements.has(m)||l===m)break;b++}while(b<=h.length);return m}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon))return typeof v.iconPath=="string"||T.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return T.URI.isUri(v)?v:T.URI.file(v)}addNodeToCache(v,_){this.elements.set(_.item.handle,v),this.nodes.set(v,_)}updateNodeCache(v,_,p,u){this.elements.delete(_.item.handle),this.nodes.delete(v),_.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(v,_);const a=this.getChildrenNodes(u)||[],t=a.filter(n=>n.item.handle===p.item.handle)[0];t&&a.splice(a.indexOf(t),1,_)}addNodeToParentCache(v,_){_?(_.children||(_.children=[]),_.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const _=this.nodes.get(v);if(_){if(_.children)for(const p of _.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(v){const _=this.nodes.get(v);if(_){if(_.children)for(const p of _.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}this.nodes.delete(v),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(ge[221],ve([0,1,18,19,21,20,7,121]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(s,d){if(d!==void 0){const S=this.testIdsToInternal.get(d),v=S==null?void 0:S.get(s);if(v)return[S,v]}return(0,E.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(s);return v&&[S,v]})}createForHierarchy(s=()=>{}){return new w(this.createIdMap(R++),s)}createIdMap(s){const d=new C(s);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=y;var i;(function(g){g[g.Disconnected=0]="Disconnected",g[g.IsChild=1]="IsChild",g[g.IsParent=2]="IsParent",g[g.IsSame=3]="IsSame"})(i=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(s){this.id=s,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const d=this.map.get(s);return d?(this.map.delete(s),this._roots.delete(d),!0):!1}get(s){return this.map.get(s)}comparePositions(s,d){const S=typeof s=="string"?this.map.get(s):s,v=typeof d=="string"?this.map.get(d):d;if(!S||!v)return 0;if(S===v)return 3;for(let _=this.map.get(v.parent);_;_=this.map.get(_.parent))if(_===S)return 1;for(let _=this.map.get(S.parent);_;_=this.map.get(_.parent))if(_===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class w{constructor(s,d){this.testIdToInternal=s,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(s,d){this.addItem(s,d,null)}getTestByReference(s){return this.testItemToInternal.get(s)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const d=this.diff[this.diff.length-1];if(d&&s[0]===1){if(d[0]===1&&d[1].extId===s[1].extId){(0,A.applyTestItemUpdate)(d[1],s[1]);return}if(d[0]===0&&d[1].item.extId===s[1].extId){(0,A.applyTestItemUpdate)(d[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,d){var S;const v=this.testIdToInternal.object.get(s);if(!!v){if((v.expandLevels===void 0||d>v.expandLevels)&&(v.expandLevels=d),v.expand===1){const _=this.refreshChildren(v);return _.isSettled?this.expandChildren(v,d-1):_.p.then(()=>this.expandChildren(v,d-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,d-1)):this.expandChildren(v,d-1)}}dispose(){var s;for(const d of this.testItemToInternal.values())(s=d.discoverCts)===null||s===void 0||s.dispose(!0),d.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(s,d,S){if(!(s instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);if(this.testItemToInternal.has(s))throw new Error(`Attempted to add a single TestItem ${s.id} multiple times to the tree`);if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);const v=S?S.item.extId:null,_=s.expandable?1:0,p=S==null?void 0:S.expandLevels,u={provider:d,tree:this.testIdToInternal.object.id},a={actual:s,parent:v,item:P.TestItem.from(s),expandLevels:p&&_===1?p-1:void 0,expand:_,src:u};this.testIdToInternal.object.add(a),this.testItemToInternal.set(s,a),this.pushDiff([0,{parent:v,src:u,expand:_,item:a.item}]),s[D.TestItemHookProperty]={created:t=>this.addItem(t,d,a),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,n)=>this.pushDiff([1,{extId:s.id,item:{[t]:t==="range"?P.Range.from(n):n}}])};for(const t of s.children)this.addItem(t,d,a)}expandChildren(s,d){if(!(d<0)){const S=[...s.actual.children].map(v=>this.expand(v.id,d-1)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(s){s.discoverCts&&s.discoverCts.dispose(!0),s.expand=2,s.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(s);const d=new I.DeferredPromise;return s.initialExpand=d,s.actual.discoverChildren({report:S=>{S.busy?(s.expand=2,this.pushExpandStateUpdate(s)):(s.expand=3,d.isSettled||d.complete(),this.pushExpandStateUpdate(s))}},s.discoverCts.token),d}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.actual.id,expand:s.expand}])}removeItembyId(s){var d;this.pushDiff([2,s]);const S=[this.testIdToInternal.object.get(s)];for(;S.length;){const v=S.pop();if(!!v){(d=v.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const _ of v.actual.children)S.push(this.testIdToInternal.object.get(_.id))}}}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}e.SingleUseTestCollection=w}),define(ge[222],ve([0,1,29,3,8]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=P;class D{constructor(R){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${E.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(w=>C.add(E.ExtensionIdentifier.toKey(w))),this._extensionDescriptions=this._extensionDescriptions.filter(w=>C.has(E.ExtensionIdentifier.toKey(w.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const w=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(w.map(g=>g.identifier)),C.length>0){const g=new Set;C.forEach(s=>g.add(E.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!g.has(E.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(w)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const _=C.getArcs(S);for(let p=0;p<_.length;p++)if(!v.has(_[p]))return!1;return!0}getNodes(){return this._nodesArr}};let w=new Map;for(let S of R){const v=E.ExtensionIdentifier.toKey(S.identifier);if(w.set(v,S),S.extensionDependencies)for(let _ of S.extensionDependencies){const p=E.ExtensionIdentifier.toKey(_);C.addArc(v,p)}}let g=new Set;C.getNodes().filter(S=>C.getArcs(S).length===0).forEach(S=>g.add(S));let s=C.getNodes().filter(S=>!g.has(S)),d;do{d=!1;for(let S=0;S<s.length;S++){const v=s[S];C.hasOnlyGoodArcs(v,g)&&(s.splice(S,1),S--,g.add(v),d=!0)}}while(d);return s.map(S=>w.get(S))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(E.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=D;var A;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(A||(A={}));function y(i,R){const C=i.isBuiltin?0:i.isUnderDevelopment?2:1,w=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==w)return C-w;const g=T.posix.basename(i.extensionLocation.path),s=T.posix.basename(R.extensionLocation.path);return g<s?-1:g>s?1:0}}),define(ge[223],ve([0,1,22]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(A){const y=E.VSBuffer.alloc(1);switch(A){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=P;function D(A,y){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(ge[41],ve([0,1,3,2,4,29,183]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class A{constructor(_){this.dependency=_}}e.MissingDependencyError=A;var y;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(_,p,u,a){this.codeLoadingTime=_,this.activateCallTime=p,this.activateResolvedTime=u,this.activationReason=a}}e.ActivationTimes=i;class R{constructor(_,p){this.description=_,this.value=p}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function w(v){v.enableProposedApi||g(v)}e.checkProposedApiEnabled=w;function g(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=g;function s(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=s;function d(v){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,p){}_activateById(_,p){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,p,u,a,t){}_onExtensionRuntimeError(_,p){}_onExtensionHostExit(_){}}e.NullExtensionService=S}),define(ge[224],ve([0,1,160,29,41,12]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(d,S,v,_){this.startup=d,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=_}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,S){return d===-1||S===-1?-1:S-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class i{constructor(d,S,v,_,p,u){this.activationFailed=d,this.activationFailedError=S,this.activationTimes=v,this.module=_,this.exports=p,this.subscriptions=u}}e.ActivatedExtension=i;class R extends i{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends i{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class w extends i{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=w;let g=class{constructor(d,S,v,_,p){this._logService=p,this._registry=d,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,v.forEach(u=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(u),u)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const S=I.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(S)}getActivatedExtension(d){const S=I.ExtensionIdentifier.toKey(d),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+d.value+"` is not known or not activated");return v}activateByEvent(d,S){if(this._alreadyActivatedEvents[d])return D;const v=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(v.map(_=>({id:_.identifier,reason:{startup:S,extensionId:_.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,S){const v=this._registry.getExtensionDescription(d);if(!v)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(d,S,v){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(d.id))){S[I.ExtensionIdentifier.toKey(d.id)]=d;return}const _=this._registry.getExtensionDescription(d.id);if(!_){this._host.onExtensionActivationError(d.id,new T.MissingDependencyError(d.id.value));const a=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(d.id),new w(a));return}const p=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let u=!0;for(let a=0,t=p.length;a<t;a++){const n=p[a];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const o=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(_.identifier,E.localize(0,null,_.displayName||_.identifier.value,n));const h=new Error(`Dependency ${n} failed to activate`);h.detail=o.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new w(h));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){u=!1,S[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){u=!1,S[I.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(_.identifier,new T.MissingDependencyError(n));const l=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new w(l));return}}}u?S[I.ExtensionIdentifier.toKey(_.identifier)]=d:v.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(p=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(p.id))),d.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let p=0,u=d.length;p<u;p++)this._handleActivateRequest(d[p],S,v);for(let p=0,u=v.length;p<u;p++){const a=I.ExtensionIdentifier.toKey(v[p].id);S[a]&&delete S[a]}const _=Object.keys(S).map(p=>S[p]);return v.length===0?Promise.all(_.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(_).then(p=>this._activateExtensions(v))}_activateExtension(d,S){const v=I.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const _=this._activatingExtensions.get(v);if(_)return _;const p=this._host.actualActivateExtension(d,S).then(void 0,u=>(this._host.onExtensionActivationError(d,E.localize(1,null,d.value,u.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(u),new w(u))).then(u=>{this._activatedExtensions.set(v,u),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,p),p}};g=je([Ue(4,P.ILogService)],g),e.ExtensionsActivator=g}),define(ge[225],ve([0,1,12,41,27,11,109]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends E.LogService{constructor(i){if(i.logFile.scheme!==P.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(I.ExtensionHostLogFileName,i.logFile.fsPath,!0,i.logLevel))}$setLevel(i){this.setLevel(i)}};A=je([Ue(0,T.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ge[226],ve([0,1,17]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,D)=>{this._actualOk=P,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,E.onUnexpectedError)(P))}then(P,D){return this._ensureActual().then(P,D)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=I}),define(ge[123],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,i){this.isMain=y,this.sid=i,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const I=[];function T(A){const y=new E(!0,A);return I[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function P(A){const y=new E(!1,A);return I[y.nid]=y,y}e.createExtHostContextProxyIdentifier=P;function D(A){return I[A].sid}e.getStringIdentifierForProxy=D}),define(ge[5],ve([0,1,2,123,57]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var D;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var i;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(i=e.CellKind||(e.CellKind={}));var R;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var g;(function(u){u.name="$ident";function a(n,o){return Object.defineProperty(n,u.name,{value:o,enumerable:!0}),n}u.mixin=a;function t(n){return n[u.name]}u.of=t})(g=e.ObjectIdentifier||(e.ObjectIdentifier={}));class s{static mixin(a){return a._id=s._n++,a}}e.IdObject=s,s._n=0;var d;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(u){if(u&&u.edits)for(const a of u.edits)typeof a.resource=="object"?a.resource=E.URI.revive(a.resource):(a.newUri=E.URI.revive(a.newUri),a.oldUri=E.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,T.revive)(a.metadata));return u}e.reviveWorkspaceEditDto=_;var p;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],ve([0,1,5,3,4]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,i){return this._proxy.$setPassword(A,y,i)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[62],ve([0,1,4,12,5,13]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,i,R){const C=this.getUsageKey(y,i);this._reportedUsages.has(C)||(this._reportedUsages.add(C),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:y}))}getUsageKey(y,i){return`${y}-${i.identifier.value}`}};D=je([Ue(0,P.IExtHostRpcService),Ue(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,i){}})}),define(ge[227],ve([0,1,3,5,7,29]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,i,R,C={}){const w=P.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(w)||[],s=R.sort().join(" ");let d=g.find(S=>S.scopes===s);if(d)return d.result;{const S=this._getSession(y,w,i,R,C);d={scopes:s,result:S},g.push(d),this._inFlightRequests.set(w,g);try{await S}finally{const v=g.findIndex(_=>_.scopes===s);v>-1&&(g.splice(v),this._inFlightRequests.set(w,g))}return S}}async _getSession(y,i,R,C,w={}){await this._proxy.$ensureProvider(R);const g=y.displayName||y.name;return this._proxy.$getSession(R,C,i,g,w)}async removeSession(y,i){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(i):this._proxy.$removeSession(y,i)}registerAuthenticationProvider(y,i,R,C){var w;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:i,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===y)||this._providers.push({id:y,label:i});const g=R.onDidChangeSessions(s=>{var d,S,v;this._proxy.$sendDidChangeSessions(y,{added:(d=s.added)!==null&&d!==void 0?d:[],changed:(S=s.changed)!==null&&S!==void 0?S:[],removed:(v=s.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(y,i,(w=C==null?void 0:C.supportsMultipleAccounts)!==null&&w!==void 0?w:!1),new T.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const s=this._providers.findIndex(d=>d.id===y);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,i){return this._onDidChangeSessions.fire({provider:{id:y,label:i}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,i){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),i.forEach(R=>{const C=this._providers.findIndex(w=>w.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ge[228],ve([0,1,5,13,20]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(A,y){this._extHostDocumentsAndEditors=y,this._proxy=A.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const y=T.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};P=je([Ue(0,I.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(ge[229],ve([0,1,5]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(P){const D=P.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=I}),define(ge[51],ve([0,1,14,7,20,23,5,18,12,57,43,49,2,6,4,13]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=n,this.converter=new v(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===p.Void?r:void 0},n),this._argumentProcessors=[{processArgument(o){return(0,i.revive)(o)}},{processArgument(o){return(0,P.cloneAndChange)(o,function(r){if(R.Range.isIRange(r))return T.Range.to(r);if(C.Position.isIPosition(r))return T.Position.to(r);if(R.Range.isIRange(r.range)&&w.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((h,m)=>{if(!h.validate(o[m]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[m]}`);return h.convert(o[m])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,o,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:o,thisArg:r,description:l}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,o){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,P.cloneAndChange)(n,function(l){if(l instanceof I.Position)return T.Position.from(l);if(l instanceof I.Range)return T.Range.from(l);if(l instanceof I.Location)return T.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,o);return(0,i.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw l}}}async _executeContributedCommand(t,n){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:l,description:h}=o;if(h)for(let m=0;m<h.args.length;m++)try{(0,E.validateConstraint)(n[m],h.args[m].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[m].name}' - ${h.args[m].description}`)}try{return await r.apply(l,n)}catch(m){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...n);b&&(t=b.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(o=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),o)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(o=>o[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,o]of this._commands){let{description:r}=o;r&&(t[n]=r)}return Promise.resolve(t)}};S=je([Ue(0,d.IExtHostRpcService),Ue(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class v{constructor(t,n,o){this._commands=t,this._lookupApiCommand=n,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((l,h)=>l.convert(t.arguments&&t.arguments[h]));else if((0,A.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),o.$ident=l,o.id=this.delegatingCommandId,o.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return o}}fromInternal(t){const n=D.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class _{constructor(t,n,o,r){this.name=t,this.description=n,this.validate=o,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",a=>w.URI.isUri(a),a=>a),_.Position=new _("position","A position in a text document",a=>I.Position.isPosition(a),T.Position.from),_.Range=new _("range","A range in a text document",a=>I.Range.isRange(a),T.Range.from),_.Selection=new _("selection","A selection in a text document",a=>I.Selection.isSelection(a),T.Selection.from),_.Number=new _("number","",a=>typeof a=="number",a=>a),_.String=new _("string","",a=>typeof a=="string",a=>a),_.CallHierarchyItem=new _("item","A call hierarchy item",a=>a instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class p{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=p,p.Void=new p("no result",a=>a);class u{constructor(t,n,o,r,l){this.id=t,this.internalId=n,this.description=o,this.args=r,this.result=l}}e.ApiCommand=u}),define(ge[230],ve([0,1,6,20,7,79,51,202,18,106]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",w(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,d)=>{if(!(0,y.isFalsyOrEmpty)(s)){class S extends T.SymbolInformation{static to(_){const p=new S(_.name,I.SymbolKind.to(_.kind),_.containerName||"",new T.Location(d[0],I.Range.to(_.range)));return p.detail=_.detail,p.range=p.location.range,p.selectionRange=I.Range.to(_.selectionRange),p.children=_.children?_.children.map(S.to):[],p}}return s.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(d=>T.Position.isPosition(d)),s=>s.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(d=>{let S;for(const v of d.reverse())S=new T.SelectionRange(I.Range.to(v),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const d=[];if(Array.isArray(s))for(let S of s)d.push(...S[1].map(I.WorkspaceSymbol.to));return d})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return I.WorkspaceEdit.to(s)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,i.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,i.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,d,S)=>{if(!s)return new T.CompletionList([]);const v=s.suggestions.map(_=>I.CompletionItem.to(_,S));return new T.CompletionList(v,s.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return I.SignatureHelp.to(s)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,d,S)=>w(v=>new T.CodeLens(I.Range.to(v.range),v.command&&S.fromInternal(v.command)))(s))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?I.Selection.from(s):I.Range.from(s)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,d,S)=>w(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const _=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=I.WorkspaceEdit.to(v.edit)),v.command&&(_.command=S.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(s))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(d=>new T.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:I.Range.from(s.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(I.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)]).optional()],D.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new E.DisposableStore,this._commands=d}static register(d){return R.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=S=>(...v)=>S(this._commands,...v);this._register(A.RemoveFromRecentlyOpenedAPICommand.ID,d(A.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(A.OpenIssueReporter.ID,d(A.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(d,S,v){const _=this._commands.registerCommand(!1,d,S,this,v);this._disposables.add(_)}}e.ExtHostApiCommands=C;function w(s){return d=>{if(Array.isArray(d))return d.map(s)}}function g(s){if(!!Array.isArray(s)){const d=[];for(const S of s)P.isLocationLink(S)?d.push(I.DefinitionLink.to(S)):d.push(I.location.to(S));return d}}}),define(ge[231],ve([0,1,19,68,3,6,2,79,29,20,7,5]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class w{constructor(u,a,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadComments),a.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.commentUniqueId,h=r.getCommentByUniqueId(l);return h||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.text,h=n.commentUniqueId,m=r.getCommentByUniqueId(h);return m?(m.body=l,m):n}return n}})}createCommentController(u,a,t){const n=w.handlePool++,o=new s(u,n,this._proxy,a,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(o),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),r),o}$createCommentThreadTemplate(u,a,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(a,t)}async $updateCommentThreadTemplate(u,a,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(a,t)}$deleteCommentThread(u,a){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(a)}$provideCommentingRanges(u,a,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(D.URI.revive(a));return(0,E.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(l=>i.Range.from(l)):void 0)}$toggleReaction(u,a,t,n,o){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const l=r.getCommentThread(a);if(l){const h=l.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&h&&r.reactionHandler)return r.reactionHandler(h,v(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=w,w.handlePool=0;class g{constructor(u,a,t,n,o,r,l){this._proxy=u,this._commentController=a,this._id=t,this._uri=n,this._range=o,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${a.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),a={};u("range")&&(a.range=i.Range.from(this._range)),u("label")&&(a.label=this.label),u("contextValue")&&(a.contextValue=this.contextValue),u("comments")&&(a.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(a.collapseState=_(this._collapseState)),u("canReply")&&(a.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,a)}}getCommentByUniqueId(u){for(let a of this._commentsMap){let t=a[0],n=a[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,I.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class s{constructor(u,a,t,n,o){this._extension=u,this._handle=a,this._proxy=t,this._id=n,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,a,t,n){if(typeof u=="string"){const o=new g(this._proxy,this,u,a,t,n,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new g(this._proxy,this,void 0,u,a,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,a){const t=new g(this._proxy,this,void 0,D.URI.revive(u),i.Range.to(a),[],this._extension.identifier);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,a){let t=this._threads.get(u);t&&(t.range=i.Range.to(a))}$deleteCommentThread(u){let a=this._threads.get(u);a&&a.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(p,u,a,t){let n=t.get(a);n||(n=++p.commentHandle,t.set(a,n));const o=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:n,body:i.MarkdownString.from(a.body),userName:a.author.name,userIconPath:o,label:a.label,commentReactions:a.reactions?a.reactions.map(r=>S(r)):void 0}}function S(p){return{label:p.label,iconPath:p.iconPath?i.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?D.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function _(p){if(p!==void 0)switch(p){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}}),define(ge[124],ve([0,1,2,5,7,4,13,12,18,10,8]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class fn{constructor(g,s){this._logService=s,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,s){const d=fn._handlePool++;this._provider.set(d,{provider:g,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(d,null);return}let _=(0,y.asArray)(v);if(_.length<=fn._maxEventSize){this._proxy.$onDidChange(d,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,_.length);const p=_.map(t=>({uri:t,rank:(0,i.count)(t.path,"/")})),u=(0,y.groupBy)(p,(t,n)=>t.rank-n.rank||(0,i.compare)(t.uri.path,n.uri.path));let a=[];e:for(let t of u){let n;for(let o of t){let r=(0,R.dirname)(o.uri.path);if(n!==r&&(n=r,a.push(o.uri)>=fn._maxEventSize))break e}}this._proxy.$onDidChange(d,a)});return new T.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(g,s,d){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:_}=this._provider.get(g);return await Promise.all(s.map(async p=>{try{const{uri:u,id:a}=p,t=await Promise.resolve(v.provideFileDecoration(E.URI.revive(u),d));if(!t)return;try{T.FileDecoration.validate(t),S[a]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(u){this._logService.error(u)}})),S}};C._handlePool=0,C._maxEventSize=250,C=je([Ue(0,D.IExtHostRpcService),Ue(1,A.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(ge[232],ve([0,1,159,110,2,5,7,20,3,12,24]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(s,d,S,v,_){this._name=s,this._owner=d,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,d){if(!s){this.clear();return}this._checkDisposed();let S=[];if(T.URI.isUri(s)){if(!d){this.delete(s);return}this._data.set(s,d.slice()),S=[s]}else if(Array.isArray(s)){S=[];let _;s=[...s].sort(C._compareIndexedTuplesByUri);for(const p of s){const[u,a]=p;if((!_||u.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=u,S.push(u),this._data.set(u,[])),a){const t=this._data.get(u);t&&t.push(...a)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let _ of S){let p=[];const u=this._data.get(_);if(u)if(u.length>this._maxDiagnosticsPerFile){p=[];const a=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===a[t]&&p.push(A.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;p.push({severity:I.MarkerSeverity.Info,message:(0,E.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=u.map(a=>A.Diagnostic.from(a));v.push([_,p])}this._proxy.$changeMany(this._owner,v)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,d){this._checkDisposed();for(let S of this._data.keys())s.apply(d,[S,this.get(S),this])}get(s){this._checkDisposed();const d=this._data.get(s);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,d){return s[0].toString()<d[0].toString()?-1:s[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let w=class zt{constructor(s,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=s.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(s,d){return s?s.concat(d):d}static _mapper(s){const d=[],S=new Set;for(const v of s)typeof v=="string"?S.has(v)||(S.add(v),d.push(T.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),d.push(v));return Object.freeze(d),{uris:d}}createDiagnosticCollection(s,d){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:_,_logService:p}=this,u=new class{$changeMany(n,o){v.$changeMany(n,o),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,n,o.length===0?"CLEARING":o)}$clear(n){v.$clear(n),p.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,n)}dispose(){v.dispose()}};let a;if(!d)d="_generated_diagnostic_collection_name_#"+zt._idPool++,a=d;else if(!S.has(d))a=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do a=d+zt._idPool++;while(S.has(a))}return new class extends C{constructor(){super(d,a,zt._maxDiagnosticsPerFile,u,_);S.set(a,this)}dispose(){super.dispose(),S.delete(a)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const d=new Map,S=[];for(const v of this._collections.values())v.forEach((_,p)=>{let u=d.get(_.toString());typeof u=="undefined"&&(u=S.length,d.set(_.toString(),u),S.push([_,[]])),S[u][1]=S[u][1].concat(...p)});return S}}_getDiagnostics(s){let d=[];for(let S of this._collections.values())S.has(s)&&(d=d.concat(S.get(s)));return d}$acceptMarkersChange(s){if(!this._mirrorCollection){const d="_generated_mirror",S=new C(d,d,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,S),this._mirrorCollection=S}for(const[d,S]of s)this._mirrorCollection.set(T.URI.revive(d),S.map(A.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=je([Ue(1,i.ILogService)],w),e.ExtHostDiagnostics=w}),define(ge[233],ve([0,1,2,5]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?E.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ge[234],ve([0,1,17,2,7,5,11,21,10]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(C,w,g){this._documentsAndEditors=w,this._logService=g,this._documentContentProviders=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,w){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const g=i._handlePool++;this._documentContentProviders.set(g,w),this._proxy.$registerTextContentProvider(g,C);let s;return typeof w.onDidChange=="function"&&(s=w.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(g,d).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(d);if(!!v){const _=(0,y.splitLines)(S);if(!v.equalLines(_))return this._proxy.$onVirtualDocumentChange(d,S)}}},E.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(C,w){const g=this._documentContentProviders.get(C);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(w),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(ge[235],ve([0,1,3,6,2,5,118,20,14,23]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(w,g){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const d of s)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const d of s)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!!w){const g=this._documentsAndEditors.getDocument(w);if(g)return g}}getDocument(w){const g=this.getDocumentData(w);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this._documentsAndEditors.getDocument(w);if(g)return Promise.resolve(g);let s=this._documentLoader.get(w.toString());return s||(s=this._proxy.$tryOpenDocument(w).then(d=>{this._documentLoader.delete(w.toString());const S=T.URI.revive(d);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(w.toString()),Promise.reject(d))),this._documentLoader.set(w.toString(),s)),s}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(g=>T.URI.revive(g))}$acceptModelModeChanged(w,g){const s=T.URI.revive(w),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(g),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(w){const g=T.URI.revive(w),s=this._documentsAndEditors.getDocument(g);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(w,g){const s=T.URI.revive(w),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");d._acceptIsDirty(g),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(w,g,s){const d=T.URI.revive(w),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(s),S.onEvents(g),this._onDidChangeDocument.fire((0,i.deepFreeze)({document:S.document,contentChanges:g.changes.map(v=>({range:A.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(w,g){(0,D.setWordDefinitionFor)(w,g)}}e.ExtHostDocuments=R}),define(ge[39],ve([0,1,52,3,6,2,4,5,118,13,122,20,12,24,11,71,133]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(u,a){this._extHostRpc=u,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const a=[],t=[],n=[];if(u.removedDocuments)for(const o of u.removedDocuments){const r=P.URI.revive(o),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),a.push(l.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const r=P.URI.revive(o.uri);let l=this._documents.get(r);if(l&&r.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new v(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(u.removedEditors)for(const o of u.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&n.push(r)}if(u.addedEditors)for(const o of u.addedEditors){const r=P.URI.revive(o.documentUri);E.ok(this._documents.has(r),`document '${r}' does not exist`),E.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const l=this._documents.get(r).value,h=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(m=>C.Range.to(m)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}u.newActiveEditor!==void 0&&(E.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,T.dispose)(a),(0,T.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(a),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var a;return(a=this._documents.get(u))===null||a===void 0?void 0:a.value}allDocuments(){return d.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const a=this._editors.get(this._activeEditorId);return u?a:a==null?void 0:a.value}}allEditors(){return[...this._editors.values()]}};_=je([Ue(0,i.IExtHostRpcService),Ue(1,w.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[236],ve([0,1,2,5,6,7,20,141,10,22]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const s=this._schemes.indexOf(g);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),s=[];let d,S,v=14,_=14;for(const p of g){let u=d?(0,y.commonPrefixLength)(d,p):0;for(u===0?S=1:S=_;u<p.length;u++)u+1===p.length?(v=_,_=9):_+=1,s.push([S,p.toUpperCase().charCodeAt(u),_]),s.push([S,p.toLowerCase().charCodeAt(u),_]),S=_;d=p,_=v}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new A.StateMachine(s)}}provideDocumentLinks(g){this._initStateMachine();const s=[],d=A.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of d){const v=D.DocumentLink.to(S);v.target&&s.push(v)}return s}}class C{constructor(g,s){this._extHostLanguageFeatures=s,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,s,d,S={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(v,d);let _=2;S.isCaseSensitive&&(_+=1024),S.isReadonly&&(_+=2048),typeof d.copy=="function"&&(_+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(v,s,_).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${s}`),console.error(u)});const p=d.onDidChangeFile(u=>{const a=[];for(const t of u){let{uri:n,type:o}=t;if(n.scheme===s){let r;switch(o){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(v,a)});return(0,T.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(g){const{type:s,ctime:d,mtime:S,size:v}=g;return{type:s,ctime:d,mtime:S,size:v}}$stat(g,s){return Promise.resolve(this._getFsProvider(g).stat(E.URI.revive(s))).then(C._asIStat)}$readdir(g,s){return Promise.resolve(this._getFsProvider(g).readDirectory(E.URI.revive(s)))}$readFile(g,s){return Promise.resolve(this._getFsProvider(g).readFile(E.URI.revive(s))).then(d=>i.VSBuffer.wrap(d))}$writeFile(g,s,d,S){return Promise.resolve(this._getFsProvider(g).writeFile(E.URI.revive(s),d.buffer,S))}$delete(g,s,d){return Promise.resolve(this._getFsProvider(g).delete(E.URI.revive(s),d))}$rename(g,s,d,S){return Promise.resolve(this._getFsProvider(g).rename(E.URI.revive(s),E.URI.revive(d),S))}$copy(g,s,d,S){const v=this._getFsProvider(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(E.URI.revive(s),E.URI.revive(d),S))}$mkdir(g,s){return Promise.resolve(this._getFsProvider(g).createDirectory(E.URI.revive(s)))}$watch(g,s,d,S){const v=this._getFsProvider(g).watch(E.URI.revive(d),S);this._watches.set(s,v)}$unwatch(g,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(g,s,d){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(E.URI.revive(s),d))}$close(g,s){const d=this._getFsProvider(g);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(g,s,d,S){const v=this._getFsProvider(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const _=i.VSBuffer.alloc(S);return Promise.resolve(v.read(s,d,_.buffer,0,S)).then(p=>_.slice(0,p))}$write(g,s,d,S){const v=this._getFsProvider(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,d,S.buffer,0,S.byteLength))}_getFsProvider(g){const s=this._fsProvider.get(g);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=C}),define(ge[87],ve([0,1,5,44,7,22,4,13,60]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class Rt{constructor(C,w){const g=C.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return g.$stat(s).catch(Rt._handleError)},readDirectory(s){return g.$readdir(s).catch(Rt._handleError)},createDirectory(s){return g.$mkdir(s).catch(Rt._handleError)},async readFile(s){return g.$readFile(s).then(d=>d.buffer).catch(Rt._handleError)},writeFile(s,d){return g.$writeFile(s,P.VSBuffer.wrap(d)).catch(Rt._handleError)},delete(s,d){return g.$delete(s,Object.assign({recursive:!1,useTrash:!1},d)).catch(Rt._handleError)},rename(s,d,S){return g.$rename(s,d,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},copy(s,d,S){return g.$copy(s,d,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},isWritableFileSystem(s){const d=w.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};i=je([Ue(0,A.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[237],ve([0,1,6,5]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ge[238],ve([0,1,2,23,20,7,19,5,10,43,18,14,138,6,106,70,116,46,17]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentSymbols(V,Y){const te=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,Y)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(T.DocumentSymbol.from):p._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(V){var Y;V=V.slice(0).sort((fe,De)=>{let Oe=fe.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(fe.location.range.end)),Oe});const te=[],ae=[];for(const fe of V){const De={name:fe.name||"!!MISSING: name!!",kind:T.SymbolKind.from(fe.kind),tags:((Y=fe.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:T.Range.from(fe.location.range),selectionRange:T.Range.from(fe.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Oe=ae[ae.length-1];if(i.Range.containsRange(Oe.range,De.range)&&!i.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(V,Y,te){this._documents=V,this._commands=Y,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,Y){const te=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(te,Y);if(!(!ae||Y.isCancellationRequested)){const fe=this._cache.add(ae),De=new g.DisposableStore;this._disposables.set(fe,De);const Oe={cacheId:fe,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[fe,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,De)});return Oe}}async resolveCodeLens(V,Y){var te;const ae=V.cacheId&&this._cache.get(...V.cacheId);if(!!ae){let fe;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?fe=ae:fe=await this._provider.resolveCodeLens(ae,Y),fe||(fe=ae),!Y.isCancellationRequested){const De=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!De)return V.command=this._commands.toInternal((te=fe.command)!==null&&te!==void 0?te:u._badCmd,De),V}}}releaseCodeLenses(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(Me){return Array.isArray(Me)?Me.map(T.DefinitionLink.from):Me?[T.DefinitionLink.from(Me)]:[]}class t{constructor(V,Y){this._documents=V,this._provider=Y}provideDefinition(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,fe,te)).then(a)}}class n{constructor(V,Y){this._documents=V,this._provider=Y}provideDeclaration(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,fe,te)).then(a)}}class o{constructor(V,Y){this._documents=V,this._provider=Y}provideImplementation(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,fe,te)).then(a)}}class r{constructor(V,Y){this._documents=V,this._provider=Y}provideTypeDefinition(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,fe,te)).then(a)}}class l{constructor(V,Y){this._documents=V,this._provider=Y}provideHover(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideHover(ae,fe,te)).then(De=>{if(!(!De||(0,R.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(fe)),De.range||(De.range=new P.Range(fe,fe)),T.Hover.from(De)})}}class h{constructor(V,Y){this._documents=V,this._provider=Y}provideEvaluatableExpression(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,fe,te)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class m{constructor(V,Y){this._documents=V,this._provider=Y}provideInlineValues(V,Y,te,ae){const fe=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideInlineValues(fe,T.Range.to(Y),T.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>T.InlineValue.from(Oe))})}}class b{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentHighlights(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,fe,te)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class c{constructor(V,Y){this._documents=V,this._provider=Y}provideLinkedEditingRanges(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,fe,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,R.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class f{constructor(V,Y){this._documents=V,this._provider=Y}provideReferences(V,Y,te,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideReferences(fe,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class k{constructor(V,Y,te,ae,fe,De,Oe){this._documents=V,this._commands=Y,this._diagnostics=te,this._provider=ae,this._logService=fe,this._extension=De,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,Y,te,ae){const fe=this._documents.getDocument(V),De=w.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const ke of this._diagnostics.getDiagnostics(V))if(De.intersection(ke.range)&&Oe.push(ke)>k._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:te.only?new P.CodeActionKind(te.only):void 0,triggerKind:T.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(fe,De,be,ae)).then(ke=>{var Te;if(!(!(0,R.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),Se=new g.DisposableStore;this._disposables.set(xe,Se);const Ke=[];for(let G=0;G<ke.length;G++){const re=ke[G];!re||(k._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Se)})):(be.only&&(re.kind?be.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[xe,G],title:re.title,command:re.command&&this._commands.toInternal(re.command,Se),diagnostics:re.diagnostics&&re.diagnostics.map(T.Diagnostic.from),edit:re.edit&&T.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Te=re.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:xe,actions:Ke}}})}async resolveCodeAction(V,Y){var te;const[ae,fe]=V,De=this._cache.get(ae,fe);if(!(!De||k._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(te=await this._provider.resolveCodeAction(De,Y))!==null&&te!==void 0?te:De;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}k._maxCodeActionsPerFile=1e3;class L{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentFormattingEdits(V,Y,te){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,te)).then(fe=>{if(Array.isArray(fe))return fe.map(T.TextEdit.from)})}}class ${constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentRangeFormattingEdits(V,Y,te,ae){const fe=this._documents.getDocument(V),De=T.Range.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class ee{constructor(V,Y){this._documents=V,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,Y,te,ae,fe){const De=this._documents.getDocument(V),Oe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,te,ae,fe)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class H{constructor(V,Y){this._provider=V,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,Y){const te=A.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,Y)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const fe of ae)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const De=A.IdObject.mixin(T.WorkspaceSymbol.from(fe));this._symbolCache.set(De._id,fe),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(V,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const te=this._symbolCache.get(V._id);if(te){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Y));return ae&&(0,I.mixin)(V,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const Y=this._resultCache.get(V);if(Y){for(let[te,ae]=Y;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(V)}}}class x{constructor(V,Y,te){this._documents=V,this._provider=Y,this._logService=te}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,Y,te,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(fe,De,te,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=x._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(V,Y,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,fe,te)).then(De=>{let Oe,be;if(P.Range.isRange(De)?(Oe=De,be=ae.getText(De)):(0,C.isObject)(De)&&(Oe=De.range,be=De.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},De=>{const Oe=x._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class B{constructor(V,Y){this.resultId=V,this.tokens=Y}}class F{constructor(V,Y){this._documents=V,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,Y,te){const ae=this._documents.getDocument(V),fe=Y!==0?this._previousResults.get(Y):null;return(0,D.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,fe.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(fe&&this._previousResults.delete(Y),De?(De=F._fixProvidedSemanticTokens(De),this._send(F._convertToEdits(fe,De),De)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return F._isSemanticTokens(V)?F._isCorrectSemanticTokens(V)?V:new P.SemanticTokens(new Uint32Array(V.data),V.resultId):F._isSemanticTokensEdits(V)?F._isCorrectSemanticTokensEdits(V)?V:new P.SemanticTokensEdits(V.edits.map(Y=>new P.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const Y of V.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,Y){if(!F._isSemanticTokens(Y)||!V||!V.tokens)return Y;const te=V.tokens,ae=te.length,fe=Y.data,De=fe.length;let Oe=0;const be=Math.min(ae,De);for(;Oe<be&&te[Oe]===fe[Oe];)Oe++;if(Oe===ae&&Oe===De)return new P.SemanticTokensEdits([],Y.resultId);let ke=0;const Te=be-Oe;for(;ke<Te&&te[ae-ke-1]===fe[De-ke-1];)ke++;return new P.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-ke,data:fe.subarray(Oe,De-ke)}],Y.resultId)}_send(V,Y){if(F._isSemanticTokens(V)){const te=this._nextResultId++;return this._previousResults.set(te,new B(V.resultId,V.data)),(0,s.encodeSemanticTokensDto)({id:te,type:"full",data:V.data})}if(F._isSemanticTokensEdits(V)){const te=this._nextResultId++;return F._isSemanticTokens(Y)?this._previousResults.set(te,new B(Y.resultId,Y.data)):this._previousResults.set(te,new B(V.resultId)),(0,s.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentRangeSemanticTokens(V,Y,te){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(Y),te)).then(fe=>fe?this._send(fe):null)}_send(V){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(V,Y,te,ae,fe){this._documents=V,this._commands=Y,this._provider=te,this._apiDeprecation=ae,this._extension=fe,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,Y,te,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y),Oe=fe.getWordRangeAtPosition(De)||new P.Range(De,De),be=Oe.with({end:De}),ke=new v.StopWatch(!0),Te=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(fe,De,ae,T.CompletionContext.to(te)));if(!!Te&&!ae.isCancellationRequested){const xe=Array.isArray(Te)?new P.CompletionList(Te):Te,Se=M.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(Se,Ke);const G=[],re={x:Se,b:G,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Ee=0;Ee<xe.items.length;Ee++){const Ne=xe.items[Ee],Ve=this._convertCompletionItem(Ne,[Se,Ee],be,Oe);G.push(Ve)}return re}}async resolveCompletionItem(V,Y){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...V);if(!!te){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,Y));if(!!ae)return this._convertCompletionItem(ae,V)}}}releaseCompletionItems(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,Y,te,ae){var fe;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(fe=V.label)!==null&&fe!==void 0?fe:"",o:V.label2,b:V.kind!==void 0?T.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(T.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(V.command,De)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=V.textEdit.newText):typeof V.insertText=="string"?Oe.h=V.insertText:V.insertText instanceof P.SnippetString&&(Oe.h=V.insertText.value,Oe.i|=4);let be;return V.textEdit?be=V.textEdit.range:V.range&&(be=V.range),P.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(te==null?void 0:te.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class N{constructor(V,Y){this._documents=V,this._provider=Y,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(V,Y,te,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y),Oe=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(fe,De,ae,Oe)).then(be=>{if(be){const ke=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:ke})}})}reviveContext(V){let Y;if(V.activeSignatureHelp){const te=T.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=te.activeSignature,Y.activeParameter=te.activeParameter):Y=te}return Object.assign(Object.assign({},V),{activeSignatureHelp:Y})}releaseSignatureHelp(V){this._cache.delete(V)}}class O{constructor(V,Y){this._documents=V,this._provider=Y}provideInlineHints(V,Y,te){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(Y),te)).then(fe=>fe?{hints:fe.map(T.InlineHint.from)}:void 0)}}class j{constructor(V,Y){this._documents=V,this._provider=Y,this._cache=new S.Cache("DocumentLink")}provideLinks(V,Y){const te=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const fe=this._cache.add(ae),De={links:[],id:fe};for(let Oe=0;Oe<ae.length;Oe++){const be=T.DocumentLink.from(ae[Oe]);be.cacheId=[fe,Oe],De.links.push(be)}return De}}})}resolveLink(V,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...V);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,Y)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class K{constructor(V,Y){this._documents=V,this._provider=Y}provideColors(V,Y){const te=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,Y)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:fe},te)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class X{constructor(V,Y){this._documents=V,this._provider=Y}provideFoldingRanges(V,Y,te){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(T.FoldingRange.from)})}}class me{constructor(V,Y,te){this._documents=V,this._provider=Y,this._logService=te}provideSelectionRanges(V,Y,te){const ae=this._documents.getDocument(V),fe=Y.map(T.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,fe,te)).then(De=>{if(!(0,R.isNonEmptyArray)(De))return[];if(De.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<fe.length;be++){const ke=[];Oe.push(ke);let Te=fe[be],xe=De[be];for(;;){if(!xe.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(T.SelectionRange.from(xe)),!xe.parent)break;Te=xe.range,xe=xe.parent}}return Oe})}}class we{constructor(V,Y){this._documents=V,this._provider=Y,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,Y,te){const ae=this._documents.getDocument(V),fe=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(ae,fe,te);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(V,Y,te){const ae=this._itemFromCache(V,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!fe)return fe.map(De=>({from:this._cacheAndConvertItem(V,De.from),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(V,Y,te){const ae=this._itemFromCache(V,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!fe)return fe.map(De=>({to:this._cacheAndConvertItem(V,De.to),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,Y){var te;const ae=this._cache.get(V),fe={_sessionId:V,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(te=Y.tags)===null||te===void 0?void 0:te.map(T.SymbolTag.from)};return ae.set(fe._itemId,Y),fe}_itemFromCache(V,Y){const te=this._cache.get(V);return te==null?void 0:te.get(Y)}}class Ae{constructor(V,Y){this.adapter=V,this.extension=Y}}class Ie{constructor(V,Y,te,ae,fe,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=V.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=fe,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(V){return(0,R.coalesce)((0,R.asArray)(V).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:T.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new P.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Ie._handlePool++}_withAdapter(V,Y,te,ae,fe=!1){const De=this._adapter.get(V);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const be=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(be).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Te=>{fe&&Te instanceof _.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Te))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,Y){const te=this._nextHandle();return this._adapter.set(te,new Ae(V,Y)),te}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,Y,te,ae){const fe=this._addNewAdapter(new p(this._documents,te),V),De=ae&&ae.label||Ie._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Y),De),this._createDisposable(fe)}$provideDocumentSymbols(V,Y,te){return this._withAdapter(V,p,ae=>ae.provideDocumentSymbols(E.URI.revive(Y),te),void 0)}registerCodeLensProvider(V,Y,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new u(this._documents,this._commands.converter,te),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=te.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideCodeLenses(V,Y,te){return this._withAdapter(V,u,ae=>ae.provideCodeLenses(E.URI.revive(Y),te),void 0)}$resolveCodeLens(V,Y,te){return this._withAdapter(V,u,ae=>ae.resolveCodeLens(Y,te),void 0)}$releaseCodeLenses(V,Y){this._withAdapter(V,u,te=>Promise.resolve(te.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(V,Y,te){const ae=this._addNewAdapter(new t(this._documents,te),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(V,Y,te,ae){return this._withAdapter(V,t,fe=>fe.provideDefinition(E.URI.revive(Y),te,ae),[])}registerDeclarationProvider(V,Y,te){const ae=this._addNewAdapter(new n(this._documents,te),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(V,Y,te,ae){return this._withAdapter(V,n,fe=>fe.provideDeclaration(E.URI.revive(Y),te,ae),[])}registerImplementationProvider(V,Y,te){const ae=this._addNewAdapter(new o(this._documents,te),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(V,Y,te,ae){return this._withAdapter(V,o,fe=>fe.provideImplementation(E.URI.revive(Y),te,ae),[])}registerTypeDefinitionProvider(V,Y,te){const ae=this._addNewAdapter(new r(this._documents,te),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(V,Y,te,ae){return this._withAdapter(V,r,fe=>fe.provideTypeDefinition(E.URI.revive(Y),te,ae),[])}registerHoverProvider(V,Y,te,ae){const fe=this._addNewAdapter(new l(this._documents,te),V);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideHover(V,Y,te,ae){return this._withAdapter(V,l,fe=>fe.provideHover(E.URI.revive(Y),te,ae),void 0)}registerEvaluatableExpressionProvider(V,Y,te,ae){const fe=this._addNewAdapter(new h(this._documents,te),V);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideEvaluatableExpression(V,Y,te,ae){return this._withAdapter(V,h,fe=>fe.provideEvaluatableExpression(E.URI.revive(Y),te,ae),void 0)}registerInlineValuesProvider(V,Y,te,ae){const fe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new m(this._documents,te),V);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),fe);let Oe=this._createDisposable(De);if(fe!==void 0){const be=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(fe));Oe=P.Disposable.from(Oe,be)}return Oe}$provideInlineValues(V,Y,te,ae,fe){return this._withAdapter(V,m,De=>De.provideInlineValues(E.URI.revive(Y),te,ae,fe),void 0)}registerDocumentHighlightProvider(V,Y,te){const ae=this._addNewAdapter(new b(this._documents,te),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(V,Y,te,ae){return this._withAdapter(V,b,fe=>fe.provideDocumentHighlights(E.URI.revive(Y),te,ae),void 0)}registerLinkedEditingRangeProvider(V,Y,te){const ae=this._addNewAdapter(new c(this._documents,te),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,Y,te,ae){return this._withAdapter(V,c,async fe=>{const De=await fe.provideLinkedEditingRanges(E.URI.revive(Y),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(V,Y,te){const ae=this._addNewAdapter(new f(this._documents,te),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(V,Y,te,ae,fe){return this._withAdapter(V,f,De=>De.provideReferences(E.URI.revive(Y),te,ae,fe),void 0)}registerCodeActionProvider(V,Y,te,ae){var fe,De;const Oe=new g.DisposableStore,be=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,te,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(Y),{providedKinds:(fe=ae==null?void 0:ae.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Ie._extLabel(V),Boolean(te.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(V,Y,te,ae,fe){return this._withAdapter(V,k,De=>De.provideCodeActions(E.URI.revive(Y),te,ae,fe),void 0)}$resolveCodeAction(V,Y,te){return this._withAdapter(V,k,ae=>ae.resolveCodeAction(Y,te),void 0)}$releaseCodeActions(V,Y){this._withAdapter(V,k,te=>Promise.resolve(te.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(V,Y,te){const ae=this._addNewAdapter(new L(this._documents,te),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,Y,te,ae){return this._withAdapter(V,L,fe=>fe.provideDocumentFormattingEdits(E.URI.revive(Y),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,Y,te){const ae=this._addNewAdapter(new $(this._documents,te),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,Y,te,ae,fe){return this._withAdapter(V,$,De=>De.provideDocumentRangeFormattingEdits(E.URI.revive(Y),te,ae,fe),void 0)}registerOnTypeFormattingEditProvider(V,Y,te,ae){const fe=this._addNewAdapter(new ee(this._documents,te),V);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Y),ae,V.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(V,Y,te,ae,fe,De){return this._withAdapter(V,ee,Oe=>Oe.provideOnTypeFormattingEdits(E.URI.revive(Y),te,ae,fe,De),void 0)}registerWorkspaceSymbolProvider(V,Y){const te=this._addNewAdapter(new H(Y,this._logService),V);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(V,Y,te){return this._withAdapter(V,H,ae=>ae.provideWorkspaceSymbols(Y,te),{symbols:[]})}$resolveWorkspaceSymbol(V,Y,te){return this._withAdapter(V,H,ae=>ae.resolveWorkspaceSymbol(Y,te),void 0)}$releaseWorkspaceSymbols(V,Y){this._withAdapter(V,H,te=>te.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(V,Y,te){const ae=this._addNewAdapter(new x(this._documents,te,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),x.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(V,Y,te,ae,fe){return this._withAdapter(V,x,De=>De.provideRenameEdits(E.URI.revive(Y),te,ae,fe),void 0)}$resolveRenameLocation(V,Y,te,ae){return this._withAdapter(V,x,fe=>fe.resolveRenameLocation(E.URI.revive(Y),te,ae),void 0)}registerDocumentSemanticTokensProvider(V,Y,te,ae){const fe=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ae(new F(this._documents,te),V)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae,De);let Oe=this._createDisposable(fe);if(De){const be=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=P.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(V,Y,te,ae){return this._withAdapter(V,F,fe=>fe.provideDocumentSemanticTokens(E.URI.revive(Y),te,ae),null,!0)}$releaseDocumentSemanticTokens(V,Y){this._withAdapter(V,F,te=>te.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(V,Y,te,ae){const fe=this._addNewAdapter(new U(this._documents,te),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(V,Y,te,ae){return this._withAdapter(V,U,fe=>fe.provideDocumentRangeSemanticTokens(E.URI.revive(Y),te,ae),null,!0)}registerCompletionItemProvider(V,Y,te,ae){const fe=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Y),ae,M.supportsResolving(te),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(fe)}$provideCompletionItems(V,Y,te,ae,fe){return this._withAdapter(V,M,De=>De.provideCompletionItems(E.URI.revive(Y),te,ae,fe),void 0)}$resolveCompletionItem(V,Y,te){return this._withAdapter(V,M,ae=>ae.resolveCompletionItem(Y,te),void 0)}$releaseCompletionItems(V,Y){this._withAdapter(V,M,te=>te.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(V,Y,te,ae){const fe=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),V);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),fe),this._createDisposable(De)}$provideSignatureHelp(V,Y,te,ae,fe){return this._withAdapter(V,N,De=>De.provideSignatureHelp(E.URI.revive(Y),te,ae,fe),void 0)}$releaseSignatureHelp(V,Y){this._withAdapter(V,N,te=>te.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(V,Y,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new O(this._documents,te),V);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(Y),ae);let De=this._createDisposable(fe);if(ae!==void 0){const Oe=te.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Oe)}return De}$provideInlineHints(V,Y,te,ae){return this._withAdapter(V,O,fe=>fe.provideInlineHints(E.URI.revive(Y),te,ae),void 0)}registerDocumentLinkProvider(V,Y,te){const ae=this._addNewAdapter(new j(this._documents,te),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,Y,te){return this._withAdapter(V,j,ae=>ae.provideLinks(E.URI.revive(Y),te),void 0)}$resolveDocumentLink(V,Y,te){return this._withAdapter(V,j,ae=>ae.resolveLink(Y,te),void 0)}$releaseDocumentLinks(V,Y){this._withAdapter(V,j,te=>te.releaseLinks(Y),void 0)}registerColorProvider(V,Y,te){const ae=this._addNewAdapter(new K(this._documents,te),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(V,Y,te){return this._withAdapter(V,K,ae=>ae.provideColors(E.URI.revive(Y),te),[])}$provideColorPresentations(V,Y,te,ae){return this._withAdapter(V,K,fe=>fe.provideColorPresentations(E.URI.revive(Y),te,ae),void 0)}registerFoldingRangeProvider(V,Y,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new X(this._documents,te),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideFoldingRanges(V,Y,te,ae){return this._withAdapter(V,X,fe=>fe.provideFoldingRanges(E.URI.revive(Y),te,ae),void 0)}registerSelectionRangeProvider(V,Y,te){const ae=this._addNewAdapter(new me(this._documents,te,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(V,Y,te,ae){return this._withAdapter(V,me,fe=>fe.provideSelectionRanges(E.URI.revive(Y),te,ae),[])}registerCallHierarchyProvider(V,Y,te){const ae=this._addNewAdapter(new we(this._documents,te),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(V,Y,te,ae){return this._withAdapter(V,we,fe=>Promise.resolve(fe.prepareSession(E.URI.revive(Y),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,Y,te,ae){return this._withAdapter(V,we,fe=>fe.provideCallsTo(Y,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,Y,te,ae){return this._withAdapter(V,we,fe=>fe.provideCallsFrom(Y,te,ae),void 0)}$releaseCallHierarchy(V,Y){this._withAdapter(V,we,te=>Promise.resolve(te.releaseSession(Y)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,y.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Ie._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Ie._serializeRegExp(V.beforeText),afterText:V.afterText?Ie._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Ie._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(V,Y,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ie._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ie._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ie._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Y,De),this._createDisposable(fe)}$setWordDefinitions(V){for(const Y of V)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(ge[239],ve([0,1,5,20,7]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(A,y){this._proxy=A.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,y){await this._proxy.$changeLanguage(A,y);const i=this._documents.getDocumentData(A);if(!i)throw new Error(`document '${A.toString}' NOT found`);return i.document}async tokenAtPosition(A,y){var i;const R=A.version,C=I.Position.from(y),w=await this._proxy.$tokensAtPosition(A.uri,C),g={type:T.StandardTokenType.Other,range:(i=A.getWordRangeAtPosition(y))!==null&&i!==void 0?i:new T.Range(y.line,y.character,y.line,y.character)};if(!w)return g;const s={range:I.Range.to(w.range),type:I.TokenType.to(w.type)};return!s.range.contains(y)||R!==A.version?g:s}}e.ExtHostLanguages=P}),define(ge[240],ve([0,1,5,12,41]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(A){return A&&A.title}let D=class{constructor(y,i){this._logService=i,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,i,R,C,w){const g={extension:y};let s;typeof C=="string"||P(C)?s=[C,...w]:(g.modal=C&&C.modal,g.useCustom=C&&C.useCustom,s=w),g.useCustom&&(0,T.checkProposedApiEnabled)(y);const d=[];for(let S=0;S<s.length;S++){const v=s[S];if(typeof v=="string")d.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:_,isCloseAffordance:p}=v;d.push({title:_,isCloseAffordance:!!p,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(i,R,g,d).then(S=>{if(typeof S=="number")return s[S]})}};D=je([Ue(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(ge[241],ve([0,1,21,3,6,2,28,5,20,7,84,85,24,217,218,70,14,22,73]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class p extends T.Disposable{constructor(m,b,c,f,k){super();this._editorId=m,this.uri=b,this._proxy=c,this._webviewInitData=f,this.document=k,this._onDidReceiveDocumentMessage=new I.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:L=>this._proxy.$postMessage(this._editorId,void 0,L),asWebviewUri:L=>this._asWebviewUri(L)}}onDidReceiveMessage(m,b){var c;this._onDidReceiveDocumentMessage.fire(b),m!==void 0&&((c=this._rendererIdToEmitters.get(m))===null||c===void 0||c.fire(b))}getRendererComm(m){const b=new I.Emitter;return this._rendererIdToEmitters.set(m,b),{editorId:this._editorId,onDidReceiveMessage:b.event,postMessage:c=>this._proxy.$postMessage(this._editorId,m,c),asWebviewUri:c=>this._asWebviewUri(c)}}_asWebviewUri(m){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,m)}}class u extends T.Disposable{constructor(m,b,c,f){super();this._proxy=m,this._handle=b,this._extension=c,this._provider=f,this._kernelToFriendlyId=new w.ResourceMap,this._friendlyIdToKernel=new w.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(k=>{const L=k==null?void 0:k.uri;this._proxy.$onNotebookKernelChange(this._handle,L)}))}async provideKernels(m,b){const c=await this._provider.provideKernels(m.notebookDocument,b)||[],f=new Map;let k=0;const L=new Set,$=this._kernelToFriendlyId.get(m.uri),ee=c.map(x=>{let B=$==null?void 0:$.get(x);return B===void 0&&(x.id&&L.has(x.id)?B=`${this._extension.identifier.value}_${x.id}_${k++}`:B=`${this._extension.identifier.value}_${x.id||D.generateUuid()}`),f.set(x,B),{id:x.id,friendlyId:B,label:x.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:x.description,detail:x.detail,isPreferred:x.isPreferred,preloads:x.preloads,supportedLanguages:x.supportedLanguages,implementsInterrupt:!!x.interrupt}});this._kernelToFriendlyId.set(m.uri,f);const H=new Map;return f.forEach((x,B)=>{H.set(x,B)}),this._friendlyIdToKernel.set(m.uri,H),ee}getKernelByFriendlyId(m,b){var c;return(c=this._friendlyIdToKernel.get(m))===null||c===void 0?void 0:c.get(b)}async resolveNotebook(m,b,c,f){var k;const L=(k=this._friendlyIdToKernel.get(b.uri))===null||k===void 0?void 0:k.get(m);if(L&&this._provider.resolveKernel)return this._provider.resolveKernel(L,b.notebookDocument,c,f)}async executeNotebook(m,b,c){var f;const k=(f=this._friendlyIdToKernel.get(b.uri))===null||f===void 0?void 0:f.get(m);if(!!k){const L=c.map($=>y.NotebookCellRange.to($));return k.executeCellsRequest(b.notebookDocument,L)}}async interruptNotebookExecution(m,b){var c;const f=(c=this._friendlyIdToKernel.get(b.uri))===null||c===void 0?void 0:c.get(m);if(!(!f||!f.interrupt))return f.interrupt(b.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=u;class a{constructor(m,b){const c=a._Keys.nextId();m.$registerNotebookEditorDecorationType(c,y.NotebookDecorationRenderOptions.from(b)),this.value={key:c,dispose(){m.$removeNotebookEditorDecorationType(c)}}}}e.NotebookEditorDecorationType=a,a._Keys=new d.IdGenerator("NotebookEditorDecorationType");class t{constructor(m,b,c,f,k,L,$){this._textDocumentsAndEditors=c,this._textDocuments=f,this._webviewInitData=k,this.logService=L,this._extensionStoragePaths=$,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new w.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new I.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new w.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=b.converter,b.registerArgumentProcessor({processArgument:ee=>{var H;if(ee&&ee.$mid===12){const x=(H=ee.notebookEditor)===null||H===void 0?void 0:H.notebookUri,B=ee.cell.handle,F=this._documents.get(x),U=F==null?void 0:F.getCell(B);if(U)return U.cell}return ee}})}get activeNotebookEditor(){var m;return(m=this._activeNotebookEditor)===null||m===void 0?void 0:m.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(m){return this._documents.get(m)}_getNotebookDocument(m){const b=this._documents.get(m);if(!b)throw new Error(`NO notebook document for '${m}'`);return b}_getProviderData(m){const b=this._notebookContentProviders.get(m);if(!b)throw new Error(`NO provider for '${m}'`);return b}registerNotebookContentProvider(m,b,c,f){var k,L,$;if(this._notebookContentProviders.has(b))throw new Error(`Notebook provider for '${b}' already registered`);this._notebookContentProviders.set(b,{extension:m,provider:c});let ee;c.onDidChangeNotebookContentOptions&&(ee=c.onDidChangeNotebookContentOptions(()=>{const B=y.NotebookDocumentContentOptions.from(c.options);this._notebookProxy.$updateNotebookProviderOptions(b,B)}));const H=(k=f==null?void 0:f.viewOptions)===null||k===void 0?void 0:k.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((L=f==null?void 0:f.viewOptions)===null||L===void 0?void 0:L.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${($=f==null?void 0:f.viewOptions)===null||$===void 0?void 0:$.filenamePattern}`);const x=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation,description:m.description},b,{transientOutputs:x.transientOutputs,transientMetadata:x.transientMetadata,viewOptions:(f==null?void 0:f.viewOptions)&&H?{displayName:f.viewOptions.displayName,filenamePattern:H,exclusive:f.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{ee==null||ee.dispose(),this._notebookContentProviders.delete(b),this._notebookProxy.$unregisterNotebookProvider(b)})}registerNotebookKernelProvider(m,b,c){const f=t._notebookKernelProviderHandlePool++,k=new u(this._notebookProxy,f,m,c);return this._notebookKernelProviders.set(f,k),this._notebookProxy.$registerNotebookKernelProvider({id:m.identifier,location:m.extensionLocation,description:m.description},f,{viewType:b.viewType,filenamePattern:b.filenamePattern?y.NotebookExclusiveDocumentPattern.from(b.filenamePattern):void 0}),new i.Disposable(()=>{k.dispose(),this._notebookKernelProviders.delete(f),this._notebookProxy.$unregisterNotebookKernelProvider(f)})}createNotebookEditorDecorationType(m){return new a(this._notebookEditorsProxy,m).value}async openNotebookDocument(m){const b=this._documents.get(m);if(b)return b.notebookDocument;const c=await this._notebookDocumentsProxy.$tryOpenDocument(m),f=this._documents.get(P.URI.revive(c));return(0,S.assertIsDefined)(f==null?void 0:f.notebookDocument)}_withAdapter(m,b,c){const f=this._documents.get(P.URI.revive(b));if(!f)return[];const k=this._notebookKernelProviders.get(m);return k?c(k,f):[]}async showNotebookDocument(m,b){var c;P.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let f;typeof b=="object"?f={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:b.selection&&y.NotebookCellRange.from(b.selection),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:f={preserveFocus:!1};const k=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.viewType,f),L=k&&((c=this._editors.get(k))===null||c===void 0?void 0:c.editor);if(L)return L.editor;throw k?new Error(`Could NOT open editor for "${m.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.toString()}".`)}async $provideNotebookKernels(m,b,c){return this._withAdapter(m,b,(f,k)=>f.provideKernels(k,c))}async $resolveNotebookKernel(m,b,c,f,k){await this._withAdapter(m,c,async(L,$)=>{const ee=this._webviewComm.get(b);ee&&await L.resolveNotebook(f,$,ee.contentProviderComm,k)})}async $resolveNotebookEditor(m,b,c){const f=this._notebookContentProviders.get(m),k=P.URI.revive(b),L=this._documents.get(k);if(!(!L||!f)){let $=this._webviewComm.get(c);$||($=new p(c,k,this._notebookProxy,this._webviewInitData,L),this._webviewComm.set(c,$))}}async $executeNotebookKernelFromProvider(m,b,c,f){await this._withAdapter(m,b,async(k,L)=>k.executeNotebook(c,L,f))}registerNotebookSerializer(m,b,c,f){const k=this._handlePool++;this._notebookSerializer.set(k,c);const L=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookSerializer(k,{id:m.identifier,location:m.extensionLocation,description:m.description},b,L),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(k)})}async $dataToNotebook(m,b){const c=this._notebookSerializer.get(m);if(!c)throw new Error("NO serializer found");const f=await c.dataToNotebook(b.buffer);return{metadata:y.NotebookDocumentMetadata.from(f.metadata),cells:f.cells.map(y.NotebookCellData.from)}}async $notebookToData(m,b){const c=this._notebookSerializer.get(m);if(!c)throw new Error("NO serializer found");const f=await c.notebookToData({metadata:y.NotebookDocumentMetadata.to(b.metadata),cells:b.cells.map(y.NotebookCellData.to)});return v.VSBuffer.wrap(f)}async $cancelNotebookCellExecution(m,b,c,f){await this._withAdapter(m,b,async(L,$)=>L.interruptNotebookExecution(c,$));const k=this._documents.get(P.URI.revive(b));if(!!k)for(let L of f)for(let $=L.start;$<L.end;$++){const ee=k.getCellFromIndex($);ee&&this.cancelOneNotebookCellExecution(ee)}}cancelOneNotebookCellExecution(m){const b=this._activeExecutions.get(m.uri);b==null||b.cancel()}async $openNotebook(m,b,c,f,k){const{provider:L}=this._getProviderData(m),$=await L.openNotebook(P.URI.revive(b),{backupId:c,untitledDocumentData:f==null?void 0:f.buffer},k);return{metadata:y.NotebookDocumentMetadata.from($.metadata),cells:$.cells.map(y.NotebookCellData.from)}}async $saveNotebook(m,b,c){const f=this._getNotebookDocument(P.URI.revive(b)),{provider:k}=this._getProviderData(m);return await k.saveNotebook(f.notebookDocument,c),!0}async $saveNotebookAs(m,b,c,f){const k=this._getNotebookDocument(P.URI.revive(b)),{provider:L}=this._getProviderData(m);return await L.saveNotebookAs(P.URI.revive(c),k.notebookDocument,f),!0}async $backupNotebook(m,b,c){var f;const k=this._getNotebookDocument(P.URI.revive(b)),L=this._getProviderData(m),$=(f=this._extensionStoragePaths.workspaceValue(L.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(L.extension),ee=String((0,_.hash)([k.uri.toString(),this._backupIdPool++])),H=P.URI.joinPath($,ee),x=await L.provider.backupNotebook(k.notebookDocument,{destination:H},c);return k.updateBackup(x),x.id}$acceptNotebookActiveKernelChange(m){m.providerHandle!==void 0&&this._withAdapter(m.providerHandle,m.uri,async(b,c)=>{const f=m.kernelFriendlyId?b.getKernelByFriendlyId(P.URI.revive(m.uri),m.kernelFriendlyId):void 0;this._editors.forEach(k=>{k.editor.notebookData===c&&k.editor._acceptKernel(f)}),this._onDidChangeActiveNotebookKernel.fire({document:c.notebookDocument,kernel:f})})}$onDidReceiveMessage(m,b,c){var f;(f=this._webviewComm.get(m))===null||f===void 0||f.onDidReceiveMessage(b,c)}$acceptModelChanged(m,b,c){this._getNotebookDocument(P.URI.revive(m)).acceptModelChanged(b,c)}$acceptDirtyStateChanged(m,b){const c=this._getNotebookDocument(P.URI.revive(m));c.acceptModelChanged({rawEvents:[],versionId:c.notebookDocument.version},b)}$acceptModelSaved(m){const b=this._getNotebookDocument(P.URI.revive(m));this._onDidSaveNotebookDocument.fire(b.notebookDocument)}$acceptEditorPropertiesChanged(m,b){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,b);const c=this._editors.get(m);if(!c)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);b.visibleRanges&&c.editor._acceptVisibleRanges(b.visibleRanges.ranges.map(y.NotebookCellRange.to)),b.selections&&c.editor._acceptSelections(b.selections.selections.map(y.NotebookCellRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:c.editor.editor,visibleRanges:c.editor.editor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:c.editor.editor,selections:c.editor.editor.selections}))}$acceptEditorViewColumns(m){for(const b in m){const c=this._editors.get(b);if(!c)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);c.editor._acceptViewColumn(y.ViewColumn.to(m[b]))}}$acceptDocumentPropertiesChanged(m,b){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",m.path,b);const c=this._getNotebookDocument(P.URI.revive(m));c.acceptDocumentPropertiesChanged(b),b.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:c.notebookDocument})}_createExtHostEditor(m,b,c){var f;const k=m.uri;let L=this._webviewComm.get(b);L||(L=new p(b,k,this._notebookProxy,this._webviewInitData,m),this._webviewComm.set(b,L));const $=new s.ExtHostNotebookEditor(b,this._notebookEditorsProxy,m,c.visibleRanges.map(y.NotebookCellRange.to),c.selections.map(y.NotebookCellRange.to),typeof c.viewColumn=="number"?y.ViewColumn.to(c.viewColumn):void 0);(f=this._editors.get(b))===null||f===void 0||f.editor.dispose(),this._editors.set(b,{editor:$})}$acceptDocumentAndEditorsDelta(m){var b,c,f,k;let L=!1;if(m.removedDocuments)for(const ee of m.removedDocuments){const H=P.URI.revive(ee),x=this._documents.get(H);x&&(x.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.getCells().map(B=>B.document.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const B of this._editors.values())B.editor.notebookData.uri.toString()===H.toString()&&(B.editor.dispose(),this._editors.delete(B.editor.id),L=!0)}if(m.addedDocuments){const ee=[];for(const H of m.addedDocuments){const x=P.URI.revive(H.uri),B=H.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x} `);const F=this,U=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){F._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){F._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){F._onDidChangeCellMetadata.fire(M)},emitCellExecutionStateChange(M){F._onDidChangeCellExecutionState.fire(M)}},B,H.metadata?y.NotebookDocumentMetadata.to(H.metadata):new i.NotebookDocumentMetadata,x);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),ee.push(...H.cells.map(M=>g.ExtHostCell.asModelAddData(U.notebookDocument,M))),(b=this._documents.get(x))===null||b===void 0||b.dispose(),this._documents.set(x,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:ee}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(m.addedEditors)for(const ee of m.addedEditors){if(this._editors.has(ee.id))return;const H=P.URI.revive(ee.documentUri),x=this._documents.get(H);x&&(this._createExtHostEditor(x,ee.id,ee),L=!0)}const $=[];if(m.removedEditors)for(const ee of m.removedEditors){const H=this._editors.get(ee);H&&(L=!0,this._editors.delete(ee),((c=this._activeNotebookEditor)===null||c===void 0?void 0:c.id)===H.editor.id&&(this._activeNotebookEditor=void 0),$.push(H))}if(L&&$.forEach(ee=>{ee.editor.dispose()}),m.visibleEditors){this._visibleNotebookEditors=m.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const ee=new Set;this._visibleNotebookEditors.forEach(H=>ee.add(H.id));for(const H of this._editors.values()){const x=ee.has(H.editor.id);H.editor._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.newActiveEditor===null?this._activeNotebookEditor=void 0:m.newActiveEditor&&(this._activeNotebookEditor=(f=this._editors.get(m.newActiveEditor))===null||f===void 0?void 0:f.editor),m.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((k=this._activeNotebookEditor)===null||k===void 0?void 0:k.editor)}createNotebookCellStatusBarItemInternal(m,b,c){const f=new n(this._notebookProxy,this._commandsConverter,m,b,c),k=C.CellUri.parse(m.document.uri);if(k){const L=this._documents.get(k.notebook);if(L){const $=L.getCell(k.handle);$&&I.Event.once($.onDidDispose)(()=>f.dispose())}}return f}createNotebookCellExecution(m,b,c){const f=this.lookupNotebookDocument(m);if(!f)throw new Error(`Invalid cell uri / index: ${m}, ${b} `);const k=f.getCellFromIndex(b);if(!k)throw new Error(`Invalid cell uri / index: ${m}, ${b} `);if(!this._activeExecutions.has(k.uri)){const L=new l(m,f,k,this._notebookDocumentsProxy);this._activeExecutions.set(k.uri,L);const $=L.onDidChangeState(()=>{L.state===r.Resolved&&(L.dispose(),$.dispose(),this._activeExecutions.delete(k.uri))});return L.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class n extends T.Disposable{constructor(m,b,c,f,k){super();this._proxy=m,this._commands=b,this._cell=c,this._priority=k,this._id=n.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=f!=null?f:i.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(m){this._alignment=m,this.update()}get priority(){return this._priority}set priority(m){this._priority=m,this.update()}get text(){return this._text}set text(m){this._text=m,this.update()}get tooltip(){return this._tooltip}set tooltip(m){this._tooltip=m,this.update()}get command(){var m;return(m=this._command)===null||m===void 0?void 0:m.fromApi}set command(m){var b;((b=this._command)===null||b===void 0?void 0:b.fromApi)!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:this._commands.toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:this._commands.toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var m;if(!this._isDisposed){const b={alignment:this.alignment===i.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(m=this._command)===null||m===void 0?void 0:m.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,b)}}}e.NotebookCellStatusBarItemInternal=n,n.NEXT_ID=0;function o(h){return Object.freeze({cell:h.cell,get alignment(){return h.alignment},set alignment(m){h.alignment=m},get priority(){return h.priority},set priority(m){h.priority=m},get text(){return h.text},set text(m){h.text=m},get tooltip(){return h.tooltip},set tooltip(m){h.tooltip=m},get command(){return h.command},set command(m){h.command=m},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(m){h.accessibilityInformation=m},show(){h.show()},hide(){h.hide()},dispose(){h.dispose()}})}var r;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(r||(r={}));class l extends T.Disposable{constructor(m,b,c,f){super();this._uri=m,this._document=b,this._cell=c,this._proxy=f,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=c.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(m){return this._proxy.$applyEdits(this._uri,m,!1)}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(m){const b=[{editType:11,handle:this._cell.handle,metadata:m}];this.applyEdits(b)}cellIndexToHandle(m){const b=typeof m=="number"?this._document.getCellFromIndex(m):this._cell;if(!!b)return b.handle}asApiObject(){const m=this;return Object.freeze({get document(){return m._document.notebookDocument},get cell(){return m._cell.cell},get executionOrder(){return m._executionOrder},set executionOrder(b){m._executionOrder=b,m.mixinMetadata({executionOrder:b})},start(b){if(m._state===r.Resolved||m._state===r.Started)throw new Error("Cannot call start again");m._state=r.Started,m._onDidChangeState.fire(),m.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:b==null?void 0:b.startTime})},end(b){var c,f;if(m._state===r.Resolved)throw new Error("Cannot call resolve twice");m._state=r.Resolved,m._onDidChangeState.fire(),m.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(c=b==null?void 0:b.success)!==null&&c!==void 0?c:null,lastRunDuration:(f=b==null?void 0:b.duration)!==null&&f!==void 0?f:null})},clearOutput(b){return m.verifyStateForOutput(),this.replaceOutput([],b)},async appendOutput(b,c){m.verifyStateForOutput();const f=m.cellIndexToHandle(c);if(typeof f=="number")return b=Array.isArray(b)?b:[b],m.applyEdits([{editType:2,handle:f,append:!0,outputs:b.map(y.NotebookCellOutput.from)}])},async replaceOutput(b,c){m.verifyStateForOutput();const f=m.cellIndexToHandle(c);if(typeof f=="number")return b=Array.isArray(b)?b:[b],m.applyEdits([{editType:2,handle:f,outputs:b.map(y.NotebookCellOutput.from)}])},async appendOutputItems(b,c){return m.verifyStateForOutput(),b=Array.isArray(b)?b:[b],m.applyEdits([{editType:10,append:!0,items:b.map(y.NotebookCellOutputItem.from),outputId:c}])},async replaceOutputItems(b,c){return m.verifyStateForOutput(),b=Array.isArray(b)?b:[b],m.applyEdits([{editType:10,items:b.map(y.NotebookCellOutputItem.from),outputId:c}])},token:m._tokenSource.token})}}}),define(ge[63],ve([0,1,5,3,6,22,4,13]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(s,d,S,v){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=v,this._id=v.$register(this.name,d,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?P.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class i extends y{constructor(s,d){super(s,!1,void 0,d)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class R extends y{constructor(s,d,S){super(s,!0,d,S)}append(s){throw new Error("Not supported")}}class C{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(S=>S.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=C;let w=class{constructor(s){this._proxy=s.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new i(s,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new R(s,d,this._proxy)}};w=je([Ue(0,A.IExtHostRpcService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[242],ve([0,1,19,21,3,6,5,2,7,17,18,56]),function(Q,e,E,I,T,P,D,A,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(g,s,d){const S=g.getProxy(D.MainContext.MainThreadQuickOpen);class v{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,h,m=I.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(r),c=++this._instances,f=S.$show(c,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},m),k={},L=f.then(()=>k);return Promise.race([L,b]).then($=>{if($!==k)return b.then(ee=>{const H=[];for(let x=0;x<ee.length;x++){const B=ee[x];let F,U,M,N,O;typeof B=="string"?F=B:(F=B.label,U=B.description,M=B.detail,N=B.picked,O=B.alwaysShow),H.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{h.onDidSelectItem(ee[x])}),S.$setItems(c,H),f.then(x=>{if(typeof x=="number")return ee[x];if(Array.isArray(x))return x.map(B=>ee[B])})})}).then(void 0,$=>{if(!(0,i.isPromiseCanceledError)($))return S.$setError(c,$),Promise.reject($)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=I.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",l).then(void 0,h=>{if(!(0,i.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(r){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=I.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!h){const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(b=>b.uri.toString()===h.uri.toString())}}createQuickPick(r,l){const h=new t(r,l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const l=new n(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const h=this._sessions.get(r);h&&h._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const h=this._sessions.get(r);h&&h._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class _{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,h)=>{const m=l===y.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(m,l)}),this.update({buttons:r.map((l,h)=>({iconPath:p(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const h=r[l];this._pendingUpdate[l]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function p(o){if(o instanceof y.ThemeIcon)return{id:o.id};const r=a(o),l=u(o);return{dark:typeof r=="string"?A.URI.file(r):r,light:typeof l=="string"?A.URI.file(l):l}}function u(o){return typeof o=="object"&&"light"in o?o.light:o}function a(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends _{constructor(r,l,h){super(r,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,h)=>{this._handlesToItems.set(h,l),this._itemsToHandles.set(l,h)}),this.update({items:r.map((l,h)=>({label:l.label,description:l.description,handle:h,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class n extends _{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new v(s,d)}e.createExtHostQuickOpen=w}),define(ge[243],ve([0,1,2,3,68,6,19,5,18,95,12,29,41]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?E.URI.file(r.iconPath):r.iconPath}function s(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const h=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,m=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,i.comparePaths)(h,m)}function d(r,l){let h=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(h=s(r,l),h!==0)return h;if(r.light&&l.light)h=s(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(h!==0)return h;if(r.dark&&l.dark)h=s(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return h}function S(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let h=0;h<r.arguments.length;h++){const m=r.arguments[h],b=l.arguments[h];if(m!==b)return m<b?-1:1}return 0}function v(r,l){let h=(0,i.comparePaths)(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(h!==0)return h;if(r.command&&l.command)h=S(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(h!==0)return h;if(r.decorations&&l.decorations)h=d(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return h}function _(r,l){for(let h=0;h<r.length;h++)if(r[h]!==l[h])return!1;return!0}function p(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?_(r.arguments,l.arguments):r.arguments===l.arguments)}function u(r,l){return(0,y.equals)(r,l,p)}class a{constructor(l,h,m){this._extension=l,this._proxy=h,this._sourceControlHandle=m,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,w.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=a;class t{constructor(l,h,m,b,c){this._proxy=l,this._commands=h,this._sourceControlHandle=m,this._id=b,this._label=c,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,h){const m=this._resourceStatesCommandsMap.get(l);return m?(0,D.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const h=[...this._resourceStates].sort(v),b=(0,y.sortedDiff)(this._resourceSnapshot,h,v).map(k=>{const L=k.toInsert.map($=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,$);const H=$.resourceUri,x=g($.decorations),B=$.decorations&&g($.decorations.light)||x,F=$.decorations&&g($.decorations.dark)||x,U=[];let M;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const me=new P.DisposableStore;M=this._commands.converter.toInternal($.command,me),this._resourceStatesDisposablesMap.set(ee,me)}else this._resourceStatesCommandsMap.set(ee,$.command);B&&U.push(B),F&&F.toString()!==(B==null?void 0:B.toString())&&U.push(F);const N=$.decorations&&$.decorations.tooltip||"",O=$.decorations&&!!$.decorations.strikeThrough,j=$.decorations&&!!$.decorations.faded,K=$.contextValue||"";return{rawResource:[ee,H,U,N,O,j,K,M],handle:ee}});return{start:k.start,deleteCount:k.deleteCount,toInsert:L}}),c=b.map(({start:k,deleteCount:L,toInsert:$})=>[k,L,$.map(ee=>ee.rawResource)]),f=b.reverse();for(const{start:k,deleteCount:L,toInsert:$}of f){const ee=$.map(x=>x.handle),H=this._handlesSnapshot.splice(k,L,...ee);for(const x of H)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(l=this._resourceStatesDisposablesMap.get(x))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=h,c}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(l,h,m,b,c,f){this._proxy=h,this._commands=m,this._id=b,this._label=c,this._rootUri=f,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,c,f)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=l;const h=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&u(this._statusBarCommands,l))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=l;const h=(l||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(l,h){const m=new t(this._proxy,this._commands,this.handle,l,h),b=I.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,b),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const l=[],h=[];for(const[m,b]of this.createdResourceGroups){b.dispose();const c=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});I.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),c.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),l.push([m.handle,m.id,m.label,m.features]);const f=m._takeResourceStateSnapshot();f.length>0&&h.push([m.handle,f]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,l,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(h=>{const m=h._takeResourceStateSnapshot();m.length!==0&&l.push([h.handle,m])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Ln{constructor(l,h,m){this._commands=h,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=l.getProxy(A.MainContext.MainThreadSCM),this._telemetry=l.getProxy(A.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const c=this._sourceControls.get(b.sourceControlHandle);if(!c)return b;const f=c.getResourceGroup(b.groupHandle);return f?f.getResourceState(b.handle):b}else if(b&&b.$mid===4){const c=this._sourceControls.get(b.sourceControlHandle);return c?c.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const c=this._sourceControls.get(b.handle);return c||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,h,m,b){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,h,m,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const c=Ln._handlePool++,f=new n(l,this._proxy,this._commands,h,m,b);this._sourceControls.set(c,f);const k=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier))||[];return k.push(f),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(l.identifier),k),f}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const h=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier)),m=h&&h[h.length-1];return m&&m.inputBox}$provideOriginalResource(l,h,m){const b=E.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,b.toString());const c=this._sourceControls.get(l);return!c||!c.quickDiffProvider||!c.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>c.quickDiffProvider.provideOriginalResource(b,m)).then(f=>f||null)}$onInputBoxValueChange(l,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const m=this._sourceControls.get(l);return m&&m.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(l,h,m,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,h,m);const c=this._sourceControls.get(l);if(!c)return Promise.resolve(void 0);const f=c.getResourceGroup(h);return f?f.$executeResourceCommand(m,b):Promise.resolve(void 0)}$validateInput(l,h,m){this.logService.trace("ExtHostSCM#$validateInput",l);const b=this._sourceControls.get(l);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>b.inputBox.validateInput(h,m)).then(c=>c?Promise.resolve([c.message,c.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var h,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((h=this._sourceControls.get(l))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};o._handlePool=0,o=je([Ue(2,R.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[244],ve([0,1,7,5,163,6]),function(Q,e,E,I,T,P){"use strict";var D,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(w,g,s,d,S=E.StatusBarAlignment.Left,v,_){D.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,D,w,"f"),tt(this,A,g,"f"),this._id=y.ID_GEN++,this._statusId=s,this._statusName=d,this._alignment=S,this._priority=v,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var w;return(w=this._command)===null||w===void 0?void 0:w.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!y.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:$e(this,A,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:$e(this,A,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,D,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var w;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,D,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(w=this._command)===null||w===void 0?void 0:w.internal,g,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,A=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(w){this._messages=[],this._item=w.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const g={message:w};return this._messages.unshift(g),this._update(),new E.Disposable(()=>{const s=this._messages.indexOf(g);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(w,g){this._proxy=w.getProxy(I.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new i(this)}createStatusBarEntry(w,g,s,d,S){return new y(this._proxy,this._commands,w,g,s,d,S)}setStatusBarMessage(w,g){const s=this._statusMessage.setMessage(w);let d;return typeof g=="number"?d=setTimeout(()=>s.dispose(),g):typeof g!="undefined"&&g.then(()=>s.dispose(),()=>s.dispose()),new E.Disposable(()=>{s.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=R}),define(ge[88],ve([0,1,5,3,4]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}getValue(A,y,i){return this._proxy.$getValue(A,y).then(R=>R||i)}setValue(A,y,i){return this._proxy.$setValue(A,y,i)}$acceptValue(A,y,i){this._onDidChangeStorage.fire({shared:A,key:y,value:i})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[89],ve([0,1,4,27,12,87,2]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let A=class{constructor(i,R,C){var w;this._logService=R,this._extHostFileSystem=C,this._workspace=(w=i.workspace)!==null&&w!==void 0?w:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=D.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(w){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=D.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),C}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(i){if(this._value)return D.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return D.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};A=je([Ue(0,I.IExtHostInitDataService),Ue(1,T.ILogService),Ue(2,P.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ge[34],ve([0,1,3,5,4,2,13,6,7,164,17,209,21,28,189]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,o,r){this._proxy=t,this._id=n,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(h,m=!0){l._checkDisposed(),l._proxy.$sendText(l._id,h,m)},show(h){l._checkDisposed(),l._proxy.$show(l._id,h)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,n,o,r,l,h,m,b,c,f,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:o,env:r,icon:l,initialText:h,waitOnExit:m,strictEnv:b,hideFromUser:c,isFeatureTerminal:f,isExtensionOwnedTerminal:k})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,_=class extends A.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new d(this._proxy,(0,g.generateUuid)(),t,t.name),o=new S(t.pty);return n.createExtensionTerminal().then(r=>{const l=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=l}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(n),l=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(t,n,o){const r=this._getTerminalById(t);r&&r.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}async $acceptTerminalTitleChange(t,n){const o=this._getTerminalById(t);o&&(o.name=n)}async $acceptTerminalClosed(t,n){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,o,r){if(n){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){this._terminals[m]._id=t,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const l={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:P.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},h=new d(this._proxy,t,l,o);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,n){const o=this._getTerminalById(t);o&&o._setProcessId(n)}async $startExtensionTerminal(t,n){const o=this._getTerminalById(t);if(!o)return{message:(0,i.localize)(0,null,t)};o.isOpen||await new Promise(l=>{const h=this.onDidOpenTerminal(async m=>{m===o.value&&(h.dispose(),l())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const o=new A.DisposableStore;o.add(n.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),o.add(n.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,n.onProcessData),o.add(n.onProcessExit(l=>this._onProcessExit(t,l))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof S&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(n)}$acceptProcessResize(t,n,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const l=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const h=[],m={terminal:o.value,line:n},b=[];for(const k of this._linkProviders)b.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:k,links:[]}));const $=await k.provideTerminalLinks(m,l.token)||[];l.token.isCancellationRequested||L({provider:k,links:$})}));const c=await Promise.all(b);if(l.token.isCancellationRequested)return[];const f=new Map;for(const k of c)k&&k.links.length>0&&h.push(...k.links.map(L=>{const $={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return f.set($.id,{provider:k.provider,link:L}),$}));return this._terminalLinkCache.set(t,f),h}$activateLink(t,n){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const o=this._getTerminalObjectIndexById(t,n);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,n){let o=null;return t.some((r,l)=>r._id===n?(o=l,!0):!1),o}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new p,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const o=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const o=n[0],r=new p(n[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=je([Ue(1,D.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const o=this.map.get(t);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((o,r)=>t.call(n,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let u=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,o){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,n){throw new R.NotSupportedError}getDefaultShellArgs(t,n){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};u=je([Ue(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[245],ve([0,1,3,18,5,122,20,7]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(w=>w.value)}async showTextDocument(R,C,w){let g;typeof C=="number"?g={position:D.ViewColumn.from(C),preserveFocus:w}:typeof C=="object"?g={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:g={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,g),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new P.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const w=this._extHostDocumentsAndEditors.getEditor(R);if(!w)throw new Error("unknown text editor");if(C.options&&w._acceptOptions(C.options),C.selections){const g=C.selections.selections.map(D.Selection.to);w._acceptSelections(g)}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(D.Range.to));w._acceptVisibleRanges(g)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const g=A.TextEditorSelectionChangeKind.fromValue(C.selections.source),s=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:s,kind:g})}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:g})}}$acceptEditorPositionData(R){for(const C in R){const w=this._extHostDocumentsAndEditors.getEditor(C);if(!w)throw new Error("Unknown text editor");const g=D.ViewColumn.to(R[C]);w.value.viewColumn!==g&&(w._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:g}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var mn=this&&this.__rest||function(Q,e){var E={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(E[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(Q);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[T])&&(E[I[T]]=Q[I[T]]);return E};define(ge[246],ve([0,1,2,4,5,6,7]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class A{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:w=>{var g,s;if(w&&w.$mid===11){const d=w.uri===void 0?void 0:E.URI.revive(w.uri);return(s=(g=this._itemsBySourceAndUriMap.get(w.source))===null||g===void 0?void 0:g.get(y(d)))===null||s===void 0?void 0:s.get(w.handle)}return w}})}async $getTimeline(R,C,w,g,s){const d=this._providers.get(R);return d==null?void 0:d.provideTimeline(E.URI.revive(C),w,g,s)}registerTimelineProvider(R,C,w,g){const s=new P.DisposableStore,d=this.convertTimelineItem(C.id,g,s).bind(this);let S;C.onDidChange&&(S=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(_,p,u,a){var t;(a==null?void 0:a.resetCache)&&(s.clear(),(t=v.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(_,p,u);if(n!=null){const o=d(_,a);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(o)})}},dispose(){var _;for(const p of v.values())(_=p.get(C.id))===null||_===void 0||_.clear();S==null||S.dispose(),s.dispose()}}))}convertTimelineItem(R,C,w){return(g,s)=>{let d;if(s==null?void 0:s.cacheResults){let S=this._itemsBySourceAndUriMap.get(R);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(R,S));const v=y(g);d=S.get(v),d===void 0&&(d=new Map,S.set(v,d))}return S=>{var v,_;const{iconPath:p}=S,u=mn(S,["iconPath"]),a=`${R}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;d==null||d.set(a,S);let t,n,o;return S.iconPath&&(p instanceof D.ThemeIcon?o={id:p.id}:E.URI.isUri(p)?(t=p,n=p):{light:t,dark:n}=p),Object.assign(Object.assign({},u),{id:(_=u.id)!==null&&_!==void 0?_:void 0,handle:a,source:R,command:S.command?C.toInternal(S.command,w):void 0,icon:t,iconDark:n,themeIcon:o,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,P.toDisposable)(()=>{var w;for(const g of this._itemsBySourceAndUriMap.values())(w=g.get(R.id))===null||w===void 0||w.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=A;function y(i){return i==null?void 0:i.toString()}}),define(ge[247],ve([0,1,6,11,2,5]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,i,R,C){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const w=C.schemes.find(g=>!D.supportedSchemes.has(g));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,R),this._proxy.$registerUriOpener(i,C.schemes,y,C.label),(0,E.toDisposable)(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(y,i,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const w=T.URI.revive(i);return C.canOpenExternalUri(w,R)}async $openUri(y,i,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(T.URI.revive(i.resolvedUri),{sourceUri:T.URI.revive(i.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[248],ve([0,1,5,2,6,17,29]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(i,R){if(this.handles.has(D.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const C=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(i)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,i),(0,T.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(i)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(i,R){const C=this.handlers.get(i);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(R))}catch(w){(0,P.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(i){return I.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=A,A.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[64],ve([0,1,22,3,2,176,199,84,5]),function(Q,e,E,I,T,P,D,A,y){"use strict";var i,R,C,w,g,s,d,S,v,_,p,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(c,f,k,L,$,ee,H){i.set(this,void 0),R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,""),S.set(this,void 0),v.set(this,!1),_.set(this,!1),p.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new I.Emitter),this._onDidDispose=$e(this,u,"f").event,tt(this,i,c,"f"),tt(this,R,f,"f"),tt(this,S,k,"f"),tt(this,w,L,"f"),tt(this,g,$,"f"),tt(this,s,ee,"f"),tt(this,p,t(ee),"f"),tt(this,C,H,"f")}dispose(){tt(this,v,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return tt(this,_,!0,"f"),(0,A.asWebviewUri)($e(this,w,"f"),$e(this,i,"f"),c)}get cspSource(){return $e(this,w,"f").webviewCspSource.replace("{{uuid}}",$e(this,i,"f"))}get html(){return this.assertNotDisposed(),$e(this,d,"f")}set html(c){this.assertNotDisposed(),$e(this,d,"f")!==c&&(tt(this,d,c,"f"),!$e(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(tt(this,_,!0,"f"),$e(this,C,"f").report("Webview vscode-resource: uris",$e(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,R,"f").$setHtml($e(this,i,"f"),c))}get options(){return this.assertNotDisposed(),$e(this,S,"f")}set options(c){this.assertNotDisposed(),$e(this,R,"f").$setOptions($e(this,i,"f"),l($e(this,s,"f"),$e(this,g,"f"),c)),tt(this,S,c,"f")}async postMessage(c){if($e(this,v,"f"))return!1;const f=n(c,{serializeBuffersForPostMessage:$e(this,p,"f")});return $e(this,R,"f").$postMessage($e(this,i,"f"),f.message,...f.buffers)}assertNotDisposed(){if($e(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,i=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,_=new WeakMap,p=new WeakMap,u=new WeakMap;function t(b){if(!b.enableProposedApi)return!1;try{const c=(0,P.normalizeVersion)((0,P.parseVersion)(b.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=56}catch(c){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(b,c){if(c.serializeBuffersForPostMessage){const f=[],k=($,ee)=>{if(ee&&ee instanceof ArrayBuffer){let H=f.findIndex(x=>x.original===ee);if(H===-1){const x=new Uint8Array(ee),B=E.VSBuffer.wrap(x);H=f.length,f.push({original:ee,vsBuffer:B})}return{$$vscode_array_buffer_reference$$:!0,index:H}}return ee};return{message:JSON.stringify(b,k),buffers:f.map($=>$.vsBuffer)}}else return{message:JSON.stringify(b),buffers:[]}}e.serializeMessage=n;class o{constructor(c,f,k,L,$){this.initData=f,this.workspace=k,this._logService=L,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=c.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(c,f,...k){const L=this.getWebview(c);if(L){const{message:$}=(0,D.deserializeWebviewMessage)(f,k);L._onMessageEmitter.fire($)}}$onMissingCsp(c,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,f,k){const L=new a(c,this._webviewProxy,h(f),this.initData,this.workspace,k,this._deprecationService);return this._webviews.set(c,L),L._onDidDispose(()=>{this._webviews.delete(c)}),L}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=o;function r(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=r;function l(b,c,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||m(b,c)}}e.serializeWebviewOptions=l;function h(b){var c;return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:(c=b.localResourceRoots)===null||c===void 0?void 0:c.map(f=>T.URI.from(f))}}e.reviveOptions=h;function m(b,c){return[...((c==null?void 0:c.getWorkspaceFolders())||[]).map(f=>f.uri),b.extensionLocation]}}),define(ge[249],ve([0,1,21,73,6,11,25,2,20,64,116,5,7]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class s{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,o){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const l=new g(n,o);return this._documents.set(r,l),l}delete(t,n){const o=this.key(t,n.uri);this._documents.delete(o)}key(t,n){return`${t}@@@${n}`}}var d;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(d||(d={}));class S{constructor(){this._providers=new Map}addTextProvider(t,n,o){return this.add(0,t,n,o)}addCustomProvider(t,n,o){return this.add(1,t,n,o)}get(t){return this._providers.get(t)}add(t,n,o,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:o,provider:r}),new w.Disposable(()=>this._providers.delete(n))}}class v{constructor(t,n,o,r,l){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new s,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,o,r){const l=new T.DisposableStore;return _(o)?(l.add(this._editorProviders.addTextProvider(n,t,o)),this._proxy.$registerTextEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,i.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(n,t,o)),this.supportEditing(o)&&l.add(o.onDidChangeCustomDocument(h=>{const m=this.getCustomDocumentEntry(n,h.document.uri);if(p(h)){const b=m.addEdit(h);this._proxy.$onDidEdit(h.document.uri,n,b,h.label)}else this._proxy.$onContentChange(h.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,i.shouldSerializeBuffersForPostMessage)(t))),w.Disposable.from(l,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,o,r,l){var h;const m=this._editorProviders.get(n);if(!m)throw new Error(`No provider found for '${n}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${n}'`);const b=A.URI.revive(t),c=await m.provider.openCustomDocument(b,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},l);let f;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(f=(h=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(n,c,f),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=A.URI.revive(t),{document:l}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,l),l.dispose()}async $resolveWebviewEditor(t,n,o,r,l,h){const m=this._editorProviders.get(o);if(!m)throw new Error(`No provider found for '${o}'`);const b=y.ViewColumn.to(l),c=this._extHostWebview.createNewWebview(n,r.webviewOptions,m.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(n,o,r.title,b,r.panelOptions,c),k=A.URI.revive(t);switch(m.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,k);return m.provider.resolveCustomEditor(L,f,h)}case 0:{const L=this._extHostDocuments.getDocument(k);return m.provider.resolveCustomTextEditor(L,f,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,o){this.getCustomDocumentEntry(n,t).disposeEdits(o)}async $onMoveCustomEditor(t,n,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const h=A.URI.revive(n),m=this._extHostDocuments.getDocument(h);await r.provider.moveCustomTextEditor(m,l,E.CancellationToken.None)}async $undo(t,n,o,r){return this.getCustomDocumentEntry(n,t).undo(o,r)}async $redo(t,n,o,r){return this.getCustomDocumentEntry(n,t).redo(o,r)}async $revert(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,n,o,r){const l=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(l.document,A.URI.revive(o),r)}async $backup(t,n,o){const r=this.getCustomDocumentEntry(n,t),h=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(h),h.id}getCustomDocumentEntry(t,n){const o=this._documents.get(t,A.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const n=this._editorProviders.get(t),o=n==null?void 0:n.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function _(a){return typeof a.resolveCustomTextEditor=="function"}function p(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function u(a){const t=a.scheme===P.Schemas.file||a.scheme===P.Schemas.untitled?a.fsPath:a.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[250],ve([0,1,3,6,2,28,20,64,5,7]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";var R,C,w,g,s,d,S,v,_,p,u,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(h,m,b,c,f,k,L){super();R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,void 0),S.set(this,void 0),v.set(this,void 0),_.set(this,!0),p.set(this,!0),u.set(this,!1),a.set(this,this._register(new E.Emitter)),this.onDidDispose=$e(this,a,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,tt(this,R,h,"f"),tt(this,C,m,"f"),tt(this,w,b,"f"),tt(this,s,k,"f"),tt(this,v,f,"f"),tt(this,d,c,"f"),tt(this,g,L,"f")}dispose(){$e(this,u,"f")||(tt(this,u,!0,"f"),$e(this,a,"f").fire(),$e(this,C,"f").$disposeWebview($e(this,R,"f")),$e(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,g,"f")}get viewType(){return this.assertNotDisposed(),$e(this,w,"f")}get title(){return this.assertNotDisposed(),$e(this,d,"f")}set title(h){this.assertNotDisposed(),$e(this,d,"f")!==h&&(tt(this,d,h,"f"),$e(this,C,"f").$setTitle($e(this,R,"f"),h))}get iconPath(){return this.assertNotDisposed(),$e(this,S,"f")}set iconPath(h){this.assertNotDisposed(),$e(this,S,"f")!==h&&(tt(this,S,h,"f"),$e(this,C,"f").$setIconPath($e(this,R,"f"),T.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return $e(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,v,"f")=="number"&&$e(this,v,"f")<0))return $e(this,v,"f")}get active(){return this.assertNotDisposed(),$e(this,p,"f")}get visible(){return this.assertNotDisposed(),$e(this,_,"f")}_updateViewState(h){$e(this,u,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,p,h.active,"f"),tt(this,_,h.visible,"f"),tt(this,v,h.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(h,m){this.assertNotDisposed(),$e(this,C,"f").$reveal($e(this,R,"f"),{viewColumn:h?D.ViewColumn.from(h):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,_=new WeakMap,p=new WeakMap,u=new WeakMap,a=new WeakMap,t=new WeakMap;class o{constructor(h,m,b){this.webviews=m,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(h,m,b,c,f={}){const k=typeof c=="object"?c.viewColumn:c,L={viewColumn:D.ViewColumn.from(k),preserveFocus:typeof c=="object"&&!!c.preserveFocus},$=(0,A.shouldSerializeBuffersForPostMessage)(h),ee=o.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(h),ee,m,{title:b,panelOptions:r(f),webviewOptions:(0,A.serializeWebviewOptions)(h,this.workspace,f),serializeBuffersForPostMessage:$},L);const H=this.webviews.createNewWebview(ee,f,h);return this.createNewWebviewPanel(ee,m,b,k,f,H)}$onDidChangeWebviewPanelViewStates(h){const m=Object.keys(h);m.sort((b,c)=>{const f=h[b],k=h[c];return f.active?1:k.active?-1:+f.visible-+k.visible});for(const b of m){const c=this.getWebviewPanel(b);if(!!c){const f=h[b];c._updateViewState({active:f.active,visible:f.visible,viewColumn:D.ViewColumn.to(f.position)})}}}async $onDidDisposeWebviewPanel(h){const m=this.getWebviewPanel(h);m==null||m.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,m,b){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:b,extension:h}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(h)}),new i.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(h,m,b,c){const f=this._serializers.get(m);if(!f)throw new Error(`No serializer found for '${m}'`);const{serializer:k,extension:L}=f,$=this.webviews.createNewWebview(h,b.webviewOptions,L),ee=this.createNewWebviewPanel(h,m,b.title,c,b.panelOptions,$);await k.deserializeWebviewPanel(ee,b.state)}createNewWebviewPanel(h,m,b,c,f,k){const L=new n(h,this._proxy,m,b,c,f,k);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[251],ve([0,1,3,6,64,5,7]),function(Q,e,E,I,T,P,D){"use strict";var A,y,i,R,C,w,g,s,d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends I.Disposable{constructor(u,a,t,n,o,r){super();A.set(this,void 0),y.set(this,void 0),i.set(this,void 0),R.set(this,void 0),C.set(this,!1),w.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=$e(this,d,"f").event,S.set(this,this._register(new E.Emitter)),this.onDidDispose=$e(this,S,"f").event,tt(this,i,t,"f"),tt(this,g,n,"f"),tt(this,A,u,"f"),tt(this,y,a,"f"),tt(this,R,o,"f"),tt(this,w,r,"f")}dispose(){$e(this,C,"f")||(tt(this,C,!0,"f"),$e(this,S,"f").fire(),$e(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,g,"f")}set title(u){this.assertNotDisposed(),$e(this,g,"f")!==u&&(tt(this,g,u,"f"),$e(this,y,"f").$setWebviewViewTitle($e(this,A,"f"),u))}get description(){return this.assertNotDisposed(),$e(this,s,"f")}set description(u){this.assertNotDisposed(),$e(this,s,"f")!==u&&(tt(this,s,u,"f"),$e(this,y,"f").$setWebviewViewDescription($e(this,A,"f"),u))}get visible(){return $e(this,w,"f")}get webview(){return $e(this,R,"f")}get viewType(){return $e(this,i,"f")}_setVisible(u){u===$e(this,w,"f")||$e(this,C,"f")||(tt(this,w,u,"f"),$e(this,d,"f").fire())}show(u){this.assertNotDisposed(),$e(this,y,"f").$show($e(this,A,"f"),!!u)}assertNotDisposed(){if($e(this,C,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,y=new WeakMap,i=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap;class _{constructor(u,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,a,t,n){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(u),a,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(u,a,t,n,o){const r=this._viewProviders.get(a);if(!r)throw new Error(`No view provider found for '${a}'`);const{provider:l,extension:h}=r,m=this._extHostWebview.createNewWebview(u,{},h),b=new v(u,this._proxy,a,t,m,!0);this._webviewViews.set(u,b),await l.resolveWebviewView(b,{state:n},o)}async $onDidChangeWebviewViewVisibility(u,a){this.getWebviewView(u)._setVisible(a)}async $disposeWebviewView(u){const a=this.getWebviewView(u);this._webviewViews.delete(u),a.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const a=this._webviewViews.get(u);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=_}),define(ge[125],ve([0,1,3,5,2,11,10,4,13]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class Fn{constructor(C){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,w){let g;if(typeof C=="string"){g=C;try{C=T.URI.parse(C)}catch(s){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,g,w)}async asExternalUri(C,w){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const g=await this._proxy.$asExternalUri(C,w);return T.URI.from(g)}};i.InitialState={focused:!0},i=je([Ue(0,y.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ge[252],ve([0,1,8,48,28,51,6,5,2,13]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(w,g){super();const s=w.getProxy(A.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async d=>{const S=y.URI.file((0,E.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await s.$download(d,S),S})}};R=je([Ue(0,i.IExtHostRpcService),Ue(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ge[253],ve([0,1,2,8,145,26,37,63,27,13,6,12,109,44]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class s{constructor(_,p){this.file=p,this.appender=(0,w.createRotatingLogger)(_,p,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(_,p,u){super(_,!1,E.URI.file(p.file),u);this._appender=p}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,p){this._appender.flush(),super.show(_,p)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let S=class extends A.ExtHostOutputService{constructor(_,p,u){super(_);this.logService=p,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new R.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(_){if(_){const p=this._channels.get(_);p&&(this._visibleChannelDisposable.value=p.onDidAppend(()=>p.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this._doCreateOutChannel(_);return p.then(u=>u._id.then(a=>this._channels.set(a,u))),new A.LazyOutputChannel(_,p)}async _doCreateOutChannel(_){try{const p=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await P.SymlinkSupport.existsDirectory(p)||await D.promises.mkdir(p,{recursive:!0});const a=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=E.URI.file((0,I.join)(p,`${a}.log`)),n=new s(a,t.fsPath);return new d(_,n,this._proxy)}catch(p){return this.logService.error(p),new A.ExtHostPushOutputChannel(_,this._proxy)}}};S=je([Ue(0,i.IExtHostRpcService),Ue(1,C.ILogService),Ue(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(ge[254],ve([0,1,5,13,6,27,2,38,25,37,26,7,9,50,3,72,12]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(m,b,c){this.remoteAddress=m,this.localAddress=b,this._dispose=c,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(h){const m=h.trim().split(`
`),b=[];return m.forEach(f=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(f);k&&k.length>=3&&b.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),b.reduce((f,k)=>(f[k.socket]=k,f),{})}e.getSockets=_;function p(...h){const m=[].concat(...h.map(a));return[...new Map(m.filter(b=>b.st==="0A").map(b=>{const c=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:u(c[0]),port:parseInt(c[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=p;function u(h){let m="";if(h.length===8)for(let b=h.length-2;b>=0;b-=2)m+=parseInt(h.substr(b,2),16),b!==0&&(m+=".");else for(let b=h.length-4;b>=0;b-=4)m+=parseInt(h.substr(b,4),16).toString(16),b!==0&&(m+=":");return m}e.parseIpAddress=u;function a(h){const m=h.trim().split(`
`),b=m.shift().trim().split(/\s+/).filter(f=>f!=="rx_queue"&&f!=="tm->when");return m.map(f=>f.trim().split(/\s+/).reduce((k,L,$)=>(k[b[$]||$]=L,k),{}))}e.loadConnectionTable=a;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function n(h){const m=h.trim().split(`
`),b=[];return m.forEach(c=>{const f=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(c);f&&f.length>=4&&b.push({pid:parseInt(f[1],10),ppid:parseInt(f[2]),cmd:f[3]})}),b}e.getRootProcesses=n;async function o(h,m,b){const c=b.reduce((k,L)=>(k[L.pid]=L,k),{}),f=[];return h.forEach(({socket:k,ip:L,port:$})=>{var ee;const H=m[k]?m[k].pid:void 0,x=H?(ee=c[H])===null||ee===void 0?void 0:ee.cmd:void 0;H&&x&&!t(x)&&f.push({host:L,port:$,detail:x,pid:H})}),f}e.findPorts=o;function r(h,m,b){const c=new Map,f=n(m);for(const k of h){const L=b.get(k.port);if(L){c.set(k.port,L);continue}const $=f.find(ee=>ee.cmd.includes(`${k.port}`));if($){let ee=$,H;do H=f.find(x=>x.ppid===ee.pid),H&&(ee=H);while(H);c.set(k.port,{host:k.ip,port:k.port,pid:ee.pid,detail:ee.cmd,ppid:ee.ppid})}else c.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return c}e.tryFindRootPorts=r;let l=class extends T.Disposable{constructor(m,b,c){super();this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new s.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(E.MainContext.MainThreadTunnelService),w.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier} called openTunnel API for ${b.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(b,m.displayName);if(c){const f=new v(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(f),f}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,b){const c=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(c,{selector:m,provider:b}),this._proxy.$registerPortsAttributesProvider(m,c),new C.Disposable(()=>{this._portAttributesProviders.delete(c),this._proxy.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(m,b,c,f,k){const L=[];for(const ee of m){const H=this._portAttributesProviders.get(ee);if(!H)return[];L.push(...await Promise.all(b.map(async x=>H.provider.providePortAttributes(x,c,f,k))))}const $=L.filter(ee=>!!ee);return $.length>0?$.map(ee=>({autoForwardAction:ee.autoForwardAction,port:ee.port})):[]}async $registerCandidateFinder(m){if(!(m&&this._candidateFindingEnabled)){this._candidateFindingEnabled=m;let b=new d.MovingAverage,c;for(;this._candidateFindingEnabled;){const f=new Date().getTime(),k=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${k.map($=>$.port).join(", ")}`);const L=new Date().getTime()-f;b.update(L),(!c||JSON.stringify(c)!==JSON.stringify(k))&&(c=k,await this._proxy.$onFoundNewCandidates(c)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(b.value)))}}}async setTunnelExtensionFunctions(m){var b;return m?(m.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,await this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,await this._proxy.$setTunnelProvider((b=m.tunnelFeatures)!==null&&b!==void 0?b:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,b){if(this._extensionTunnels.has(m.host)){const c=this._extensionTunnels.get(m.host);c.has(m.port)&&(b&&c.get(m.port).disposeListener.dispose(),await c.get(m.port).tunnel.dispose(),c.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(m,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const f=await c;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const k=this._register(f.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(f.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:f,disposeListener:k}),g.TunnelDto.fromApiTunnel(f)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const b=await Promise.all(m.map(f=>{var k;return this._showCandidatePort(f.host,f.port,(k=f.detail)!==null&&k!==void 0?k:"")})),c=m.filter((f,k)=>b[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(f=>f.port).join(", ")} to ${c.map(f=>f.port).join(", ")}`),c}async findCandidatePorts(){let m="",b="";try{m=await i.promises.readFile("/proc/net/tcp","utf8"),b=await i.promises.readFile("/proc/net/tcp6","utf8")}catch(F){}const c=p(m,b),f=await new Promise(F=>{(0,A.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,M,N)=>{F(M)})}),k=_(f),L=await R.readdir("/proc"),$=[];for(let F of L)try{const U=Number(F),M=y.joinPath(D.URI.file("/proc"),F);if((await i.promises.stat(M.fsPath)).isDirectory()&&!isNaN(U)){const O=await i.promises.readlink(y.joinPath(M,"cwd").fsPath),j=await i.promises.readFile(y.joinPath(M,"cmdline").fsPath,"utf8");$.push({pid:U,cwd:O,cmd:j})}}catch(U){}const ee=[],H=c.filter(F=>{const U=k[F.socket];return U||ee.push(F),U}),x=o(H,k,$);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ee.length}`),ee.length>0){const F=await new Promise(U=>{(0,A.exec)("ps -F -A -l | grep root",(M,N,O)=>{U(N)})});this._foundRootPorts=r(ee,F,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return x.then(F=>B?F.concat(B):F)}};l=je([Ue(0,I.IExtHostRpcService),Ue(1,P.IExtHostInitDataService),Ue(2,S.ILogService)],l),e.ExtHostTunnelService=l}),define(ge[255],ve([0,1,19,21,17,3,6,97,226,123,22]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function w(r,l){try{return JSON.stringify(r,l)}catch(h){return"null"}}function g(r,l){return JSON.stringify(r,l)}function s(r){return r?(l,h)=>h&&h.$mid===1?r.transformOutgoing(h):h:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},_=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class u extends D.Disposable{constructor(l,h=null,m=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=h,this._uriTransformer=m,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,c=i.ProxyIdentifier.count;b<c;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,A.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:h,sid:m}=l;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,m)),this._proxies[h]}_createProxy(l,h){let m={get:(b,c)=>(typeof c=="string"&&!b[c]&&c.charCodeAt(0)===36&&(b[c]=(...f)=>this._remoteCall(l,c,f)),c===p?h:b[c])};return new Proxy(Object.create(null),m)}set(l,h){return this._locals[l.nid]=h,h}assertRegistered(l){for(let h=0,m=l.length;h<m;h++){const b=l[h];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const h=l.byteLength,m=a.read(l,0),b=m.readUInt8(),c=m.readUInt32();switch(b){case 1:case 2:{let{rpcId:f,method:k,args:L}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,c,f,k,L,b===2);break}case 3:case 4:{let{rpcId:f,method:k,args:L}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,c,f,k,L,b===4);break}case 5:{this._logger&&this._logger.logIncoming(h,c,0,"ack"),this._onDidReceiveAcknowledge(c);break}case 6:{this._receiveCancel(h,c);break}case 7:{this._receiveReply(h,c,void 0);break}case 9:{let f=t.deserializeReplyOKJSON(m);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReply(h,c,f);break}case 8:{let f=t.deserializeReplyOKVSBuffer(m);this._receiveReply(h,c,f);break}case 10:{let f=t.deserializeReplyErrError(m);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReplyErr(h,c,f);break}case 11:{this._receiveReplyErr(h,c,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,h,m,b,c,f){this._logger&&this._logger.logIncoming(l,h,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(m)}.${b}(`,c);const k=String(h);let L,$;if(f){const H=new I.CancellationTokenSource;c.push(H.token),L=this._invokeHandler(m,b,c),$=()=>H.cancel()}else L=this._invokeHandler(m,b,c),$=v;this._cancelInvokedHandlers[k]=$;const ee=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(ee.byteLength,h,1,"ack"),this._protocol.send(ee),L.then(H=>{delete this._cancelInvokedHandlers[k];const x=t.serializeReplyOK(h,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"reply:",H),this._protocol.send(x)},H=>{delete this._cancelInvokedHandlers[k];const x=t.serializeReplyErr(h,H);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"replyErr:",H),this._protocol.send(x)})}_receiveCancel(l,h){this._logger&&this._logger.logIncoming(l,h,1,"receiveCancel");const m=String(h);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(l,h,m){this._logger&&this._logger.logIncoming(l,h,0,"receiveReply:",m);const b=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(b)){const c=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],c.resolveOk(m)}}_receiveReplyErr(l,h,m){this._logger&&this._logger.logIncoming(l,h,0,"receiveReplyErr:",m);const b=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(b)){const c=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let f;m&&(m.$isError?(f=new Error,f.name=m.name,f.message=m.message,f.stack=m.stack):f=m),c.resolveErr(f)}}_invokeHandler(l,h,m){try{return Promise.resolve(this._doInvokeHandler(l,h,m))}catch(b){return Promise.reject(b)}}_doInvokeHandler(l,h,m){const b=this._locals[l];if(!b)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(l));let c=b[h];if(typeof c!="function")throw new Error("Unknown method "+h+" on actor "+(0,i.getStringIdentifierForProxy)(l));return c.apply(b,m)}_remoteCall(l,h,m){if(this._isDisposed)return Promise.reject(T.canceled());let b=null;if(m.length>0&&I.CancellationToken.isCancellationToken(m[m.length-1])&&(b=m.pop()),b&&b.isCancellationRequested)return Promise.reject(T.canceled());const c=t.serializeRequestArguments(m,this._uriReplacer),f=++this._lastMessageId,k=String(f),L=new y.LazyPromise;b&&b.onCancellationRequested(()=>{const ee=t.serializeCancel(f);this._logger&&this._logger.logOutgoing(ee.byteLength,f,0,"cancel"),this._protocol.send(t.serializeCancel(f))}),this._pendingRPCReplies[k]=L,this._onWillSendRequest(f);const $=t.serializeRequest(f,l,h,c,!!b);return this._logger&&this._logger.logOutgoing($.byteLength,f,0,`request: ${(0,i.getStringIdentifierForProxy)(l)}.${h}(`,m),this._protocol.send($),L}}e.RPCProtocol=u,C=_,u.UNRESPONSIVE_TIME=3*1e3;class a{constructor(l,h){this._buff=l,this._offset=h}static alloc(l,h,m){let b=new a(R.VSBuffer.alloc(m+1+4),0);return b.writeUInt8(l),b.writeUInt32(h),b}static read(l,h){return new a(l,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,h}static sizeMixedArray(l,h){let m=0;m+=1;for(let b=0,c=l.length;b<c;b++){const f=l[b],k=h[b];switch(m+=1,k){case 1:m+=this.sizeLongString(f);break;case 2:m+=this.sizeVSBuffer(f);break;case 3:break}}return m}writeMixedArray(l,h){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let m=0,b=l.length;m<b;m++){const c=l[m];switch(h[m]){case 1:this.writeUInt8(1),this.writeLongString(c);break;case 2:this.writeUInt8(2),this.writeVSBuffer(c);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(l);for(let m=0;m<l;m++)switch(this.readUInt8()){case 1:h[m]=this.readLongString();break;case 2:h[m]=this.readVSBuffer();break;case 3:h[m]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(l){for(let h=0,m=l.length;h<m;h++)if(l[h]instanceof R.VSBuffer||typeof l[h]=="undefined")return!0;return!1}static serializeRequestArguments(l,h){if(this._arrayContainsBufferOrUndefined(l)){let m=[],b=[];for(let c=0,f=l.length;c<f;c++){const k=l[c];k instanceof R.VSBuffer?(m[c]=k,b[c]=2):typeof k=="undefined"?(m[c]=R.VSBuffer.alloc(0),b[c]=3):(m[c]=R.VSBuffer.fromString(g(k,h)),b[c]=1)}return{type:"mixed",args:m,argsType:b}}return{type:"simple",args:g(l,h)}}static serializeRequest(l,h,m,b,c){return b.type==="mixed"?this._requestMixedArgs(l,h,m,b.args,b.argsType,c):this._requestJSONArgs(l,h,m,b.args,c)}static _requestJSONArgs(l,h,m,b,c){const f=R.VSBuffer.fromString(m),k=R.VSBuffer.fromString(b);let L=0;L+=a.sizeUInt8(),L+=a.sizeShortString(f),L+=a.sizeLongString(k);let $=a.alloc(c?2:1,l,L);return $.writeUInt8(h),$.writeShortString(f),$.writeLongString(k),$.buffer}static deserializeRequestJSONArgs(l){const h=l.readUInt8(),m=l.readShortString(),b=l.readLongString();return{rpcId:h,method:m,args:JSON.parse(b)}}static _requestMixedArgs(l,h,m,b,c,f){const k=R.VSBuffer.fromString(m);let L=0;L+=a.sizeUInt8(),L+=a.sizeShortString(k),L+=a.sizeMixedArray(b,c);let $=a.alloc(f?4:3,l,L);return $.writeUInt8(h),$.writeShortString(k),$.writeMixedArray(b,c),$.buffer}static deserializeRequestMixedArgs(l){const h=l.readUInt8(),m=l.readShortString(),b=l.readMixedArray(),c=new Array(b.length);for(let f=0,k=b.length;f<k;f++){const L=b[f];typeof L=="string"?c[f]=JSON.parse(L):c[f]=L}return{rpcId:h,method:m,args:c}}static serializeAcknowledged(l){return a.alloc(5,l,0).buffer}static serializeCancel(l){return a.alloc(6,l,0).buffer}static serializeReplyOK(l,h,m){return typeof h=="undefined"?this._serializeReplyOKEmpty(l):h instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(l,h):this._serializeReplyOKJSON(l,w(h,m))}static _serializeReplyOKEmpty(l){return a.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,h){let m=0;m+=a.sizeVSBuffer(h);let b=a.alloc(8,l,m);return b.writeVSBuffer(h),b.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,h){const m=R.VSBuffer.fromString(h);let b=0;b+=a.sizeLongString(m);let c=a.alloc(9,l,b);return c.writeLongString(m),c.buffer}static deserializeReplyOKJSON(l){const h=l.readLongString();return JSON.parse(h)}static serializeReplyErr(l,h){return h?this._serializeReplyErrEror(l,h):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,h){const m=R.VSBuffer.fromString(w(T.transformErrorForSerialization(h),null));let b=0;b+=a.sizeLongString(m);let c=a.alloc(10,l,b);return c.writeLongString(m),c.buffer}static deserializeReplyErrError(l){const h=l.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(l){return a.alloc(11,l,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[256],ve([0,1,4]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ge[257],ve([0,1,11,8,9,2,4,256]),function(Q,e,E,I,T,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||T.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?I.win32:I.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const g=R.indexOf("/",2);g===-1?(C=R.substring(2),R="/"):(C=R.substring(2,g),R=R.substring(g)||"/")}return P.URI.from({scheme:E.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([Ue(1,A.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ge[31],ve([0,1,18,33,23,30,10,4,8,17]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",w=(R.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var g;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function d(F){return!!F.preview}e.resultIsMatch=d;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var _;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=p;class u{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&a(O)){U=(0,D.getNLines)(U,N.matchLines);let j="",K=0,X=0;const me=Math.floor(N.charsPerLine/5),we=[];for(const Ae of O){const Ie=Math.max(Ae.startColumn-me,0),Me=Ae.startColumn+N.charsPerLine;if(Ie>X+me+w){const V=R+(Ie-X)+C;j+=V+U.slice(Ie,Me),K+=Ie-(X+V.length)}else j+=U.slice(X,Me);we.push(new n(0,Ae.startColumn-K,Ae.endColumn-K)),X=Me}this.preview={text:j,matches:Array.isArray(this.ranges)?we:we[0]}}else{const j=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,E.mapArrayOrNot)(M,K=>new t(K.startLineNumber-j,K.startColumn,K.endLineNumber-j,K.endColumn))}}}}e.TextSearchMatch=u;function a(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class n extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=n;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=T.mixin(O,T.deepClone(M)),O=T.mixin(O,T.deepClone(N),!0),O}}e.getExcludes=r;function l(F,U){return F.excludePattern&&I.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&I.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(P.isEqualOrParent(U,N)){const O=y.relative(N,U);return!M.includePattern||!!I.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var h;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=m;function b(F){const U=F.message;if((0,i.isPromiseCanceledError)(F))return new m(U,h.canceled);try{const M=JSON.parse(U);return new m(M.message,M.code)}catch(M){return new m(U,h.other)}}e.deserializeSearchError=b;function c(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=c;function f(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=f;function k(F){return F.type==="success"}e.isSerializedSearchSuccess=k;function L(F){return!!F.path}e.isSerializedFileMatch=L;function $(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,D.fuzzyContains)(M,U)}e.isFilePatternMatch=$;class ee{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function H(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=H;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=I.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(K=>!!K):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=x;function B(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(ge[32],ve([0,1,18,19,21,3,24,11,72,25,10,14,2,166,4,12,185,59,60,27,13,7,31,5]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p,u,a,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(k,L,$){return new i.ExtUri(ee=>m(ee,$)).isEqual(k,L)}function r(k,L,$){return o(k.uri,L.uri,$)?0:(0,R.compare)(k.uri.toString(),L.uri.toString())}function l(k,L,$){return k.index!==L.index?k.index<L.index?-1:1:o(k.uri,L.uri,$)?(0,R.compare)(k.name,L.name):(0,R.compare)(k.uri.toString(),L.uri.toString())}function h(k,L,$,ee){const H=k.slice(0).sort((B,F)=>$(B,F,ee)),x=L.slice(0).sort((B,F)=>$(B,F,ee));return(0,E.delta)(H,x,(B,F)=>$(B,F,ee))}function m(k,L){const $=L.getCapabilities(k.scheme);return!($&&$&1024)}class b extends v.Workspace{constructor(L,$,ee,H,x,B){super(L,ee.map(F=>new v.WorkspaceFolder(F)),H,B);this._name=$,this._isUntitled=x,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(B),ee.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,$,ee,H){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:B,folders:F,configuration:U,isUntitled:M}=L,N=[],O=$;$?F.forEach((me,we)=>{const Ae=w.URI.revive(me.uri),Ie=b._findFolder(ee||$,Ae,H);Ie?(Ie.name=me.name,Ie.index=me.index,N.push(Ie)):N.push({uri:Ae,name:me.name,index:we})}):N.push(...F.map(({uri:me,name:we,index:Ae})=>({uri:w.URI.revive(me),name:we,index:Ae}))),N.sort((me,we)=>me.index<we.index?-1:1);const j=new b(x,B,N,U?w.URI.revive(U):null,!!M,me=>m(me,H)),{added:K,removed:X}=h(O?O.workspaceFolders:[],j.workspaceFolders,r,H);return{workspace:j,added:K,removed:X}}static _findFolder(L,$,ee){for(let H=0;H<L.folders.length;H++){const x=L.workspaceFolders[H];if(o(x.uri,$,ee))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,$){return $&&this._structure.get(L)&&(L=(0,i.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let c=class{constructor(L,$,ee,H){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=a.WorkspaceTrustState.Unspecified,this._logService=H,this._extHostFileSystemInfo=ee,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const x=$.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],x.configuration?w.URI.revive(x.configuration):null,!!x.isUntitled,B=>m(B,ee)):void 0}$initializeWorkspace(L,$){this._workspaceTrustState=$,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?w.URI.from({scheme:A.Schemas.untitled,path:(0,i.basename)((0,i.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,ee,...H){const x=[];if(Array.isArray(H)&&H.forEach(N=>{w.URI.isUri(N.uri)&&!x.some(O=>o(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[$,ee].some(N=>typeof N!="number"||N<0)||ee===0&&x.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+ee>B.length)return!1;const F=B.slice(0);F.splice($,ee,...x.map(N=>({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((j,K)=>K!==N&&o(O.uri,j.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=h(B,F,l,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,$,ee,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,g.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,$){let ee,H="";if(typeof L=="string"?(ee=w.URI.file(L),H=L):typeof L!="undefined"&&(ee=L,H=L.fsPath),!ee)return H;const x=this.getWorkspaceFolder(ee,!0);if(!x)return H;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let B=(0,i.relativePath)(x.uri,ee);return $&&x.name&&(B=`${x.name}/${B}`),B}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:ee,removed:H}=b.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:H}))}findFiles(L,$,ee,H,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let B;if($===null?B=!1:$&&(typeof $=="string"?B=$:B=$.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=f(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(B),(0,C.withUndefinedAsNull)(ee),x).then(M=>Array.isArray(M)?M.map(N=>w.URI.revive(N)):[])}async findTextInFiles(L,$,ee,H,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),F=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:U,folder:M}=f($.include),N=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,O={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:F,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:U,excludePattern:N},j=!1;if(this._activeSearchCallbacks[B]=K=>{if(!j){const X=w.URI.revive(K.resource);K.results.forEach(me=>{(0,t.resultIsMatch)(me)?ee({uri:X,preview:{text:me.preview.text,matches:(0,E.mapArrayOrNot)(me.preview.matches,we=>new a.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,E.mapArrayOrNot)(me.ranges,we=>new a.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):ee({uri:X,text:me.text,lineNumber:me.lineNumber})})}},x.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(M),O,B,x);return delete this._activeSearchCallbacks[B],K||{}}catch(K){throw delete this._activeSearchCallbacks[B],K}}$handleTextSearchResult(L,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze({newTrustState:L.currentTrustState}))}};c=je([Ue(0,u.IExtHostRpcService),Ue(1,p.IExtHostInitDataService),Ue(2,_.IExtHostFileSystemInfo),Ue(3,d.ILogService)],c),e.ExtHostWorkspace=c,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function f(k){let L,$;return k&&(typeof k=="string"?L=k:(L=k.pattern,$=k.baseFolder||w.URI.file(k.base))),{includePattern:L,folder:$}}}),define(ge[35],ve([0,1,23,3,32,5,7,187,82,14,19,4,13,12,2]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,o){if(o){const r=o.split(".");let l=n;for(let h=0;l&&h<r.length;h++)l=l[r[h]];return l}}function S(n){return n instanceof s.URI}function v(n){return n&&n.uri instanceof s.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function p(n){return n&&n.uri instanceof s.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(S(n))return{resource:n};if(v(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(p(n))return{resource:n.uri};if(n===null)return{resource:null}}let a=class{constructor(o,r,l){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(o,r))}};a=je([Ue(0,w.IExtHostRpcService),Ue(1,T.IExtHostWorkspace),Ue(2,g.ILogService)],a),e.ExtHostConfiguration=a;class t{constructor(o,r,l,h){this._onDidChangeConfiguration=new I.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=r,this._configuration=A.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(o,r,l){const h=u(r)||{},m=this._toReadonlyValue(o?d(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,l==null?void 0:l.identifier);function b(f){if(f==null)return null;if(typeof f=="boolean")return f?1:4;switch(f){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(f){return typeof d(m,f)!="undefined"},get:(f,k)=>{this._validateConfigurationAccess(o?`${o}.${f}`:f,h,l==null?void 0:l.identifier);let L=d(m,f);if(typeof L=="undefined")L=k;else{let $;const ee=(H,x)=>{let B;const F=()=>{$=$||(0,E.deepClone)(m),B=B||d($,x)};return(0,i.isObject)(H)?new Proxy(H,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>B;if($)return B=B||d($,x),B[M];const N=U[M];return typeof M=="string"?ee(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),B&&(B[M]=N),!0),deleteProperty:(U,M)=>(F(),B&&delete B[M],!0),defineProperty:(U,M,N)=>(F(),B&&Object.defineProperty(B,M,N),!0)}):H};L=ee(L,f)}return L},update:(f,k,L,$)=>{f=o?`${o}.${f}`:f;const ee=b(L);return k!==void 0?this._proxy.$updateConfigurationOption(ee,f,k,h,$):this._proxy.$removeConfigurationOption(ee,f,h,$)},inspect:f=>{var k,L,$,ee,H,x,B,F;f=o?`${o}.${f}`:f;const U=(0,E.deepClone)(this._configuration.inspect(f,h,this._extHostWorkspace.workspace));if(U)return{key:f,defaultValue:(k=U.default)===null||k===void 0?void 0:k.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:($=U.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(ee=U.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(B=U.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof m=="object"&&(0,E.mixin)(c,m,!1),Object.freeze(c)}_toReadonlyValue(o){const r=l=>(0,i.isObject)(l)?new Proxy(l,{get:(h,m)=>r(h[m]),set:(h,m,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(h,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(h,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(o)}_validateConfigurationAccess(o,r,l){const h=y.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),m=l?`[${l.value}] `:"";if(h===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(r==null?void 0:r.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const l=new A.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,m)=>l.affectsConfiguration(h,u(m))})}_toMap(o){return o.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[65],ve([0,1,2,19,3,5,7,32,39,35,21,34,13,27,4,11,9,12,62,208,17]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(H){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}H.is=x;function B(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=o.from(U.options)),M}}H.from=B;function F(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}H.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(H){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}H.is=x;function B(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=l.from(U.options)),M}}H.from=B;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=F})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(H){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}H.is=x;function B(U){return{customExecution:"customExecution"}}H.from=B;function F(U,M){return M.get(U)}H.to=F})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(H){function x(B,F){let U;return B.scope!==void 0&&typeof B.scope!="number"?U=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===D.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=p.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:U}}H.from=x})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(H){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const j=B(O,M);j&&N.push(j)}return N}H.fromMany=x;function B(U,M){if(U!=null){let N;U.execution instanceof D.ProcessExecution?N=r.from(U.execution):U.execution instanceof D.ShellExecution?N=h.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(N=m.from(U.execution));const O=t.from(U.definition);let j;if(U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=D.TaskScope.Workspace,!(!O||!j)){const K=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:j},execution:N,isBackground:U.isBackground,group:K,presentationOptions:n.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=B;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):h.is(U.execution)?O=h.to(U.execution):m.is(U.execution)&&(O=m.to(U._id,N));const j=t.to(U.definition);let K;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?K=U.source.scope:K=await M.resolveWorkspaceFolder(E.URI.revive(U.source.scope)):K=D.TaskScope.Workspace),!(!j||!K)){const X=new D.Task(j,K,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(X.isBackground=U.isBackground),U.group!==void 0&&(X.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(X.presentationOptions=n.to(U.presentationOptions)),U._id&&(X._id=U._id),U.detail&&(X.detail=U.detail),X}}}H.to=F})(c=e.TaskDTO||(e.TaskDTO={}));var f;(function(H){function x(F){return F}H.from=x;function B(F){if(!!F)return Object.assign(Object.create(null),F)}H.to=B})(f=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(x,B,F){this._id=B,this._task=F,a.set(this,void 0),tt(this,a,x,"f")}get task(){return this._task}terminate(){$e(this,a,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}a=new WeakMap;var L;(function(H){function x(B){return{id:B._id,task:void 0}}H.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(x,B,F,U,M,N,O,j){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=x.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,B,F){if(!F)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:B,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,B),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,B){this._proxy.$registerTaskSystem(x,B)}fetchTasks(x){return this._proxy.$fetchTasks(f.from(x)).then(async B=>{const F=[];for(let U of B){const M=await c.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(B=>x.push(B)),x}terminateTask(x){if(!(x instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,B,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal(B,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const B=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const B=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:B,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const B=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:x.exitCode})}$provideTasks(x,B){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,I.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal(B,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,B){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if(B.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await c.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,R.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=c.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,B,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,B.execution)}async getTaskExecution(x,B){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=B||await c.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new k(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,B){x._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};$=je([Ue(0,w.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,i.IExtHostConfiguration),Ue(5,C.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let ee=class extends ${constructor(x,B,F,U,M,N,O,j){super(x,B,F,U,M,N,O,j);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const F=c.from(B,x);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.addCustomExecution(F,B,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),B);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,B,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=c.from(N,F.extension);O&&m.is(O.execution)?(M.push(O),B.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(m.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,B){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,B,F){}};ee=je([Ue(0,w.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,i.IExtHostConfiguration),Ue(5,C.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var mn=this&&this.__rest||function(Q,e){var E={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(E[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(Q);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[T])&&(E[I[T]]=Q[I[T]]);return E};define(ge[258],ve([0,1,18,19,21,3,69,6,23,14,2,28,5,39,13,20,7,32,221,121]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(b,c)=>`${b}:${c.toString()}`;let a=class{constructor(c,f,k){this.documents=f,this.workspace=k,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new _.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=c.getProxy(w.MainContext.MainThreadTesting),this.workspaceObservers=new h(this.proxy),this.textDocumentObservers=new m(this.proxy,f)}registerTestProvider(c){const f=(0,C.generateUuid)();this.providers.set(f,c),this.proxy.$registerTestProvider(f);const k=[...this.testSubscriptions.keys()];return setTimeout(()=>{var L;for(const $ of k)(L=this.testSubscriptions.get($))===null||L===void 0||L.subscribeFn(f,c)},0),new S.Disposable(()=>{this.providers.delete(f),this.proxy.$unregisterTestProvider(f)})}createTextDocumentTestObserver(c){return this.textDocumentObservers.checkout(c.uri)}createWorkspaceTestObserver(c){return this.workspaceObservers.checkout(c.uri)}async runTests(c,f=T.CancellationToken.None){const k=L=>L.map(this.getInternalTestForReference,this).filter(i.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:c.exclude?k(c.exclude).map(L=>L.testId):void 0,tests:k(c.tests),debug:c.debug},f)}publishExtensionProvidedResults(c,f){this.proxy.$publishExtensionProvidedResults(d.TestResults.from((0,C.generateUuid)(),c),f)}$publishTestResults(c){this.results=Object.freeze(c.map(f=>(0,y.deepFreeze)(d.TestResults.to(f))).concat(this.results).sort((f,k)=>k.completedAt-f.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(c,f){const k=R.URI.revive(f),L=u(c,k);if(!this.testSubscriptions.has(L)){const $=new T.CancellationTokenSource;let ee;if(c===1){let F=this.documents.getDocument(k);if(!F){const U=new A.DisposableStore;F=await new Promise(M=>{U.add((0,I.disposableTimeout)(()=>M(void 0),5e3)),U.add(this.documents.onDidAddDocuments(N=>{const O=N.find(j=>j.document.uri.toString()===k.toString());O&&M(O)}))}).finally(()=>U.dispose())}if(F){const U=await this.workspace.getWorkspaceFolder2(k,!1);ee=M=>M.provideDocumentTestRoot?M.provideDocumentTestRoot(F.document,$.token):(0,e.createDefaultDocumentTestRoot)(M,F.document,U,$.token)}}else{const F=await this.workspace.getWorkspaceFolder2(k,!1);F&&(ee=U=>U.provideWorkspaceTestRoot(F,$.token))}if(!!ee){const H=async(F,U)=>{try{const M=await ee(U);M&&B.addRoot(M,F)}catch(M){console.error(M)}},x=new A.DisposableStore,B=x.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(c,f,F)));x.add((0,A.toDisposable)(()=>$.dispose(!0)));for(const[F,U]of this.providers)H(F,U);B.pushDiff([3,-1]),this.testSubscriptions.set(L,{store:x,collection:B,subscribeFn:H})}}}async $expandTest(c,f){const k=(0,E.mapFind)(this.testSubscriptions.values(),L=>L.collection.treeId===c.src.tree?L:void 0);await(k==null?void 0:k.collection.expand(c.testId,f<0?Infinity:f)),this.flushCollectionDiffs()}$unsubscribeFromTests(c,f){var k;const L=R.URI.revive(f),$=u(c,L);(k=this.testSubscriptions.get($))===null||k===void 0||k.store.dispose(),this.testSubscriptions.delete($)}$acceptDiff(c,f,k){c===1?this.textDocumentObservers.acceptDiff(R.URI.revive(f),k):this.workspaceObservers.acceptDiff(R.URI.revive(f),k)}async $runTestsForProvider(c,f){const k=this.providers.get(c.tests[0].src.provider);if(!!k){const L=c.tests.map(({testId:H,src:x})=>this.ownedTests.getTestById(H,x.tree)).filter(i.isDefined).map(([H,x])=>x),$=c.excludeExtIds.map(H=>this.ownedTests.getTestById(H)).filter(i.isDefined).filter(([H,x])=>L.some(B=>H.comparePositions(B,x)===1));if(!!L.length){const ee=H=>{for(const[x,B]of $){const F=x.comparePositions(B,H.id);if(F===1||F===3)return!0}return!1};try{await k.runTests({appendOutput(){},appendMessage:(H,x)=>{ee(H)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(c.runId,H.id,d.TestMessage.from(x)))},setState:(H,x,B)=>{ee(H)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(c.runId,H.id,x,B))},tests:L.map(H=>n.unwrap(H.actual)),exclude:$.map(([,H])=>n.unwrap(H.actual)),debug:c.debug},f);for(const{collection:H}of this.testSubscriptions.values())H.flushDiff();return}catch(H){throw console.error(H),H}}}}$lookupTest(c){const f=this.ownedTests.getTestById(c.testId);if(!f)return Promise.resolve(void 0);const k=f[1],{actual:L,discoverCts:$,expandLevels:ee}=k,H=mn(k,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:c}of this.testSubscriptions.values())c.flushDiff()}getInternalTestForReference(c){var f,k;return(k=(f=this.workspaceObservers.getMirroredTestDataByReference(c))!==null&&f!==void 0?f:(0,E.mapFind)(this.testSubscriptions.values(),L=>L.collection.getTestByReference(c)))!==null&&k!==void 0?k:this.textDocumentObservers.getMirroredTestDataByReference(c)}};a=je([Ue(0,s.IExtHostRpcService),Ue(1,g.IExtHostDocumentsAndEditors),Ue(2,v.IExtHostWorkspace)],a),e.ExtHostTesting=a;const t=async(b,c,f,k)=>{if(!!f){const L=await b.provideWorkspaceTestRoot(f,k);if(!!L)return k.onCancellationRequested(()=>{n.removeFilter(c)}),n.getWrapperForTestItem(L,c)}};e.createDefaultDocumentTestRoot=t;class n extends S.TestItem{constructor(c,f,k){super(c.id,c.label,c.uri,c.expandable);if(this.actual=c,this.filterDocument=f,this.parent=k,!(c instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);c[S.TestItemHookProperty]={setProp:(L,$)=>this[L]=$,created:L=>n.getWrapperForTestItem(L,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:L=>this.children.delete(L)}}static removeFilter(c){this.wrapperMap.delete(c)}static getWrapperForTestItem(c,f,k){let L=this.wrapperMap.get(f);if(L==null?void 0:L.has(c))return L.get(c);L||(L=new WeakMap,this.wrapperMap.set(f,L));const $=new n(c,f,k);return L.set(c,$),$}static unwrap(c){return c instanceof n?c.actual:c}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var c;const f=this._cachedMatchesFilter;for(const L of this.actual.children){const $=n.getWrapperForTestItem(L,this.filterDocument,this);$.hasNodeMatchingFilter?this.children.add($):this.children.delete($)}const k=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=k,k!==f&&((c=this.parent)===null||c===void 0||c.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=n,n.wrapperMap=new WeakMap;class o extends p.IncrementalChangeCollector{constructor(c){super();this.emitter=c,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(c){this.added.add(c)}update(c){Object.assign(c.revived,d.TestItem.toPlain(c.item)),this.added.has(c)||this.updated.add(c)}remove(c){if(this.added.has(c)){this.added.delete(c);return}if(this.updated.delete(c),c.parent&&this.alreadyRemoved.has(c.parent)){this.alreadyRemoved.add(c.item.extId);return}this.removed.add(c)}getChangeEvent(){const{added:c,updated:f,removed:k}=this;return{get added(){return[...c].map(L=>L.revived)},get updated(){return[...f].map(L=>L.revived)},get removed(){return[...k].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(c){let f=[];for(const k of c){const L=this.items.get(k);L&&f.push(L.revived)}return f}getMirroredTestDataById(c){return this.items.get(c)}getMirroredTestDataByReference(c){return this.items.get(c.id)}createItem(c,f){return Object.assign(Object.assign({},c),{revived:d.TestItem.toPlain(c.item),depth:f?f.depth+1:0,children:new Set})}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=r;class l{constructor(){this.resources=new Map}checkout(c){var f,k;const L=c.toString(),$=(f=this.resources.get(L))!==null&&f!==void 0?f:this.createObserverData(c);return(k=$.pendingDeletion)===null||k===void 0||k.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,D.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(c))})}}getMirroredTestDataByReference(c){for(const{tests:f}of this.resources.values()){const k=f.getMirroredTestDataByReference(c);if(k)return k}}eventuallyDispose(c){return(0,I.disposableTimeout)(()=>this.unlisten(c),10*1e3)}createObserverData(c){const f=new r,k=this.listen(c,$=>f.apply($)),L={observers:0,tests:f,listener:k};return this.resources.set(c.toString(),L),L}unlisten(c){var f;const k=c.toString(),L=this.resources.get(k);L&&(L.observers=-1,(f=L.pendingDeletion)===null||f===void 0||f.dispose(),L.listener.dispose(),this.resources.delete(k))}}class h extends l{constructor(c){super();this.proxy=c,this.diffListeners=new Map}acceptDiff(c,f){var k;(k=this.diffListeners.get(c.toString()))===null||k===void 0||k(f)}listen(c,f){this.proxy.$subscribeToDiffs(0,c);const k=c.toString();return this.diffListeners.set(k,f),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,c),this.diffListeners.delete(k)})}}class m extends l{constructor(c,f){super();this.proxy=c,this.documents=f,this.diffListeners=new Map}acceptDiff(c,f){var k;(k=this.diffListeners.get(c.toString()))===null||k===void 0||k(f)}listen(c,f){if(!this.documents.getDocument(c))return new S.Disposable(()=>{});const L=c.toString();return this.diffListeners.set(L,f),this.proxy.$subscribeToDiffs(1,c),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,c),this.diffListeners.delete(L)})}}}),define(ge[259],ve([0,1,18,53,33,75,24,11,8,25,10,14,2,139,172,83,59,213,257,31]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(b,c,f,k){this.configurationService=b,this.workspaceContextService=c,this.editorGroupsService=f,this.pathService=k}text(b,c,f={}){b=this.getContentPattern(b,f);const k=this.configurationService.getValue(),L=c&&c.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),$=this.commonQuery(c==null?void 0:c.map(S.toWorkspaceFolder),f);return Object.assign(Object.assign({},$),{type:2,contentPattern:b,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:k.search.usePCRE2||L||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles})}getContentPattern(b,c){const f=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const k=Object.assign(Object.assign({},b),{wordSeparators:f.editor.wordSeparators});return this.isCaseSensitive(b,c)&&(k.isCaseSensitive=!0),this.isMultiline(b)&&(k.isMultiline=!0),k}file(b,c={}){const f=this.commonQuery(b,c);return Object.assign(Object.assign({},f),{type:1,filePattern:c.filePattern?c.filePattern.trim():c.filePattern,exists:c.exists,sortByScore:c.sortByScore,cacheKey:c.cacheKey})}handleIncludeExclude(b,c){return b?(b=Array.isArray(b)?b.map(r):r(b),c?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],c={}){const f=this.handleIncludeExclude(c.includePattern,c.expandPatterns),k=this.handleIncludeExclude(c.excludePattern,c.expandPatterns),L=b.length>1,$=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,c,k)):b.map(x=>this.getFolderQueryForRoot(x,c,k,L))).filter(x=>!!x),ee={_reason:c._reason,folderQueries:$,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:c.extraFileResources,excludePattern:k.pattern,includePattern:f.pattern,onlyOpenEditors:c.onlyOpenEditors,maxResults:c.maxResults};if(c.onlyOpenEditors){const B=E.coalesce(E.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,p.pathIncludedInQuery)(ee,U.fsPath)),F=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},ee),F)}const H=c.extraFileResources&&c.extraFileResources.filter(x=>(0,p.pathIncludedInQuery)(ee,x.fsPath));return ee.extraFileResources=H&&H.length?H:void 0,ee}commonQueryFromFileList(b){const c=[],f=new D.ResourceMap,k={};let L=!1;return b.forEach($=>{var ee,H;if($.scheme!==A.Schemas.walkThrough)if((0,i.isAbsolutePath)($)){const B=(H=(ee=this.workspaceContextService.getWorkspaceFolder($))===null||ee===void 0?void 0:ee.uri)!==null&&H!==void 0?H:$.with({path:y.dirname($.fsPath)});let F=f.get(B);F||(L=!0,F={folder:B,includePattern:{}},c.push(F),f.set(B,F));const U=y.relative(B.fsPath,$.fsPath);(0,C.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else $.fsPath&&(L=!0,k[$.fsPath]=!0)}),{folderQueries:c,includePattern:k,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(b,c){if(c.isSmartCase){if(b.isRegExp){if(R.containsUppercaseCharacter(b.pattern,!0))return!0}else if(R.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,g.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const c=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),k=(Array.isArray(b)?b:n(b)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(F,U.scheme===A.Schemas.file?U.fsPath:U.path):F}),L=I.groupBy(k,F=>c(F)?"searchPaths":"exprSegments"),$=(L.exprSegments||[]).map(F=>R.rtrim(F,"/")).map(F=>R.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),o(F))),ee={},H=this.expandSearchPathPatterns(L.searchPaths||[]);H&&H.length&&(ee.searchPaths=H);const x=E.flatten($),B=t(...x);return B&&(ee.pattern=B),ee}getExcludesForFolder(b,c){return c.disregardExcludeSettings?void 0:(0,p.getExcludes)(b,!c.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const c=E.flatten(b.map(k=>{let{pathPortion:L,globPortion:$}=a(k);$&&($=l($));const ee=this.expandOneSearchPath(L);return E.flatten(ee.map(H=>this.resolveOneSearchPathPattern(H,$)))})),f=new Map;return c.forEach(k=>{const L=k.searchPath.toString(),$=f.get(L);$?k.pattern&&($.pattern=$.pattern||{},$.pattern[k.pattern]=!0):f.set(L,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(f.values())}expandOneSearchPath(b){if(y.isAbsolute(b)){const c=this.workspaceContextService.getWorkspace().folders;return c[0]&&c[0].uri.scheme!==A.Schemas.file?[{searchPath:c[0].uri.with({path:b})}]:[{searchPath:w.URI.file(y.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const c=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const k=y.posix.resolve(c.path,b);return[{searchPath:c.with({path:k})}]}const f=l(b);return[{searchPath:c,pattern:f}]}else{if(b==="./"||b===".\\")return[];{const c=b.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(c){const f=c[1],k=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===f);if(k.length)return k.map(L=>{const $=c[2];return{searchPath:L.uri,pattern:$&&l($)}});{const L=s.localize(0,null,f);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(b,c){const f=b.pattern&&c?`${b.pattern}/${c}`:b.pattern||c,k=[{searchPath:b.searchPath,pattern:f}];return f&&!f.endsWith("**")&&k.push({searchPath:b.searchPath,pattern:f+"/**"}),k}getFolderQueryForSearchPath(b,c,f){const k=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(b.searchPath),c,f,!1);return k?Object.assign(Object.assign({},k),{includePattern:b.pattern}):null}getFolderQueryForRoot(b,c,f,k){let L;const $=w.URI.isUri(b)?b:b.uri;if(f.searchPaths){const F=f.searchPaths.filter(U=>(0,i.isEqual)(U.searchPath,$))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const ee=this.configurationService.getValue({resource:$}),H=this.getExcludesForFolder(ee,c),x=Object.assign(Object.assign({},H||{}),L||{}),B=w.URI.isUri(b)?(0,i.basename)(b):b.name;return{folder:$,folderName:k?B:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof c.disregardIgnoreFiles=="boolean"?c.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof c.disregardGlobalIgnoreFiles=="boolean"?c.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof c.ignoreSymlinks=="boolean"?c.ignoreSymlinks:!ee.search.followSymlinks}}};u=je([Ue(0,d.IConfigurationService),Ue(1,S.IWorkspaceContextService),Ue(2,v.IEditorGroupsService),Ue(3,_.IPathService)],u),e.QueryBuilder=u;function a(m){const b=m.match(/[\*\{\}\(\)\[\]\?]/);if(b){const c=b.index,f=m.substr(0,c).match(/[/|\\][^/\\]*$/);if(f){let k=m.substr(0,f.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:m.substr((f.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((b,c)=>(b[c]=!0,b),Object.create(null)):void 0}function n(m){return T.splitGlobAware(m,",").map(b=>b.trim()).filter(b=>!!b.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(c=>c.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function l(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(m,b){m=E.distinct(m,k=>k.toString());const c=[],f=b.getWorkspace();return m&&m.forEach(k=>{let L;if(b.getWorkbenchState()===2)L=(0,i.relativePath)(f.folders[0].uri,k),L&&L!=="."&&(L="./"+L);else{const $=b.getWorkspaceFolder(k);if($){const ee=$.name;if(f.folders.filter(x=>x.name===ee).length===1){const x=(0,i.relativePath)($.uri,k);x===""?L=`./${$.name}`:L=`./${$.name}/${x}`}else L=k.fsPath}}L&&c.push(L)}),c}e.resolveResourcesForSearchIncludes=h}),define(ge[260],ve([0,1,25,2,21,17,4,259,31,59]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(d,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const _=[],p=[];for(const r of v)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||d.forceUsingSearch?p.push(l):_.push(l)}if(_.length===0&&p.length===0)return Promise.resolve(void 0);let u;const a=new Promise((r,l)=>{u=r}),t=r=>u({activationEvent:r}),n=Promise.all(_.map(r=>w(d,r,t))).then(()=>{}),o=g(d,S.identifier,p,t);return Promise.all([n,o]).then(()=>{u(void 0)}),a}e.checkActivateWorkspaceContainsExtension=C;async function w(d,S,v){for(const _ of d.folders)if(await d.exists(E.joinPath(I.URI.revive(_),S))){v(`workspaceContains:${S}`);return}}async function g(d,S,v,_){if(v.length===0)return Promise.resolve(void 0);const p=new T.CancellationTokenSource,u=d.checkExists(d.folders,v,p.token),a=setTimeout(async()=>{p.cancel(),_(`workspaceContainsTimeout:${v.join(",")}`)},R);let t=!1;try{t=await u}catch(n){P.isPromiseCanceledError(n)||P.onUnexpectedError(n)}p.dispose(),clearTimeout(a),t&&_(`workspaceContains:${v.join(",")}`)}function s(d,S,v,_){const p=d.get(D.IInstantiationService),u=d.get(y.ISearchService),t=p.createInstance(A.QueryBuilder).file(S.map(n=>(0,i.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:v,exists:!0});return u.fileSearch(t,_).then(n=>!!n.limitHit,n=>P.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(Q,e,E,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,E):T?T.value=E:e.set(Q,E),E},$e=this&&this.__classPrivateFieldGet||function(Q,e,E,I){if(E==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?I:E==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[42],ve([0,1,161,8,66,25,19,6,24,2,12,5,35,224,88,32,41,222,17,29,11,22,195,7,113,4,27,89,13,81,50,34,3,260,86,196]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p,u,a,t,n,o,r,l,h,m,b,c,f,k,L,$,ee){"use strict";var H,x,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class Mn extends A.Disposable{constructor(O,j,K,X,me,we,Ae,Ie,Me,V){super();this._onDidChangeRemoteConnectionData=this._register(new k.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=K,this._initData=Ae,this._extHostWorkspace=X,this._extHostConfiguration=me,this._logService=we,this._extHostTunnelService=Me,this._extHostTerminalService=V,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new b.ServiceCollection([s.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const Y=new Set;this._initData.hostExtensions.forEach(te=>Y.add(p.ExtensionIdentifier.toKey(te))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(Y.has(p.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new g.HostExtension;const fe=this._registry.getExtensionDescription(te);return this._activateExtension(fe,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){_.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch(j){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,j){return this._activator.activateByEvent(O,j)}_activateById(O,j){return this._activator.activateById(O,j)}activateByIdWithErrors(O,j){return this._activateById(O,j).then(()=>{const K=this._activator.getActivatedExtension(O);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(K=>{if(!!this._getEntryPoint(K))return this._hostUtils.realpath(K.extensionLocation.fsPath).then(X=>O.set(i.URI.file(X).fsPath,K))});this._extensionPathIndex=Promise.all(j).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return j;const K=this._activator.getActivatedExtension(O);if(!K)return j;try{typeof K.module.deactivate=="function"&&(j=Promise.resolve(K.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,A.dispose)(K.subscriptions)}catch(X){}return j}async _activateExtension(O,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,j).then(K=>{const X=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,j),this._logExtensionActivationTimes(O,j,"success",X),K},K=>{throw this._logExtensionActivationTimes(O,j,"failure"),K})}_logExtensionActivationTimes(O,j,K,X){const me=U(O,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},me),X||{}),{outcome:K}))}_doActivateExtension(O,j){const K=U(O,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const me=new g.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,P.joinPath)(O.extensionLocation,X),me),this._loadExtensionContext(O)]).then(we=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Mn._callActivate(this._logService,O.identifier,we[0],we[1],me))).then(we=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),we))}_loadExtensionContext(O){const j=new t.ExtensionGlobalMemento(O,this._storage),K=new t.ExtensionMemento(O.identifier.value,!1,this._storage),X=new ee.ExtensionSecrets(O,this._secretState),me=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,we=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([j.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Ie;return Object.freeze({globalState:j,workspaceState:K,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return I.join(O.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Ae._storagePath.workspaceValue(O))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return I.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return i.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return me},get extension(){return Ie===void 0&&(Ie=new M(Ae,O.identifier,O,we)),Ie},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,j,K,X,me){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,j,K,X,me).then(we=>new g.ActivatedExtension(!1,null,me.build(),K,we,X.subscriptions))}static _callActivateOptional(O,j,K,X,me){if(typeof K.activate=="function")try{me.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${j.value}`);const we=typeof global=="object"?global:self,Ae=K.activate.apply(we,[X]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Ae).then(Ie=>(me.activateResolveStop(),Ie))}catch(we){return Promise.reject(we)}else return Promise.resolve(K)}_activateOneStartupFinished(O,j){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:j}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const j of O.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(O,j)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions(j),X=Promise.all([O,K]).then(()=>{});return Promise.race([X,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(O,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,j){if(!this.isActivated(j.identifier)){const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(we=>we.uri),forceUsingSearch:K,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Ae,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(we,Ae,Ie)},me=await(0,L.checkActivateWorkspaceContainsExtension)(X,j);if(!!me)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:me.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:j}=this._initData.environment;if(!O||!j||j.scheme!==u.Schemas.file)throw new Error(E.localize(0,null));const K=(0,P.originalFSPath)(j),X=await this._loadCommonJSModule(null,j,new g.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(E.localize(1,null,K));return new Promise((me,we)=>{const Ae=(Me,V)=>{Me?we(Me):me(typeof V=="number"&&V>0?1:0)},Ie=X.run(K,Ae);Ie&&Ie.then&&Ie.then(()=>{me(0)}).catch(Me=>{we(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,j){return this._resolvers[O]=j,(0,A.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,j){const K=O.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const X=O.substr(0,K);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const me=this._resolvers[X];if(!me)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${X}`);const we=await me.resolve(O,{resolveAttempt:j});T.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(me));const Ae={authority:O,host:we.host,port:we.port,connectionToken:we.connectionToken},Ie={extensionHostEnv:we.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Ie,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(T.mark(`code/extHost/didResolveAuthorityError/${X}`),we instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,j){return j===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(O,!1))}async $activate(O,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,j),!0):!1}async $deltaExtensions(O,j){O.forEach(X=>X.extensionLocation=i.URI.revive(X.extensionLocation));const K=await this.getExtensionPathIndex();return await Promise.all(j.map(async X=>{const me=this._registry.getExtensionDescription(X);if(!!me){const we=await this._hostUtils.realpath(me.extensionLocation.fsPath);K.delete(i.URI.file(we).fsPath)}})),await Promise.all(O.map(async X=>{const me=await this._hostUtils.realpath(X.extensionLocation.fsPath);K.set(i.URI.file(me).fsPath,X)})),this._registry.deltaExtensions(O,j),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let j=a.VSBuffer.alloc(O),K=Math.random()%256;for(let X=0;X<O;X++)j.writeUInt8(K,X);return j}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,m.IExtHostRpcService),Ue(3,d.IExtHostWorkspace),Ue(4,w.IExtHostConfiguration),Ue(5,R.ILogService),Ue(6,l.IExtHostInitDataService),Ue(7,h.IExtensionStoragePaths),Ue(8,c.IExtHostTunnelService),Ue(9,f.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,j,K,X){H.set(this,void 0),x.set(this,void 0),B.set(this,void 0),tt(this,H,O,"f"),tt(this,x,j,"f"),tt(this,B,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=I.normalize((0,P.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=X}get isActive(){return $e(this,H,"f").isActivated($e(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,H,"f").getExtensionExports($e(this,B,"f"))}activate(){return $e(this,H,"f").activateByIdWithErrors($e(this,B,"f"),{startup:!1,extensionId:$e(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,H=new WeakMap,x=new WeakMap,B=new WeakMap}),define(ge[45],ve([0,1,8,2,3,19,5,7,119,32,42,39,212,35,203,13,4,14,36]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let p=class{constructor(h,m,b,c,f){this._workspaceService=m,this._extensionService=b,this._editorsService=c,this._configurationService=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=h.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(k=>{k.onDidChange(L=>{this.registerAllDebugTypes(k)}),this.registerAllDebugTypes(k)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,m){const b=h;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let c=`debug:${encodeURIComponent(b.path||"")}`,f="?";return m&&(c+=`${f}session=${encodeURIComponent(m.id)}`,f="&"),c+=`${f}ref=${b.sourceReference}`,I.URI.parse(c)}else{if(b.path)return I.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const m=[];for(const b of h.getAllExtensionDescriptions())if(b.contributes){const c=b.contributes.debuggers;if(c&&c.length>0)for(const f of c)(0,s.isDebuggerMainContribution)(f)&&m.push(f.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(m=>h.push(m)),h}addBreakpoints(h){this.startBreakpoints();const m=h.filter(f=>{const k=f.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,f),!0)});this.fireBreakpointChanges(m,[],[]);const b=[],c=new Map;for(const f of m)if(f instanceof A.SourceBreakpoint){let k=c.get(f.location.uri.toString());k||(k={type:"sourceMulti",uri:f.location.uri,lines:[]},c.set(f.location.uri.toString(),k),b.push(k)),k.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.FunctionBreakpoint&&b.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(h){this.startBreakpoints();const m=h.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],m,[]);const b=m.filter(k=>k instanceof A.SourceBreakpoint).map(k=>k.id),c=m.filter(k=>k instanceof A.FunctionBreakpoint).map(k=>k.id),f=m.filter(k=>k instanceof A.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(b,c,f)}startDebugging(h,m,b){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,m,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,m,b){if(!m)return new A.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:c,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,b,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,c),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(h,m,b){if(!b)return new A.Disposable(()=>{});if(!this.definesDebugType(h,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:c,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,c),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(h,m){if(!m)return new A.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:b,factory:m}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==m)})}async $runInTerminal(h,m){return Promise.resolve(void 0)}async $substituteVariables(h,m){if(!this._variableResolver){const[f,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(f||[],this._editorsService,k)}let b;const c=await this.getFolder(h);return c&&(b={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,m)}createDebugAdapter(h,m){if(h.type==="implementation")return new o(h.implementation)}createSignService(){}async $startDASession(h,m){const b=this,c=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const k=this.convertToDto(f),L=this.createDebugAdapter(k,c);if(!L)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const $=L;return this._debugAdapters.set(h,$),this.getDebugAdapterTrackers(c).then(ee=>(ee&&this._debugAdaptersTrackers.set(h,ee),$.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const x=H,B={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);B.body={signature:F},$.sendResponse(B)}else throw new Error("no signer")}catch(F){B.success=!1,B.message=F.message,$.sendResponse(B)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(H),H=(0,s.convertToVSCPaths)(H,!0),b._debugServiceProxy.$acceptDAMessage(h,H)}),$.onError(H=>{ee&&ee.onError&&ee.onError(H),this._debugServiceProxy.$acceptDAError(h,H.name,H.message,H.stack)}),$.onExit(H=>{ee&&ee.onExit&&ee.onExit((0,v.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,v.withNullAsUndefined)(H),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),$.startSession()))})}$sendDAMessage(h,m){m=(0,s.convertToDAPaths)(m,!1);const b=this._debugAdaptersTrackers.get(h);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(m);const c=this._debugAdapters.get(h);c&&c.sendMessage(m)}$stopDASession(h){const m=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),m&&m.onWillStopSession&&m.onWillStopSession();const b=this._debugAdapters.get(h);return this._debugAdapters.delete(h),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const m=[],b=[],c=[];if(h.added)for(const f of h.added){const k=f.id;if(k&&!this._breakpoints.has(k)){let L;if(f.type==="function")L=new A.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const $=I.URI.revive(f.uri);L=new A.SourceBreakpoint(new A.Location($,new A.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}L._id=k,this._breakpoints.set(k,L),m.push(L)}}if(h.removed)for(const f of h.removed){const k=this._breakpoints.get(f);k&&(this._breakpoints.delete(f),b.push(k))}if(h.changed){for(const f of h.changed)if(f.id){const k=this._breakpoints.get(f.id);if(k){if(k instanceof A.FunctionBreakpoint&&f.type==="function"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(k instanceof A.SourceBreakpoint&&f.type==="source"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.Location(I.URI.revive(f.uri),new A.Position(f.line,f.character))}c.push(k)}}}this.fireBreakpointChanges(m,b,c)}$provideDebugConfigurations(h,m,b){return(0,P.asPromise)(async()=>{const c=this.getConfigProviderByHandle(h);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(m);return c.provideDebugConfigurations(f,b)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(h,m,b,c){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(m);return f.resolveDebugConfiguration(k,b,c)})}$resolveDebugConfigurationWithSubstitutedVariables(h,m,b,c){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(m);return f.resolveDebugConfigurationWithSubstitutedVariables(k,b,c)})}async $provideDebugAdapter(h,m){const b=this.getAdapterDescriptorFactoryByHandle(h);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(m);return this.getAdapterDescriptor(b,c).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(h){const m=await this.getSession(h);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(h){const m=await this.getSession(h);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,m){const b=await this.getSession(h);b&&b._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(h,m){const c={session:await this.getSession(h),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(h){if(h instanceof A.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof A.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const m=this._adapterFactories.filter(b=>b.type===h);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(h){const m=this._adapterFactories.filter(b=>b.handle===h);if(m.length>0)return m[0].factory}getConfigProviderByHandle(h){const m=this._configProviders.filter(b=>b.handle===h);if(m.length>0)return m[0].provider}definesDebugType(h,m){if(h.contributes){const b=h.contributes.debuggers;if(b&&b.length>0){for(const c of b)if(c.label&&c.type&&c.type===m)return!0}}return!1}getDebugAdapterTrackers(h){const b=h.configuration.type,c=this._trackerFactories.filter(f=>f.type===b||f.type==="*").map(f=>(0,P.asPromise)(()=>f.factory.createDebugAdapterTracker(h)).then(k=>k,k=>null));return Promise.race([Promise.all(c).then(f=>{const k=f.filter(L=>!!L);if(k.length>0)return new n(k)}),new Promise((f,k)=>{const L=setTimeout(()=>{clearTimeout(L),k(new Error("timeout"))},1e3)})]).catch(f=>{})}async getAdapterDescriptor(h,m){const b=m.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new A.DebugAdapterServer(b));if(h){const f=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>h.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,f))).then(k=>{if(k)return k})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,c))}daExecutableFromPackage(h,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,m,b){(h.length>0||m.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:m,changed:b}))}async getSession(h){if(h)if(typeof h=="string"){const m=this._debugSessions.get(h);if(m)return m}else{let m=this._debugSessions.get(h.id);if(!m){const b=await this.getFolder(h.folderUri);m=new u(this._debugServiceProxy,h.id,h.type,h.name,b,h.configuration),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(h){if(h){const m=I.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};p=je([Ue(0,d.IExtHostRpcService),Ue(1,i.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class u{constructor(h,m,b,c,f,k){this._debugServiceProxy=h,this._id=m,this._type=b,this._name=c,this._workspaceFolder=f,this._configuration=k}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,m)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=u;class a{constructor(h){this.value=Object.freeze({append(m){h.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class t extends w.AbstractVariableResolverService{constructor(h,m,b,c){super({getFolderUri:f=>{const k=h.filter(L=>L.name===f);if(k&&k.length>0)return k[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(f,k)=>b.getConfiguration(void 0,f).get(k),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(m){const f=m.activeEditor();if(f)return E.normalize(f.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(m&&c){const f=m.activeEditor();if(f){const k=c.getWorkspaceFolder(f.document.uri);if(k)return E.normalize(k.uri.fsPath)}}},getSelectedText:()=>{if(m){const f=m.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(m){const f=m.activeEditor();if(f)return String(f.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class n{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(m=>m.onError?m.onError(h):void 0)}onExit(h,m){this.trackers.forEach(b=>b.onExit?b.onExit(h,m):void 0)}}class o extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends p{constructor(h,m,b,c,f){super(h,m,b,c,f)}createVariableResolver(h,m,b){return new t(h,m,b)}};r=je([Ue(0,d.IExtHostRpcService),Ue(1,i.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,C.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[261],ve([0,1,66,2,5,35,41,29,13,27,4,42,36,12]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(p,u,a,t,n,o,r){this._apiFactory=p,this._extensionRegistry=u,this._instaService=a,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,u,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,u,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let u of p.nodeModuleName)this._factories.set(u,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(u=>p.alternativeModuleName(u))}};s=je([Ue(2,R.IInstantiationService),Ue(3,P.IExtHostConfiguration),Ue(4,C.IExtHostExtensionService),Ue(5,i.IExtHostInitDataService),Ue(6,g.ILogService)],s),e.RequireInterceptor=s;class d{constructor(p,u,a,t,n){this._apiFactory=p,this._extensionPaths=u,this._extensionRegistry=a,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,u){const a=this._extensionPaths.findSubstr(u.fsPath);if(a){let t=this._extApiImpl.get(A.ExtensionIdentifier.toKey(a.identifier));return t||(t=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(a.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,o)=>t+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(p,u){this.nodeModuleName="keytar";const{environment:a}=u,t=p.getProxy(T.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;w.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>t.$getPassword(n,o),setPassword:(n,o,r)=>t.$setPassword(n,o,r),deletePassword:(n,o)=>t.$deletePassword(n,o),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(p,u){return this._impl}alternativeModuleName(p){const u=p.length;if(!(u<=7||!this.alternativeNames)){const a=u-7;if((p.charAt(a)==="/"||p.charAt(a)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};S=je([Ue(0,y.IExtHostRpcService),Ue(1,i.IExtHostInitDataService)],S);let v=class{constructor(p,u,a){this._extensionPaths=p,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(T.MainContext.MainThreadTelemetry);const t=a.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,o)=>{const r=I.URI.parse(n);return o?this.callOriginal(n,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,o)}}load(p,u,a){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=a(p),this._impl}callOriginal(p,u){return this.sendNoForwardTelemetry(),this._original(p,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Ue(2,y.IExtHostRpcService)],v)}),define(ge[262],ve([0,1,167,9,7,204,32,42,39,35,34,13,45,188,207,19]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends w.ExtHostDebugServiceBase{constructor(p,u,a,t,n,o){super(p,u,a,t,n);this._terminalService=o,this._integratedTerminalInstances=new v}createDebugAdapter(p,u){switch(p.type){case"server":return new P.SocketDebugAdapter(p);case"pipeServer":return new P.NamedPipeDebugAdapter(p);case"executable":return new P.ExecutableDebugAdapter(p,u.type)}return super.createDebugAdapter(p,u)}daExecutableFromPackage(p,u){const a=P.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),p.type);if(a)return new T.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new g.SignService}async $runInTerminal(p,u){if(p.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(f=>{this._integratedTerminalInstances.onTerminalClosed(f)}));const a=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,a),n=this._terminalService.getDefaultShellArgs(!0,a),o=JSON.stringify({shell:t,shellArgs:n});let r=await this._integratedTerminalInstances.checkout(o),l,h=!1;if(r)l=p.cwd;else{const f={shellPath:t,shellArgs:n,cwd:p.cwd,name:p.title||E.localize(0,null)};h=!0,r=this._terminalService.createTerminalFromOptions(f,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const m=await r.processId;h?await new Promise(f=>setTimeout(f,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):I.isWindows?r.sendText("cls"):r.sendText("clear"));const b=(0,s.prepareCommand)(t,p.args,l,p.env);r.sendText(b);const c=this.onDidTerminateDebugSession(f=>{f.id===u&&(this._integratedTerminalInstances.free(r),c.dispose())});return m}else if(p.kind==="external")return(0,s.runInExternalTerminal)(p,await this._configurationService.getConfigProvider());return super.$runInTerminal(p,u)}createVariableResolver(p,u,a){return new w.ExtHostVariableResolverService(p,u,a,this._workspaceService)}};S=je([Ue(0,C.IExtHostRpcService),Ue(1,D.IExtHostWorkspace),Ue(2,A.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,i.IExtHostConfiguration),Ue(5,R.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(p){const a=[...this._terminalInstances.entries()].map(([t,n])=>(0,d.createCancelablePromise)(async o=>{if(n.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await t.processId))return null;const r=Date.now();return n.lastUsedAt+v.minUseDelay>r||o.isCancellationRequested||n.config!==p?null:(n.lastUsedAt=r,t)}));return await(0,d.firstParallel)(a,t=>!!t)}insert(p,u){this._terminalInstances.set(p,{lastUsedAt:Date.now(),config:u})}free(p){const u=this._terminalInstances.get(p);u&&(u.lastUsedAt=-1)}onTerminalClosed(p){this._terminalInstances.delete(p)}}v.minUseDelay=1e3}),define(ge[263],ve([0,1,8,2,77,32,45,39,35,34,13,27,65,11,12,62]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends w.ExtHostTaskBase{constructor(_,p,u,a,t,n,o,r){super(_,p,u,a,t,n,o,r);this.workspaceService=u,p.remote.isRemote&&p.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:p.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,p){const u=p;if(!p.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const a=w.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(a);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,p);return this._proxy.$executeTask(a).catch(()=>{}),n}else{const a=w.TaskDTO.from(p,_);if(a===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(a.execution)&&await this.addCustomExecution(a,p,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(a),p);return this._proxy.$executeTask(a).catch(()=>{}),t}}provideTasksInternal(_,p,u,a){const t=[];if(a)for(let n of a){this.checkDeprecation(n,u),(!n.definition||!_[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=w.TaskDTO.from(n,u.extension);o&&(t.push(o),w.CustomExecutionDTO.is(o.execution)&&p.push(this.addCustomExecution(o,n,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const p=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(_,this._editorService,p,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,p){const u=I.URI.revive(_),a={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(n),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let l of p.variables)a.variables[l]=await o.resolveAsync(r,l);if(p.process!==void 0){let l;if(p.process.path!==void 0){l=p.process.path.split(E.delimiter);for(let h=0;h<l.length;h++)l[h]=await o.resolveAsync(r,l[h])}a.process=await T.win32.findExecutable(await o.resolveAsync(r,p.process.name),p.process.cwd!==void 0?await o.resolveAsync(r,p.process.cwd):void 0,l)}return a}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,p,u){return T.win32.findExecutable(_,p,u)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,C.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,A.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,i.IExtHostTerminalService),Ue(6,s.ILogService),Ue(7,d.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(ge[264],ve([0,1,9,14,28,148,12,35,45,39,13,34,32,210,211]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(v,_,p,u,a){super(!0,v);this._extHostConfiguration=_,this._extHostWorkspace=p,this._extHostDocumentsAndEditors=u,this._logService=a,this._isWorkspaceShellAllowed=!1,(0,P.getSystemShell)(E.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,_,p){const u=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:v,shellPath:_,shellArgs:p},v);return this._terminals.push(u),u.create(_,p),u.value}createTerminalFromOptions(v,_){const p=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),v,v.name);return this._terminals.push(p),p.create((0,I.withNullAsUndefined)(v.shellPath),(0,I.withNullAsUndefined)(v.shellArgs),(0,I.withNullAsUndefined)(v.cwd),(0,I.withNullAsUndefined)(v.env),(0,I.withNullAsUndefined)(v.icon),(0,I.withNullAsUndefined)(v.message),void 0,(0,I.withNullAsUndefined)(v.strictEnv),(0,I.withNullAsUndefined)(v.hideFromUser),(0,I.withNullAsUndefined)(_),!0),p.value}getDefaultShell(v,_){var p;const u=a=>{const t=_.getConfiguration(a.substr(0,a.lastIndexOf("."))).inspect(a.substr(a.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return g.getDefaultShell(u,this._isWorkspaceShellAllowed,(p=this._defaultShell)!==null&&p!==void 0?p:(0,P.getSystemShellSync)(E.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,_){const p=u=>{const a=_.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(a)};return g.getDefaultShellArgs(p,this._isWorkspaceShellAllowed,v,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const _=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,s.detectAvailableProfiles)(v,void 0,this._logService,_,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,_),args:this.getDefaultShellArgs(v,_)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};d=je([Ue(0,R.IExtHostRpcService),Ue(1,A.IExtHostConfiguration),Ue(2,w.IExtHostWorkspace),Ue(3,i.IExtHostDocumentsAndEditors),Ue(4,D.ILogService)],d),e.ExtHostTerminalService=d}),define(ge[265],ve([0,1,19,17,66,6,2,5,255,12,78,81,27,184,13,61,42,34]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(u,a,t,n){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new y.RPCProtocol(u,null,n);a=_._transform(a,o);const r=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(w.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},a)),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(o)),r.set(d.IURITransformerService,new d.URITransformerService(n)),r.set(S.IHostUtils,t);const l=new g.InstantiationService(r,!0),h=l.invokeFunction(f=>f.get(v.IExtHostTerminalService));this._disposables.add(h),this._logService=l.invokeFunction(f=>f.get(i.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",a),this._extensionService=l.invokeFunction(f=>f.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(k,L)=>{let $="",ee,H;for(const x of L)$+=`
	at ${x.toString()}`,H=x.getFileName(),!ee&&H&&(ee=f.findSubstr(H));return m.set(k,ee),`${k.name||"Error"}: ${k.message||""}${$}`}});const b=o.getProxy(A.MainContext.MainThreadExtensionService),c=o.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{const k=I.transformErrorForSerialization(f),L=m.get(f);L?b.$onExtensionRuntimeError(L.identifier,k):c.$onUnexpectedError(k)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const a=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),a]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,a){u.extensions.forEach(n=>n.extensionLocation=D.URI.revive(a.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=D.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>D.URI.revive(a.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=D.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=D.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=D.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=D.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.logFile=D.URI.revive(a.transformIncomingURIs(u.logFile)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=_}),define(ge[266],ve([0,1,8,21,58,33,25,46,31]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class i{constructor(w,g,s){this.config=w,this.provider=g,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&P.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&P.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const g=this.config.folderQueries||[];return new Promise((s,d)=>{const S=v=>{this.resultCount++,w(v)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const _=v.toString(),p=E.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,p)||this.matchFile(S,{base:v,basename:p})}),Promise.all(g.map(v=>this.searchInFolder(v,S))).then(v=>{s({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{d(new Error((0,T.toErrorMessage)(v)))})})}async searchInFolder(w,g){const s=new I.CancellationTokenSource,d=this.getSearchOptionsForFolder(w),S=this.initDirectoryTree(),v=new y.QueryGlobTester(this.config,w),_=!v.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(s),p=A.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,s.token),a=p.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const o=E.posix.relative(w.folder.path,n.path);if(_){const r=E.basename(n.path);this.matchFile(g,{base:w.folder,relativePath:o,basename:r});return}this.addDirectoryEntries(S,w.folder,o,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,v,g),{providerTime:a,postProcessTime:t.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(w){const g=(0,y.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:s,includes:g,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},g,s,d){if(s===this.filePattern){const v=E.basename(this.filePattern);this.matchFile(d,{base:g,relativePath:this.filePattern,basename:v})}function S(v){const _=E.basename(v),p=E.dirname(v);let u=w[p];u||(u=w[p]=[],S(p)),u.push({base:g,relativePath:v,basename:_})}S(s)}matchDirectoryTree({rootEntries:w,pathToEntries:g},s,d){const S=this,v=this.filePattern;function _(p){const u=P.hasSiblingFn(()=>p.map(a=>a.basename));for(let a=0,t=p.length;a<t;a++){const n=p[a],{relativePath:o,basename:r}=n;if(!!s.includedInQuerySync(o,r,v!==r?u:void 0)){const l=g[o];if(l)_(l);else{if(o===v)continue;S.matchFile(d,n)}if(S.isLimitHit)break}}}_(w)}matchFile(w,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(g))}}class R{constructor(){this.sessions=new Map}fileSearch(w,g,s,d){const S=this.getSessionTokenSource(w.cacheKey),v=new i(w,g,S&&S.token);let _=0;const p=u=>{_+=u.length,s(u.map(a=>this.rawMatchToSearchItem(a)))};return this.doSearch(v,R.BATCH_SIZE,p,d).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:u.stats}}))}clearCache(w){const g=this.getSessionTokenSource(w);g&&g.cancel()}getSessionTokenSource(w){if(!!w)return this.sessions.has(w)||this.sessions.set(w,new I.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:D.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,g,s,d){d.onCancellationRequested(()=>{w.cancel()});const S=_=>{_&&(v.push(_),g>0&&v.length>=g&&(s(v),v=[]))};let v=[];return w.search(S).then(_=>(v.length&&s(v),_),_=>(v.length&&s(v),Promise.reject(_)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ge[126],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class E{constructor(P,D){this.line=P,this.character=D}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,D){return new E(0,0)}with(P){return new E(0,0)}}e.Position=E;class I{constructor(P,D,A,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(P,D),this.end=new E(A,y)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new I(0,0,0,0)}with(P){return new I(0,0,0,0)}}e.Range=I}),define(ge[127],ve([0,1,8,18,21,58,25,33,2,31,11]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(_,p,u){this.query=_,this.provider=p,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,p){const u=this.query.folderQueries||[],a=new T.CancellationTokenSource;return p.onCancellationRequested(()=>a.cancel()),new Promise((t,n)=>{this.collector=new g(_);let o=!1;const r=(l,h)=>{if(!o&&!this.isLimitHit){const m=this.resultSize(l);d(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,o=!0,a.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const b=this.resultSize(l);this.resultCount+=b,(b>0||!d(l))&&this.collector.add(l,h)}};Promise.all(u.map((l,h)=>this.searchInFolder(l,m=>r(m,h),a.token))).then(l=>{a.dispose(),this.collector.flush();const h=l.some(m=>!!m&&!!m.limitHit);t({limitHit:this.isLimitHit||h,stats:{type:"textSearchProvider"}})},l=>{a.dispose();const h=(0,P.toErrorMessage)(l);n(new Error(h))})})}resultSize(_){return d(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,p){const u=Array.isArray(_.ranges)?_.ranges:[_.ranges],a=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:u.slice(0,p),preview:{matches:a.slice(0,p),text:_.preview.text},uri:_.uri}}async searchInFolder(_,p,u){const a=new i.QueryGlobTester(this.query,_),t=[],n={report:l=>{if(!!this.validateProviderResult(l)){const h=_.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,m=D.relativePath(_.folder,l.uri);m&&t.push(a.includedInQuery(m,E.basename(m),h).then(b=>{b&&p(l)}))}}},o=this.getSearchOptionsForFolder(_),r=await this.provider.provideTextSearchResults(w(this.query.contentPattern),o,n,u);return await Promise.all(t),r}validateProviderResult(_){if(d(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const p=(0,i.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),u=(0,i.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),a={folder:y.URI.from(_.folder),excludes:u,includes:p,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=C;function w(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class g{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,p=>this.sendItems(p))}add(_,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(s(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=g;function s(v){return d(v)?{preview:{matches:(0,I.mapArrayOrNot)(v.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:v.preview.text},ranges:(0,I.mapArrayOrNot)(v.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function d(v){return!!v.preview}e.extensionResultIsMatch=d;class S{constructor(_,p){this.maxBatchSize=_,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,p){!_||this.addItemToBatch(_,p)}addItems(_,p){!_||this.addItemsToBatch(_,p)}addItemToBatch(_,p){this.batch.push(_),this.batchSize+=p,this.onUpdate()}addItemsToBatch(_,p){this.batch=this.batch.concat(_),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(ge[67],ve([0,1,6,5,4,266,13,61,12,2,127]),function(Q,e,E,I,T,P,D,A,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(d,S,v){this.extHostRpc=d,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,S){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(d)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(d,S){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(d)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(d,S,v,_){const p=w(v),u=this._fileSearchProvider.get(d);if(u)return this._fileSearchManager.fileSearch(p,u,a=>{this._proxy.$handleFileMatch(d,S,a.map(t=>t.resource))},_);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,S,v,_){const p=this._textSearchProvider.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const u=w(v);return this.createTextSearchManager(u,p).search(t=>this._proxy.$handleTextMatch(d,S,t),_)}createTextSearchManager(d,S){return new R.TextSearchManager(d,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};C=je([Ue(0,D.IExtHostRpcService),Ue(1,A.IURITransformerService),Ue(2,y.ILogService)],C),e.ExtHostSearch=C;function w(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(g),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>i.URI.revive(d))})}e.reviveQuery=w;function g(s){return Object.assign(Object.assign({},s),{folder:i.URI.revive(s.folder)})}}),define(ge[267],ve([0,1,158,21,17,3,56,2,150,104,140,76,44,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,63,219,242,243,244,88,34,245,220,20,7,248,64,125,32,41,53,200,237,114,124,65,45,67,12,61,13,27,241,198,50,62,227,246,197,89,87,251,249,250,228,60,258,247,86,194,117]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p,u,a,t,n,o,r,l,h,m,b,c,f,k,L,$,ee,H,x,B,F,U,M,N,O,j,K,X,me,we,Ae,Ie,Me,V,Y,te,ae,fe,De,Oe,be,ke,Te,xe,Se,Ke,G,re,Ee,Ne,Ve,Be,et,q,oe,he,Z,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function pe(_e){const He=_e.get(Oe.IExtHostInitDataService),We=_e.get(q.IExtHostFileSystemInfo),qe=_e.get(Ee.IExtHostConsumerFileSystem),Ye=_e.get(r.IExtHostExtensionService),Ze=_e.get(K.IExtHostWorkspace),ut=_e.get(le.IExtHostTelemetry),ot=_e.get(_.IExtHostConfiguration),nt=_e.get(fe.IURITransformerService),ue=_e.get(De.IExtHostRpcService),Ce=_e.get(H.IExtHostStorage),ce=_e.get(re.IExtensionStoragePaths),J=_e.get(ae.ILogService),Re=_e.get(Te.IExtHostTunnelService),Le=_e.get(xe.IExtHostApiDeprecationService),Je=_e.get(j.IExtHostWindow),Ge=_e.get(Z.IExtHostSecretState);ue.set(g.ExtHostContext.ExtHostFileSystemInfo,We),ue.set(g.ExtHostContext.ExtHostLogService,J),ue.set(g.ExtHostContext.ExtHostWorkspace,Ze),ue.set(g.ExtHostContext.ExtHostConfiguration,ot),ue.set(g.ExtHostContext.ExtHostExtensionService,Ye),ue.set(g.ExtHostContext.ExtHostStorage,Ce),ue.set(g.ExtHostContext.ExtHostTunnelService,Re),ue.set(g.ExtHostContext.ExtHostWindow,Je),ue.set(g.ExtHostContext.ExtHostSecretState,Ge),ue.set(g.ExtHostContext.ExtHostTelemetry,ut);const rt=ue.set(g.ExtHostContext.ExtHostDecorations,_e.get(Me.IExtHostDecorations)),at=ue.set(g.ExtHostContext.ExtHostDocumentsAndEditors,_e.get(o.IExtHostDocumentsAndEditors)),Qe=ue.set(g.ExtHostContext.ExtHostCommands,_e.get(S.IExtHostCommands)),ct=ue.set(g.ExtHostContext.ExtHostTerminalService,_e.get(x.IExtHostTerminalService)),st=ue.set(g.ExtHostContext.ExtHostDebugService,_e.get(Y.IExtHostDebugService)),gt=ue.set(g.ExtHostContext.ExtHostSearch,_e.get(te.IExtHostSearch)),Et=ue.set(g.ExtHostContext.ExtHostTask,_e.get(V.IExtHostTask)),Dt=ue.set(g.ExtHostContext.ExtHostOutputService,_e.get(f.IExtHostOutputService)),wt=ue.set(g.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=ue.set(g.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(ue)),pt=ue.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,at)),Lt=ue.set(g.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(ue,at,J)),Ft=ue.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(J,pt,ue.getProxy(g.MainContext.MainThreadBulkEdits))),ft=ue.set(g.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Qe,at,pt,He.environment,J,ce)),yt=ue.set(g.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(ue,at)),Vt=ue.set(g.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(ue.getProxy(g.MainContext.MainThreadTreeViews),Qe,J)),Qt=ue.set(g.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ue.getProxy(g.MainContext.MainThreadEditorInsets),yt,He.environment)),Mt=ue.set(g.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ue,J)),ht=ue.set(g.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ue,nt,pt,Qe,Mt,J,Le)),Xt=ue.set(g.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ue,ht)),kt=ue.set(g.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(ue,J,at)),Nt=ue.set(g.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Qe)),jt=ue.set(g.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(ue,Qe,J)),Jt=ue.set(g.ExtHostContext.ExtHostComments,new v.ExtHostComments(ue,Qe,pt)),sn=ue.set(g.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(ue.getProxy(g.MainContext.MainThreadProgress))),gn=ue.set(g.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(ue)),on=ue.set(g.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(ue)),Ot=ue.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(ue)),pn=ue.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Qe)),Ut=ue.set(g.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,He.environment,Ze,J,Le)),xt=ue.set(g.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(ue,Ut,Ze)),vn=ue.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ue,pt,ce,Ut,xt)),wn=ue.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ue,Ut)),At=ue.set(g.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(ue,at,Ze)),bn=ue.set(g.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),qt=(0,me.values)(g.ExtHostContext);ue.assertRegistered(qt);const _n=new et.ExtHostBulkEdits(ue,at),En=new d.ExtHostClipboard(ue),Bt=new c.ExtHostMessageService(ue,J),an=new u.ExtHostDialogs(ue),Kt=new ee.ExtHostStatusBar(ue,Qe.converter),Wt=new b.ExtHostLanguages(ue,pt);return s.ExtHostApiCommands.register(Qe),function(Fe,Yt,Zt){const mt=function(){let ie=!Fe.isUnderDevelopment;function de(Pe){ie||(J.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Pe(lt){if(Array.isArray(lt))lt.forEach(Pe);else if(typeof lt=="string")de(lt);else{const bt=lt;typeof bt.scheme=="undefined"&&de(lt),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,X.throwProposedApiError)(Fe)}return lt}}(),Sn={getSession(ie,de,Pe){return Ot.getSession(Fe,ie,de,Pe)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(ie,de,Pe,lt){return Ot.registerAuthenticationProvider(ie,de,Pe,lt)},get onDidChangeAuthenticationProviders(){return(0,X.checkProposedApiEnabled)(Fe),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,X.checkProposedApiEnabled)(Fe),Ot.providers},logout(ie,de){return(0,X.checkProposedApiEnabled)(Fe),Ot.removeSession(ie,de)}},yn={registerCommand(ie,de,Pe){return Qe.registerCommand(!0,ie,de,Pe)},registerTextEditorCommand(ie,de,Pe){return Qe.registerCommand(!0,ie,(...lt)=>{const bt=yt.getActiveTextEditor();if(!bt){J.warn("Cannot execute "+ie+" because there is no active text editor.");return}return bt.edit(z=>{de.apply(Pe,[bt,z,...lt])}).then(z=>{z||J.warn("Edits from command "+ie+" were not applied.")},z=>{J.warn("An error occurred while running command "+ie,z)})})},registerDiffInformationCommand:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),Qe.registerCommand(!0,ie,async(...lt)=>{const bt=at.activeEditor(!0);if(!bt){J.warn("Cannot execute "+ie+" because there is no active text editor.");return}const z=await yt.getDiffInformation(bt.id);de.apply(Pe,[z,...lt])})),executeCommand(ie,...de){return Qe.executeCommand(ie,...de)},getCommands(ie=!1){return Qe.getCommands(ie)}},ln={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var ie,de;return(de=(ie=He.environment.appRoot)===null||ie===void 0?void 0:ie.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return En.value},get shell(){return ct.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return Je.openUri(ie,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ie){return ie.scheme===He.environment.appUriScheme?St.createAppUri(ie):Je.asExternalUri(ie,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(ln);const cn=He.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Dn={registerTestProvider(ie){return(0,X.checkProposedApiEnabled)(Fe),At.registerTestProvider(ie)},createDocumentTestObserver(ie){return(0,X.checkProposedApiEnabled)(Fe),At.createTextDocumentTestObserver(ie)},createWorkspaceTestObserver(ie){return(0,X.checkProposedApiEnabled)(Fe),At.createWorkspaceTestObserver(ie)},runTests(ie){return(0,X.checkProposedApiEnabled)(Fe),At.runTests(ie)},publishTestResult(ie,de=!0){return(0,X.checkProposedApiEnabled)(Fe),At.publishExtensionProvidedResults(ie,de)},get onDidChangeTestResults(){return(0,X.checkProposedApiEnabled)(Fe),At.onResultsChanged},get testResults(){return(0,X.checkProposedApiEnabled)(Fe),At.results}},en={getExtension(ie){const de=Yt.getExtensionDescription(ie);if(de)return new r.Extension(Ye,Fe.identifier,de,cn)},get all(){return Yt.getAllExtensionDescriptions().map(ie=>new r.Extension(Ye,Fe.identifier,ie,cn))},get onDidChange(){return Yt.onDidChange}},Cn={createDiagnosticCollection(ie){return Mt.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:ie=>Mt.getDiagnostics(ie),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ie,de){return Wt.changeLanguage(ie.uri,de)},match(ie,de){return(0,C.score)(U.LanguageSelector.from(ie),de.uri,de.languageId,!0)},registerCodeActionsProvider(ie,de,Pe){return ht.registerCodeActionProvider(Fe,mt(ie),de,Pe)},registerCodeLensProvider(ie,de){return ht.registerCodeLensProvider(Fe,mt(ie),de)},registerDefinitionProvider(ie,de){return ht.registerDefinitionProvider(Fe,mt(ie),de)},registerDeclarationProvider(ie,de){return ht.registerDeclarationProvider(Fe,mt(ie),de)},registerImplementationProvider(ie,de){return ht.registerImplementationProvider(Fe,mt(ie),de)},registerTypeDefinitionProvider(ie,de){return ht.registerTypeDefinitionProvider(Fe,mt(ie),de)},registerHoverProvider(ie,de){return ht.registerHoverProvider(Fe,mt(ie),de,Fe.identifier)},registerEvaluatableExpressionProvider(ie,de){return ht.registerEvaluatableExpressionProvider(Fe,mt(ie),de,Fe.identifier)},registerInlineValuesProvider(ie,de){return ht.registerInlineValuesProvider(Fe,mt(ie),de,Fe.identifier)},registerDocumentHighlightProvider(ie,de){return ht.registerDocumentHighlightProvider(Fe,mt(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ht.registerLinkedEditingRangeProvider(Fe,mt(ie),de)},registerReferenceProvider(ie,de){return ht.registerReferenceProvider(Fe,mt(ie),de)},registerRenameProvider(ie,de){return ht.registerRenameProvider(Fe,mt(ie),de)},registerDocumentSymbolProvider(ie,de,Pe){return ht.registerDocumentSymbolProvider(Fe,mt(ie),de,Pe)},registerWorkspaceSymbolProvider(ie){return ht.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,de){return ht.registerDocumentFormattingEditProvider(Fe,mt(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ht.registerDocumentRangeFormattingEditProvider(Fe,mt(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Pe,...lt){return ht.registerOnTypeFormattingEditProvider(Fe,mt(ie),de,[Pe].concat(lt))},registerDocumentSemanticTokensProvider(ie,de,Pe){return ht.registerDocumentSemanticTokensProvider(Fe,mt(ie),de,Pe)},registerDocumentRangeSemanticTokensProvider(ie,de,Pe){return ht.registerDocumentRangeSemanticTokensProvider(Fe,mt(ie),de,Pe)},registerSignatureHelpProvider(ie,de,Pe,...lt){return typeof Pe=="object"?ht.registerSignatureHelpProvider(Fe,mt(ie),de,Pe):ht.registerSignatureHelpProvider(Fe,mt(ie),de,typeof Pe=="undefined"?[]:[Pe,...lt])},registerCompletionItemProvider(ie,de,...Pe){return ht.registerCompletionItemProvider(Fe,mt(ie),de,Pe)},registerDocumentLinkProvider(ie,de){return ht.registerDocumentLinkProvider(Fe,mt(ie),de)},registerColorProvider(ie,de){return ht.registerColorProvider(Fe,mt(ie),de)},registerFoldingRangeProvider(ie,de){return ht.registerFoldingRangeProvider(Fe,mt(ie),de)},registerSelectionRangeProvider(ie,de){return ht.registerSelectionRangeProvider(Fe,ie,de)},registerCallHierarchyProvider(ie,de){return ht.registerCallHierarchyProvider(Fe,ie,de)},setLanguageConfiguration:(ie,de)=>ht.setLanguageConfiguration(Fe,ie,de),getTokenInformationAtPosition(ie,de){return(0,X.checkProposedApiEnabled)(Fe),Wt.tokenAtPosition(ie,de)},registerInlineHintsProvider(ie,de){return(0,X.checkProposedApiEnabled)(Fe),ht.registerInlineHintsProvider(Fe,ie,de)}},kn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(ie,de,Pe){const lt=await(A.URI.isUri(ie)?Promise.resolve(un.openTextDocument(ie)):Promise.resolve(ie));return yt.showTextDocument(lt,de,Pe)},createTextEditorDecorationType(ie){return yt.createTextEditorDecorationType(ie)},onDidChangeActiveTextEditor(ie,de,Pe){return yt.onDidChangeActiveTextEditor(ie,de,Pe)},onDidChangeVisibleTextEditors(ie,de,Pe){return yt.onDidChangeVisibleTextEditors(ie,de,Pe)},onDidChangeTextEditorSelection(ie,de,Pe){return yt.onDidChangeTextEditorSelection(ie,de,Pe)},onDidChangeTextEditorOptions(ie,de,Pe){return yt.onDidChangeTextEditorOptions(ie,de,Pe)},onDidChangeTextEditorVisibleRanges(ie,de,Pe){return yt.onDidChangeTextEditorVisibleRanges(ie,de,Pe)},onDidChangeTextEditorViewColumn(ie,de,Pe){return yt.onDidChangeTextEditorViewColumn(ie,de,Pe)},onDidCloseTerminal(ie,de,Pe){return ct.onDidCloseTerminal(ie,de,Pe)},onDidOpenTerminal(ie,de,Pe){return ct.onDidOpenTerminal(ie,de,Pe)},onDidChangeActiveTerminal(ie,de,Pe){return ct.onDidChangeActiveTerminal(ie,de,Pe)},onDidChangeTerminalDimensions(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalDimensions(ie,de,Pe)},onDidWriteTerminalData(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ct.onDidWriteTerminalData(ie,de,Pe)},get state(){return Je.state},onDidChangeWindowState(ie,de,Pe){return Je.onDidChangeWindowState(ie,de,Pe)},showInformationMessage(ie,...de){return Bt.showMessage(Fe,D.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return Bt.showMessage(Fe,D.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return Bt.showMessage(Fe,D.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Pe){return Nt.showQuickPick(ie,!!Fe.enableProposedApi,de,Pe)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Nt.showInput(ie,de)},showOpenDialog(ie){return an.showOpenDialog(ie)},showSaveDialog(ie){return an.showSaveDialog(ie)},createStatusBarItem(ie,de){let Pe,lt,bt,z;return ie&&typeof ie!="number"?(Pe=ie.id,lt=ie.name,bt=ie.alignment,de=ie.priority,z=ie.accessibilityInformation):(Pe=Fe.identifier.value,lt=E.localize(0,null,Fe.displayName||Fe.name),bt=ie),Kt.createStatusBarEntry(Pe,lt,bt,de,z)},setStatusBarMessage(ie,de){return Kt.setStatusBarMessage(ie,de)},withScmProgress(ie){return Le.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),sn.withProgress(Fe,{location:M.ProgressLocation.SourceControl},(de,Pe)=>ie({report(lt){}}))},withProgress(ie,de){return sn.withProgress(Fe,ie,de)},createOutputChannel(ie){return Dt.createOutputChannel(ie)},createWebviewPanel(ie,de,Pe,lt){return xt.createWebviewPanel(Fe,ie,de,Pe,lt)},createWebviewTextEditorInset(ie,de,Pe,lt){return(0,X.checkProposedApiEnabled)(Fe),Qt.createWebviewEditorInset(ie,de,Pe,lt,Fe)},createTerminal(ie,de,Pe){return typeof ie=="object"?"pty"in ie?ct.createExtensionTerminal(ie):(ie.message&&(0,X.checkProposedApiEnabled)(Fe),ie.icon&&(0,X.checkProposedApiEnabled)(Fe),ct.createTerminalFromOptions(ie)):ct.createTerminal(ie,de,Pe)},registerTerminalLinkProvider(ie){return ct.registerLinkProvider(ie)},registerTreeDataProvider(ie,de){return Vt.registerTreeDataProvider(ie,de,Fe)},createTreeView(ie,de){return Vt.createTreeView(ie,de,Fe)},registerWebviewPanelSerializer:(ie,de)=>xt.registerWebviewPanelSerializer(Fe,ie,de),registerCustomEditorProvider:(ie,de,Pe={})=>vn.registerCustomEditorProvider(Fe,ie,de,Pe),registerFileDecorationProvider(ie){return rt.registerFileDecorationProvider(ie,Fe.identifier)},registerUriHandler(ie){return St.registerUriHandler(Fe.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Pe){return on.onDidChangeActiveColorTheme(ie,de,Pe)},registerWebviewViewProvider(ie,de,Pe){return wn.registerWebviewViewProvider(Fe,ie,de,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,X.checkProposedApiEnabled)(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookEditor(ie,de,Pe)},get visibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorSelection(ie,de,Pe)},onDidChangeNotebookEditorVisibleRanges(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorVisibleRanges(ie,de,Pe)},showNotebookDocument(ie,de){return(0,X.checkProposedApiEnabled)(Fe),ft.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),bn.registerExternalUriOpener(Fe.identifier,ie,de,Pe)},get openEditors(){return(0,X.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,X.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},un={get rootPath(){return Le.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(ie){throw T.readonly()},getWorkspaceFolder(ie){return Ze.getWorkspaceFolder(ie)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(ie){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(ie){throw T.readonly()},updateWorkspaceFolders:(ie,de,...Pe)=>Ze.updateWorkspaceFolders(Fe,ie,de||0,...Pe),onDidChangeWorkspaceFolders:function(ie,de,Pe){return Ze.onDidChangeWorkspace(ie,de,Pe)},asRelativePath:(ie,de)=>Ze.getRelativePath(ie,de),findFiles:(ie,de,Pe,lt)=>Ze.findFiles(U.GlobPattern.from(ie),U.GlobPattern.from(de),Pe,Fe.identifier,lt),findTextInFiles:(ie,de,Pe,lt)=>{let bt,z;return typeof de=="object"?(bt=de,z=Pe):(bt={},z=de,lt=Pe),Ze.findTextInFiles(ie,bt||{},z,Fe.identifier,lt)},saveAll:ie=>Ze.saveAll(ie),applyEdit(ie){return _n.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,de,Pe,lt)=>kt.createFileSystemWatcher(U.GlobPattern.from(ie),de,Pe,lt),get textDocuments(){return pt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw T.readonly()},openTextDocument(ie){let de;const Pe=ie;if(typeof ie=="string")de=Promise.resolve(A.URI.file(ie));else if(A.URI.isUri(ie))de=Promise.resolve(ie);else if(!Pe||typeof Pe=="object")de=pt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(lt=>pt.ensureDocumentData(lt).then(bt=>bt.document))},onDidOpenTextDocument:(ie,de,Pe)=>pt.onDidAddDocument(ie,de,Pe),onDidCloseTextDocument:(ie,de,Pe)=>pt.onDidRemoveDocument(ie,de,Pe),onDidChangeTextDocument:(ie,de,Pe)=>pt.onDidChangeDocument(ie,de,Pe),onDidSaveTextDocument:(ie,de,Pe)=>pt.onDidSaveDocument(ie,de,Pe),onWillSaveTextDocument:(ie,de,Pe)=>Ft.getOnWillSaveTextDocumentEvent(Fe)(ie,de,Pe),onDidChangeConfiguration:(ie,de,Pe)=>Zt.onDidChangeConfiguration(ie,de,Pe),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,Zt.getConfiguration(ie,de,Fe)},registerTextDocumentContentProvider(ie,de){return Lt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(Le.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Fe,ie,de)),registerFileSystemProvider(ie,de,Pe){return Xt.registerFileSystemProvider(Fe.identifier,ie,de,Pe)},get fs(){return qe.value},registerFileSearchProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),gt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),gt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),Ye.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,X.checkProposedApiEnabled)(Fe),gn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Pe)=>kt.onDidCreateFile(ie,de,Pe),onDidDeleteFiles:(ie,de,Pe)=>kt.onDidDeleteFile(ie,de,Pe),onDidRenameFiles:(ie,de,Pe)=>kt.onDidRenameFile(ie,de,Pe),onWillCreateFiles:(ie,de,Pe)=>kt.getOnWillCreateFileEvent(Fe)(ie,de,Pe),onWillDeleteFiles:(ie,de,Pe)=>kt.getOnWillDeleteFileEvent(Fe)(ie,de,Pe),onWillRenameFiles:(ie,de,Pe)=>kt.getOnWillRenameFileEvent(Fe)(ie,de,Pe),openTunnel:ie=>((0,X.checkProposedApiEnabled)(Fe),Re.openTunnel(Fe,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,X.checkProposedApiEnabled)(Fe),Re.getTunnels()},onDidChangeTunnels:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),Re.onDidChangeTunnels(ie,de,Pe)),registerPortAttributesProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),Re.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),pn.registerTimelineProvider(ie,de,Fe.identifier,Qe.converter)),get trustState(){return(0,X.checkProposedApiEnabled)(Fe),Ze.trustState},requestWorkspaceTrust:ie=>((0,X.checkProposedApiEnabled)(Fe),Ze.requestWorkspaceTrust(ie)),onDidChangeWorkspaceTrustState:(ie,de,Pe)=>Ze.onDidChangeWorkspaceTrustState(ie,de,Pe)},In={get inputBox(){return Le.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Fe)},createSourceControl(ie,de,Pe){return jt.createSourceControl(Fe,ie,de,Pe)}},Pn={createCommentController(ie,de){return Jt.createCommentController(Fe,ie,de)}},dn={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(ie,de,Pe){return st.onDidStartDebugSession(ie,de,Pe)},onDidTerminateDebugSession(ie,de,Pe){return st.onDidTerminateDebugSession(ie,de,Pe)},onDidChangeActiveDebugSession(ie,de,Pe){return st.onDidChangeActiveDebugSession(ie,de,Pe)},onDidReceiveDebugSessionCustomEvent(ie,de,Pe){return st.onDidReceiveDebugSessionCustomEvent(ie,de,Pe)},onDidChangeBreakpoints(ie,de,Pe){return st.onDidChangeBreakpoints(ie,de,Pe)},registerDebugConfigurationProvider(ie,de,Pe){return st.registerDebugConfigurationProvider(ie,de,Pe||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return st.registerDebugAdapterDescriptorFactory(Fe,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return st.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?st.startDebugging(ie,de,{parentSession:Pe}):st.startDebugging(ie,de,Pe||{})},stopDebugging(ie){return st.stopDebugging(ie)},addBreakpoints(ie){return st.addBreakpoints(ie)},removeBreakpoints(ie){return st.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return st.asDebugSourceUri(ie,de)}},Gt={registerTaskProvider:(ie,de)=>Et.registerTaskProvider(Fe,ie,de),fetchTasks:ie=>Et.fetchTasks(ie),executeTask:ie=>Et.executeTask(Fe,ie),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ie,de,Pe)=>Et.onDidStartTask(ie,de,Pe),onDidEndTask:(ie,de,Pe)=>Et.onDidEndTask(ie,de,Pe),onDidStartTaskProcess:(ie,de,Pe)=>Et.onDidStartTaskProcess(ie,de,Pe),onDidEndTaskProcess:(ie,de,Pe)=>Et.onDidEndTaskProcess(ie,de,Pe)},hn={openNotebookDocument:ie=>((0,X.checkProposedApiEnabled)(Fe),ft.openNotebookDocument(ie)),get onDidOpenNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,X.checkProposedApiEnabled)(Fe),ft.notebookDocuments.map(ie=>ie.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookSerializer(Fe,ie,de,Pe)},registerNotebookContentProvider:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookContentProvider(Fe,ie,de,Pe)),registerNotebookKernelProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookKernelProvider(Fe,ie,de)),createNotebookEditorDecorationType(ie){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookEditorDecorationType(ie)},onDidChangeNotebookDocumentMetadata(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookDocumentMetadata(ie,de,Pe)},onDidChangeNotebookCells(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCells(ie,de,Pe)},onDidChangeCellExecutionState(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCellExecutionState(ie,de,Pe)},onDidChangeCellOutputs(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeCellOutputs(ie,de,Pe)},onDidChangeCellMetadata(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeCellMetadata(ie,de,Pe)},createConcatTextDocument(ie,de){return(0,X.checkProposedApiEnabled)(Fe),new G.ExtHostNotebookConcatDocument(ft,pt,ie,de)},createCellStatusBarItem(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookCellStatusBarItemInternal(ie,de,Pe)},createNotebookCellExecutionTask(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookCellExecution(ie,de,Pe)}};return{version:He.version,authentication:Sn,commands:yn,comments:Pn,debug:dn,env:ln,extensions:en,languages:Cn,notebook:hn,scm:In,tasks:Gt,test:Dn,window:kn,workspace:un,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:w.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:R.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:i.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:A.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=pe}),define(ge[268],ve([0,1,78,63,32,124,35,51,39,34,65,45,67,89,88,50,62,125,87,60,86,117]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_,p,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,E.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,E.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,E.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,E.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,E.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,E.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,E.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,E.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch),(0,E.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,E.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,E.registerSingleton)(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),(0,E.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,E.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,E.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,E.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,E.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry)}),define(ge[90],ve([0,1,18,12,31,126]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function A(C,w,g,s){const d=(0,E.mapArrayOrNot)(g,y),S=new T.TextSearchMatch(w,d,s),v=S.preview.matches;return{ranges:(0,E.mapArrayOrNot)(d,i),uri:C,preview:{text:S.preview.text,matches:(0,E.mapArrayOrNot)(v,i)}}}e.createTextSearchResult=A;function y(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function i(C){return new P.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(w,g){this.prefix=w,this.logService=g}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};R=je([Ue(1,I.ILogService)],R),e.OutputChannel=R}),define(ge[269],ve([0,1,91,22]),function(Q,e,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,D=512,A=512*8,y=512*128;class i{constructor(n){this.iconvLiteDecoder=n}static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((l,h)=>{Q(["iconv-lite-umd"],l,h)})).getDecoder(g(n));else{const r=new TextDecoder;o={write(l){return r.decode(l,{stream:!0})},end(){return r.decode()}}}return new i(o)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function R(t,n){var o;const r=((o=n.minBytesRequiredForDetection)!==null&&o!==void 0?o:n.guessEncoding)?A:D;return new Promise((l,h)=>{const m=(0,E.newWriteableStream)(L=>L.join("")),b=[];let c=0,f;const k=async()=>{try{const L=await a({buffer:I.VSBuffer.concat(b),bytesRead:c},n.guessEncoding);L.encoding=await n.overwriteEncoding(L.encoding),f=await i.create(L.encoding);const $=f.write(I.VSBuffer.concat(b).buffer);m.write($),b.length=0,c=0,l({stream:m,detected:L})}catch(L){h(L)}};(0,E.listenStream)(t,{onData:async L=>{f?m.write(f.write(L.buffer)):(b.push(L),c+=L.byteLength,c>=r&&(t.pause(),await k(),setTimeout(()=>t.resume())))},onError:L=>m.error(L),onEnd:async()=>{f||await k(),m.end(f==null?void 0:f.end())}})})}e.toDecodeStream=R;async function C(t,n,o){const l=(await new Promise((b,c)=>{Q(["iconv-lite-umd"],b,c)})).getEncoder(g(n),o);let h=!1,m=!1;return{read(){if(m)return null;const b=t.read();if(typeof b!="string"){if(m=!0,!h&&(o==null?void 0:o.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const c=l.end();return c&&c.length>0?(h=!0,I.VSBuffer.wrap(c)):null}return h=!0,I.VSBuffer.wrap(l.write(b))}}}e.toEncodeReadable=C;async function w(t){return(await new Promise((o,r)=>{Q(["iconv-lite-umd"],o,r)})).encodingExists(g(t))}e.encodingExists=w;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function s(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const d=["ascii","utf-16","utf-32"];async function S(t){const n=await new Promise((m,b)=>{Q(["jschardet"],m,b)}),o=t.slice(0,y),r=p(o.buffer),l=n.detect(r);if(!l||!l.encoding)return null;const h=l.encoding.toLowerCase();return 0<=d.indexOf(h)?null:_(l.encoding)}const v={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[n]||n}function p(t){let n="";for(let o=0;o<t.length;o++)n+=String.fromCharCode(t[o]);return n}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=u;function a({buffer:t,bytesRead:n},o){let r=s(t,n),l=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let h=!0,m=!0,b=!1;for(let c=0;c<n&&c<P;c++){const f=c%2==1,k=t.readUInt8(c)===0;if(k&&(b=!0),h&&(f&&!k||!f&&k)&&(h=!1),m&&(f&&k||!f&&!k)&&(m=!1),k&&!h&&!m)break}b&&(h?r=e.UTF16le:m?r=e.UTF16be:l=!0)}return o&&!l&&!r&&t?S(t.slice(0,n)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:l,encoding:r}}e.detectEncodingFromBuffer=a,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],ve([0,1,269,26,127]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends T.TextSearchManager{constructor(A,y,i=I){super(A,y,{readdir:R=>i.readdir(R.fsPath),toCanonicalName:R=>(0,E.toCanonicalName)(R)})}}e.NativeTextSearchManager=P}),define(ge[270],ve([0,1,271,285,286,2,287]),function(Q,e,E,I,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(C,w,g,s,d,S){const v=S.environment.useHostProxy,_=typeof v=="boolean"?v:!S.remote.isRemote,p=(0,D.createProxyResolver)({resolveProxy:a=>C.resolveProxy(a),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(a,t,...n)=>{switch(a){case D.LogLevel.Trace:s.trace(t,...n);break;case D.LogLevel.Debug:s.debug(t,...n);break;case D.LogLevel.Info:s.info(t,...n);break;case D.LogLevel.Warning:s.warn(t,...n);break;case D.LogLevel.Error:s.error(t,...n);break;case D.LogLevel.Critical:s.critical(t,...n);break;case D.LogLevel.Off:break;default:o(a,t,n);break}function o(r,l,...h){s.error("Unknown log level",r),s.error(l,...h)}},getLogLevel:()=>s.getLevel(),proxyResolveTelemetry:a=>{d.$publicLog2("resolveProxy",a)},useHostProxy:_,env:process.env}),u=y(w,p);return R(g,u)}e.connectProxyResolver=A;function y(C,w){const g={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{g.config=C.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{s.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"off"},s,!0)),on:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"on"},s,!0)),override:Object.assign({},E,(0,D.createHttpPatch)(E,w,{config:"override"},s,!0)),onRequest:Object.assign({},E,(0,D.createHttpPatch)(E,w,g,s,!0)),default:Object.assign(E,(0,D.createHttpPatch)(E,w,g,s,!1))},https:{off:Object.assign({},I,(0,D.createHttpPatch)(I,w,{config:"off"},s,!0)),on:Object.assign({},I,(0,D.createHttpPatch)(I,w,{config:"on"},s,!0)),override:Object.assign({},I,(0,D.createHttpPatch)(I,w,{config:"override"},s,!0)),onRequest:Object.assign({},I,(0,D.createHttpPatch)(I,w,g,s,!0)),default:Object.assign(I,(0,D.createHttpPatch)(I,w,g,s,!1))},tls:Object.assign(T,(0,D.createTlsPatch)(T))}}const i=new Map;function R(C,w){return C.getExtensionPathIndex().then(g=>{const s=Q.__$__nodeRequire("module"),d=s._load;s._load=function(v,_,p){if(v==="tls")return w.tls;if(v!=="http"&&v!=="https")return d.apply(this,arguments);const u=w[v],a=g.findSubstr(P.URI.file(_.filename).fsPath);let t=i.get(a);if(t||i.set(a,t={}),!t[v]){let n=u.default;a&&a.enableProposedApi&&(n=u[a.proxySupport]||u.onRequest),t[v]=Object.assign({},n)}return t[v]}})}}),define(ge[272],ve([0,1,38,8,74,30,9,10,90,273]),function(Q,e,E,I,T,P,D,A,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=i.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(p,u,a,t){const n=w(p,u,a,t),o=u.folder.fsPath;return{cmd:E.spawn(R,n.args,{cwd:o}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.spawnRipgrepCmd=C;function w(p,u,a,t){const n=["--files","--hidden","--case-sensitive"];s([u],a,!1).forEach(r=>{const l=(0,y.anchorGlob)(r);if(n.push("-g",l),D.isMacintosh){const h=(0,T.normalizeNFD)(l);h!==l&&n.push("-g",h)}});const o=g([u],t,void 0,!1);return o.globArgs.forEach(r=>{const l=`!${(0,y.anchorGlob)(r)}`;if(n.push("-g",l),D.isMacintosh){const h=(0,T.normalizeNFD)(l);h!==l&&n.push("-g",h)}}),u.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),u.ignoreSymlinks||n.push("--follow"),p.exists&&n.push("--quiet"),n.push("--no-config"),u.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function g(p,u,a,t=!0){const n=[];let o={};return p.forEach(r=>{const l=Object.assign({},r.excludePattern||{},u||{}),h=d(l,t?r.folder.fsPath:void 0,a);n.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:n,siblingClauses:o}}e.foldersToRgExcludeGlobs=g;function s(p,u,a=!0){const t=[];return p.forEach(n=>{const o=Object.assign({},u||{},n.includePattern||{}),r=d(o,a?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=s;function d(p,u,a){const t=[],n={};return Object.keys(p).forEach(o=>{if(!(a&&a.has(o))&&!!o){const r=p[o];o=v(u?S(u,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(_(o))):r&&r.when&&(n[o]=r)}}),{globArgs:t,siblingClauses:n}}function S(p,u){return I.isAbsolute(u)?u:I.join(p,u)}e.getAbsoluteGlob=S;function v(p){return p=A.rtrim(p,"\\"),A.rtrim(p,"/")}function _(p){return P.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=_}),define(ge[274],ve([0,1,38,37,8,98,18,58,33,74,30,9,46,10,14,26,31,272,96]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(o=>o())});class u{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),m=l.folder.fsPath;r.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==m).forEach(b=>{(0,R.isEqualOrParent)(b,m)&&(h[T.relative(m,b)]=!0)}),this.folderExcludePatterns.set(m,new t(h,m))})}cancel(){this.isCanceled=!0}walk(r,l,h,m,b){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);l.forEach(c=>{const f=T.basename(c.fsPath);this.globalExcludePattern&&this.globalExcludePattern(c.fsPath,f)||this.matchFile(h,{relativePath:c.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(r,(c,f)=>{this.call(this.cmdTraversal,this,c,h,m,k=>{if(k){const L=(0,A.toErrorMessage)(k);console.error(L),this.errors.push(L),f(k,void 0)}else f(null,void 0)})},(c,f)=>{this.fileWalkSW.stop();const k=c?D.coalesce(c)[0]:null;b(k,this.isLimitHit)})}parallel(r,l,h){const m=new Array(r.length),b=new Array(r.length);let c=!1,f=0;if(r.length===0)return h(null,[]);r.forEach((k,L)=>{l(k,($,ee)=>{if($?(c=!0,m[L]=null,b[L]=$):(m[L]=ee,b[L]=null),++f===r.length)return h(c?b:null,m)})})}call(r,l,...h){try{r.apply(l,h)}catch(m){h[h.length-1](m)}}cmdTraversal(r,l,h,m){const b=r.folder.fsPath,c=C.isMacintosh;let f;const k=()=>f&&f.kill();p.add(k);let L=U=>{p.delete(k),L=()=>{},m(U)},$="";const ee=this.initDirectoryTree();let H;const x=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);f=x.cmd,H=!Object.keys(x.siblingClauses).length;const B=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${B}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),h({message:F}),this.cmdResultCount=0,this.collectStdout(f,"utf8",h,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const j=($+(c?i.normalizeNFC(M||""):M)).split(`
`);if(N){const K=j.length;j[K-1]=j[K-1].trim(),j[K-1]||j.pop()}else $=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,H){for(const K of j)if(this.matchFile(l,{base:b,relativePath:K,searchPath:this.getSearchPath(r,K)}),this.isLimitHit){k();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ee,b,j,l),N&&(this.matchDirectoryTree(ee,b,l),L())})}spawnFindCmd(r){const l=this.folderExcludePatterns.get(r.folder.fsPath),h=l.getBasenameTerms(),m=l.getPathTerms(),b=["-L","."];if(h.length||m.length){b.push("-not","(","(");for(const c of h)b.push("-name",c),b.push("-o");for(const c of m)b.push("-path",c),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),E.spawn("find",b,{cwd:r.folder.fsPath})}readStdout(r,l,h){let m="";this.collectStdout(r,l,()=>{},(b,c,f)=>{if(b){h(b);return}m+=c,f&&h(null,m)})}collectStdout(r,l,h,m){let b=(k,L,$)=>{(k||$)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),m(k,L,$)},c=!1;r.stdout?(this.forwardData(r.stdout,l,b),r.stdout.once("data",()=>c=!0)):h({message:"stdout is null"});let f;r.stderr?f=this.collectData(r.stderr):h({message:"stderr is null"}),r.on("error",k=>{b(k)}),r.on("close",k=>{let L;!c&&(L=this.decodeData(f,l))&&n(L)?b(new Error(`command failed with error code ${k}: ${this.decodeData(f,l)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(r,l,h){const m=new P.StringDecoder(l);return r.on("data",b=>{h(null,m.write(b))}),m}collectData(r){const l=[];return r.on("data",h=>{l.push(h)}),l}decodeData(r,l){const h=new P.StringDecoder(l);return r.map(m=>h.write(m)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:l},h,m,b){m.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const c=f=>{const k=T.basename(f),L=T.dirname(f);let $=l[L];$||($=l[L]=[],c(L)),$.push({base:h,relativePath:f,basename:k,searchPath:this.getSearchPath(r,f)})};m.forEach(c)}matchDirectoryTree({rootEntries:r,pathToEntries:l},h,m){const b=this,c=this.folderExcludePatterns.get(h),f=this.filePattern;function k(L){b.directoriesWalked++;const $=y.hasSiblingFn(()=>L.map(ee=>ee.basename));for(let ee=0,H=L.length;ee<H;ee++){const x=L[ee],{relativePath:B,basename:F}=x;if(!c.test(B,F,f!==F?$:void 0)){const U=l[B];if(U)k(U);else{if(b.filesWalked++,B===f)continue;b.matchFile(m,x)}if(b.isLimitHit)break}}}k(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,l,h,m,b){const c=r.folder,f=y.hasSiblingFn(()=>h);this.parallel(h,(k,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const $=l?[l,k].join(T.sep):k;if(this.folderExcludePatterns.get(r.folder.fsPath).test($,k,this.config.filePattern!==k?f:void 0))return L(null);const ee=[c.fsPath,$].join(T.sep);I.lstat(ee,(H,x)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ee,x,(B,F)=>B||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,d.readdir)(ee).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,$,N,m,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&s.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(m,{base:c.fsPath,relativePath:$,searchPath:this.getSearchPath(r,$)}),L(null,void 0)))})},k=>{const L=k&&D.coalesce(k);return b(L&&L.length>0?L[0]:void 0)})}matchFile(r,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,T.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(l))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,l,h){return l.isSymbolicLink()?I.stat(r,h):h(null,l)}realPathIfNeeded(r,l,h){return l.isSymbolicLink()?I.realpath(r,(m,b)=>m?h(m):h(null,b)):h(null,r)}getSearchPath(r,l){return r.folderName?T.join(r.folderName,l):l}}e.FileWalker=u;class a{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new u(r)}search(r,l,h){this.walker.walk(this.folderQueries,this.extraFiles,r,l,(m,b)=>{h(m,{limitHit:b,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(r,l){this.expression=r,this.root=l,this.init(r)}init(r){let l,h;Object.keys(r).filter(m=>r[m]).forEach(m=>{T.isAbsolute(m)?(l=l||y.getEmptyExpression(),l[m]=r[m]):(h=h||y.getEmptyExpression(),h[m]=r[m])}),this.absoluteParsedExpr=l&&y.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(r,l,h){return this.relativeParsedExpr&&this.relativeParsedExpr(r,l,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),l,h)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function n(o){const r=o.trim().split(`
`),l=r[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=n}),define(ge[129],ve([0,1,38,288,98,18,53,33,8,10,2,31,126,289,273,90]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=s.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(c){this.outputChannel=c}provideTextSearchResults(c,f,k,L){return this.outputChannel.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify(Object.assign(Object.assign({},f),{folder:f.folder.toString()}))}`),new Promise(($,ee)=>{L.onCancellationRequested(()=>O());const H=n(c,f),x=f.folder.fsPath,B=H.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${B}
 - cwd: ${x}`);let F=E.spawn(S,H,{cwd:x});F.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),ee((0,C.serializeSearchError)(new C.SearchError(we&&we.message,C.SearchErrorCode.rgProcessError)))});let U=!1;const M=new u(f.maxResults,x,f.previewOptions);M.on("result",we=>{U=!0,K="",k.report(we)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let j=!1;M.on("hitLimit",()=>{j=!0,O()});let K="";F.stdout.on("data",we=>{M.handleData(we),U||(K+=we)});let X=!1;F.stdout.once("data",()=>X=!0);let me="";F.stderr.on("data",we=>{const Ae=we.toString();this.outputChannel.appendLine(Ae),me+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),N)$({limitHit:j});else{M.flush(),F=null;let we;me&&!X&&(we=_(me))?ee((0,C.serializeSearchError)(new C.SearchError(we.message,we.code))):$({limitHit:j})}})})}}e.RipgrepTextSearchEngine=v;function _(b){const c=b.split(`
`),f=c[0].trim();if(c.some(L=>L.startsWith("regex parse error")))return new C.SearchError(p(c),C.SearchErrorCode.regexParseError);const k=f.match(/grep config error: unknown encoding: (.*)/);if(k)return new C.SearchError(`Unknown encoding: ${k[1]}`,C.SearchErrorCode.unknownEncoding);if(f.startsWith("error parsing glob"))return new C.SearchError(f.charAt(0).toUpperCase()+f.substr(1),C.SearchErrorCode.globParseError);if(f.startsWith("the literal"))return new C.SearchError(f.charAt(0).toUpperCase()+f.substr(1),C.SearchErrorCode.invalidLiteral);if(f.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(f,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function p(b){const c=["Regex parse error"],f=b.filter(k=>k.startsWith("PCRE2:"));if(f.length>=1){const k=f[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const L=k.split(":")[1];c.push(":"+L)}}return c.join("")}e.buildRegexParseError=p;class u extends I.EventEmitter{constructor(c,f,k){super();this.maxResults=c,this.rootFolder=f,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(c,f){return super.on(c,f),this}handleData(c){if(!this.isDone){const f=typeof c=="string"?c:this.stringDecoder.write(c);this.handleDecodedData(f)}}handleDecodedData(c){let f=c.indexOf(`
`);const k=this.remainder+c;if(f>=0)f+=this.remainder.length;else{this.remainder=k;return}let L=0;for(;f>=0;)this.handleLine(k.substring(L,f).trim()),L=f+1,f=k.indexOf(`
`,L);this.remainder=k.substring(L)}handleLine(c){if(!(this.isDone||!c)){let f;try{f=JSON.parse(c)}catch(k){throw new Error(`malformed line from rg: ${c}`)}if(f.type==="match"){const k=a(f.data.path),L=R.URI.file(y.join(this.rootFolder,k)),$=this.createTextSearchMatch(f.data,L);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(f.type==="context"){const k=a(f.data.path),L=R.URI.file(y.join(this.rootFolder,k));this.createTextSearchContext(f.data,L).forEach(ee=>this.onResult(ee))}}}createTextSearchMatch(c,f){const k=c.line_number-1;let L=!1,$=a(c.lines);k===0&&(0,i.startsWithUTF8BOM)($)&&(L=!0,$=(0,i.stripUTF8BOM)($));const ee=Buffer.from($);let H=0,x=0,B=k;c.submatches.length===0&&c.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(c.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=a(U.match);k===0&&M===0&&L&&(N=(0,i.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=ee.slice(H,U.start).toString().length,j=x+O,K=t(N),X=B,me=K.numLines+X,we=K.numLines>0?K.lastLineLength:K.lastLineLength+j;return H=U.end,x=we,B=me,new w.Range(X,j,me,we)}));return(0,d.createTextSearchResult)(f,$,F,this.previewOptions)}createTextSearchContext(c,f){const k=a(c.lines),L=c.line_number;return k.replace(/\r?\n$/,"").split(`
`).map(($,ee)=>({text:$,uri:f,lineNumber:L+ee}))}onResult(c){this.emit("result",c)}}e.RipgrepParser=u;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const c=/\n/g;let f=0,k=-1,L;for(;L=c.exec(b);)f++,k=L.index;const $=k>=0?b.length-k-1:b.length;return{numLines:f,lastLineLength:$}}function n(b,c){const f=["--hidden"];f.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:L}=(0,D.groupBy)(c.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ee=new Set;L.forEach(H=>{ee.add(H)}),f.push("-g","!*"),ee.forEach(H=>{o(H).map(d.anchorGlob).forEach(x=>{f.push("-g",x)})})}k&&k.length&&k.forEach(ee=>{f.push("-g",ee)}),c.excludes.map(d.anchorGlob).forEach(ee=>f.push("-g",`!${ee}`)),c.maxFileSize&&f.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?f.push("--no-ignore-parent"):f.push("--no-ignore"),c.followSymlinks&&f.push("--follow"),c.encoding&&c.encoding!=="utf8"&&f.push("--encoding",c.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,i.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),c.usePCRE2&&f.push("--pcre2"),f.push("--crlf"),b.isRegExp&&(b.pattern=r(b.pattern),f.push("--auto-hybrid-regex"));let $;if(b.isWordMatch){const H=(0,i.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");f.push("--regexp",H)}else if(b.isRegExp){let ee=h(b.pattern);ee=m(ee),f.push("--regexp",ee)}else $=b.pattern,f.push("--fixed-strings");return f.push("--no-config"),c.useGlobalIgnoreFiles||f.push("--no-ignore-global"),f.push("--json"),b.isMultiline&&f.push("--multiline"),c.beforeContext&&f.push("--before-context",c.beforeContext+""),c.afterContext&&f.push("--after-context",c.afterContext+""),f.push("--"),$&&f.push($),f.push("."),f}function o(b){const c=(0,A.splitGlobAware)(b,"/");return c.map((f,k)=>c.slice(0,k+1).join("/"))}e.spreadGlobComponents=o;function r(b){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(c);)b=b.replace(c,"$1\\x{$2}");const f=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(f);)b=b.replace(f,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=r;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let c;try{c=new g.RegExpParser().parsePattern(b)}catch(H){return b}let f="",k=0;const L=(H,x,B)=>{f+=b.slice(k,H)+B,k=x},$=[];return new g.RegExpVisitor({onCharacterEnter(H){if(H.raw==="\\n"){const x=$[0];if(!x)L(H.start,H.end,"\\r?\\n");else if(!$.some(l))if(x.type==="CharacterClass"){const B=b.slice(x.start+1,H.start)+b.slice(H.end,x.end-1);L(x.start,x.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")}},onQuantifierEnter(H){$.unshift(H)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(H){$.unshift(H)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(H){$.unshift(H)},onCharacterClassLeave(){$.shift()},onAssertionEnter(H){l(H)&&$.push(H)},onAssertionLeave(H){$[0]===H&&$.shift()}}).visit(c),f+=b.slice(k),f}e.fixRegexNewline=h;function m(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(ge[275],ve([0,1,21,129,111,11]),function(Q,e,E,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(i){this.outputChannel=i,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(i,R,C,w){const g=new I.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.userData){const s=Object.assign(Object.assign({},R),{folder:R.folder.with({scheme:P.Schemas.file})}),d=new T.Progress(S=>C.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:R.folder.scheme})})));return this.withToken(w,S=>g.provideTextSearchResults(i,s,d,S))}else return this.withToken(w,s=>g.provideTextSearchResults(i,R,C,s))}async withToken(i,R){const C=A(i);this.inProgress.add(C);const w=await R(C.token);return this.inProgress.delete(C),w}dispose(){this.inProgress.forEach(i=>i.cancel())}}e.RipgrepSearchProvider=D;function A(y){const i=new E.CancellationTokenSource;return y.onCancellationRequested(()=>i.cancel()),i}}),define(ge[276],ve([0,1,26,129,128]),function(Q,e,E,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(y){this.query=y}search(y,i,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(g){R({message:g})}},w=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),E);return new Promise((g,s)=>w.search(d=>{i(d.map(D))},y).then(d=>g({limitHit:d.limitHit,type:"success"}),s))}}e.TextSearchEngineAdapter=P;function D(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,i)=>{if(i.ranges){const R=i;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(ge[277],ve([0,1,37,290,18,19,17,3,96,8,46,2,44,31,274,276]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(E);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const o=p(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{n=(0,P.createCancelablePromise)(l=>this.doFileSearchWithEngine(s.Engine,o,h=>r.fire(h),l)),n.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const o=p(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{n=(0,P.createCancelablePromise)(l=>this.ripgrepTextSearch(o,h=>r.fire(h),l)),n.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,o){return t.maxFileSize=(0,w.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(o,n,n)}doFileSearch(t,n,o){return this.doFileSearchWithEngine(s.Engine,t,n,o)}doFileSearchWithEngine(t,n,o,r,l=S.BATCH_SIZE){let h=0;const m=c=>{Array.isArray(c)?(h+=c.length,o(c.map(f=>this.rawMatchToSearchItem(f)))):c.relativePath?(h++,o(this.rawMatchToSearchItem(c))):o(c)};if(n.sortByScore){let c=this.trySortedSearchFromCache(n,m,r);if(!c){const f=n.maxResults?Object.assign({},n,{maxResults:null}):n,k=new t(f);c=this.doSortedSearch(k,n,o,m,r)}return new Promise((f,k)=>{c.then(([L,$])=>{const ee=$.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(ee,o,l),f(L)},k)})}const b=new t(n);return this.doSearch(b,m,l,r).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,i.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,o,r,l){const h=new A.Emitter;let m=(0,P.createCancelablePromise)(c=>{let f=[];const k=L=>{Array.isArray(L)?f=L:(r(L),h.fire(L))};return this.doSearch(t,k,-1,c).then(L=>[L,f])}),b;if(n.cacheKey){b=this.getOrCreateCache(n.cacheKey);const c={promise:m,event:h.event,resolved:!1};b.resultsToSearchCache[n.filePattern||""]=c,m.then(()=>{c.resolved=!0},f=>{delete b.resultsToSearchCache[n.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([c,f])=>{const k=b?b.scorerCache:Object.create(null),L=(typeof n.maxResults!="number"||n.maxResults>0)&&R.StopWatch.create(!1);return this.sortResults(n,f,k,l).then($=>{const ee=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:$.length},limitHit:c.limitHit||typeof n.maxResults=="number"&&f.length>n.maxResults},$]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new v)}trySortedSearchFromCache(t,n,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const l=this.getResultsFromCache(r,t.filePattern||"",n,o);if(l)return l.then(([h,m,b])=>{const c=R.StopWatch.create(!1);return this.sortResults(t,m,r.scorerCache,o).then(f=>{const k=c.elapsed(),L={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:m.length,sortingTime:k};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:L},f]})})}}sortResults(t,n,o,r){const l=(0,y.prepareQuery)(t.filePattern||""),h=(b,c)=>(0,y.compareItemsByFuzzyScore)(b,c,l,!0,_,o),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,h,m,1e4,r)}sendProgress(t,n,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)n(t.slice(r,r+o));else n(t)}getResultsFromCache(t,n,o,r){const l=R.StopWatch.create(!1),h=n.indexOf(i.sep)>=0;let m;for(const k in t.resultsToSearchCache)if(n.startsWith(k)){if(h&&k.indexOf(i.sep)<0&&k!=="")continue;const L=t.resultsToSearchCache[k];m={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!m)return null;const b=l.elapsed(),c=R.StopWatch.create(!1),f=m.event(o);return r&&r.onCancellationRequested(()=>{f.dispose()}),m.promise.then(([k,L])=>{if(r&&r.isCancellationRequested)throw(0,D.canceled)();const $=[],ee=(0,y.prepareQuery)(n).normalizedLowercase;for(const H of L)!(0,g.isFilePatternMatch)(H,ee)||$.push(H);return[k,$,{cacheWasResolved:m.resolved,cacheLookupTime:b,cacheFilterTime:c.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,n,o,r){return new Promise((l,h)=>{let m=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(o?(m.push(b),o>0&&m.length>=o&&(n(m),m=[])):n(b))},b=>{n(b)},(b,c)=>{m.length&&n(m),b?h(b):l(c)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,o){return t.then(n,o)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(a){return(0,i.basename)(a.relativePath)}getItemDescription(a){return(0,i.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function p(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(u),extraFileResources:a.extraFileResources&&a.extraFileResources.map(t=>C.URI.revive(t))})}function u(a){return Object.assign(Object.assign({},a),{folder:C.URI.revive(a.folder)})}}),define(ge[278],ve([0,1,6,2,26,12,31,277,275,90,13,61,27,67,11,128]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(_,p,u,a){super(_,u,a);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new i.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(s.Schemas.userData,new y.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new i.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(s.Schemas.file,new y.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(s.Schemas.file,new A.SearchService)}registerInternalFileSearchProvider(_,p){const u=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(_)),(0,E.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(_,p,u,a){const t=(0,g.reviveQuery)(u);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,p,t,a):super.$provideFileSearchResults(_,p,u,a)}doInternalFileSearch(_,p,u,a){const t=n=>{if((0,D.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,p,n.map(o=>I.URI.file(o.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,a)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,p){return new d.NativeTextSearchManager(_,p)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,w.IExtHostInitDataService),Ue(2,C.IURITransformerService),Ue(3,P.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[130],ve([0,1,291,120,292,3,101,8,48,28,6,22,102,17,9]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(m){this.socket=m,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const b=c=>m(C.VSBuffer.wrap(c));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((m,b)=>{if(this.socket.bufferSize===0){m();return}const c=()=>{this.socket.off("close",c),this.socket.off("end",c),this.socket.off("error",c),this.socket.off("timeout",c),this.socket.off("drain",c),m()};this.socket.on("close",c),this.socket.on("end",c),this.socket.on("error",c),this.socket.on("timeout",c),this.socket.on("drain",c)})}}e.NodeSocket=d;var S;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(v||(v={}));class _ extends R.Disposable{constructor(m,b,c,f){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=f,b?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,g.onUnexpectedError)(k),this._onClose.fire()}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),c&&(this._zlibInflate.write(c.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,g.onUnexpectedError)(k),this._onClose.fire()}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(C.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,b){let c=2;m.byteLength<126?c+=0:m.byteLength<2**16?c+=2:c+=8;const f=C.VSBuffer.alloc(c);if(b?f.writeUInt8(194,0):f.writeUInt8(130,0),m.byteLength<126)f.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){f.writeUInt8(126,1);let k=1;f.writeUInt8(m.byteLength>>>8&255,++k),f.writeUInt8(m.byteLength>>>0&255,++k)}else{f.writeUInt8(127,1);let k=1;f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(m.byteLength>>>24&255,++k),f.writeUInt8(m.byteLength>>>16&255,++k),f.writeUInt8(m.byteLength>>>8&255,++k),f.writeUInt8(m.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=f.byteLength+m.byteLength,this.socket.write(C.VSBuffer.concat([f,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),f=(b.readUInt8(0)&128)>>>7,k=b.readUInt8(1),L=(k&128)>>>7,$=k&127;this._state.state=2,this._state.readLen=2+(L?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=f,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),c=b.readUInt8(1),f=(c&128)>>>7;let k=c&127,L=1;k===126?k=b.readUInt8(++L)*2**8+b.readUInt8(++L):k===127&&(k=b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L));let $=0;f&&($=b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L)),this._state.state=3,this._state.readLen=k,this._state.mask=$}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);p(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const c=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=c.length,this._onData.fire(C.VSBuffer.wrap(c))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function p(h,m){if(m!==0){let b=h.byteLength>>>2;for(let ee=0;ee<b;ee++){const H=h.readUInt32BE(ee*4);h.writeUInt32BE(H^m,ee*4)}let c=b*4,f=h.byteLength-c;const k=m>>>24&255,L=m>>>16&255,$=m>>>8&255;f>=1&&h.writeUInt8(h.readUInt8(c)^k,c),f>=2&&h.writeUInt8(h.readUInt8(c+1)^L,c+1),f>=3&&h.writeUInt8(h.readUInt8(c+2)^$,c+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function a(){const h=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):m=(0,A.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),n(m),m}e.createRandomIPCHandle=a;function t(h,m,b){const c=(0,E.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${c}-${b}-${m}-sock`;let f;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?f=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${c.substr(0,8)}-${b}-${m}.sock`):f=(0,A.join)(h,`${b}-${m}.sock`),n(f),f}e.createStaticIPCHandle=t;function n(h){const m=u[s.platform];typeof m=="number"&&h.length>=m&&console.warn(`WARNING: IPC handle "${h}" is longer than ${m} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{constructor(m){super(o.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const b=P.Event.fromNodeEventEmitter(m,"connection");return P.Event.map(b,c=>({protocol:new w.Protocol(new d(c)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(c,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(h){return new Promise((m,b)=>{const c=(0,I.createServer)();c.on("error",b),c.listen(h,()=>{c.removeListener("error",b),m(new o(c))})})}e.serve=r;function l(h,m){return new Promise((b,c)=>{const f=(0,I.createConnection)(h,()=>{f.removeListener("error",c),b(w.Client.fromSocket(new d(f),m))});f.once("error",c)})}e.connect=l}),define(ge[279],ve([0,1,130,271,37,51,2,115,12]),function(Q,e,E,I,T,P,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class i{constructor(w,g,s){this._commands=w,this.logService=g,this._ipcHandlePath=s,this._server=I.createServer((d,S)=>this.onRequest(d,S)),this.setup().catch(d=>(g.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch(w){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,g){const s=[];w.setEncoding("utf8"),w.on("data",d=>s.push(d)),w.on("end",()=>{const d=JSON.parse(s.join(""));switch(d.type){case"open":this.open(d,g);break;case"openExternal":this.openExternal(d,g);break;case"status":this.getStatus(d,g);break;case"command":this.runCommand(d,g).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(d,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${d.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(w,g){let{fileURIs:s,folderURIs:d,forceNewWindow:S,diffMode:v,addMode:_,forceReuseWindow:p,gotoLineMode:u,waitMarkerFilePath:a}=w;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:D.URI.parse(n)})}catch(o){}if(Array.isArray(s))for(const n of s)try{(0,A.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:D.URI.parse(n)}):t.push({fileUri:D.URI.parse(n)})}catch(o){}if(t.length){const n=a?D.URI.file(a):void 0,r={forceNewWindow:S,diffMode:v,addMode:_,gotoLineMode:u,forceReuseWindow:p,preferNewWindow:!p&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_files.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(w,g){for(const s of w.uris){const d=D.URI.parse(s),S=d.scheme==="file"?d:s;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(w,g){try{const s=v=>v==null?void 0:v.map(_=>/\.vsix$/i.test(_)?D.URI.parse(_):_),d={list:w.list,install:s(w.install),uninstall:s(w.uninstall),force:w.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);g.writeHead(200),g.write(S)}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)})}g.end()}async getStatus(w,g){try{const s=await this._commands.executeCommand("_issues.getSystemStatus");g.writeHead(200),g.write(s),g.end()}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)}),g.end()}}async runCommand(w,g){try{const{command:s,args:d}=w,S=await this._commands.executeCommand(s,...d);g.writeHead(200),g.write(JSON.stringify(S),v=>{v&&this.logService.error(v)}),g.end()}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=i;let R=class extends i{constructor(w,g){super(w,g,(0,E.createRandomIPCHandle)())}};R=je([Ue(0,P.IExtHostCommands),Ue(1,y.ILogService)],R),e.CLIServer=R}),define(ge[280],ve([0,1,66,267,261,5,270,42,252,2,11,7,279,99]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends T.RequireInterceptor{_installInterceptor(){const v=this,_=Q.__$__nodeRequire("module"),p=_._load;_._load=function(a,t,n){for(let o of v._alternatives){let r=o(a);if(r){a=r;break}}return v._factories.has(a)?v._factories.get(a).load(a,i.URI.file((0,g.realpathSync)(t.filename)),o=>p.apply(this,[o,t,n])):p.apply(this,arguments)}}}class d extends A.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(w.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(s,v,this._registry).install(),E.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),E.mark("code/extHost/didInitProxyResolver");const u=process.send,a=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(a.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,_,p){if(_.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let u=null;p.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{v&&E.mark(`code/extHost/willLoadExtensionCode/${v.value}`),u=Q.__$__nodeRequire(_.fsPath)}catch(a){return Promise.reject(a)}finally{v&&E.mark(`code/extHost/didLoadExtensionCode/${v.value}`),p.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const _ in v){const p=v[_];p===null?delete process.env[_]:process.env[_]=p}}}e.ExtHostExtensionService=d}),define(ge[281],ve([0,1,78,253,264,263,262,278,280,225,254,45,42,63,67,65,34,50,12]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(w.IExtHostExtensionService,y.ExtHostExtensionService),(0,E.registerSingleton)(_.ILogService,i.ExtHostLogService),(0,E.registerSingleton)(C.IExtHostDebugService,D.ExtHostDebugService),(0,E.registerSingleton)(g.IExtHostOutputService,I.ExtHostOutputService2),(0,E.registerSingleton)(s.IExtHostSearch,A.NativeExtHostSearch),(0,E.registerSingleton)(d.IExtHostTask,P.ExtHostTask),(0,E.registerSingleton)(S.IExtHostTerminalService,T.ExtHostTerminalService),(0,E.registerSingleton)(v.IExtHostTunnelService,R.ExtHostTunnelService)}),define(ge[282],ve([0,1,120,293,66,17,102,130,186,223,265,22,97,26,99,19,268,281]),function(Q,e,E,I,T,P,D,A,y,i,R,C,w,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=Q.__$__nodeRequire("module"),r=o._load;o._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function _(o){process.exit=function(r){if(o)v(r);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let p=function(o){v()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let l=null,h=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const m=108e5,b=3e5,c=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (1)"),m),f=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (2)"),b);process.on("message",(L,$)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let H;if(L.skipWebSocketFrames)H=new A.NodeSocket($);else{const x=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));H=new A.WebSocketNodeSocket(new A.NodeSocket($),L.permessageDeflate,x,!1)}l?(c.cancel(),f.cancel(),l.beginAcceptReconnection(H,ee),l.endAcceptReconnection()):(clearTimeout(h),l=new D.PersistentProtocol(H,ee),l.onDidDispose(()=>p("renderer disconnected")),o(l),l.onSocketClose(()=>{c.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(f.isScheduled())return;c.isScheduled()&&f.schedule()}});const k={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(k)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,l)=>{const h=E.createConnection(o,()=>{h.removeListener("error",l),r(new D.PersistentProtocol(new A.NodeSocket(h)))});h.once("error",l)})}}async function a(){const o=await u();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,i.isMessageOfType)(r,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const l=o.onMessage(h=>{l.dispose();const m=JSON.parse(h.toString()),b=m.commit,c=y.default.commit;b&&c&&b!==c&&v(55);const f=[];process.on("unhandledRejection",($,ee)=>{f.push(ee),setTimeout(()=>{const H=f.indexOf(ee);H>=0&&ee.catch(x=>{f.splice(H,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,P.onUnexpectedError)($)})},1e3)}),process.on("rejectionHandled",$=>{const ee=f.indexOf($);ee>=0&&f.splice(ee,1)}),process.on("uncaughtException",function($){(0,P.onUnexpectedError)($)});let k=0;setInterval(function(){try{process.kill(m.parentPid,0),k=0}catch($){$&&$.code==="EPERM"?(k++,k>=3&&p(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):p(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let L;try{L=Q.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch($){(0,P.onUnexpectedError)($)}o.send((0,i.createMessageOfType)(0)),r({protocol:o,initData:m})});o.send((0,i.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const o=await a();T.mark("code/extHost/didConnectToRenderer");const r=await t(o);T.mark("code/extHost/didWaitForInitData");const{initData:l}=r;_(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const h=new class{exit(f){v(f)}exists(f){return(0,g.exists)(f)}realpath(f){return(0,s.realpath)(f)}};let m=null;if(l.remote.authority&&S.uriTransformerPath)try{const f=Q.__$__nodeRequire(S.uriTransformerPath)(l.remote.authority);m=new w.URITransformer(f)}catch(c){console.error(c)}const b=new R.ExtensionHostMain(r.protocol,l,h,m);p=c=>b.terminate(c)}e.startExtensionHostProcess=n}),define(ge[294],ve([0,1,282]),function(Q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5904b7b686e9274631893d560fdbc55a5567f878/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
